<?php
// +-------------------------------------------------+
//  2002-2004 PMB Services / www.sigb.net pmb@sigb.net et contributeurs (voir www.sigb.net)
// +-------------------------------------------------+
// $Id: suggestions_display.inc.php,v 1.5 2007/07/20 16:54:17 dbellamy Exp $

if (stristr($_SERVER['REQUEST_URI'], ".inc.php")) die("no access");

require_once($class_path.'/suggestions.class.php');
require_once($class_path.'/suggestions_origine.class.php');
require_once($class_path.'/suggestions_categ.class.php');
require_once($class_path.'/suggestions_map.class.php');
require_once($include_path.'/templates/suggestions.tpl.php');

//Affiche la liste des suggestions
function show_list_sug($id_bibli=0) {
	
	global $dbh;
	global $msg, $charset;
	global $sug_map;
	global $sug_search_form, $sug_list_form;
	global $nb_per_page;
	global $include_path, $class_path;
	global $user_input, $statut, $num_categ, $page, $nbr_lignes, $tri_param, $limit_param, $last_param;
	global $current_module;
	global $script, $bt_chk, $bt_imp;
	global $acquisition_sugg_categ, $acquisition_sugg_categ_default;

	// nombre de rfrences par pages
	if (!$nb_per_page) $nb_per_page = 10;		
		
	//Affichage form de recherche
	$titre = htmlentities($msg['recherche'].' : '.$msg['acquisition_sug'], ENT_QUOTES, $charset);
	$action ="./acquisition.php?categ=sug&action=list&id_bibli=".$id_bibli."&user_input=&nb_per_page=".$nb_per_page;
	$bouton_add = "<input class='bouton' type='button' value='".$msg['acquisition_ajout_sug']."' onClick=\"document.location='./acquisition.php?categ=sug&sub=todo&action=modif&id_bibli=".$id_bibli."&id_sug=0';\" />";
	$lien_last_sug = "";
	$sug_search_form = str_replace('!!form_title!!', $titre, $sug_search_form);
	$sug_search_form = str_replace('!!action!!', $action, $sug_search_form);
	$sug_search_form = str_replace('<!-- sel_state -->', $sug_map->getStateSelector(), $sug_search_form);
	$sug_search_form = str_replace('<!-- bouton_add -->', $bouton_add, $sug_search_form);
	$sug_search_form = str_replace('<!-- lien_last -->', $lien_last_sug, $sug_search_form);
	
	//Selecteur de categories
	if ($acquisition_sugg_categ != '1') {
		$sel_categ="";
	} else {
		$tab_categ = suggestions_categ::getCategList();
		$sel_categ = "<select class='saisie-25em' id='num_categ' name='num_categ' onchange=\"submit();\">";
		$sel_categ.= "<option value='-1'>".htmlentities($msg['acquisition_sug_tous'],ENT_QUOTES, $charset)."</option>";
		foreach($tab_categ as $id_categ=>$lib_categ){
			$sel_categ.= "<option value='".$id_categ."' > ";
			$sel_categ.= htmlentities($lib_categ,ENT_QUOTES, $charset)."</option>";
		}
		$sel_categ.= "</select>";
	}
	$sug_search_form = str_replace('<!-- sel_categ -->', $sel_categ, $sug_search_form);


	print $sug_search_form;
	
	//Affiche par defaut toutes les categories de suggestions
	if ($acquisition_sugg_categ != '1') {
		$num_categ = "-1";
	} else {
		if (!$num_categ) $num_categ = '-1';
		print "<script type='text/javascript' >document.forms['search'].elements['num_categ'].value = ".$num_categ.";</script>";
	}
	
	if(!$statut) $statut='-1';	//Affiche par dfaut toutes les suggestions
	print "<script type='text/javascript' >document.forms['search'].elements['statut'].value = ".$statut.";document.forms['search'].elements['user_input'].focus();</script>";
	
	
	//Prise en compte du formulaire de recherche
	$mask=$sug_map->getMask_FILED();
		
	
	// traitement de la saisie utilisateur

	require_once($class_path."/analyse_query.class.php");
	
	// on rcupre le nombre de lignes qui vont bien
	if(!$nbr_lignes) {
		if(!$user_input) {
			$nbr_lignes = suggestions::getNbSuggestions($id_bibli, $statut, $num_categ, $mask );
		} else {
			$aq=new analyse_query(stripslashes($user_input));
			if ($aq->error) {
				error_message($msg["searcher_syntax_error"],sprintf($msg["searcher_syntax_error_desc"],$aq->current_car,$aq->input_html,$aq->error_message));
				exit;
			}
			$nbr_lignes = suggestions::getNbSuggestions($id_bibli, $statut, $num_categ, $mask, $aq);
		}

	} else {
		$aq=new analyse_query(stripslashes($user_input));
	}

	
	if(!$page) $page=1;
	$debut =($page-1)*$nb_per_page;


	if($nbr_lignes) {
	
		$url_base = "acquisition.php?categ=sug&action=list&id_bibli=$id_bibli&user_input=".rawurlencode(stripslashes($user_input))."&statut=$statut&num_categ=$num_categ" ;
		// on lance la vraie requte
		if(!$user_input) {
			$q = suggestions::listSuggestions($id_bibli, $statut, $num_categ, $mask, $debut, $nb_per_page);
		} else {
			$q = suggestions::listSuggestions($id_bibli, $statut, $num_categ, $mask, $debut, $nb_per_page, $aq);
		}
		$res = mysql_query($q, $dbh);
	
		//Affichage liste des suggestions
		
		$nbr = mysql_num_rows($res);
		$aff_row="";
		$parity=1;
		for($i=0;$i<$nbr;$i++) {
			$row=mysql_fetch_object($res);
			
			$lib_statut=$sug_map->getHtmlComment($row->statut);
	
			
			if(!$row->num_notice) $lib_cat='';
				else $lib_cat='X'; 
			
			if ($parity % 2) {
				$pair_impair = "even";
			} else {
				$pair_impair = "odd";
			}
			$parity += 1;
			$tr_javascript = "onmouseover=\"this.className='surbrillance'\" onmouseout=\"this.className='".$pair_impair."'\" ";
			$dn_javascript = "onmousedown=\"document.location='./acquisition.php?categ=sug&action=modif&id_bibli=".$id_bibli."&id_sug=".$row->id_suggestion."' \" ";
	        $aff_row.=	"<tr class='".$pair_impair."' ".$tr_javascript." style='cursor: pointer' >
						<td ".$dn_javascript." ><i>".formatdate($row->date_creation)."</i></td>
						<td ".$dn_javascript." ><i>".htmlentities($row->titre, ENT_QUOTES, $charset)."</i></td>
						<td ".$dn_javascript." ><i>".htmlentities($row->editeur, ENT_QUOTES, $charset)."</i></td>
						<td ".$dn_javascript." ><i>".htmlentities($row->auteur, ENT_QUOTES, $charset)."</i></td>
						<td ".$dn_javascript." ><i>$lib_statut</i></td>
						<td ".$dn_javascript." ><i>".$lib_cat."</i></td>";
			if ($acquisition_sugg_categ == '1') {
				$categ = new suggestions_categ($row->num_categ);
				$aff_row.="<td ".$dn_javascript." ><i>".htmlentities($categ->libelle_categ, ENT_QUOTES, $charset)."</i></td>";
			}			
			$aff_row.= "<td><input type='checkbox' id='chk[".$row->id_suggestion."]' name='chk[]' value='".$row->id_suggestion."' /></td>
					</tr>";
		}
		$sug_list_form = str_replace('<!-- sug_list -->',$aff_row, $sug_list_form); 
	
	
		//Affichage des boutons
		
		//Bouton Imprimer
		$imp = "window.open('./pdf.php?pdfdoc=listsug&user_input=".urlencode(stripslashes($user_input))."&statut=".$statut."&num_categ=".$num_categ."' ,'print_PDF', 'toolbar=no, dependent=yes, width=600, height=500, resizable=yes');" ;
		$bt_imp = str_replace('!!imp!!', $imp, $bt_imp);
		$sug_list_form=str_replace('<!-- bt_imp -->', $bt_imp,$sug_list_form);
		
	
		//Bouton Slectionner
		$sug_list_form=str_replace('<!-- bt_chk -->', $bt_chk,$sug_list_form);
		
		
		//Liste Boutons
		$button_list=$sug_map->getButtonList($statut);
		$sug_list_form = str_replace('<!-- bt_list -->', $button_list,$sug_list_form);
	
	
		//Bouton Reprendre
		$bt_todo=$sug_map->getButtonList_TODO($statut);
		$sug_list_form=str_replace('<!-- bt_todo -->', $bt_todo,$sug_list_form);

		if ($acquisition_sugg_categ == '1' ) { 	
			//Selecteur Affecter a une categorie
			$to_categ=$sug_map->getCategModifier($statut, $num_categ, $nb_per_page);
		} else {
			$to_categ = "";
		}
		$sug_list_form=str_replace('<!-- to_categ -->', $to_categ,$sug_list_form);
		
		
		//Bouton Supprimer
		$button_sup = $sug_map->getButtonList_DELETED($statut);
		$sug_list_form = str_replace('<!-- bt_sup -->', $button_sup, $sug_list_form);
		
		//JavaScript
		$script_list = $sug_map->getScriptList($statut,$num_categ,$nb_per_page);
		$script = str_replace('<!-- script_list -->', $script_list, $script);
		$sug_list_form=str_replace('<!-- script -->', $script,$sug_list_form);
		
		//Barre de navigation
		if (!$last_param) $nav_bar = aff_pagination ($url_base, $nbr_lignes, $nb_per_page, $page, 10, true, true) ;
	        else $nav_bar = "";
	    $sug_list_form=str_replace('<!-- nav_bar -->', $nav_bar,$sug_list_form);
		
		print $sug_list_form;		
	
	} else {
		// la requte n'a produit aucun rsultat
		error_message($msg['acquisition_sug_rech'], str_replace('!!sug_cle!!', stripslashes($user_input), $msg['acquisition_sug_rech_error']), 0, './categ=sug&sub=todo&action=list&id_bibli='.$id_bibli);
	}
	
}


//Affiche le formulaire de modification de suggestion
function show_form_sug($update_action) {
	
	global $dbh, $msg, $charset;
	global $id_bibli, $id_sug;
	global $sug_map;
	global $sug_modif_form;
	global $acquisition_poids_sugg, $lk_url_sug;
	global $acquisition_sugg_categ, $acquisition_sugg_categ_default;
	global $orig_form_mod;
	
	$form = $sug_modif_form;

	//Rcupration des pondrations de suggestions
	$tab_poids = explode(",", $acquisition_poids_sugg);
	$tab_poids[0] = substr($tab_poids[0], 2); //utilisateur
	$tab_poids[1] = substr($tab_poids[1], 2); //abonn
	$tab_poids[2] = substr($tab_poids[2], 2); //visiteur

	if(!$id_sug) {	//Cration de suggestion
	
		$titre = htmlentities($msg['acquisition_sug_cre'], ENT_QUOTES, $charset);
		
		//Rcupration de l'utilisateur
	 	$requete_user = "SELECT userid, nom, prenom FROM users where username='".SESSlogin."' limit 1 ";
		$res_user = mysql_query($requete_user, $dbh);
		$row_user=mysql_fetch_row($res_user);
		$orig = $row_user[0];
		$lib_orig = $row_user[1];
		if ($row_user[2]) $lib_orig.= ", ".$row_user[2];

		$form = str_replace('!!lib_orig!!', $orig_form_mod, $form);
				
		$form = str_replace('!!dat_cre!!', formatdate(today()), $form);
		$form = str_replace('!!orig!!', $orig, $form);
		$form = str_replace('!!lib_orig!!', htmlentities($lib_orig, ENT_QUOTES, $charset), $form);
		$form = str_replace('!!typ!!', '0', $form);
		$form = str_replace('!!poi!!', $tab_poids[0], $form);
		$form = str_replace('!!poi_tot!!', $tab_poids[0], $form);
		$statut = $sug_map->getFirstStateId();
		$form = str_replace('!!statut!!', $statut, $form);
		$form = str_replace('!!lib_statut!!', $sug_map->getHtmlComment($statut), $form);

		if ($acquisition_sugg_categ != '1') {
			$sel_categ="";
		} else {
			
			if (suggestions_categ::exists($acquisition_sugg_categ_default)) {
				$sugg_categ = new suggestions_categ($acquisition_sugg_categ_default);
			} else {
				$sugg_categ = new suggestions_categ('1');
			}
			$tab_categ = suggestions_categ::getCategList();
			$sel_categ = "<select class='saisie-25em' id='num_categ' name='num_categ'>";
			foreach($tab_categ as $id_categ=>$lib_categ){
				$sel_categ.= "<option value='".$id_categ."' ";
				if ($id_categ==$sugg_categ->id_categ) $sel_categ.= "selected='selected' ";
				$sel_categ.= ">";
				$sel_categ.= htmlentities($lib_categ,ENT_QUOTES, $charset)."</option>";
			}
			$sel_categ.= "</select>"; 
		}

		$form = str_replace('!!categ!!', $sel_categ, $form);
		$form = str_replace('!!tit!!', '', $form);
		$form = str_replace('!!edi!!', '', $form);
		$form = str_replace('!!aut!!', '', $form);
		$form = str_replace('!!cod!!', '', $form);
		$form = str_replace('!!pri!!', '', $form);
		$form = str_replace('!!com!!', '', $form);	
		$form = str_replace('!!url_sug!!', '', $form);
		$form = str_replace('!!id_notice!!', 0, $form);
		
	} else {	//Modification de suggestion

		$titre = htmlentities($msg['acquisition_sug_mod'], ENT_QUOTES, $charset);

		$sug = new suggestions($id_sug);
		$q = suggestions_origine::listOccurences($id_sug);
		$list_orig = mysql_query($q, $dbh);
		$orig = 0;

		$poids_tot = 0;
		while($row_orig = mysql_fetch_object($list_orig)) {
			if (!$orig) {
				$orig = $row_orig->origine;
				$typ = $row_orig->type_origine;
				$poids = $tab_poids[$row_orig->type_origine]; 
			}
			$poids_tot = $poids_tot + $tab_poids[$row_orig->type_origine];
		}

		//Rcupration du nom du crateur de la suggestion
		switch($typ){
			default:
			case '0' :
			 	$requete_user = "SELECT userid, nom, prenom FROM users where userid = '".$orig."' limit 1 ";
				$res_user = mysql_query($requete_user, $dbh);
				$row_user=mysql_fetch_row($res_user);
				$lib_orig = $row_user[1];
				if ($row_user[2]) $lib_orig.= ", ".$row_user[2];			
				break;
			case '1' :
			 	$requete_empr = "SELECT id_empr, empr_nom, empr_prenom FROM empr where id_empr = '".$orig."' limit 1 ";
				$res_empr = mysql_query($requete_empr, $dbh);
				$row_empr=mysql_fetch_row($res_empr);
				$lib_orig = $row_empr[1];
				if ($row_empr[2]) $lib_orig.= ", ".$row_empr[2];			
				break;
			case '2' :
				$lib_orig = $orig;
				break;
		}	
		
		//Rcupration du statut de la suggestion
		$lib_statut=$sug_map->getHtmlComment($sug->statut);
	
		$form = str_replace('!!dat_cre!!', formatdate($sug->date_creation), $form);
		$form = str_replace('!!orig!!', $orig, $form);
		if ($lib_orig) {
			$form = str_replace('!!lib_orig!!', htmlentities($lib_orig, ENT_QUOTES, $charset), $form);
		} else {
			$form = str_replace('!!lib_orig!!', '&nbsp;', $form);
		}
		$form = str_replace('!!typ!!', $typ, $form);
		$form = str_replace('!!poi!!', $poids, $form);
		$form = str_replace('!!poi_tot!!', $poids_tot, $form);
		$form = str_replace('!!statut!!', $sug->statut, $form);
		$form = str_replace('!!lib_statut!!', $lib_statut, $form);
		
		if ($acquisition_sugg_categ != '1') {
			$sel_categ="";
		} else {
			
			$state_name = $sug_map->getStateNameFromId($sug->statut);
			$categ = $sug_map->getState_CATEG($state_name);
			$sugg_categ = new suggestions_categ($sug->num_categ);

			if ($categ == 'YES') {
				$tab_categ = suggestions_categ::getCategList();
				$sel_categ = "<select class='saisie-25em' id='sel_categ' name='sel_categ'>";
				foreach($tab_categ as $id_categ=>$lib_categ){
					$sel_categ.= "<option value='".$id_categ."' ";
					if ($id_categ==$sug->num_categ) $sel_categ.= "selected='selected' ";
					$sel_categ.= ">";
					$sel_categ.= htmlentities($lib_categ,ENT_QUOTES, $charset)."</option>";
				}
				$sel_categ.= "</select>"; 
			} else {
				$sel_categ = htmlentities($sugg_categ->libelle_categ, ENT_QUOTES,$charset);
			}			
		}
		
		$form = str_replace('!!categ!!', $sel_categ, $form);
		$form = str_replace('!!tit!!', htmlentities($sug->titre, ENT_QUOTES, $charset), $form);
		$form = str_replace('!!edi!!', htmlentities($sug->editeur, ENT_QUOTES, $charset), $form);
		$form = str_replace('!!aut!!', htmlentities($sug->auteur, ENT_QUOTES, $charset), $form);
		$form = str_replace('!!cod!!', htmlentities($sug->code, ENT_QUOTES, $charset), $form);
		$form = str_replace('!!pri!!', round($sug->prix, 2), $form);
		$form = str_replace('!!com!!', htmlentities($sug->commentaires, ENT_QUOTES, $charset), $form);
		if ($sug->url_suggestion ) {
			$form = str_replace('<!-- url_sug -->', $lk_url_sug, $form);
		}
		$form = str_replace('!!url_sug!!', htmlentities($sug->url_suggestion, ENT_QUOTES, $charset), $form);	
		$form = str_replace('!!id_notice!!', $sug->num_notice, $form);
		

		// Affichage du bouton supprimer
		$bt_sup = $sug_map->getButton_DELETED($sug->statut, $id_bibli, $id_sug);
		$form = str_replace('<!-- bouton_sup -->', $bt_sup, $form);
		
		if ($sug->num_notice) {
			//Eventuellement, lien vers la notice	

		} else {
			
			// Affichage du bouton cataloguer
			$bt_cat = $sug_map->getButton_CATALOG($sug->statut, $id_bibli, $id_sug);
			$form = str_replace('<!-- bouton_cat -->', $bt_cat, $form);	
		}
	}
	
	//$action ="./acquisition.php?categ=sug&action=update&id_bibli=".$id_bibli."&id_sug=".$id_sug;
	$form = str_replace('!!action!!', $update_action, $form);
	$form = str_replace('!!form_title!!', $titre, $form);
	
	
	print $form;
}

?>

