<?php
// +-------------------------------------------------+
//  2002-2004 PMB Services / www.sigb.net pmb@sigb.net et contributeurs (voir www.sigb.net)
// +-------------------------------------------------+
// $Id: update_notice.inc.php,v 1.9 2007/10/02 19:32:49 gueluneau Exp $

if (stristr($_SERVER['REQUEST_URI'], ".inc.php")) die("no access");

//Pour les champs personnaliss
require_once($class_path."/parametres_perso.class.php");
require_once($class_path."/notice.class.php");
require_once($include_path."/isbn.inc.php");

require_once($class_path."/author.class.php");

// dfinition de quelques variables
$requete = "INSERT INTO notices SET create_date=sysdate(), update_date=sysdate(), ";
$postrequete = ';';
$notitle_message = $msg[279];

if($id) {
	$requete = "UPDATE notices SET update_date=sysdate(), ";
	$postrequete = " WHERE notice_id=$id ";
	$notitle_message = $msg[280];
}

$p_perso=new parametres_perso("notices");
$nberrors=$p_perso->check_submited_fields();

if(($f_tit1)&&(!$nberrors)) {

	// nettoyage des champs du form
	$f_tit1		=	clean_string($f_tit1);	
	$f_tit2		=	clean_string($f_tit2);
	$f_tit3		=	clean_string($f_tit3);
	$f_tit4		=	clean_string($f_tit4);
	$f_tparent	=	clean_string($f_tparent);
	$f_tnvol	=	clean_string($f_tnvol);
	$f_ed1		=	clean_string($f_ed1);
	$f_ed2		=	clean_string($f_ed2);
	$f_coll		=	clean_string($f_coll);
	$f_subcoll	=	clean_string($f_subcoll);
	$f_year		=	clean_string($f_year);
	$f_nocoll	=	clean_string($f_nocoll);
	$f_mention_edition	=	clean_string($f_mention_edition);
	$f_cb		=	clean_string($f_cb);
	$f_npages	=	clean_string($f_npages);
	$f_ill		=	clean_string($f_ill);
	$f_size		=	clean_string($f_size);
	$f_prix		=	clean_string($f_prix);
	$f_accomp	=	clean_string($f_accomp);
	$f_lang		=	clean_string($f_lang);
	$f_org_lang =	clean_string($f_org_lang);
	$f_lien		=	clean_string($f_lien);
	$f_eformat	=	clean_string($f_eformat);
	$f_commentaire_gestion	=	$f_commentaire_gestion ;
	
	// le contenu des champs du form est mis dans un tableau
	$t_notice['typdoc'] = $typdoc;
	$t_notice['statut'] = $form_notice_statut;
	$t_notice['commentaire_gestion'] = $f_commentaire_gestion;
	
	$t_notice['tit1'] = $f_tit1;
	$t_notice['tit2'] = $f_tit2;
	$t_notice['tit3'] = $f_tit3;
	$t_notice['tit4'] = $f_tit4;
	$f_tparent ? $t_notice['tparent_id'] = $f_tparent_id : $t_notice['tparent_id'] = 0;
	$t_notice['tnvol'] = $f_tnvol;

	// auteur principal
	$f_aut[] = array (
			'id' => $f_aut0_id,
			'fonction' => $f_f0_code,
			'type' => '0' );
	// autres auteurs
	for ($i=$max_aut1; $i>=0 ; $i--) {
		$var_autid = "f_aut1_id$i" ;
		$var_autfonc = "f_f1_code$i" ;
		$f_aut[] = array (
				'id' => $$var_autid,
				'fonction' => $$var_autfonc,
				'type' => '1' );
		}
	// auteurs secondaires
	for ($i=$max_aut2; $i>=0 ; $i--) {
		$var_autid = "f_aut2_id$i" ;
		$var_autfonc = "f_f2_code$i" ;
		$f_aut[] = array (
				'id' => $$var_autid,
				'fonction' => $$var_autfonc,
				'type' => '2' );
		}

	$f_ed1 ? $t_notice['ed1_id'] = $f_ed1_id : $t_notice['ed1_id'] = 0;
	$f_ed2 ? $t_notice['ed2_id'] = $f_ed2_id : $t_notice['ed2_id'] = 0;
	$f_coll && $t_notice['ed1_id'] ? $t_notice['coll_id'] = $f_coll_id : $t_notice['coll_id'] = 0;
	$f_subcoll && $t_notice['coll_id'] ? $t_notice['subcoll_id'] = $f_subcoll_id : $t_notice['subcoll_id'] = 0;
	$t_notice['year'] = trim($f_year) ;
	$f_nocoll && $t_notice['coll_id'] ? $t_notice['nocoll'] = trim($f_nocoll) : $t_notice['nocoll'] = '';
	$t_notice['mention_edition'] = trim($f_mention_edition) ; 

	if ($f_cb) {
		// ce contrle redondant est l pour le cas ou l'utilisateur aurait chang le code
		if(isEAN($f_cb)) {
			// la saisie est un EAN -> on tente de le formater en ISBN
			$code = EANtoISBN($f_cb);
			// si chec, on prend l'EAN comme il vient
			if(!$code) $code = $f_cb;
		} else {
			if(isISBN($f_cb)) {
				// si la saisie est un ISBN
				$code = formatISBN($f_cb,13);
				// si chec, ISBN erron on le prend sous cette forme
				if(!$code) $code = $f_cb;
			} else {
				// ce n'est rien de tout a, on prend la saisie telle quelle
				$code = $f_cb;
			}
		}
		$t_notice['code'] = $code;
	}

	$t_notice['npages'] = $f_npages;
	$t_notice['ill'] = $f_ill;
	$t_notice['size'] = $f_size;
	$t_notice['prix'] = $f_prix;
	$t_notice['accomp'] = $f_accomp;

	$t_notice['n_gen'] = $f_n_gen;
	$t_notice['n_contenu'] = $f_n_contenu;
	$t_notice['n_resume'] = $f_n_resume;

	// catgories
	for ($i=0; $i< $max_categ ; $i++) {
		$var_categid = "f_categ_id$i" ;
		$f_categ[] = array (
				'id' => $$var_categid
				);
		}

	$f_indexint ? $t_notice['indexint'] = $f_indexint_id : $t_notice['indexint']= 0;

	$f_lien ? $t_notice['lien'] = $f_lien : $t_notice['lien'] = '';
	$t_notice['lien'] && $f_eformat ? $t_notice['eformat'] = $f_eformat : $t_notice['eformat'] = '';

	$b_level ? $t_notice['b_level'] = $b_level : $t_notice['b_level'] = 'm';
	$h_level ? $t_notice['h_level'] = $h_level : $t_notice['h_level'] = '0';

	// mise  jour des index
	// titre de srie
	if($t_notice['tparent_id']) {
		$tserie = new serie($t_notice['tparent_id']);
		$ind_serie = addslashes($tserie->name);
		} else $ind_serie = '';  
	$ind_wew = $ind_serie." ".$t_notice['tit1']." ".$t_notice['tit2']." ".$t_notice['tit3']." ".$t_notice['tit4'] ;
	$ind_sew = strip_empty_words($ind_wew) ; 
	$tserie->name ? $index_serie = ' '.strip_empty_words($tserie->name).' ' : $index_serie = '';

	// champ d'indexation libre
	if ($f_indexation) $ind_libre = ' '.strip_empty_words($f_indexation).' ' ;
		else $ind_libre = '';
	
	// notes 
	$f_n_gen ? $index_n_gen = ' '.strip_empty_words($f_n_gen).' ' : $index_n_gen = '';
	$f_n_contenu ? $index_n_contenu = ' '.strip_empty_words($f_n_contenu).' ' : $index_n_contenu = '';
	$f_n_resume ? $index_n_resume = ' '.strip_empty_words($f_n_resume).' ' : $index_n_resume = '';

	$requete .= " typdoc='${t_notice['typdoc']}'";
	$requete .= ", tit1='${t_notice['tit1']}'";
	$requete .= ", tit2='${t_notice['tit2']}'";
	$requete .= ", tit3='${t_notice['tit3']}'";
	$requete .= ", tit4='${t_notice['tit4']}'";
	$requete .= ", tparent_id=${t_notice['tparent_id']}";
	$requete .= ", tnvol='${t_notice['tnvol']}'";
	$requete .= ", ed1_id='${t_notice['ed1_id']}'";
	$requete .= ", ed2_id='${t_notice['ed2_id']}'";
	$requete .= ", coll_id='${t_notice['coll_id']}'";
	$requete .= ", subcoll_id='${t_notice['subcoll_id']}'";
	$requete .= ", year='${t_notice['year']}'";
	$requete .= ", nocoll='${t_notice['nocoll']}'";
	$requete .= ", mention_edition='${t_notice['mention_edition']}'";
	$requete .= ", code='${t_notice['code']}'";
	$requete .= ", npages='${t_notice['npages']}'";
	$requete .= ", ill='${t_notice['ill']}'";
	$requete .= ", size='${t_notice['size']}'";
	$requete .= ", prix='${t_notice['prix']}'";
	$requete .= ", accomp='${t_notice['accomp']}'";
	$requete .= ", n_gen='${t_notice['n_gen']}'";
	$requete .= ", n_contenu='${t_notice['n_contenu']}'";
	$requete .= ", n_resume='$t_notice[n_resume]'";
	$requete .= ", indexint='${t_notice['indexint']}'";
	$requete .= ", index_l='${f_indexation}'";
	$requete .= ", lien='${t_notice['lien']}'";
	$requete .= ", eformat='${t_notice['eformat']}'";
	$requete .= ", index_serie='$index_serie'";
	$requete .= ", index_sew=' $ind_sew '";
	$requete .= ", index_wew='$ind_wew'";
	$requete .= ", index_matieres='$ind_libre'";
	$requete .= ", niveau_biblio='${t_notice['b_level']}'";
	$requete .= ", niveau_hierar='${t_notice['h_level']}'";
	$requete .= ", index_n_gen='$index_n_gen'";
	$requete .= ", index_n_contenu='$index_n_contenu'";
	$requete .= ", index_n_resume='$index_n_resume'";
	$requete .= ", statut='${t_notice['statut']}'";
	$requete .= ", commentaire_gestion='${t_notice['commentaire_gestion']}'";
	
	$requete .= $postrequete;

	$result = mysql_query($requete, $dbh);
	if (!$id) {
		$id=mysql_insert_id($dbh);
		audit::insert_creation (1, $id) ;
		} else audit::insert_modif (1, $id) ;
	
	// traitement des auteurs
	$rqt_del = "delete from responsability where responsability_notice='$id' ";
	$res_del = mysql_query($rqt_del, $dbh);
	$rqt_ins = "insert into responsability (responsability_author, responsability_notice, responsability_fonction, responsability_type) VALUES ";
	$i=0;
	while ($i<=count ($f_aut)-1) {
		$id_aut=$f_aut[$i]['id'];
		if ($id_aut) {
			$fonc_aut=$f_aut[$i]['fonction'];
			$type_aut=$f_aut[$i]['type'];
			$rqt = $rqt_ins . " ('$id_aut','$id','$fonc_aut','$type_aut') " ; 
			$res_ins = @mysql_query($rqt, $dbh);
		}
		$i++;
	}
		
	// traitement des categories
	$rqt_del = "delete from notices_categories where notcateg_notice='$id' ";
	$res_del = mysql_query($rqt_del, $dbh);
	$rqt_ins = "insert into notices_categories (notcateg_notice, num_noeud) VALUES ";
	while (list ($key, $val) = each ($f_categ)) {
		$id_categ=$val['id'];
		if ($id_categ) {
			$rqt = $rqt_ins . " ('$id','$id_categ') " ; 
			$res_ins = @mysql_query($rqt, $dbh);
			}
		}
	// traitement des langues
	// langues
	$f_lang_form = array();
	$f_langorg_form = array() ;
	for ($i=0; $i< $max_lang ; $i++) {
		$var_langcode = "f_lang_code$i" ;
		if ($$var_langcode) $f_lang_form[] =  array ('code' => $$var_langcode);
		}

	// langues originales
	for ($i=0; $i< $max_langorg ; $i++) {
		$var_langorgcode = "f_langorg_code$i" ;
		if ($$var_langorgcode) $f_langorg_form[] =  array ('code' => $$var_langorgcode);
		}

	$rqt_del = "delete from notices_langues where num_notice='$id' ";
	$res_del = mysql_query($rqt_del, $dbh);
	$rqt_ins = "insert into notices_langues (num_notice, type_langue, code_langue) VALUES ";
	while (list ($key, $val) = each ($f_lang_form)) {
		$tmpcode_langue=$val['code'];
		if ($tmpcode_langue) {
			$rqt = $rqt_ins . " ('$id',0, '$tmpcode_langue') " ; 
			$res_ins = mysql_query($rqt, $dbh);
			}
		}
	
	// traitement des langues originales
	$rqt_ins = "insert into notices_langues (num_notice, type_langue, code_langue) VALUES ";
	while (list ($key, $val) = each ($f_langorg_form)) {
		$tmpcode_langue=$val['code'];
		if ($tmpcode_langue) {
			$rqt = $rqt_ins . " ('$id',1, '$tmpcode_langue') " ; 
			$res_ins = @mysql_query($rqt, $dbh);
			}
		}
	
	
	//Traitement des champs personnaliss
	$p_perso->rec_fields_perso($id);
	
	if($result) {
		
	} else {
		// chec de la requte
		error_message($libelle, $msg[281], 1, "./acquisition.php?categ=sug&action=modif&id_bibli=0&id_sug=".$id_sug);
	}

	// Mise  jour de la table notices_global_index
	notice::majNoticesGlobalIndex($id);
	// Mise  jour de la table notices_mots_global_index
	notice::majNoticesMotsGlobalIndex($id);
	
	//Mise  jour de la suggestion
	$sug = new suggestions($id_sug);
	$sug->titre = stripslashes($t_notice['tit1']);
	$f_aut[] = array (
			'id' => $f_aut0_id,
			'fonction' => $f_f0_code,
			'type' => '0' );
	if ($f_aut0_id) {
		$auteur = new auteur($f_aut0_id);
		$sug->auteur = $auteur->display;		
	}
	if ($f_ed1_id)	$sug->editeur = stripslashes($f_ed1); 
	$sug->code = $t_notice['code'];
	$sug->prix = $t_notice['prix'];
	$sug->num_notice = $id;
	$sug->save(); 
	
	
} else {
	if ($f_tit1=="") {
		// erreur : le champ tit1 est vide
		error_message($libelle, $notitle_message, 1, "./acquisition.php?categ=sug&action=modif&id_bibli=0&id_sug=".$id_sug);
	} else {
		error_message_history($msg["notice_champs_perso"],$p_perso->error_message,1);
	}
}
