<?php
// +-------------------------------------------------+
//  2002-2004 PMB Services / www.sigb.net pmb@sigb.net et contributeurs (voir www.sigb.net)
// +-------------------------------------------------+
// $Id: iimport_expl.php,v 1.42 2007/10/26 10:26:44 gueluneau Exp $

// dfinition du minimum ncssaire
$base_path="../..";
$base_auth = "ADMINISTRATION_AUTH";
$base_title = "";
require_once ("$base_path/includes/init.inc.php");

// les requis par iimport_expl.php ou ses sous modules
require_once ("$include_path/isbn.inc.php");
require_once ("$include_path/marc_tables/$lang/empty_words");
require_once ("$class_path/iso2709.class.php");
require_once ("$class_path/author.class.php");
require_once ("$class_path/serie.class.php");
require_once ("$class_path/editor.class.php");
require_once ("$class_path/collection.class.php");
require_once ("$class_path/subcollection.class.php");
require_once ("$class_path/expl.class.php");
require_once ("$class_path/lender.class.php");
require_once ("$class_path/docs_type.class.php");
require_once ("$class_path/docs_section.class.php");
require_once ("$class_path/docs_statut.class.php");
require_once ("$class_path/docs_location.class.php");
require_once ("$class_path/docs_codestat.class.php");
require_once ("$class_path/indexint.class.php");
require_once ("$class_path/origine_notice.class.php");
require_once ("$class_path/marc_table.class.php");
require_once ("$class_path/lender.class.php");
require_once ("$class_path/notice.class.php");

require_once("import_func.inc.php");
if (!$pmb_import_modele) require_once("func_bdp.inc.php");
    else require_once($pmb_import_modele);

print "<div id='contenu-frame'>" ;

$nom_fichier_transfert_ftp = "unimarc".(defined("LOCATION")?"_".constant("LOCATION"):"").".fic";

$userfile_name = $_FILES['userfile']['name'] ;


//-------------------------------------> L L I U R E X <--------------------------------------
//cambiamos la ruta para que escriba en el temporal
if ((stripos($userfile_name, "/temp/"))===false){
$userfile_name=$base_path."/temp/".$userfile_name;
}
//-------------------------------------> L L I U R E X <--------------------------------------



$userfile = $_FILES['userfile']['tmp_name'] ;


/* this script does nearly the same thing that import.inc does,
   the difference is between the loading of the exemplaires table.
   Every record in the ISO2709 file will be treated as a copy, that means
   the memoir will be created if necessary (including editors, authors and collections),
   the specific doc type will be created and finally the copy will be created */


if ($sub == "import_expl") {
    echo window_title($msg[520].$msg[1003].$msg[1001]);
    /* the name of the lender is read in the table */
    if ($book_lender_id!="") {
        $sql_rech="select lender_libelle from lenders where idlender = '".$book_lender_id."' ";
        $sql_result_rech = mysql_query($sql_rech) or die ("Couldn't select lenders ! = ".$sql_rech);
        if (mysql_num_rows($sql_result_rech)==0) {
            $book_lender_name = $msg[561];
            } else {
                $book_lender_name = mysql_result ($sql_result_rech,0,"lender_libelle");
                }
        } else {
            $book_lender_name = $msg[561];
            }
//-------------------------------------> L L I U R E X <--------------------------------------
    } else if ($sub == "import_reb"){
        echo window_title($msg["import_reb"].$msg[1003].$msg[1001]);
//-------------------------------------> L L I U R E X <--------------------------------------
        } else {
        	echo window_title($msg[500].$msg[1003].$msg[1001]);
		}

switch ($action) {
    case 'beforeupload':
        if ($sub == "import_expl") {
            $book_lender_id = "";
            $book_statut_id = "";
            print $tpl_beforeupload_expl ;
//-------------------------------------> L L I U R E X <--------------------------------------
            } else if ($sub == "import_reb") {
             	   print $tpl_beforeupload_reb ;
//-------------------------------------> L L I U R E X <--------------------------------------
		} else {
              	  // import de notice
             	   print $tpl_beforeupload_notices ;
             	   }
        break;
    case 'afterupload':
    	if (!$statutnot) $statutnot = 1 ;
        if ($sub == "import_expl") {
            if ($book_lender_id==0 || $book_lender_id=="") {
                print $msg[561];
                break;
                }
            if ($book_statut_id==0 || $book_statut_id=="") {
                print $msg[561];
                break;
                }
            if ($userfile_name=="") {
                printf ($msg[503],$userfile_name); /* wrong permissions to copy the file %s ... Contact your admin... */
                break;
                }
            //if (!is_writeable($userfile)) {
            //    printf ($msg[503],$userfile_name); /* wrong permissions to copy the file %s ... Contact your admin... */
            //    break;
            //    }	
		
            if (!move_uploaded_file($userfile,$userfile_name)) {
                printf ($msg[504],$userfile_name); /* Fail to copy %s, Contact your admin... */
                } else {
                    printf ($msg[505],$userfile_name); /* File transfered, Loading is about to go on */
                    print "<form class='form-$current_module' NAME=\"afterupload\" METHOD=\"post\" ACTION=\"iimport_expl.php\">";
                    print "<INPUT NAME=\"categ\" TYPE=\"hidden\" value=\"import\">";
                    print "<INPUT NAME=\"sub\" TYPE=\"hidden\" value=\"import_expl\">";
                    print "<INPUT NAME=\"action\" TYPE=\"hidden\" value=\"preload\">";
                    print "<INPUT NAME=\"book_lender_id\" TYPE=\"hidden\" value=\"".$book_lender_id."\">";
                    print "<INPUT NAME=\"book_statut_id\" TYPE=\"hidden\" value=\"".$book_statut_id."\">";
                    print "<input type=\"hidden\" name=\"file_submit\" value=\"$userfile_name\">";
                    print "<INPUT TYPE=\"hidden\" NAME=\"isbn_mandatory\" VALUE=\"$isbn_mandatory\">\n";
                    print "<INPUT TYPE=\"hidden\" NAME=\"isbn_only\" VALUE=\"$isbn_only\">\n";
                    print "<INPUT TYPE=\"hidden\" NAME=\"isbn_dedoublonnage\" VALUE=\"$isbn_dedoublonnage\">\n";
                    print "<INPUT TYPE=\"hidden\" NAME=\"cote_mandatory\" VALUE=\"$cote_mandatory\">\n";
                    print "<INPUT TYPE=\"hidden\" NAME=\"tdoc_codage\" VALUE=\"$tdoc_codage\">\n";
                    print "<INPUT TYPE=\"hidden\" NAME=\"statisdoc_codage\" VALUE=\"$statisdoc_codage\">\n";
                    print "<INPUT TYPE=\"hidden\" NAME=\"sdoc_codage\" VALUE=\"$sdoc_codage\">\n";
                    print "<INPUT TYPE=\"hidden\" NAME=\"statutnot\" VALUE=\"$statutnot\">\n";
                    print "<INPUT TYPE=\"hidden\" NAME=\"book_location_id\" VALUE=\"$book_location_id\">\n";
                    print "<INPUT TYPE=\"hidden\" NAME=\"que_faire\" VALUE=\"$que_faire\">\n";
                    print "</FORM>";
		    print "<SCRIPT>setTimeout(\"document.afterupload.submit()\",2000);</SCRIPT>";
			
                    }
//-------------------------------------> L L I U R E X <--------------------------------------
            } else if ($sub == "import_reb") {

		// import de rebeca
		       if ($userfile_name=="") {
		           printf ($msg[503],$userfile_name); /* wrong permissions to copy the file %s ... Contact your admin... */
		           break;
		           }

			if (strrpos(strtolower($userfile_name), ".reb") === false) {
				printf ($msg['import_reb_fail_reb'],$userfile_name); /* wrong rebeca file %s ... Contact your admin... */
		          	break;
			}

		       if (!move_uploaded_file($userfile,$userfile_name)) {
		           printf ($msg[504],$userfile_name); /* Fail to copy %s, Contact your admin... */
		            } else {
		              printf ($msg[505],$userfile_name); /* File transfered, Loading is about to go on */
		               print "<form class='form-$current_module' NAME=\"afterupload\" METHOD=\"post\" ACTION=\"iimport_expl.php\">";
		               print "<INPUT NAME=\"categ\" TYPE=\"hidden\" value=\"import\">";
		               print "<INPUT NAME=\"sub\" TYPE=\"hidden\" value=\"import_reb\">";
		               print "<INPUT NAME=\"action\" TYPE=\"hidden\" value=\"preload\">";
		               print "<input type=\"hidden\" name=\"file_submit\" value=\"$userfile_name\">";
		               print "</FORM>";
		               print "<SCRIPT>setTimeout(\"document.afterupload.submit()\",2000);</SCRIPT>";
			}
//-------------------------------------> L L I U R E X <--------------------------------------
		} else {
		        // import de notice
		        if ($userfile_name=="") {
		            printf ($msg[503],$userfile_name); /* wrong permissions to copy the file %s ... Contact your admin... */
		            break;
		            }
		        //if (!is_writeable($userfile)) {
		        //    printf ($msg[503],$userfile_name); /* wrong permissions to copy the file %s ... Contact your admin... */
		        //    break;
		        //    }
		        if (!move_uploaded_file($userfile,$userfile_name)) {
		            printf ($msg[504],$userfile_name); /* Fail to copy %s, Contact your admin... */
		            } else {
		                printf ($msg[505],$userfile_name); /* File transfered, Loading is about to go on */
		                print "<form class='form-$current_module' NAME=\"afterupload\" METHOD=\"post\" ACTION=\"iimport_expl.php\">";
		                print "<INPUT NAME=\"categ\" TYPE=\"hidden\" value=\"import\">";
		                print "<INPUT NAME=\"sub\" TYPE=\"hidden\" value=\"import\">";
		                print "<INPUT NAME=\"action\" TYPE=\"hidden\" value=\"preload\">";
		                print "<input type=\"hidden\" name=\"file_submit\" value=\"$userfile_name\">";
		                print "<INPUT TYPE=\"hidden\" NAME=\"isbn_mandatory\" VALUE=\"$isbn_mandatory\">\n";
		                print "<INPUT TYPE=\"hidden\" NAME=\"isbn_dedoublonnage\" VALUE=\"$isbn_dedoublonnage\">\n";
		                print "<INPUT TYPE=\"hidden\" NAME=\"isbn_only\" VALUE=\"$isbn_only\">\n";
		                print "<INPUT TYPE=\"hidden\" NAME=\"statutnot\" VALUE=\"$statutnot\">\n";
		                print "</FORM>";
		                print "<SCRIPT>setTimeout(\"document.afterupload.submit()\",2000);</SCRIPT>";
				}
		        }
        break;
    case 'preload':
        if ($sub == "import_expl") {
            /* Does the file exist ? */
            if ($file_submit=="") {
                /* l'utilisateur n'est pas pass par le tlchargement du fichier */

//-------------------------------------> L L I U R E X <--------------------------------------
//el fichero se encuentra en el temporal, lo referenciamos.
           $filename = "$base_path/temp/unimarc".(defined("LOCATION")?"_".constant("LOCATION"):"").".fic";
//         $filename = "$base_path/temp/unimarc_pmb.fic";
//-------------------------------------> L L I U R E X <--------------------------------------
                } else {
                    $filename=$file_submit;
                    }
            if ($book_lender_id=="" || $book_statut_id=="" || $isbn_mandatory=="" || $cote_mandatory=="" || $book_location_id=="" || $statutnot=="") {
                /* l'utilisateur n'est pas pass par le tlchargement du fichier, il faut qu'il choisisse un prteur s'il n'en a pas communiqu auparavant */
                print "
                    <form class='form-$current_module' NAME=\"preload\" METHOD=\"post\" ACTION=\"iimport_expl.php\">
                        <h3>".$msg['import_expl_form_titre']."</h3>
                        <div class='form-contenu'>
                    	<div class='row'>
                        <div class='colonne2'>
                            <label class='etiquette' for='isbn_obligatoire'>$msg[564]</label><br>
                            <INPUT TYPE='radio' NAME='isbn_mandatory' id='io1' VALUE='1' CLASS='radio' /><label for='io1'> $msg[40] </label>
                            <INPUT TYPE='radio' NAME='isbn_mandatory' id='io0' VALUE='0' CLASS='radio' checked /><label for='io0'> $msg[39] </label>
                            </div>
                        <div class='colonne-suite'>
                            <label class='etiquette' for='isbn_dedoublonnage'>$msg[568]</label><br>
                            <INPUT TYPE='radio' NAME='isbn_dedoublonnage' id='di1' VALUE='1' CLASS='radio' checked /><label for='di1'> $msg[40] </label>
                            <INPUT TYPE='radio' NAME='isbn_dedoublonnage' id='di0' VALUE='0' CLASS='radio' /><label for='di0'> $msg[39] </label>
                            <input type='checkbox' name='isbn_only' id='ionly' value='1'/><label for='ionly'> ".$msg["ignore_issn"]." </label>
                            </div>
                        </div>
                        <div class='row'>&nbsp;</div>
                        <div class='row'>
        	                <label class='etiquette' for='statutnot'>$msg[import_statutnot]</label>
            	            </div>
	                    <div class='row'>".
    	                    gen_liste_multiple ("select id_notice_statut, gestion_libelle from notice_statut order by 2", "id_notice_statut", "gestion_libelle", "id_notice_statut", "statutnot", "", 1, "", "","","",0)."
                        	</div>
                        <div class='row'><hr /></div>
                    	<div class='row'>
                            <label class='etiquette' for='prteur statut'>$msg[560]</label>
                            </div>
                        <div class='row'>".
                            lender::gen_combo_box($book_lender_id)."&nbsp;&nbsp;".
                            docs_statut::gen_combo_box($book_statut_id)."
                            </div>
	                    <div class='row'>
    	                    <label class='etiquette' for='localisation'>$msg[import_localisation]</label>
        	                </div>
            	        <div class='row'>".
                	        docs_location::gen_combo_box($deflt_docs_location)."
                    	    </div>
                        <div class='row'><hr /></div>
                    	<div class='row'>
                            <label class='etiquette' for='cote_obligatoire'>$msg[566]</label>
                            </div>
                        <div class='row'>
                            <INPUT TYPE='radio' NAME='cote_mandatory' VALUE='1' CLASS='radio' /> $msg[40]
                            <INPUT TYPE='radio' NAME='cote_mandatory' VALUE='0' CLASS='radio' checked/> $msg[39]
                            </div>
                        <div class='row'><hr /></div>
                        <div class='row'>
                            <label class='etiquette'>$msg[17]</label>
                            </div>
                        <div class='row'>
                            <INPUT TYPE='radio' NAME='tdoc_codage' VALUE='1' CLASS='radio' /> ".$msg["import_expl_codage_proprio"]."
                            <INPUT TYPE='radio' NAME='tdoc_codage' VALUE='0' CLASS='radio' checked/> ".$msg["import_expl_codage_generique"]."
                            </div>
                        <div class='row'>
                            <label class='etiquette'>$msg[24]</label>
                            </div>
                        <div class='row'>
                            <INPUT TYPE='radio' NAME='statisdoc_codage' VALUE='1' CLASS='radio' /> ".$msg["import_expl_codage_proprio"]."
                            <INPUT TYPE='radio' NAME='statisdoc_codage' VALUE='0' CLASS='radio' checked/> ".$msg["import_expl_codage_generique"]."
                            </div>
                        <div class='row'>
                            <label class='etiquette'>$msg[19]</label>
                            </div>
                        <div class='row'>
                            <INPUT TYPE='radio' NAME='sdoc_codage' VALUE='1' CLASS='radio' /> ".$msg["import_expl_codage_proprio"]."
                            <INPUT TYPE='radio' NAME='sdoc_codage' VALUE='0' CLASS='radio' checked/> ".$msg["import_expl_codage_generique"]."
                            </div>
                        <div class='row'>
                            <label class='etiquette'>$msg[21]</label>
                            </div>
                        </div>
                    <INPUT TYPE=\"SUBMIT\"  class='bouton' NAME=\"upload\" VALUE=\"".$msg[502]."\">
                    <INPUT NAME=\"categ\" TYPE=\"hidden\" value=\"import\">
                    <INPUT NAME=\"sub\" TYPE=\"hidden\" value=\"import_expl\">
                    <INPUT NAME=\"action\" TYPE=\"hidden\" value=\"preload\">
                    </FORM>";
                break;
                }
		loadfile_in_table() ;
            if ($pb_fini=="EOF") {
                $formulaire="<form class='form-$current_module' name=\"load\" method=\"post\" action=\"iimport_expl.php\">";
                $formulaire.="<INPUT NAME=\"categ\" TYPE=\"hidden\" value=\"import\">";
                $formulaire.="<INPUT NAME=\"sub\" TYPE=\"hidden\" value=\"import_expl\">";
                $formulaire.="<INPUT NAME=\"action\" TYPE=\"hidden\" value=\"load\">";
                $formulaire.="<INPUT NAME=\"book_lender_id\" TYPE=\"hidden\" value=\"".$book_lender_id."\">";
                $formulaire.="<INPUT NAME=\"book_statut_id\" TYPE=\"hidden\" value=\"".$book_statut_id."\">";
                $formulaire.="<input type=\"hidden\" name=\"filename\" value=\"$filename\">";
                $formulaire.="<INPUT TYPE=\"hidden\" NAME=\"isbn_mandatory\" VALUE=\"$isbn_mandatory\">\n";
                $formulaire.="<INPUT TYPE=\"hidden\" NAME=\"isbn_dedoublonnage\" VALUE=\"$isbn_dedoublonnage\">\n";
                $formulaire.="<INPUT TYPE=\"hidden\" NAME=\"isbn_only\" VALUE=\"$isbn_only\">\n";
                $formulaire.="<INPUT TYPE=\"hidden\" NAME=\"cote_mandatory\" VALUE=\"$cote_mandatory\">\n";
                $formulaire.="<INPUT TYPE=\"hidden\" NAME=\"tdoc_codage\" VALUE=\"$tdoc_codage\">\n";
                $formulaire.="<INPUT TYPE=\"hidden\" NAME=\"statisdoc_codage\" VALUE=\"$statisdoc_codage\">\n";
                $formulaire.="<INPUT TYPE=\"hidden\" NAME=\"sdoc_codage\" VALUE=\"$sdoc_codage\">\n";
                $formulaire.="<INPUT TYPE=\"hidden\" NAME=\"statutnot\" VALUE=\"$statutnot\">\n";
                $formulaire.="<INPUT TYPE=\"hidden\" NAME=\"book_location_id\" VALUE=\"$book_location_id\">\n";
                $formulaire.="<input type=\"hidden\" name=\"recharge\" value=\"YES\">";
                $formulaire.="<INPUT TYPE=\"hidden\" NAME=\"que_faire\" VALUE=\"$que_faire\">\n";
                $formulaire.="</form>";
                printf ($msg[512], $filename); /* File %s... . End of preload... */
                $script = "<script>setTimeout(\"document.load.submit()\",2000);</script>";
                } else {
                    $formulaire="<form class='form-$current_module' name=\"preload\" method=\"post\" action=\"iimport_expl.php\">";
                    $formulaire.="<INPUT NAME=\"categ\" TYPE=\"hidden\" value=\"import\">";
                    $formulaire.="<INPUT NAME=\"sub\" TYPE=\"hidden\" value=\"import_expl\">";
                    $formulaire.="<INPUT NAME=\"action\" TYPE=\"hidden\" value=\"preload\">";
                    $formulaire.="<INPUT NAME=\"book_lender_id\" TYPE=\"hidden\" value=\"".$book_lender_id."\">";
                    $formulaire.="<INPUT NAME=\"book_statut_id\" TYPE=\"hidden\" value=\"".$book_statut_id."\">";
                    $formulaire.="<input type=\"hidden\" name=\"recharge\" value=\"$recharge\">";
                    $formulaire.="<input type=\"hidden\" name=\"file_submit\" value=\"$filename\">";
                    $formulaire.="<INPUT TYPE=\"hidden\" NAME=\"isbn_mandatory\" VALUE=\"$isbn_mandatory\">\n";
                    $formulaire.="<INPUT TYPE=\"hidden\" NAME=\"isbn_dedoublonnage\" VALUE=\"$isbn_dedoublonnage\">\n";
                    $formulaire.="<INPUT TYPE=\"hidden\" NAME=\"isbn_only\" VALUE=\"$isbn_only\">\n";
                    $formulaire.="<INPUT TYPE=\"hidden\" NAME=\"cote_mandatory\" VALUE=\"$cote_mandatory\">\n";
                    $formulaire.="<INPUT TYPE=\"hidden\" NAME=\"tdoc_codage\" VALUE=\"$tdoc_codage\">\n";
                    $formulaire.="<INPUT TYPE=\"hidden\" NAME=\"statisdoc_codage\" VALUE=\"$statisdoc_codage\">\n";
                    $formulaire.="<INPUT TYPE=\"hidden\" NAME=\"sdoc_codage\" VALUE=\"$sdoc_codage\">\n";
                    $formulaire.="<INPUT TYPE=\"hidden\" NAME=\"statutnot\" VALUE=\"$statutnot\">\n";
                    $formulaire.="<INPUT TYPE=\"hidden\" NAME=\"book_location_id\" VALUE=\"$book_location_id\">\n";
                    $formulaire.="<input type=\"hidden\" name=\"noticenumber\" value=\"".($noticenumber+$j)."\">";
                    $formulaire.="<INPUT TYPE=\"hidden\" NAME=\"que_faire\" VALUE=\"$que_faire\">\n";
                    $formulaire.="</form>";
                    $script = "<script>setTimeout(\"document.preload.submit()\",2000);</script>";
                    }
            print $formulaire;
            print $script;
//-------------------------------------> L L I U R E X <--------------------------------------
		} else if ($sub == "import_reb") {

      		// import de notice
                /* Does the file exist ? */
                if ($file_submit=="") $filename = "unimarc".(defined("LOCATION")?"_".constant("LOCATION"):"").".fic"; else $filename=$file_submit;

		if ($noticenumber=="") $noticenumber=0;
	
		if (!file_exists($filename)) {
			printf ($msg[506],$filename); /* The file %s doesn't exist... */
			return;
			}
	
		if (filesize($filename)==0) {
			printf ($msg[507],$filename); /* The file % is empty, it's going to be deleted */
			unlink ($filename);
			return;
			}
	
		$handle = fopen ($filename, "rb");
		if (!$handle) {
			printf ($msg[508],$filename); /* Unable to open the file %s ... */
			return;
			}
		
		exec("yaz-marcdump -o marc -s ".$base_path."/temp/rebdump ".$filename." >/dev/null", $output, $return_var);
    		if ($return_var) {
			printf ($msg['import_reb_fail_dump'],$filename); /* dump failed */
			unlink ($filename);
			return;
			}
		
                $formulaire="<form class='form-$current_module' name=\"load\" method=\"post\" action=\"iimport_expl.php\">";
                $formulaire.="<INPUT NAME=\"categ\" TYPE=\"hidden\" value=\"import\">";
                $formulaire.="<INPUT NAME=\"sub\" TYPE=\"hidden\" value=\"import_reb\">";
                $formulaire.="<INPUT NAME=\"action\" TYPE=\"hidden\" value=\"load\">";
                $formulaire.="<input type=\"hidden\" name=\"filename\" value=\"$filename\">";
                $formulaire.="</form>";
                printf ($msg[509].$msg[512], $filename, $filename); /* File %s... . End of preload... */
                $script = "<script>setTimeout(\"document.load.submit()\",2000);</script>";
                   
                print $formulaire;
                print $script;
//-------------------------------------> L L I U R E X <--------------------------------------

		} else {
                // import de notice
                /* Does the file exist ? */
                if ($file_submit=="") $filename = "unimarc".(defined("LOCATION")?"_".constant("LOCATION"):"").".fic"; else $filename=$file_submit;

                if ($isbn_mandatory=="") {
                    /* l'utilisateur n'est pas pass par le tlchargement du fichier, il faut qu'il nous dise si l'ISBN est obligatoire */
                    print "
                        <form class='form-$current_module' NAME=\"preload\" METHOD=\"post\" ACTION=\"iimport_expl.php\">
                        <h3>".$msg['import_noti_form_titre']."</h3>
                        <div class='form-contenu'>
                    	<div class='row'>
                    	    <div class='colonne2'>
                	            <label class='etiquette' for='isbn_obligatoire'>$msg[564]</label><br>
            	                <INPUT TYPE='radio' NAME='isbn_mandatory' id='io1' VALUE='1' CLASS='radio' /><label for='io1'> $msg[40] </label>
        	                    <INPUT TYPE='radio' NAME='isbn_mandatory' id='io0' VALUE='0' CLASS='radio' checked /><label for='io0'> $msg[39] </label>
    	                        </div>
	                        <div class='colonne-suite'>
                        	    <label class='etiquette' for='isbn_dedoublonnage'>$msg[568]</label><br>
                    	        <INPUT TYPE='radio' NAME='isbn_dedoublonnage' id='di1' VALUE='1' CLASS='radio' checked /><label for='di1'> $msg[40] </label>
                	            <INPUT TYPE='radio' NAME='isbn_dedoublonnage' id='di0' VALUE='0' CLASS='radio' /><label for='di0'> $msg[39] </label>
            	                <input type='checkbox' name='isbn_only' id='ionly' value='1'/><label for='ionly'> ".$msg["ignore_issn"]." </label>
        	                    </div>
    	                    </div>
						<div class='row'>&nbsp;</div>
                        <div class='row'>
        	                <label class='etiquette' for='statutnot'>$msg[import_statutnot]</label>
            	            </div>
		                <div class='row'>".
    		                gen_liste_multiple ("select id_notice_statut, gestion_libelle from notice_statut order by 2", "id_notice_statut", "gestion_libelle", "id_notice_statut", "statutnot", "", 1, "", "","","",0)."
            	        	</div>
                        </div>
                        <INPUT TYPE=\"SUBMIT\"  class='bouton' NAME=\"upload\" VALUE=\"".$msg[502]."\">
                        <INPUT NAME=\"categ\" TYPE=\"hidden\" value=\"import\">
                        <INPUT NAME=\"sub\" TYPE=\"hidden\" value=\"import\">
                        <INPUT NAME=\"action\" TYPE=\"hidden\" value=\"preload\">
                        </FORM>";
                    break;
                    }
                loadfile_in_table() ;
                if ($pb_fini=="EOF") {
                    $formulaire="<form class='form-$current_module' name=\"load\" method=\"post\" action=\"iimport_expl.php\">";
                    $formulaire.="<INPUT NAME=\"categ\" TYPE=\"hidden\" value=\"import\">";
                    $formulaire.="<INPUT NAME=\"sub\" TYPE=\"hidden\" value=\"import\">";
                    $formulaire.="<INPUT NAME=\"action\" TYPE=\"hidden\" value=\"load\">";
                    $formulaire.="<input type=\"hidden\" name=\"filename\" value=\"$filename\">";
                    $formulaire.="<INPUT TYPE=\"hidden\" NAME=\"isbn_mandatory\" VALUE=\"$isbn_mandatory\">\n";
                    $formulaire.="<INPUT TYPE=\"hidden\" NAME=\"isbn_dedoublonnage\" VALUE=\"$isbn_dedoublonnage\">\n";
                    $formulaire.="<INPUT TYPE=\"hidden\" NAME=\"isbn_only\" VALUE=\"$isbn_only\">\n";
                    $formulaire.="<INPUT TYPE=\"hidden\" NAME=\"statutnot\" VALUE=\"$statutnot\">\n";
                    $formulaire.="<input type=\"hidden\" name=\"recharge\" value=\"YES\">";
                    $formulaire.="</form>";
                    printf ($msg[509].$msg[512], $filename, $filename); /* File %s... . End of preload... */
                    $script = "<script>setTimeout(\"document.load.submit()\",2000);</script>";
                    } else {
                        $formulaire="<form class='form-$current_module' name=\"preload\" method=\"post\" action=\"iimport_expl.php\">";
                        $formulaire.="<INPUT NAME=\"categ\" TYPE=\"hidden\" value=\"import\">";
                        $formulaire.="<INPUT NAME=\"sub\" TYPE=\"hidden\" value=\"import\">";
                        $formulaire.="<INPUT NAME=\"action\" TYPE=\"hidden\" value=\"preload\">";
                        $formulaire.="<input type=\"hidden\" name=\"recharge\" value=\"$recharge\">";
                        $formulaire.="<input type=\"hidden\" name=\"file_submit\" value=\"$filename\">";
                        $formulaire.="<INPUT TYPE=\"hidden\" NAME=\"isbn_mandatory\" VALUE=\"$isbn_mandatory\">\n";
                        $formulaire.="<INPUT TYPE=\"hidden\" NAME=\"isbn_dedoublonnage\" VALUE=\"$isbn_dedoublonnage\">\n";
                        $formulaire.="<INPUT TYPE=\"hidden\" NAME=\"isbn_only\" VALUE=\"$isbn_only\">\n";
                        $formulaire.="<INPUT TYPE=\"hidden\" NAME=\"statutnot\" VALUE=\"$statutnot\">\n";
                        $formulaire.="<input type=\"hidden\" name=\"noticenumber\" value=\"".($noticenumber+$j)."\">";
                        $formulaire.="</form>";
                        $script = "<script>setTimeout(\"document.preload.submit()\",2000);</script>";
                        }
                print $formulaire;
                print $script;
                }
        break;
    case 'load':
//-------------------------------------> L L I U R E X <--------------------------------------
	if ($sub == "import_reb") {
		include("$class_path/audit.class.php");
		require ($base_path."/catalog/z3950/notice.inc.php");
		include("$include_path/templates/expl.tpl.php");
		include ("$class_path/z3950_notice.class.php");
		require_once($base_path."/catalog/z3950/func_other.inc.php");

		$integration_OK=0;
		$integration_UP=0;


		
		$dirrec=scandir($base_path."/temp/");
		foreach($dirrec as $file) {
			if ( (strpos($file, "rebdump")) !== false ) {
				$fp = fopen ($base_path."/temp/".$file,"r");
				$buffer="";
				while (!feof($fp)) {
                                	$buffer.= fread($fp, 4096);
                                }
				fclose($fp);
				unlink($base_path."/temp/".$file);

				$notice = new z3950_notice ("usmarc", $buffer);
				$res_integration = $notice->insert_in_database($show=false);
				$new_notice=$res_integration[0];
				$num_notice=$res_integration[1];
				//if (($new_notice==0) && ($num_notice==0)) $integration_OK="ECHEC"; 
				//if (($new_notice==0) && ($num_notice!=0)) $integration_OK="EXISTAIT"; 
				if (($new_notice==1) && ($num_notice!=0)) $integration_OK++; 
				if (($new_notice==2) && ($num_notice!=0)) $integration_UP++; 
				//if (($new_notice==1) && ($num_notice==0)) $integration_OK="NEWRATEE"; 

			}
		}
		unlink($filename);

		printf ($msg['import_reb_ok'], $integration_OK);
		printf ($msg['import_reb_up'], $integration_UP);

		return;
	}
//-------------------------------------> L L I U R E X <--------------------------------------

    	if (!$statutnot) $statutnot=1;
    	printf ($msg[509], $filename) ;
        if ($nbtot_notice=="") {
            $sql = "select count(1) from import_marc";
            $sql_result = mysql_query($sql) or die ("Couldn't select count(1) from import table !");
            $nbtot_notice=mysql_result($sql_result, 0, 0);
            }
        if ($sub == "import_expl") {
            $section_995_=new marc_list("section_995");
            $section_995=$section_995_->table;
            $typdoc_995_=new marc_list("typdoc_995");
            $typdoc_995=$typdoc_995_->table;
            $codstatdoc_995_=new marc_list("codstatdoc_995");
            $codstatdoc_995=$codstatdoc_995_->table;
            /* let's initialize the counters if necessary */
            if ($nb_expl_ignores == "") $nb_expl_ignores=0;
            printf ($msg[511], "\"".$book_lender_name."\"") ;
            }

        $sql = "select notice, id_import from import_marc limit $pmb_import_limit_record_load ";
        $sql_result_import = mysql_query($sql) or die ("Couldn't select import table !");
        $n_notice=mysql_num_rows($sql_result_import);
        if ($notice_deja_presente=="") $notice_deja_presente=0;
        $inotice=0;
        $txt="";

        while ($notobj = mysql_fetch_object($sql_result_import)) {
            $notice=$notobj->notice ;
            $idnotice_import=$notobj->id_import ;
            $inotice++;

            $res_lecture = recup_noticeunimarc($notice) ;
            if (!$res_lecture || !$tit_200a[0]) {
                $res_lecture = 0;
                // ".$inotice."
                $fp = fopen ("../../temp/err_import.unimarc","a+");
                fwrite ($fp, $notice);
                fclose ($fp);
                $notice_rejetee++;
                }
            if ($res_lecture) {
                recup_noticeunimarc_suite($notice) ;

                /* We've got everything, let's have a look if ISBN already exists in notices table */
                $isbn_OK = "";
                if($isbn[0]=="NULL") $isbn[0]="";
                // si isbn vide, on va tenter de prendre l'EAN stock en 345$b
                if ($isbn[0]=="") $isbn[0]=$EAN[0] ;
                // si isbn vide, on va tenter de prendre le serial en 011
                if ($isbn[0]=="") $isbn[0]=$issn_011[0];
                // si ISBN obligatoire et isbn toujours vide :
                if ($isbn_mandatory == 1 && $isbn[0]=="") {
                    // on va tenter de prendre l'ISSN stock en 225$x
                    $isbn[0]=$collection_225[0]['x'] ;
                    // si isbn toujours vide, on va tenter de prendre l'ISSN stock en 410$x
                    if ($isbn[0]=="") $isbn[0]=$collection_410[0]['x'] ;
                    }

                if($isbn[0]) {
                    if(isEAN($isbn[0])) { /* it's an EAN -> convert it to ISBN */
                        $isbn_OK = EANtoISBN($isbn[0]);
                        if(!$isbn_OK) $isbn_OK = $isbn[0]; /* EAN to ISBN failed ... */
                        } else {
                            if(isISBN($isbn[0])) { /* it's an ISBN */
                                $isbn_OK = formatISBN($isbn[0],13);
                                if(!$isbn_OK) $isbn_OK = $isbn[0]; /* format isbn failed */
                                } else { /* everything failed, let's take what was in the field */
                                    $isbn_OK = $isbn[0];
                                    }
                            }
                    }
                $isbn_OK = clean_string($isbn_OK);
                $new_notice = 0;
                $notice_id = 0 ;

                if ((($isbn_dedoublonnage)&&(!$isbn_only))||(($isbn_dedoublonnage)&&($isbn_only)&&(isISBN($isbn_OK)))) {
                    // ddoublonnage sur isbn
                    $long_maxi = mysql_field_len(mysql_query("SELECT code FROM notices limit 1"),0);
                    $isbn_OK = rtrim(substr($isbn_OK,0,$long_maxi));
                    if ($isbn_OK!="") {
                        $sql_rech="select notice_id from notices where code = '".$isbn_OK."' ";
                        $sql_result_rech = mysql_query($sql_rech) or die ("Couldn't select notice ! = ".$sql_rech);
                        if (mysql_num_rows($sql_result_rech)==0) {
                            $new_notice=1;
                            } else {
                                $new_notice=0;
                                $notice_id = mysql_result ($sql_result_rech,0,"notice_id");
                                $sql_log = mysql_query("insert into error_log (error_origin, error_text) values ('import_expl.inc', '".$msg[542]." ".$isbn_OK." ".addslashes($tit[0]['a'])."') ") ;
                                }
                        } else {
                            if ($isbn_mandatory == 1) {
                                $sql_log = mysql_query("insert into error_log (error_origin, error_text) values ('import.inc', '".$msg[543]."') ") ;
                                } else {
                                    $new_notice = 1;
                                    $sql_log = mysql_query("insert into error_log (error_origin, error_text) values ('import.inc', '".$msg[565]."') ") ;
                                    }
                            }
                    } else {
                        // pas de ddoublonnage
                        if ($isbn_mandatory == 1 && $isbn_OK=="") {
                            $sql_log = mysql_query("insert into error_log (error_origin, error_text) values ('import.inc', '".$msg[543]."') ") ;
                            } else {
                                $new_notice = 1;
                                $sql_log = mysql_query("insert into error_log (error_origin, error_text) values ('import.inc', '".$msg[565]."') ") ;
                                }
                        }
                /* the notice is new, we are going to import it... */
                if ($new_notice==1) {
                    import_new_notice() ;
    				import_new_notice_suite() ;
    				// Mise  jour de la table "notices_global_index"
    				notice::majNoticesGlobalIndex($notice_id);
    				// Mise  jour de la table "notices_mots_global_index"
    				notice::majNoticesMotsGlobalIndex($notice_id);
                    } else $notice_deja_presente++;

                // TRAITEMENT DES EXEMPLAIRES ICI
                if ($sub == "import_expl") {
                    traite_exemplaires () ;
                    } // fin if $sub=import_expl
                }
            /* this has been succesfuly read, it can be deleted */
            $sql_del = "delete from import_marc where id_import = '".$idnotice_import."' ";
            $sql_result_del = mysql_query($sql_del) or die ("Couldn't delete import_marc $idnotice_import !");
            } /* end while records in import table */
        $sql = "select count(1) as reste from import_marc ";
        $sql_result = mysql_query($sql) or die ("Couldn't select count import table !");
        $reste=mysql_result($sql_result,0,"reste");

        if ($sub == "import_expl") {
            if ($reste > 0 ) {
                $formulaire="<form class='form-$current_module' name=\"load\" method=\"post\" action=\"iimport_expl.php\">\n";
                $formulaire.="<INPUT NAME=\"categ\" TYPE=\"hidden\" value=\"import\">";
                $formulaire.="<INPUT NAME=\"sub\" TYPE=\"hidden\" value=\"import_expl\">";
                $formulaire.="<INPUT NAME=\"action\" TYPE=\"hidden\" value=\"load\">";
                $formulaire.="<INPUT NAME=\"book_lender_id\" TYPE=\"hidden\" value=\"".$book_lender_id."\">";
                $formulaire.="<INPUT NAME=\"book_statut_id\" TYPE=\"hidden\" value=\"".$book_statut_id."\">";
                $formulaire.="<input type=\"hidden\" name=\"filename\" value=\"$filename\">";
                $formulaire.="<INPUT TYPE=\"hidden\" NAME=\"isbn_mandatory\" VALUE=\"$isbn_mandatory\">\n";
                $formulaire.="<INPUT TYPE=\"hidden\" NAME=\"isbn_dedoublonnage\" VALUE=\"$isbn_dedoublonnage\">\n";
                $formulaire.="<INPUT TYPE=\"hidden\" NAME=\"isbn_only\" VALUE=\"$isbn_only\">\n";
                $formulaire.="<INPUT TYPE=\"hidden\" NAME=\"cote_mandatory\" VALUE=\"$cote_mandatory\">\n";
                $formulaire.="<INPUT TYPE=\"hidden\" NAME=\"tdoc_codage\" VALUE=\"$tdoc_codage\">\n";
                $formulaire.="<INPUT TYPE=\"hidden\" NAME=\"statisdoc_codage\" VALUE=\"$statisdoc_codage\">\n";
                $formulaire.="<INPUT TYPE=\"hidden\" NAME=\"sdoc_codage\" VALUE=\"$sdoc_codage\">\n";
                $formulaire.="<INPUT TYPE=\"hidden\" NAME=\"statutnot\" VALUE=\"$statutnot\">\n";
                $formulaire.="<INPUT TYPE=\"hidden\" NAME=\"book_location_id\" VALUE=\"$book_location_id\">\n";
                $formulaire.="<input type=\"hidden\" name=\"recharge\" value=\"YES\">\n";
                $formulaire.="<input type=\"hidden\" name=\"reste\" value=\"".($reste)."\">\n";
                $formulaire.="<input type=\"hidden\" name=\"nbtot_notice\" value=\"".($nbtot_notice)."\">\n";
                $formulaire.="<input type=\"hidden\" name=\"notice_deja_presente\" value=\"".($notice_deja_presente)."\">\n";
                $formulaire.="<input type=\"hidden\" name=\"notice_rejetee\" value=\"".($notice_rejetee)."\">\n";
                $formulaire.="<input type=\"hidden\" name=\"nb_expl_ignores\" value=\"".($nb_expl_ignores)."\">\n";
                $formulaire.="<INPUT TYPE=\"hidden\" NAME=\"que_faire\" VALUE=\"$que_faire\">\n";
                $formulaire.="</form>";
                $formulaire.="<script> setTimeout(\"document.load.submit()\",2000); </script>\n";
                printf ($msg[513], $reste, $nbtot_notice); /* File %s ... . Still %s notices to load (total = %s) ... */
                if ($notice_deja_presente==1) printf ($msg[514],$notice_deja_presente) ; /* <br>($notice_deja_presente notice already in the database has been ignored since the begining) */
                    elseif ($notice_deja_presente>1) printf ($msg[515],$notice_deja_presente) ; /* <br>($notice_deja_presente notices already in the database have been ignored since the begining) */
                printf ($msg[521], $nb_expl_ignores); /* ## exemplaire(s) ignor(s) */
                } else {
                    $formulaire="";
                    $script="";
                    printf ($msg[516], $nbtot_notice); /* There were <b>$nbtot_notice</b> notice(s) to load, everything is OK...</b> */
                    if ($notice_deja_presente==1) printf ($msg[517], $notice_deja_presente); /*  <b>$notice_deja_presente</b> notice already in the database has been ignored... */
                        elseif ($notice_deja_presente>1) printf ($msg[518], $notice_deja_presente); /*  dont <b>$notice_deja_presente</b> notices already in the database have been ignored... */
                    printf ($msg[521], $nb_expl_ignores); /* ## exemplaire(s) ignor(s) */
                    /* ajouter ici SELECT error_origin, error_text, count(*) FROM error_log group by error_origin, error_text */
                    $gen_liste_log="";
                    $resultat_liste=mysql_query("SELECT error_origin, error_text, count(*) as nb_error FROM error_log where error_origin in ('expl.class','import_expl.inc','import.inc.php') group by error_origin, error_text" );
                    $nb_liste=mysql_numrows($resultat_liste);
                    if ($nb_liste>0) {
                        $gen_liste_log = "<br><br><b>".$msg[538]."</b><br><table border='1'>" ;
                        $gen_liste_log.="<tr><th>".$msg[539]."</th><th>".$msg[540]."</th><th>".$msg[541]."</th></tr>";
                        $i_log=0;
                        while ($i_log<$nb_liste) {
                            $gen_liste_log.="<tr>";
                            $gen_liste_log.="<td>".mysql_result($resultat_liste,$i_log,"error_origin")."</td>" ;
                            $gen_liste_log.="<td><b>".mysql_result($resultat_liste,$i_log,"error_text")."</b></td>" ;
                            $gen_liste_log.="<td>".mysql_result($resultat_liste,$i_log,"nb_error")."</td>" ;
                            $gen_liste_log.="</tr>" ;
                            $i_log++;
                            }
                        }
                    $gen_liste_str.="</table>\n" ;
                    print $gen_liste_log;
                    }
            print $formulaire;
            print $script;
            } else {
                // import de notices
                if ($reste > 0 ) {
                    $formulaire="<form class='form-$current_module' name=\"load\" method=\"post\" action=\"iimport_expl.php\">\n";
                    $formulaire.="<INPUT NAME=\"categ\" TYPE=\"hidden\" value=\"import\">";
                    $formulaire.="<INPUT NAME=\"sub\" TYPE=\"hidden\" value=\"import\">";
                    $formulaire.="<INPUT NAME=\"action\" TYPE=\"hidden\" value=\"load\">";
                    $formulaire.="<input type=\"hidden\" name=\"filename\" value=\"$filename\">";
                    $formulaire.="<INPUT TYPE=\"hidden\" NAME=\"isbn_mandatory\" VALUE=\"$isbn_mandatory\">\n";
                    $formulaire.="<INPUT TYPE=\"hidden\" NAME=\"isbn_dedoublonnage\" VALUE=\"$isbn_dedoublonnage\">\n";
                    $formulaire.="<INPUT TYPE=\"hidden\" NAME=\"isbn_only\" VALUE=\"$isbn_only\">\n";
                    $formulaire.="<INPUT TYPE=\"hidden\" NAME=\"statutnot\" VALUE=\"$statutnot\">\n";
                    $formulaire.="<input type=\"hidden\" name=\"recharge\" value=\"YES\">\n";
                    $formulaire.="<input type=\"hidden\" name=\"reste\" value=\"".($reste)."\">\n";
                    $formulaire.="<input type=\"hidden\" name=\"nbtot_notice\" value=\"".($nbtot_notice)."\">\n";
                    $formulaire.="<input type=\"hidden\" name=\"notice_deja_presente\" value=\"".($notice_deja_presente)."\">\n";
                    $formulaire.="<input type=\"hidden\" name=\"notice_rejetee\" value=\"".($notice_rejetee)."\">\n";
                    $formulaire.="</form>";
                    $formulaire.="<script> setTimeout(\"document.load.submit()\",2000); </script>\n";
                    printf ($msg[509].$msg[513],$filename, $reste, $nbtot_notice); /* File %s ... . Still %s notices to load (total = %s) ... */
                    if ($notice_deja_presente==1) printf ($msg[514],$notice_deja_presente) ; /* <br>($notice_deja_presente notice already in the database has been ignored since the begining) */
                        elseif ($notice_deja_presente>1) printf ($msg[515],$notice_deja_presente) ; /* <br>($notice_deja_presente notices already in the database have been ignored since the begining) */
                    if ($notice_rejetee>0) print "<br> ".$notice_rejetee." ".$msg['notices_invalides'];
                    } else {
                        $formulaire="";
                        $script="";
                        printf ($msg[509].$msg[516], $filename, $nbtot_notice); /* There were <b>$nbtot_notice</b> notice(s) to load, everything is OK...</b> */
                        if ($notice_deja_presente==1) printf ($msg[517], $notice_deja_presente); /*  <b>$notice_deja_presente</b> notice already in the database has been ignored... */
                            elseif ($notice_deja_presente>1) printf ($msg[518], $notice_deja_presente); /*  dont <b>$notice_deja_presente</b> notices already in the database have been ignored... */
                        if ($notice_rejetee>0) print "<br> ".$notice_rejetee." ".$msg['notices_invalides'] ;
                        /* ajouter ici SELECT error_origin, error_text, count(*) FROM error_log group by error_origin, error_text */
                        $gen_liste_log="";
                        $resultat_liste=mysql_query("SELECT error_origin, error_text, count(*) as nb_error FROM error_log where error_origin in ('expl.class','iimport_expl.inc','iimport.inc.php', 'import.inc') group by error_origin, error_text" );
                        $nb_liste=mysql_numrows($resultat_liste);
                        if ($nb_liste>0) {
                            $gen_liste_log = "<br><br><b>".$msg[538]."</b><br><table width=\"100%\"  border='1'>" ;
                            $gen_liste_log.="<tr><td>".$msg[539]."</td><td>".$msg[540]."</td><td>".$msg[541]."</td></tr>";
                            $i_log=0;
                            while ($i_log<$nb_liste) {
                                $gen_liste_log.="<tr>";
                                $gen_liste_log.="<td>".mysql_result($resultat_liste,$i_log,"error_origin")."</td>" ;
                                $gen_liste_log.="<td><b>".mysql_result($resultat_liste,$i_log,"error_text")."</b></td>" ;
                                $gen_liste_log.="<td>".mysql_result($resultat_liste,$i_log,"nb_error")."</td>" ;
                                $gen_liste_log.="</tr>" ;
                                $i_log++;
                                }
                            }
                        $gen_liste_str.="</table>\n" ;
                        print $gen_liste_log;
                        }

                print $formulaire;
                print $script;
                }
        break;
    default:
        if ($sub == "import_expl") include("$include_path/messages/help/$lang/import_expl.txt") ;
//-------------------------------------> L L I U R E X <--------------------------------------
        else if ($sub == "import_reb") include("$include_path/messages/help/$lang/import_reb.txt") ;
//-------------------------------------> L L I U R E X <--------------------------------------
            else include("$include_path/messages/help/$lang/import.txt") ;
        break;
    }

print "</div></body></html>";

