<?php
// +-------------------------------------------------+
//  2002-2004 PMB Services / www.sigb.net pmb@sigb.net et contributeurs (voir www.sigb.net)
// +-------------------------------------------------+
// $Id: catalog.inc.php,v 1.27 2007/03/11 08:07:43 touraine37 Exp $

if (stristr($_SERVER['REQUEST_URI'], ".inc.php")) die("no access");

echo window_title($database_window_title.$msg[6].$msg[1003].$msg[1001]);

require_once("$include_path/templates/catalog.tpl.php");
require_once("$include_path/isbn.inc.php");
require_once("$include_path/marc_tables/$lang/empty_words");
require_once("$class_path/marc_table.class.php");
require_once("$class_path/serie.class.php");
require_once("$class_path/indexint.class.php");
require_once("$class_path/author.class.php");
require_once("$class_path/subcollection.class.php");
require_once("$class_path/collection.class.php");
require_once("$class_path/editor.class.php");
require_once("$class_path/category.class.php");
require_once("$class_path/notice.class.php");
require_once("$class_path/serial_display.class.php");
require_once("$class_path/mono_display.class.php");
require_once("$class_path/expl.class.php");
require_once("$class_path/explnum.class.php");
require_once("$class_path/emprunteur.class.php");
// require("$class_path/fpdf_carte_lecteur.class.php");
require_once("$include_path/fields_empr.inc.php");
require_once("$include_path/datatype.inc.php");
require_once("$include_path/parser.inc.php");
require_once("$include_path/notice_authors.inc.php");
require_once("$include_path/notice_categories.inc.php");
require_once("$include_path/explnum.inc.php") ;
require_once("$include_path/expl_info.inc.php") ;
require_once("$include_path/bull_info.inc.php") ;
require_once("$include_path/resa_func.inc.php") ;

if ($pmb_prefill_cote) require_once("./catalog/expl/$pmb_prefill_cote");
	else require_once("./catalog/expl/custom_no_cote.inc.php");


switch($categ) {
//-------------------------------------> L L I U R E X <--------------------------------------
	case 'tejuelo':
		include('./tejuelo.php');
		break;	
//-------------------------------------> L L I U R E X <--------------------------------------	
	case 'update':
		include('./catalog/notices/update_notice.inc.php');
		break;
	case 'notice_form':
		include('./catalog/notices/notice_form.inc.php');
		break;
	case 'isbd':
		include('./catalog/notices/isbd.inc.php');
		break;
	case 'expl_update':
		include('./catalog/expl/expl_update.inc.php');
		break;	
	case 'expl_create':
		include('./catalog/expl/expl_create.inc.php');
		break;
	case 'edit_expl':
		include('./catalog/expl/edit_expl.inc.php');
		break;
	case 'create_form':
		include('./catalog/notices/create_form.inc.php');
		break;
	case 'modif':
		include('./catalog/notices/notice_form.inc.php');
		break;
	case 'create':
		include('./catalog/notices/notice_create.inc.php');
		break;
	case 'del_expl':
		include('./catalog/expl/del_expl.inc.php');
		break;	
	case 'search':
		include('./catalog/notices/search/main.inc.php');
		break;
	case 'expl_next':
		include('./catalog/notices/expl_next.inc.php');
		break;
	case 'delete':
		include('./catalog/notices/notice_delete.inc.php');
		break;
	case 'serials':
		include('./catalog/serials/serial_main.inc.php');
		break;
	case 'caddie':
		include('./catalog/caddie/caddie.inc.php');
		break;
	case 'etagere':
		include('./catalog/etagere/main.inc.php');
		break;
	case 'z3950':
		if ($z3950_accessible) {
			// mnage dans les trucs un peu vieux qui ont t remonts
			// on delete ce qui est vieux de plus de deux jours.
			$rqt = "select zquery_id from z_query where zquery_date < date_sub(now(),INTERVAL 2 DAY) ";
			$res_zquery=mysql_query($rqt,$dbh);
			while ($ligne=mysql_fetch_array($res_zquery)) {
				$zquery_id=$ligne["zquery_id"];
				$rqt_notices = "delete from z_notices where znotices_query_id ='".$zquery_id."' ";
				$res=mysql_query($rqt_notices,$dbh);
				$rqt_query = "delete from z_query where zquery_id ='".$zquery_id."' ";
				$del_znotices=mysql_query($rqt_query,$dbh);
				}
			include('./catalog/z3950/main.inc.php');
			}
		break;
	case 'last_records':
		include('./catalog/last_records.inc.php');
		break;
	case 'remplace':
		print "<h1>$msg[catal_rep_not_h1]</h1>";
		if(!$by) {
			require_once("$include_path/templates/catal_form.tpl.php");
			$notice = new notice($id);
			$notice->replace_form();
		} else {
			// routine de remplacement
			$notice = new notice($id);
			$rep_result = $notice->replace($by);
			if(!$rep_result)
				print "<div class='row'><div class='msg-perio'>".$msg["maj_encours"]."</div></div>
					<script type=\"text/javascript\">document.location='./catalog.php?categ=isbd&id=$by'</script>";
				
			else {
				error_message($msg[132], $rep_result, 1, "./catalog.php?categ=modif&id=$id");
			}
		}
		break;
	case 'duplicate':
		print "<h1>$msg[catal_duplicate_notice]</h1>";
		// routine de copie
		$notice = new notice($id);
		$notice->id=0 ;
		$notice->code="" ;
		$notice->duplicate_from_id = $id ; 
		print pmb_bidi($notice->show_form()) ;
		break;
	case 'explnum_create':
		include('./catalog/explnum/explnum_create.inc.php');
		break;
	case 'explnum_update':
		include('./catalog/explnum/explnum_update.inc.php');
		break;	
	case 'edit_explnum':
		include('./catalog/explnum/edit_explnum.inc.php');
		break;
	case 'del_explnum':
		include('./catalog/explnum/del_explnum.inc.php');
		break;	
	case 'sug' :
		//Cration de suggestion
		include("./catalog/suggestions/make_sug.inc.php");
		break;	
	case 'avis':
		include("./catalog/notices/avis.inc.php");
		break;
	case 'tags':
		include("./catalog/notices/tags.inc.php");
		break;
	default:
		include('./catalog/notices/search/main.inc.php');
		break;
}
