<?php
// +-------------------------------------------------+
//  2002-2004 PMB Services / www.sigb.net pmb@sigb.net et contributeurs (voir www.sigb.net)
// +-------------------------------------------------+
// $Id: serial_main.inc.php,v 1.17 2007/09/05 05:53:56 touraine37 Exp $

if (stristr($_SERVER['REQUEST_URI'], ".inc.php")) die("no access");

// inclusion du template de gestion des priodiques
include("$include_path/templates/serials.tpl.php");

// classes particulires  ce module
require_once("$class_path/serials.class.php");
require_once("./catalog/serials/serial_func.inc.php");
require_once("./catalog/serials/bulletinage/bul_func.inc.php");

// rcupration des codes de fonction
if (!count($fonction_auteur)) {
	$fonction_auteur = new marc_list('function');
	$fonction_auteur = $fonction_auteur->table;
	}

// rcupration des codes langues
if (!count($langue_doc)) {
	$f_lang = new marc_list('lang');
	$langue_doc = $f_lang->table;
	} 

echo window_title($database_window_title.$msg[771].$msg[1003].$msg[1001]);

switch($sub) {
	case 'serial_form':
		include('./catalog/serials/serial_form.inc.php');
		break;
	case 'update':
		include('./catalog/serials/serial_update.inc.php');
		break;
	case 'delete':
		include('./catalog/serials/serial_delete.inc.php');
		break;
	case 'search':
		include('./catalog/serials/serial_search.inc.php');
		break;
	case 'view':
		include('./catalog/serials/serial_view.inc.php');
		break;
	case 'bulletinage':
		include('./catalog/serials/bulletinage/bul_main.inc.php');
		break;
	case 'analysis':
		include('./catalog/serials/analysis/analysis_main.inc.php');
		break;
	case 'serial_replace':
		print pmb_bidi("<h1>$msg[catal_rep_per_h1]</h1>");
		if(!$by) {
			$perio = new serial($serial_id);
			$perio->replace_form();
			} else {
				// routine de remplacement
				$perio = new serial($serial_id);
				$rep_result = $perio->replace($by);
				if(!$rep_result) print pmb_bidi("<div class='row'><div class='msg-perio'>".$msg["maj_encours"]."</div></div>
								<script type=\"text/javascript\">document.location='./catalog.php?categ=serials&sub=view&serial_id=$by'</script>");
					else error_message($msg[132], $rep_result, 1, "./catalog.php?categ=serials&sub=view&serial_id=$id");
				}
		break;
	case 'modele':
		include('./catalog/serials/modele/modele_main.inc.php');
		break;
	case 'abon':
		include('./catalog/serials/abonnement/abonnement_main.inc.php');
		break;	
	case 'pointage':
		include('./catalog/serials/pointage/pointage_main.inc.php');
		break;				
	case 'explnum_form':
		include('./catalog/serials/explnum/serial_explnum_form.inc.php');
		break;
	case 'explnum_update':
		include('./catalog/serials/explnum/serial_explnum_update.inc.php');
		break;
	case 'explnum_delete':
		include('./catalog/serials/explnum/serial_explnum_delete.inc.php');
		break;
	default:
		echo str_replace('!!page_title!!', $msg[4000].$msg[1003].$msg["recherche"], $serial_header);
		echo $serial_access_form;
		break;
	}

echo $serial_footer;
