<?php
// +-------------------------------------------------+
//  2002-2004 PMB Services / www.sigb.net pmb@sigb.net et contributeurs (voir www.sigb.net)
// +-------------------------------------------------+
// $Id: serial_update.inc.php,v 1.25 2007/09/28 15:53:25 ngantier Exp $

if (stristr($_SERVER['REQUEST_URI'], ".inc.php")) die("no access");

echo str_replace('!!page_title!!', $msg[4000].$msg[1003].$msg[346], $serial_header);

// nettoyage des valeurs du form
$f_tit1 = clean_string($f_tit1);
$f_tit3 = clean_string($f_tit3);
$f_tit4 = clean_string($f_tit4);
//$f_n_gen = clean_string($f_n_gen);
//$f_n_resume = clean_string($f_n_resume);
$f_indexation = clean_string($f_indexation);
$f_lien = clean_string($f_lien);
$f_eformat = clean_string($f_eformat);

require_once($class_path."/notice_doublon.class.php");

if ($forcage == 1) {
	$tab= unserialize( urldecode($ret_url) );
	foreach($tab->GET as $key => $val){
		$GLOBALS[$key] = $val;	    
	}	
	foreach($tab->POST as $key => $val){
		$GLOBALS[$key] = $val;
	}
} else if( $pmb_notice_controle_doublons != 0 ) {	
	//Si control de ddoublonnage activ	
	$sign = new notice_doublon();
	$signature = $sign->gen_signature();
	
	$requete="select signature, niveau_biblio ,notice_id from notices where signature='$signature'";
	if($serial_id)	$requete.= " and notice_id != '$serial_id' ";
	$requete.= " limit 1 ";
		
	$result=mysql_query($requete, $dbh);	
	if (($r=mysql_fetch_object($result)))
	{
		//affichage de l'erreur, en passant tous les param posts (serialise) pour l'ventuel forcage 	
		$tab->POST = $_POST;
		$tab->GET = $_GET;
		$ret_url= urlencode(serialize($tab));
		require_once("$class_path/mono_display.class.php");
		require_once("$class_path/serial_display.class.php");
	   
		print "
			<br /><div class='erreur'>$msg[540]</div>
			<script type='text/javascript' src='./javascript/tablist.js'></script>
			<div class='row'>
				<div class='colonne10'>
					<img src='./images/error.gif' align='left'>
				</div>
				<div class='colonne80'>
					<strong>".$msg["gen_signature_erreur_similaire"]."</strong>
				</div>
			</div>
			<div class='row'>
				<form class='form-$current_module' name='dummy'  method='post' action='./catalog.php?categ=update&id=0'>
					<input type='hidden' name='forcage' value='1'>
					<input type='hidden' name='signature' value='$signature'>
					<input type='hidden' name='ret_url' value='$ret_url'>
					<input type='button' name='ok' class='bouton' value=' $msg[89] ' onClick='history.go(-1);'>
					<input type='submit' class='bouton' name='bt_forcage' value=' ".htmlentities($msg["gen_signature_forcage"], ENT_QUOTES)." '>
				</form>
				
			</div>
			";
		if($r->niveau_biblio != 's' && $r->niveau_biblio != 'a') {
			// notice de monographie
			$nt = new mono_display($r->notice_id);
		} else {
			// on a affaire  un priodique
			$nt = new serial_display($r->notice_id);
		}
		echo "
			<div class='row'>
			$nt->result
	 	    </div>
			<script>document.getElementById('el".$r->notice_id."Child').setAttribute('startOpen','Yes');</script>
			<script type='text/javascript'>document.forms['dummy'].elements['ok'].focus();</script>";	
		exit();
	}
}

// les valeurs passes sont mises en tableau pour tre passes
//  la mthode de mise  jour
$table = array();
$table['typdoc']        = $typdoc;
$table['statut']        = $form_notice_statut;
$table['commentaire_gestion'] =  $f_commentaire_gestion ;
$table['code']          = $f_cb;
$table['tit1']          = $f_tit1;
$table['tit3']          = $f_tit3;
$table['tit4']          = $f_tit4;

// auteur principal
$f_aut[] = array (
		'id' => $f_aut0_id,
		'fonction' => $f_f0_code,
		'type' => '0' );
// autres auteurs
for ($i=$max_aut1; $i>=0 ; $i--) {
	$var_autid = "f_aut1_id$i" ;
	$var_autfonc = "f_f1_code$i" ;
	$f_aut[] = array (
			'id' => $$var_autid,
			'fonction' => $$var_autfonc,
			'type' => '1' );
	}
// auteurs secondaires
for ($i=$max_aut2; $i>=0 ; $i--) {
	$var_autid = "f_aut2_id$i" ;
	$var_autfonc = "f_f2_code$i" ;
	$f_aut[] = array (
			'id' => $$var_autid,
			'fonction' => $$var_autfonc,
			'type' => '2' );
	}

$table['ed1_id']        = $f_ed1_id;
$table['ed2_id']        = $f_ed2_id;
$table['n_gen']         = $f_n_gen;
$table['n_contenu']		= $f_n_contenu;
$table['n_resume']      = $f_n_resume;

// catgories
for ($i=0; $i< $max_categ ; $i++) {
	$var_categid = "f_categ_id$i" ;
	$f_categ[] = array (
			'id' => $$var_categid
			);
	}

$table['indexint']      = $f_indexint_id;
$table['index_l']       = $f_indexation;
$table['lien']          = $f_lien;
$table['eformat']       = $f_eformat;
$table['niveau_biblio'] = $b_level;
$table['niveau_hierar'] = $h_level;
$table['signature'] 	= $signature;
$p_perso=new parametres_perso("notices");
$nberrors=$p_perso->check_submited_fields();

if (!$nberrors) {
	$serial = new serial($serial_id);
	$update_result = $serial->update($table);
} else {
	error_message_history($msg["notice_champs_perso"],$p_perso->error_message,1);
	exit();
}

if ($update_result) {
	// traitement des auteurs
	$rqt_del = "delete from responsability where responsability_notice='$update_result' ";
	$res_del = mysql_query($rqt_del, $dbh);
	$rqt_ins = "insert into responsability (responsability_author, responsability_notice, responsability_fonction, responsability_type) VALUES ";
	$i=0;
	while ($i<=count ($f_aut)-1) {
		$id_aut=$f_aut[$i]['id'];
		if ($id_aut) {
			$fonc_aut=$f_aut[$i]['fonction'];
			$type_aut=$f_aut[$i]['type'];
			$rqt = $rqt_ins . " ('$id_aut','$update_result','$fonc_aut','$type_aut') " ; 
			$res_ins = @mysql_query($rqt, $dbh);
			}
			$i++;
		}

	// traitement des categories
	$rqt_del = "delete from notices_categories where notcateg_notice='$update_result' ";
	$res_del = mysql_query($rqt_del, $dbh);
	$rqt_ins = "insert into notices_categories (notcateg_notice, num_noeud) VALUES ";
	while (list ($key, $val) = each ($f_categ)) {
		$id_categ=$val['id'];
		if ($id_categ) {
			$rqt = $rqt_ins . " ('$update_result','$id_categ') " ; 
			$res_ins = @mysql_query($rqt, $dbh);
		}
	}
	
	// traitement des langues
	// langues
	$f_lang_form = array();
	$f_langorg_form = array() ;
	for ($i=0; $i< $max_lang ; $i++) {
		$var_langcode = "f_lang_code$i" ;
		if ($$var_langcode) $f_lang_form[] =  array ('code' => $$var_langcode);
		}

	// langues originales
	for ($i=0; $i< $max_langorg ; $i++) {
		$var_langorgcode = "f_langorg_code$i" ;
		if ($$var_langorgcode) $f_langorg_form[] =  array ('code' => $$var_langorgcode);
		}

	$rqt_del = "delete from notices_langues where num_notice='$update_result' ";
	$res_del = mysql_query($rqt_del, $dbh);
	$rqt_ins = "insert into notices_langues (num_notice, type_langue, code_langue) VALUES ";
	while (list ($key, $val) = each ($f_lang_form)) {
		$tmpcode_langue=$val['code'];
		if ($tmpcode_langue) {
			$rqt = $rqt_ins . " ('$update_result',0, '$tmpcode_langue') " ; 
			$res_ins = mysql_query($rqt, $dbh);
			}
		}
	
	// traitement des langues originales
	$rqt_ins = "insert into notices_langues (num_notice, type_langue, code_langue) VALUES ";
	while (list ($key, $val) = each ($f_langorg_form)) {
		$tmpcode_langue=$val['code'];
		if ($tmpcode_langue) {
			$rqt = $rqt_ins . " ('$update_result',1, '$tmpcode_langue') " ; 
			$res_ins = @mysql_query($rqt, $dbh);
			}
		}
	
	//Traitement des champs perso
	$p_perso->rec_fields_perso($update_result);
}

if($update_result) {
	// Mise  jour de la table notices_global_index
	notice::majNoticesGlobalIndex($serial->serial_id);
	// Mise  jour de la table notices_mots_global_index
	notice::majNoticesMotsGlobalIndex($serial->serial_id);
	
	print "<div class='row'><div class='msg-perio'>".$msg[maj_encours]."</div></div>";
	$retour = "./catalog.php?categ=serials&sub=view&serial_id=".$serial->serial_id;
	print "
		<form class='form-$current_module' name=\"dummy\" method=\"post\" action=\"$retour\" style=\"display:none\">
			<input type=\"hidden\" name=\"id_form\" value=\"$id_form\">
		</form>
		<script type=\"text/javascript\">document.dummy.submit();</script>
		";
	} else error_message($msg[4004] , $msg['catalog_serie_impossible'], 1, './catalog.php?categ=serials');


