<?php
// +-------------------------------------------------+
//  2002-2005 PMB Services / www.sigb.net pmb@sigb.net et contributeurs (voir www.sigb.net)
// +-------------------------------------------------+
// $Id: actes.class.php,v 1.20 2007/07/30 14:38:49 dbellamy Exp $

if (stristr($_SERVER['REQUEST_URI'], ".class.php")) die("no access");

include_once($base_path.'/acquisition/achats/func_achats.inc.php');
include_once($include_path.'/misc.inc.php');
include_once($include_path.'/marc_tables/'.$lang.'/empty_words');

require_once("$class_path/liens_actes.class.php");
require_once("$class_path/audit.class.php");

if(!defined('TYP_ACT_ALL')) define('TYP_ACT_ALL', -1);	//Type d'acte	-1 = Tous
if(!defined('TYP_ACT_CDE')) define('TYP_ACT_CDE', 0);	//				0 = Commande
if(!defined('TYP_ACT_DEV')) define('TYP_ACT_DEV', 1);	//				1 = Demande de devis
if(!defined('TYP_ACT_LIV')) define('TYP_ACT_LIV', 2);	//				2 = Bon de Livraison
if(!defined('TYP_ACT_FAC')) define('TYP_ACT_FAC', 3);	//				3 = Facture

if(!defined('STA_ACT_ALL')) define('STA_ACT_ALL', -1);	//Statut acte	-1 = Tous
if(!defined('STA_ACT_AVA')) define('STA_ACT_AVA', 1);	//				1 = A valider
if(!defined('STA_ACT_ENC')) define('STA_ACT_ENC', 2);	//				2 = En cours
if(!defined('STA_ACT_REC')) define('STA_ACT_REC', 4);	//				4 = Reu/Livr
if(!defined('STA_ACT_FAC')) define('STA_ACT_FAC', 8);	//				8 = Factur
if(!defined('STA_ACT_PAY')) define('STA_ACT_PAY', 16);	//				16 = Pay
if(!defined('STA_ACT_ARC')) define('STA_ACT_ARC', 32);	//				32 = Archiv


class actes{
	
	var $id_acte = 0;							//Identifiant de l'acte	
	var $date_acte = '0000-00-00';				//date de cration de l'acte
	var $numero = '';							//Numero de l'acte
	var $type_acte = 0;							//Type d'acte (0 = Commande, 1 = Demande de devis, 2 = Bon de Livraison, 3 = Facture, ...)
	var $statut = 0;							//Statut de l'acte (
												//Commande			1=A valider, 2=En cours, 4=Livre, 8=Facture, 16=Paye, 32=Archive
												//Demande Devis		2=En cours, 4=Reu, 32=Archiv
												//Bon de Livraison	4=Recu, 32=Archiv
												//Facture			4=Reue, 16=Paye, 32=Archive
	var $date_paiement = '0000-00-00';			//Date du paiement (pr-paiement)
	var $num_paiement = 0;						//Numro de virement, chque, ...
	var $num_entite = 0;						//Identifiant de l'entit sur laquelle est affecte la acte
	var $num_fournisseur = 0;					//Identifiant du fournisseur associ
	var $num_contact_livr = 0;					//Identifiant du contact pour l'adresse de livraison
	var $num_contact_fact = 0;					//Identifiant du contact pour l'adresse de facturation
	var $num_exercice = 0;						//Identifiant de l'exercice auquel est affect l'acte
	var $commentaires = '';						//Lignes de commentaires de gestion
	var $reference = '';						//Rfrence fournisseur
	var $index_acte = '';						//Champ de recherche fulltext
	var $commentaires_i = '';					//Lignes de commentaires imprims sur la commande
	var $devise = '';							//Devise de la commande

	 
	//Constructeur.	 
	function actes($id_acte=0) {
		
		global $dbh;
	
		if ($id_acte) {
			$this->id_acte = $id_acte;
			$this->load();	
		}

	}	
	
	
	// charge une acte  partir de la base.
	function load(){
	
		global $dbh;
		
		$q = "select * from actes where id_acte = '".$this->id_acte."' ";
		$r = mysql_query($q, $dbh) ;
		$obj = mysql_fetch_object($r);
		$this->date_acte = $obj->date_acte;
		$this->numero = $obj->numero;
		$this->type_acte = $obj->type_acte;
		$this->statut = $obj->statut;
		$this->date_paiement = $obj->date_paiement;
		$this->num_paiement = $obj->num_paiement;
		$this->num_entite = $obj->num_entite;
		$this->num_fournisseur = $obj->num_fournisseur;
		$this->num_contact_livr = $obj->num_contact_livr;
		$this->num_contact_fact = $obj->num_contact_fact;
		$this->num_exercice = $obj->num_exercice;
		$this->commentaires = $obj->commentaires;
		$this->reference = $obj->reference;
		$this->commentaires_i = $obj->commentaires_i;
		$this->devise = $obj->devise;

	}

	
	// enregistre un acte en base.
	function save(){
		
		global $dbh;
			
		if ( $this->numero == '' || !$this->num_entite  || !$this->num_fournisseur ) die("Erreur de cration actes");
		
		//rcupration du libelle fournisseur
		$q = "select raison_sociale from entites where id_entite = '".$this->num_fournisseur."' ";
		$r = mysql_query($q, $dbh);

		$fou = mysql_result($r, 0, 0);
	
		if ($this->id_acte) {
			
			$q = "update actes set ";
			$q.= "statut = '".$this->statut."', date_paiement = '".$this->date_paiement."', num_paiement = '".$this->num_paiement."', ";
			$q.= "num_fournisseur = '".$this->num_fournisseur."', num_contact_livr = '".$this->num_contact_livr."', num_contact_fact = '".$this->num_contact_fact."', "; 
			$q.= "num_exercice = '".$this->num_exercice."', commentaires = '".$this->commentaires."', reference = '".$this->reference."', ";
			$q.= "commentaires_i = '".$this->commentaires_i."', devise = '".$this->devise."', ";
			$q.= "index_acte = ' ".$this->numero." ".strip_empty_words($fou)." ".strip_empty_words($this->commentaires)." ".strip_empty_words($this->reference)." '"; 
			$q.= "where id_acte = '".$this->id_acte."' ";
			$r = mysql_query($q, $dbh);
			audit::insert_modif(4, $this->id_acte);
		
		} else {
			
			$q = "insert into actes set type_acte = '".$this->type_acte."', date_acte = '".today()."', numero = '".$this->numero."', ";
			$q.= "statut = '".$this->statut."', date_paiement = '".$this->date_paiement."', num_paiement = '".$this->num_paiement."', num_entite = '".$this->num_entite."', ";
			$q.= "num_fournisseur = '".$this->num_fournisseur."', num_contact_livr = '".$this->num_contact_livr."', num_contact_fact = '".$this->num_contact_fact."', ";
			$q.= "num_exercice = '".$this->num_exercice."', commentaires = '".$this->commentaires."' , reference = '".$this->reference."', "; 
			$q.= "commentaires_i = '".$this->commentaires_i."', devise = '".$this->devise."', ";
			$q.= "index_acte = ' ".$this->numero." ".strip_empty_words($fou)." ".strip_empty_words($this->commentaires)." ".strip_empty_words($this->reference)." '"; 
			$r = mysql_query($q, $dbh);
			$this->id_acte = mysql_insert_id($dbh);
			audit::insert_creation(4, $this->id_acte);
			
		}
	}


	//supprime un acte de la base
	function delete($id_acte= 0) {
		
		global $dbh;

		if(!$id_acte) $id_acte = $this->id_acte; 	

		actes::deleteLignes($id_acte);
		liens_actes::delete($id_acte);
		$q = "delete from actes where id_acte = '".$id_acte."' ";
		$r = mysql_query($q, $dbh);
		audit::delete_audit(4, $id_acte);
				
	}


	//supprime les lignes d'un acte
	function deleteLignes($id_acte) {

		global $dbh;

		if(!$id_acte) $id_acte = $this->id_acte; 	

		$q = "delete from lignes_actes where num_acte = '".$id_acte."' ";
		$r = mysql_query($q, $dbh);
	}


	//Recherche la prochaine echeance d'une commande en cours 
	function getNextLivr($id_acte) {
		
		global $dbh;
		
		if(!$id_acte) $id_acte = $this->id_acte;
		$q = "select min((date_format(date_ech, '%Y%m%d'))) from lignes_actes where num_acte = '".$id_acte."' and (('2' & statut) = '0') ";
		$r = mysql_query($q, $dbh);
		if (mysql_num_rows($r)) {
			$res = mysql_result($r,0,0);
			$res = substr($res,0,4).'-'.substr($res,4,2).'-'.substr($res,6,2);
		} else $res = '0';
		return $res;
	}


	// calcule le numro d'un acte en base.
	// Il faut d'abord avoir renseign le numro d'entit et le type d'acte
	function calc(){
	
		$this->numero = calcNumero($this->num_entite, $this->type_acte);

	}


	// Retourne les lignes d'un acte
	function getLignes($id_acte=0, $param=0){
	
		global $dbh;
		
		if(!$id_acte) $id_acte = $this->id_acte;
		$q = "select * from lignes_actes where num_acte = '".$id_acte."' ";
		if($param) $q.="and ".$param." ";
		$q.= "order by id_ligne ";
		$r = mysql_query($q, $dbh);
		return $r; 

	}


	// Retourne la liste des actes appartenant  l'exercice pass en paramtres
	function listByExercice($num_exercice){
	
		global $dbh;
		
		$q = "select id_acte from actes where num_exercice = '".$num_exercice."' ";
		$r = mysql_query($q, $dbh);
		return $r; 

	}




	//optimization de la table actes
	function optimize() {
		
		global $dbh;
		
		$opt = mysql_query('OPTIMIZE TABLE actes', $dbh);
		return $opt;
				
	}
	
				
}
?>