<?php
// +-------------------------------------------------+
//  2002-2004 PMB Services / www.sigb.net pmb@sigb.net et contributeurs (voir www.sigb.net)
// +-------------------------------------------------+
// $Id: bannette.class.php,v 1.57 2007/10/04 06:10:10 touraine37 Exp $

if (stristr($_SERVER['REQUEST_URI'], ".class.php")) die("no access");

require_once ("$class_path/search.class.php") ; 
require_once ("$class_path/equation.class.php") ; 
require_once ("$class_path/mono_display.class.php") ; 
require_once ("$class_path/serial_display.class.php") ; 
require_once($include_path."/mail.inc.php") ;

// dfinition de la classe de gestion des 'bannettes'
class bannette {

// ---------------------------------------------------------------
//		proprits de la classe
// ---------------------------------------------------------------
	var $id_bannette=0;	
	var $num_classement=1; 
	var $nom_classement=""; 
	var	$nom_bannette="";
	var	$comment_gestion="";
	var	$comment_public="";
	var	$entete_mail="";
	var	$date_last_remplissage="";
	var	$date_last_envoi="";
	var	$aff_date_last_remplissage="";
	var	$aff_date_last_envoi="";
	var	$proprio_bannette=0;
	var	$bannette_auto=0;
	var	$periodicite=0;
	var	$diffusion_email=0;
	var $nb_notices_diff=0;
	var	$categorie_lecteurs=0;
	var	$update_type="C";
	var	$nb_notices=0;
	var	$nb_abonnes=0;
	var	$alert_diff=0;
	var $texte_export ;
	var $texte_diffuse ;
	var $num_panier ;
	var $limite_type; // D ou  I : Days ou Items
	var $limite_nombre; // Nombre limite, = soit dure de vie d'une notice dans la bannette ou bien nombre maxi de notices dans le panier

// ---------------------------------------------------------------
//		constructeur
// ---------------------------------------------------------------
function bannette($id=0) {
	if ($id) {
		// on cherche  atteindre une notice existante
		$this->id_bannette = $id;
		$this->getData();
		} else {
			// la notice n'existe pas
			$this->id_bannette = 0;
			$this->getData();
			}
	}

// ---------------------------------------------------------------
//		getData() : rcupration infos
// ---------------------------------------------------------------
function getData() {
	global $dbh;
	global $msg;
	
	if (!$this->id_bannette) {
		// pas d'identifiant. on retourne un tableau vide
	 	$this->id_bannette=0;
	 	$this->num_classement = 1 ;
	 	$this->nom_classement = "" ;
		$this->nom_bannette="";
		$this->comment_gestion="";
		$this->comment_public="";
		$this->entete_mail="";
		$this->date_last_remplissage="";
		$this->date_last_envoi=today();
		$this->aff_date_last_remplissage="";
		$this->aff_date_last_envoi=formatdate($this->date_last_envoi);
		$this->proprio_bannette=0;
		$this->bannette_auto=0;
		$this->periodicite=0;
		$this->diffusion_email=0;
		$this->nb_notices_diff=0;
		$this->categorie_lecteurs="";
		$this->update_type="C";
		$this->nb_notices = 0 ;
		$this->nb_abonnes = 0 ;
		$this->alert_diff = 0 ;
		$this->num_panier = 0 ;
		$this->limite_type = '' ;
		$this->limite_nombre = 0 ;
		} else {
			$requete = "SELECT id_bannette, num_classement, nom_bannette,comment_gestion,comment_public, ";
			$requete .= "date_last_remplissage, date_format(date_last_remplissage, '".$msg["format_date_heure"]."') as aff_date_last_remplissage, ";
			$requete .= "date_last_envoi, date_format(date_last_envoi, '".$msg["format_date_heure"]."') as aff_date_last_envoi, ";
			$requete .= "proprio_bannette,bannette_auto,periodicite,diffusion_email, nb_notices_diff, categorie_lecteurs, update_type, entete_mail, num_panier, ";
			$requete .= "limite_type, limite_nombre ";
			$requete .= "FROM bannettes WHERE id_bannette='".$this->id_bannette."' " ;
			$result = mysql_query($requete, $dbh) or die ($requete."<br> in bannette.class.php : ".mysql_error());
			if(mysql_num_rows($result)) {
				$temp = mysql_fetch_object($result);
			 	$this->id_bannette			= $temp->id_bannette ;
			 	$this->num_classement 		= $temp->num_classement ;
				$this->nom_bannette			= $temp->nom_bannette ;
				$this->comment_gestion		= $temp->comment_gestion ;	
				$this->comment_public		= $temp->comment_public ;
				$this->entete_mail			= $temp->entete_mail ;
				$this->date_last_remplissage= $temp->date_last_remplissage ;
				$this->date_last_envoi		= $temp->date_last_envoi ;	
				$this->aff_date_last_remplissage	= $temp->aff_date_last_remplissage ;
				$this->aff_date_last_envoi	= $temp->aff_date_last_envoi ;	
				$this->proprio_bannette		= $temp->proprio_bannette ;	
				$this->bannette_auto		= $temp->bannette_auto ;
				$this->periodicite			= $temp->periodicite ;
				$this->diffusion_email		= $temp->diffusion_email ;	
				$this->nb_notices_diff 		= $temp->nb_notices_diff;
				$this->categorie_lecteurs	= $temp->categorie_lecteurs ;
				$this->update_type			= $temp->update_type ;
				$this->num_panier			= $temp->num_panier ;
				$this->limite_type 			= $temp->limite_type ;
				$this->limite_nombre 		= $temp->limite_nombre ;
				$this->compte_elements();
				
				$requete = "SELECt nom_classement FROM classements WHERE id_classement='".$this->num_classement."'" ;
				$resultclass = mysql_query($requete, $dbh) or die ($requete."<br> in bannette.class.php : ".mysql_error());
				 if ($temp = mysql_fetch_object($resultclass)) $this->nom_classement = $temp->nom_classement ;
				 	else $this->nom_classement = "" ;
				
				} else {
					// pas de bannette avec cette cl
				 	$this->id_bannette=0;
				 	$this->num_classement = 1 ;
				 	$this->nom_classement = "" ;
					$this->nom_bannette="";
					$this->comment_gestion="";
					$this->comment_public="";
					$this->entete_mail="";
					$this->date_last_remplissage="";
					$this->date_last_envoi="";
					$this->aff_date_last_remplissage="";
					$this->aff_date_last_envoi="";
					$this->proprio_bannette=0;
					$this->bannette_auto=0;
					$this->periodicite=0;
					$this->diffusion_email=0;
					$this->nb_notices_diff=0;
					$this->categorie_lecteurs="";
					$this->update_type="C";
					$this->nb_notices = 0 ;
					$this->nb_abonnes = 0 ;
					$this->num_panier = 0 ;
					$this->limite_type = '' ;
					$this->limite_nombre = 0 ;
					}
			}
	}

// ---------------------------------------------------------------
//		show_form : affichage du formulaire de saisie
// ---------------------------------------------------------------
function show_form($type="pro") {

	global $msg, $charset;
	global $dsi_bannette_form;
	global $dsi_bannette_form_abo;
	global $nom_prenom_abo;
	
	if ($type=="abo") $dsi_bannette_form = $dsi_bannette_form_abo ;
	
	if($this->id_bannette) {
		$action = "./dsi.php?categ=bannettes&sub=$type&id_bannette=$this->id_bannette&suite=update";
		$button_delete = "<input type='button' class='bouton' value='$msg[63]' onClick=\"confirm_delete();\">";
		$libelle = $msg['dsi_ban_form_modif'];
		} else {
			$action = "./dsi.php?categ=bannettes&sub=$type&id_bannette=0&suite=update";
			$libelle = $msg['dsi_ban_form_creat'];
			$button_delete ='';
			}

	$dsi_bannette_form = str_replace('!!libelle!!', $libelle, $dsi_bannette_form);
	$dsi_bannette_form = str_replace('!!type!!', $type, $dsi_bannette_form);

	$dsi_bannette_form = str_replace('!!id_bannette!!', $this->id_bannette, $dsi_bannette_form);
	$dsi_bannette_form = str_replace('!!action!!', $action, $dsi_bannette_form);
	$dsi_bannette_form = str_replace('!!nom_bannette!!', htmlentities($this->nom_bannette,ENT_QUOTES, $charset), $dsi_bannette_form);
	
	if ($type=="pro") $dsi_bannette_form = str_replace('!!num_classement!!', show_classement_utilise ('BAN', $this->num_classement, 0), $dsi_bannette_form);
		else $dsi_bannette_form = str_replace('!!num_classement!!', "<input type=hidden name=num_classement value=0 />", $dsi_bannette_form);
	
	global $id_empr ;
	$dsi_bannette_form = str_replace('!!id_empr!!', $id_empr, $dsi_bannette_form);
	
	$dsi_bannette_form = str_replace('!!comment_gestion!!', htmlentities($this->comment_gestion,ENT_QUOTES, $charset), $dsi_bannette_form);
	$dsi_bannette_form = str_replace('!!comment_public!!', htmlentities($this->comment_public,ENT_QUOTES, $charset), $dsi_bannette_form);
	$dsi_bannette_form = str_replace('!!entete_mail!!', htmlentities($this->entete_mail,ENT_QUOTES, $charset), $dsi_bannette_form);
	$dsi_bannette_form = str_replace('!!date_last_remplissage!!', htmlentities($this->aff_date_last_remplissage,ENT_QUOTES, $charset), $dsi_bannette_form);
	
	$date_clic   = "onClick=\"window.open('./select.php?what=calendrier&caller=saisie_bannette&date_caller=".preg_replace('/-/', '', $this->date_last_envoi)."&param1=form_date_last_envoi&param2=form_aff_date_last_envoi&auto_submit=NO&date_anterieure=YES', 'date_last_envoi', 'toolbar=no, dependent=yes, width=250, height=260, resizable=yes')\"  ";
	$date_last_envoi = "
				<input type='hidden' name='form_date_last_envoi' value='".str_replace(' ', '', str_replace('-', '', str_replace(':', '', $this->date_last_envoi)))."' />
				<input class='bouton' type='button' name='form_aff_date_last_envoi' value='".$this->aff_date_last_envoi."' ".$date_clic." />";
	
	
	$dsi_bannette_form = str_replace('!!date_last_envoi!!', $date_last_envoi, $dsi_bannette_form);
	if ($type=="pro") $dsi_bannette_form = str_replace('!!proprio_bannette!!', htmlentities($msg['dsi_ban_no_proprio'],ENT_QUOTES, $charset), $dsi_bannette_form);
		else $dsi_bannette_form = str_replace('!!proprio_bannette!!', htmlentities($nom_prenom_abo,ENT_QUOTES, $charset), $dsi_bannette_form);
			
	if ($this->bannette_auto) $dsi_bannette_form = str_replace('!!bannette_auto!!', "checked", $dsi_bannette_form);
		else $dsi_bannette_form = str_replace('!!bannette_auto!!', "", $dsi_bannette_form);
	$dsi_bannette_form = str_replace('!!periodicite!!', htmlentities($this->periodicite,ENT_QUOTES, $charset), $dsi_bannette_form);
	if ($this->diffusion_email) $dsi_bannette_form = str_replace('!!diffusion_email!!', "checked", $dsi_bannette_form);
		else $dsi_bannette_form = str_replace('!!diffusion_email!!', "", $dsi_bannette_form);
	$dsi_bannette_form = str_replace('!!nb_notices_diff!!', htmlentities($this->nb_notices_diff,ENT_QUOTES, $charset), $dsi_bannette_form);
	
	if ($type=="pro") {
		$requete = "SELECT id_categ_empr, libelle FROM empr_categ ORDER BY libelle ";
		$onchange="res=confirm('".htmlentities($msg[dsi_ban_confirm_modif_categ],ENT_QUOTES, $charset)."'); if (res) this.form.majautocateg.value=1; else this.form.majautocateg.value=0;";  
		$categ_lect_aff = gen_liste ($requete, "id_categ_empr", "libelle", "categorie_lecteurs", $onchange, $this->categorie_lecteurs, 0, $msg[dsi_ban_aucune_categ], 0,$msg[dsi_ban_aucune_categ], 0) ;
		$dsi_bannette_form = str_replace('!!categorie_lecteurs!!', $categ_lect_aff, $dsi_bannette_form);
		} else $dsi_bannette_form = str_replace('!!categorie_lecteurs!!', "<input type=hidden name=categorie_lecteurs value=0 />", $dsi_bannette_form);
	
	$requete = "SELECT idcaddie, name FROM caddie where type='NOTI' ORDER BY name ";
	$panier_bann_aff = gen_liste ($requete, "idcaddie", "name", "num_panier", "", $this->num_panier, 0, $msg[dsi_panier_aucun], 0,$msg[dsi_panier_aucun], 0) ;
	$dsi_bannette_form = str_replace('!!num_panier!!', $panier_bann_aff, $dsi_bannette_form);
	
	switch ($this->limite_type) {
		case "D":
			$selectn = "" ;
			$selecti = "" ;
			$selectd = " SELECTED " ;
			break;
		case "I":
			$selectn = "" ;
			$selectd = "" ;
			$selecti = " SELECTED " ;
			break;
		default:
		case "":
			$selecti = "" ;
			$selectd = "" ;
			$selectn = " SELECTED " ;
			break;
		}
	$limite_type = "<select name='limite_type' id='limite_type'>
					<option value='' $selectn>".$msg[dsi_ban_non_cumul]."</option>
					<option value='D' $selectd>".$msg[dsi_ban_cumul_jours]."</option>
					<option value='I' $selecti>".$msg[dsi_ban_cumul_notice]."</option>
					</select>";
	$dsi_bannette_form = str_replace('!!limite_type!!', $limite_type, $dsi_bannette_form);
	$dsi_bannette_form = str_replace('!!limite_nombre!!', $this->limite_nombre, $dsi_bannette_form);

	// update_type: se baser sur la date de cration ou la date de mise  jour des notices ?
	switch ($this->update_type) {
		case "C":
			$selectu = "" ;
			$selectc = " SELECTED " ;
			break;
		case "U":
			$selectc = "" ;
			$selectu = " SELECTED " ;
			break;
		default:
		case "":
			$selectu = "" ;
			$selectc = " SELECTED " ;
			break;
		}
	$update_type = "<select name='update_type' id='update_type'>
					<option value='C' $selectc>".$msg[dsi_ban_update_type_c]."</option>
					<option value='U' $selectu>".$msg[dsi_ban_update_type_u]."</option>
					</select>";
	$dsi_bannette_form = str_replace('!!update_type!!', $update_type, $dsi_bannette_form);

	$dsi_bannette_form = str_replace('!!delete!!', $button_delete,  $dsi_bannette_form);

	// afin de revenir o on tait : $form_cb, le critre de recherche
	global $form_cb ;
	$dsi_bannette_form = str_replace('!!form_cb!!', $form_cb,  $dsi_bannette_form);
	print $dsi_bannette_form;
	}

// ---------------------------------------------------------------
//		delete() : suppression 
// ---------------------------------------------------------------
function delete() {
	global $dbh;
	global $msg;
	
	if (!$this->id_bannette) return $msg[dsi_ban_no_access]; // impossible d'accder  cette bannette

	$requete = "delete from bannette_abon WHERE num_bannette='$this->id_bannette'";
	$res = mysql_query($requete, $dbh);
	if ($this->proprio_bannette) {
		$requete = "select num_equation from bannette_equation WHERE num_bannette='$this->id_bannette'";
		$res = mysql_query($requete, $dbh);
		$temp = @mysql_fetch_object($res);
		$requete = "delete from equations WHERE id_equation='$temp->num_equation'";
		$res = mysql_query($requete, $dbh);
		}
		
	$requete = "delete from bannette_equation WHERE num_bannette='$this->id_bannette'";
	$res = mysql_query($requete, $dbh);
	$requete = "delete from bannette_contenu WHERE num_bannette='$this->id_bannette'";
	$res = mysql_query($requete, $dbh);
	$requete = "delete from bannettes WHERE id_bannette='$this->id_bannette'";
	$res = mysql_query($requete, $dbh);
	}


// ---------------------------------------------------------------
//		update 
// ---------------------------------------------------------------
function update($temp) {

	global $dbh;
	global $msg;
	if ($this->id_bannette) {
		// update
		$req = "UPDATE bannettes set ";
		$clause = " WHERE id_bannette='".$this->id_bannette."'";
		} else {
			$req = "insert into bannettes set date_last_remplissage=sysdate(), ";
			$clause = "";
			}
	$req.="num_classement='$temp->num_classement',";
	$req.="nom_bannette='$temp->nom_bannette',";
	$req.="comment_gestion='$temp->comment_gestion',";	
	$req.="comment_public='$temp->comment_public',"; 
	$req.="entete_mail='$temp->entete_mail',"; 
	$req.="proprio_bannette='$temp->proprio_bannette',";	
	$req.="bannette_auto='$temp->bannette_auto',";
	$req.="periodicite='$temp->periodicite',";
	$req.="diffusion_email='$temp->diffusion_email',";	
	$req.="nb_notices_diff='$temp->nb_notices_diff',";	
	$req.="categorie_lecteurs='$temp->categorie_lecteurs',";
	$req.="update_type='$temp->update_type',";
	$req.="num_panier='$temp->num_panier',";
	$req.="limite_type='$temp->limite_type',";
	$req.="limite_nombre='$temp->limite_nombre',";
	if (!$temp->date_last_envoi) $req.="date_last_envoi=sysdate() ";
		else $req.="date_last_envoi='".construitdateheuremysql($temp->date_last_envoi)."' ";
	$req.=$clause ;
	$res = mysql_query($req, $dbh);
	if (!$this->id_bannette) $this->id_bannette = mysql_insert_id() ;
	}

// ---------------------------------------------------------------
//		purger() : aprs remplissage, vider ce qui dpasse selon le type de cumul de la bannette 
// ---------------------------------------------------------------
function purger() {
	global $dbh;
	global $msg;
	
	if (!$this->id_bannette) return $msg[dsi_ban_no_access]; // impossible d'accder  cette bannette

	switch ($this->limite_type) {
		case "D":
			$requete = "select num_notice from bannette_contenu WHERE num_bannette='$this->id_bannette' and ";
			$requete .= " date_add(date_ajout, INTERVAL ".$this->limite_nombre." DAY)<sysdate() ";
			$res = mysql_query($requete, $dbh) or die(mysql_error()."<br>$requete");
			$tab = array();
			while ($obj=mysql_fetch_object($res)) $tab[]=$obj->num_notice ;
			$notice_suppr=implode(",",$tab);
			if ($notice_suppr) {
				if ($this->num_panier) {
					$requete = "delete from caddie_content WHERE caddie_id='$this->num_panier' and object_id in (".$notice_suppr.") ";
					$res = mysql_query($requete, $dbh) or die(mysql_error()."<br>$requete");
					}
				$requete = "delete from bannette_contenu WHERE num_bannette='$this->id_bannette' and num_notice in (".$notice_suppr.") ";
				$res = mysql_query($requete, $dbh) or die(mysql_error()."<br>$requete");
				}
			break;
		case "I":
			$tab = array();
			// selection des ## dernires notices, celles qu'il faut absolument garder
			$requete = "select num_notice from bannette_contenu, notices WHERE num_bannette='$this->id_bannette' and notice_id=num_notice order by date_ajout DESC, update_date DESC ";
			$requete .= " limit $this->limite_nombre ";
			$res = mysql_query($requete, $dbh) or die(mysql_error()."<br>$requete");
			while ($obj=mysql_fetch_object($res)) $tab[]=$obj->num_notice ;
			
			// selection des notices ajoutes depuis moins d'un jour
			$requete = "select num_notice from bannette_contenu WHERE num_bannette='$this->id_bannette' and ";
			$requete .= " date_add(date_ajout, INTERVAL 1 DAY)>=sysdate() ";
			$res = mysql_query($requete, $dbh) or die(mysql_error()."<br>$requete");
			while ($obj=mysql_fetch_object($res)) $tab[]=$obj->num_notice ;

			// suppression de tout ce qui dpasse
			$notice_suppr=implode(",",$tab);
			if ($notice_suppr) {
				if ($this->num_panier) {
					$requete = "delete from caddie_content WHERE caddie_id='$this->num_panier' and object_id not in (".$notice_suppr.") ";
					$res = mysql_query($requete, $dbh) or die(mysql_error()."<br>$requete");
					}
				$requete = "delete from bannette_contenu WHERE num_bannette='$this->id_bannette' and num_notice not in (".$notice_suppr.") ";
				$res = mysql_query($requete, $dbh) or die(mysql_error()."<br>$requete");
				}
			break;
		default:
		case "":
			break;
		}
	$this->compte_elements() ;
	}

// ---------------------------------------------------------------
//		vider() : vider le contenu de la bannette 
// ---------------------------------------------------------------
function vider() {
	global $dbh;
	global $msg;
	
	if (!$this->id_bannette) return $msg[dsi_ban_no_access]; // impossible d'accder  cette bannette

	$requete = "delete from bannette_contenu WHERE num_bannette='$this->id_bannette'";
	$res = mysql_query($requete, $dbh);
	$requete = "delete from caddie_content WHERE caddie_id='$this->num_panier'";
	$res = mysql_query($requete, $dbh);

	$this->compte_elements() ;
	}

// ---------------------------------------------------------------
//		remplir() : remplir la bannette  partir des quations 
// ---------------------------------------------------------------
function remplir() {
	global $dbh;
	global $msg;
	if (!$this->id_bannette) return $msg[dsi_ban_no_access]; // impossible d'accder  cette bannette
	
	// rcuprer les quations associes  la bannette
	$equations = $this->get_equations() ;
	$res_affichage = "<ul>" ;
	if ($this->update_type=="C") $colonne_update_create="create_date";
		else $colonne_update_create="update_date";
	for ($i=0 ; $i < sizeof($equations) ; $i++) {
		// pour chaque quation ajouter les notices trouves au contenu de la bannette
		$equ = new equation ($equations[$i]) ;
		$search = new search() ;
		$search->unserialize_search($equ->requete) ;
		$table = $search->make_search() ;
		$temp_requete = "insert ignore into bannette_contenu (num_bannette, num_notice) (select ".$this->id_bannette." , notices.notice_id from $table , notices where notices.$colonne_update_create>='".$this->date_last_envoi."' and $table.notice_id=notices.notice_id ) " ;
		$res = @mysql_query($temp_requete, $dbh);

		if ($this->num_panier) {
			$temp_requete = "insert ignore into caddie_content (caddie_id, object_id) (select ".$this->num_panier." , notices.notice_id from $table , notices where notices.$colonne_update_create>='".$this->date_last_envoi."' and $table.notice_id=notices.notice_id ) " ;
			$res = @mysql_query($temp_requete, $dbh);
			}
		
		$res_affichage .= "<li>".$equ->human_query."</li>" ;
		
	    $temp_requete = "drop table $table " ;
		$res = @mysql_query($temp_requete, $dbh);
	    }
	$res_affichage .= "</ul>" ;
	$this->compte_elements() ;
	$temp_requete = "update bannettes set date_last_remplissage=sysdate() where id_bannette='".$this->id_bannette."' " ;
	$res = mysql_query($temp_requete, $dbh);
	$this->purger();
	return $res_affichage ;
	}

// ---------------------------------------------------------------
//		construit_diff() :   
// ---------------------------------------------------------------
function construit_diff() {
	
	$contenu = $this->construit_contenu_HTML() ;
	$contenu_total = $this->construit_contenu_HTML(0) ;
	$titre = $this->construit_liens_HTML() ;
	$this->texte_diffuse = "<html><body>". $titre;
	if ($this->diffusion_email) $this->texte_diffuse .= $contenu ;
	$this->texte_diffuse .= "<html><body>";
	
	$this->texte_export = "<html><body>".$titre . $contenu_total . "<html><body>";
	}	


// ---------------------------------------------------------------
//		diffuser() : diffuser le contenu de la bannette  
// ---------------------------------------------------------------
function diffuser() {
	global $dbh;
	global $msg, $charset;
	
	global $PMBusernom;
	global $PMBuserprenom;
	global $PMBuseremail;
	global $empr_statut_adhes_depassee;
	
	if (!$this->id_bannette) return $msg[dsi_ban_no_access]; // impossible d'accder  cette bannette
	if (!$this->nb_notices) return $msg[dsi_ban_empty]; // Bannette vide : pas question d'envoyer du vide
	
	$this->construit_diff();
	$texte_base = $this->texte_diffuse ;
	$nb_dest=0;
	$nb_echec=0;
	$nb_no_email=0;
	
	$headers  = "MIME-Version: 1.0\n";
	$headers .= "Content-type: text/html; charset=".$charset."\n";
	
	$requete = "select id_empr, empr_mail, empr_nom, empr_prenom, empr_login, empr_password, empr_statut, statut_libelle from empr, empr_statut, bannette_abon ";
	$requete .= "where num_bannette='".$this->id_bannette."' and empr_date_expiration>=sysdate() and num_empr=id_empr and empr_statut=idstatut "; 
	$requete .= "order by empr_nom, empr_prenom ";
	$res = mysql_query($requete, $dbh);
	
	while($empr=mysql_fetch_object($res)) {
		$emaildest = $empr->empr_mail;
		// $texte = str_replace("!!empr_info_login!!","&login=".$empr->empr_login, $texte_base) ;
		$texte = $texte_base ; 
		if ($emaildest) {
			if ($empr->empr_statut==$empr_statut_adhes_depassee) {
				//si statut adhsion dpasse, affichage de l'info mais pas d'envoi
				$nb_echec++;
				$echec_email .= "- ".$empr->empr_nom." ".$empr->empr_prenom." (".$msg["statut_empr"]."' ".$empr->statut_libelle."')<br>" ;
			} else {	
				// $res_envoi=@mail("$emaildest",$this->comment_public,$texte." ","From: ".$PMBuserprenom." ".$PMBusernom." <".$PMBuseremail.">\r\n".$headers);
				$res_envoi=@mailpmb($empr->empr_prenom." ".$empr->empr_nom, $emaildest,$this->comment_public,$texte,$PMBuserprenom." ".$PMBusernom, $PMBuseremail, $headers, "", "");
				if ($res_envoi) $nb_dest++;
					else {
						$nb_echec++;
						$echec_email .= "- ".$empr->empr_nom." ".$empr->empr_prenom."<br>" ;
						}
			}
		} else {
			$nb_no_email++;
			$no_email .= "- ".$empr->empr_nom." ".$empr->empr_prenom."<br>" ;
		}
	}
	
	/* A commenter pour tests */ 
	$temp_requete = "update bannettes set date_last_envoi=sysdate() where id_bannette='".$this->id_bannette."' " ;
	$res = mysql_query($temp_requete, $dbh);

	$res_envoi = $msg["dsi_dif_res_dif"]."<ul><li>".$msg["dsi_dif_res_dif_mail_ok"].": $nb_dest </li>";
	if ($nb_echec) $res_envoi .= "<li>".$msg["dsi_dif_res_dif_mail_echec"].": $nb_echec <blockquote>$echec_email</blockquote></li>" ;
	if ($nb_no_email) $res_envoi .= "<li>".$msg["dsi_dif_res_dif_no_mail"].": $nb_no_email <blockquote>$no_email</blockquote></li>" ;
	$res_envoi .= "</ul>" ;
	if ($nb_echec || $nb_no_email) $res_envoi .= "<script>window.open('./print_dsi.php?id_bannette=$this->id_bannette', 'Impression de DSI', 'toolbar=no, dependent=yes, width=500, height=400, resizable=yes')</script>" ;
	
	return $res_envoi ;
	}

// ---------------------------------------------------------------
//		get_equations() : construire un tableau des quations associes  
// ---------------------------------------------------------------
function get_equations() {
	global $dbh;
	global $msg;
	
	if (!$this->id_bannette) return $msg[dsi_ban_no_access]; // impossible d'accder  cette bannette

	$requete = "select num_equation from bannette_equation, equations WHERE num_bannette='$this->id_bannette' and id_equation=num_equation ";
	$res = mysql_query($requete, $dbh);
	while($equ=mysql_fetch_object($res)) {
		$tab_equ[] = $equ->num_equation ;
		}
	return $tab_equ ;
	}

// ---------------------------------------------------------------
// affichage du contenu complet d'une bannette
// ---------------------------------------------------------------
function aff_contenu_bannette ($url_base="", $no_del=false ) {
	global $msg;
	global $dbh;
	global $begin_result_liste, $end_result_liste;
	global $end_result_list;
	global $url_base_suppr_bannette ;

	$return_affichage = "";
	$url_base_suppr_bannette = $url_base ;

	$cb_display = "
		<div id=\"el!!id!!Parent\" class=\"notice-parent\">
    		<span class=\"notice-heada\">!!heada!!</span>
    		<br>
		</div>
		";

	$requete = "SELECT num_notice FROM bannette_contenu where num_bannette='".$this->id_bannette."' ";

	$liste=array();
	$result = @mysql_query($requete, $dbh);
	if(mysql_num_rows($result)) {
		while ($temp = mysql_fetch_object($result)) 
			$liste[] = array('num_notice' => $temp->num_notice) ;  
		}

	if(!sizeof($liste) || !is_array($liste)) {
		return $msg[dsi_ban_empty];
		} else {
			// boucle de parcours des notices trouves
			// inclusion du javascript de gestion des listes dpliables
			// dbut de liste
			$return_affichage .= $begin_result_liste;
			//Affichage du lien impression et panier
			while(list($cle, $object) = each($liste)) {
				
				// affichage de la liste des notices sous la forme 'expandable'
				$requete = "SELECT * FROM notices WHERE notice_id='".$object[num_notice]."' ";
				$fetch = mysql_query($requete, $dbh);
				if (mysql_num_rows($fetch)) {
					$notice = mysql_fetch_object($fetch);
					if($notice->niveau_biblio != 's' && $notice->niveau_biblio != 'a') {
						// notice de monographie
						$link = './catalog.php?categ=isbd&id=!!id!!';
						$link_expl = './catalog.php?categ=edit_expl&id=!!notice_id!!&cb=!!expl_cb!!&expl_id=!!expl_id!!'; 
						$link_explnum = './catalog.php?categ=edit_explnum&id=!!notice_id!!&explnum_id=!!explnum_id!!';
						if (!$no_del) $lien_suppr_cart = "<a href='$url_base&suite=suppr_notice&num_notice=$notice->notice_id&id_bannette=$this->id_bannette'><img src='./images/basket_empty_20x20.gif' align='middle' alt='basket' title=\"".$msg[caddie_icone_suppr_elt]."\" /></a> $marque_flag";
							else $lien_suppr_cart = "" ;
						$display = new mono_display($notice, 6, $link, 1, $link_expl, $lien_suppr_cart, $link_explnum );
						$return_affichage .= $display->result;
						} else {
							// on a affaire  un priodique
							// prparation des liens pour lui
							$link_serial = './catalog.php?categ=serials&sub=view&serial_id=!!id!!';
							$link_analysis = './catalog.php?categ=serials&sub=analysis&action=analysis_form&bul_id=!!bul_id!!&analysis_id=!!id!!';
							$link_bulletin = './catalog.php?categ=serials&sub=bulletinage&action=view&bul_id=!!id!!';
							if (!$no_del) $lien_suppr_cart = "<a href='$url_base&suite=suppr_notice&num_notice=$notice->notice_id&id_bannette=$this->id_bannette'><img src='./images/basket_empty_20x20.gif' align='middle' alt='basket' title=\"".$msg[caddie_icone_suppr_elt]."\" /></a> $marque_flag";
								else $lien_suppr_cart = "" ;
							$link_explnum = "./catalog.php?categ=serials&sub=analysis&action=explnum_form&bul_id=!!bul_id!!&analysis_id=!!analysis_id!!&explnum_id=!!explnum_id!!";
							$serial = new serial_display($notice, 6, $link_serial, $link_analysis, $link_bulletin, $lien_suppr_cart, $link_explnum, 0);
							$return_affichage .= $serial->result;
							}
					}
				} // fin de liste
			$return_affichage .= $end_result_liste;
		}
	$return_affichage .= "<br />" ;
	return $return_affichage ;
	}

// ---------------------------------------------------------------
//		suppr_notice() : suppression d'une notice d'une bannette
// ---------------------------------------------------------------
function suppr_notice($num_notice) {
	global $dbh, $msg;

	if (!$this->id_bannette) return $msg[dsi_ban_no_access]; // impossible d'accder  cette bannette

	$requete = "delete from bannette_contenu WHERE num_bannette='$this->id_bannette' and num_notice='$num_notice'";
	$res = mysql_query($requete, $dbh);
	}

// ---------------------------------------------------------------
//		construit_contenu_HTML() : Prparation du contenu du mail ou du bulletin
// ---------------------------------------------------------------
function construit_contenu_HTML ($use_limit=1) {
	global $dbh;
	global $msg;
	global $opac_url_base, $use_opac_url_base ;
	$url_base_opac = $opac_url_base."index.php?css=1&lvl=notice_display&id=";
	$use_opac_url_base=true;
	// pour URL image vue de l'extrieur
	global $prefix_url_image ;
	global $depliable ;
	$depliable = 0 ;
	$prefix_url_image = $opac_url_base ;

	if ($this->nb_notices_diff && $use_limit) $limitation = " LIMIT $this->nb_notices_diff " ;
	$requete = "select num_notice from bannette_contenu, notices where num_bannette='".$this->id_bannette."' and notice_id=num_notice order by index_serie, tnvol, index_sew $limitation ";
	$resultat = mysql_query($requete, $dbh) or die($requete." ".mysql_error());

	// paramtrage :
	$environement["short"] = 6 ;
	$environement["ex"] = 0 ;
	$environement["exnum"] = 1 ;
	
	if (($this->nb_notices_diff >= $this->nb_notices) || (!$this->nb_notices_diff)) $nb_envoyees = $this->nb_notices ;
		else $nb_envoyees = $this->nb_notices_diff ;
	$resultat_aff .= "<hr style='border:none; border-bottom:solid #000000 3px;'/>";
	$resultat_aff .= sprintf($msg["dsi_diff_n_notices"],$nb_envoyees, $this->nb_notices);
	$resultat_aff .= "<hr style='border:none; border-bottom:solid #000000 3px;'/>";
	while ($r=mysql_fetch_object($resultat)) {
		$n=mysql_fetch_object(@mysql_query("select * from notices where notice_id=".$r->num_notice));
		if($n->niveau_biblio != 's' && $n->niveau_biblio != 'a') {
			global $use_opac_url_base; $use_opac_url_base=1;  
			//function mono_display($id, $level=1,      $action='', $expl=1,    $expl_link='', $lien_suppr_cart="", $explnum_link='', $show_resa=0, $print=0, $show_explnum=1, $show_statut=0, $anti_loop='', $draggable=0, $no_link=false, $show_opac_hidden_fields=true )
			$mono=new mono_display($n,$environement["short"],"",$environement["ex"],"","","",0,1,$environement["exnum"],0,"",0,true,false);
			$resultat_aff .= "<a href='".$url_base_opac.$n->notice_id."'><b>".$mono->header."</b></a><br/><br/>\n\r";
			$resultat_aff .= $mono->isbd;
			} else {
				// level=2 pour ne pas rajouter le "in ..." sur le titre de la notice de dpouillement
				// function serial_display ($id, $level='1', $action_serial='', $action_analysis='', $action_bulletin='', $lien_suppr_cart="", $lien_explnum="", $bouton_explnum=1,$print=0,$show_explnum=1, $show_statut=0, $show_opac_hidden_fields=true ) {
				$serial = new serial_display($n, 2, "", "", "", "", "", 0,1,$environement["exnum"],0, false );
				$resultat_aff .= "<a href='".$url_base_opac.$n->notice_id."'><b>".$serial->header."</b></a><br/><br/>\n\r";
				$resultat_aff .= $serial->isbd;
				}		
		$resultat_aff .= "<hr/>\n\r";
		}
	return $resultat_aff ;
	}

// ---------------------------------------------------------------
//		construit_contenu_HTML() : Prparation du contenu du mail ou du bulletin
// ---------------------------------------------------------------
function construit_liens_HTML() {
	global $dbh;
	global $opac_url_base ;
	global $msg ;
	
	// $url_base_opac = $opac_url_base."empr.php?lvl=bannette!!empr_info_login!!";
	$url_base_opac = $opac_url_base."empr.php?lvl=bannette";
	$resultat_aff .= "<style type='text/css'>
		body { 	
		font-size: 10pt;
		font-family: verdana, geneva, helvetica, arial;
		color:#000000;
		background:#FFFFFF;
		}
		td {
		font-size: 10pt;
		font-family: verdana, geneva, helvetica, arial;
		color:#000000;
		}
		th {
		font-size: 10pt;
		font-family: verdana, geneva, helvetica, arial;
		font-weight:bold;
		color:#000000;
		background:#DDDDDD;
		text-align:left;
		}
		hr {
		border:none;
		border-bottom:1px solid #000000;
		}
		h3 {
		font-size: 12pt;
		color:#000000;
		}
		</style>";
	
	$date_today = formatdate(today()) ;
	$public  = "<a href='$url_base_opac&id_bannette=".$this->id_bannette."'>";
	$public .= $this->comment_public." : &nbsp;".sprintf($msg["print_n_notices"],$this->nb_notices) ;
	$public .= "</a>";

	$entete = str_replace ("!!public!!",$public,$this->entete_mail) ;
	$entete = str_replace ("!!date!!",$date_today,$entete) ;
	
	return $entete ;
	}

// ---------------------------------------------------------------
//		compte_elements() : mthode pour pouvoir recompter en dehors !
// ---------------------------------------------------------------
function compte_elements() {
	global $dbh ;
	
	$req_nb = "SELECT count(1) as nb_notices from bannette_contenu WHERE num_bannette='".$this->id_bannette."' " ;
	$res_nb = mysql_query($req_nb, $dbh) or die ($req_nb."<br> in bannette.class.php : ".mysql_error());
	$res = mysql_fetch_object($res_nb);
	$this->nb_notices = $res->nb_notices ;
	$req_nb = "SELECT count(1) as nb_abonnes from bannette_abon WHERE num_bannette='".$this->id_bannette."' " ;
	$res_nb = mysql_query($req_nb, $dbh) or die ($req_nb."<br> in bannette.class.php : ".mysql_error());
	$res = mysql_fetch_object($res_nb);
	$this->nb_abonnes = $res->nb_abonnes ;
	$requete = "SELECt if(date_last_remplissage>date_last_envoi,1,0) as alert_diff ";
	$requete .= "FROM bannettes WHERE id_bannette='".$this->id_bannette."' " ;
	$result = mysql_query($requete, $dbh) or die ($requete."<br> in bannette.class.php : ".mysql_error());
	$temp = mysql_fetch_object($result);
	$this->alert_diff = $temp->alert_diff ; 
			
	}
} # fin de dfinition de la classe serie
