<?php
// +-------------------------------------------------+
//  2002-2005 PMB Services / www.sigb.net pmb@sigb.net et contributeurs (voir www.sigb.net)
// +-------------------------------------------------+
// $Id: noeuds.class.php,v 1.11 2007/11/07 18:28:02 dbellamy Exp $

if (stristr($_SERVER['REQUEST_URI'], ".class.php")) die("no access");

require_once($class_path."/thesaurus.class.php");

class noeuds{
	
	
	var $id_noeud = 0;				//Identifiant du noeud 
	var $autorite = '';
	var $num_parent = 0;
	var $num_renvoi_voir = 0;
	var $visible = '1';
	var	$num_thesaurus = 0;			//Identifiant du thesaurus de rattachement

	 
	//Constructeur.	 
	function noeuds($id=0) {
		
		global $dbh;
	
		if ($id) {
			$this->id_noeud = $id;
			$this->load();	
		}	
	}
	
		
	// charge le noeud  partir de la base.
	function load(){
	
		global $dbh;
		
		$q = "select * from noeuds where id_noeud = '".$this->id_noeud."' ";
		$r = mysql_query($q, $dbh) ;
		$obj = mysql_fetch_object($r);
		$this->id_noeud = $obj->id_noeud;
		$this->autorite = $obj->autorite;
		$this->num_parent = $obj->num_parent;
		$this->num_renvoi_voir = $obj->num_renvoi_voir;
		$this->visible = $obj->visible;
		$this->num_thesaurus = $obj->num_thesaurus;
	
	}

	
	// enregistre le noeud en base.
	function save(){
		
		global $dbh;
		
		if (!$this->num_thesaurus) die ('Erreur de cration noeud');
		
		if ($this->id_noeud) {	//Mise  jour noeud
			
			$q = 'update noeuds set autorite =\''.addslashes($this->autorite).'\', ';
			$q.= 'num_parent = \''.$this->num_parent.'\', num_renvoi_voir = \''.$this->num_renvoi_voir.'\', ';
			$q.= 'visible = \''.$this->visible.'\', num_thesaurus = \''.$this->num_thesaurus.'\' ';
			$q.= 'where id_noeud = \''.$this->id_noeud.'\' ';
			$r = mysql_query($q, $dbh);

		} else {
			
			$q = 'insert into noeuds set autorite = \''.addslashes($this->autorite).'\', ';
			$q.= 'num_parent = \''.$this->num_parent.'\', num_renvoi_voir = \''.$this->num_renvoi_voir.'\', ';
			$q.= 'visible = \''.$this->visible.'\', num_thesaurus = \''.$this->num_thesaurus.'\' ';
			$r = mysql_query($q, $dbh);
			$this->id_noeud = mysql_insert_id($dbh);
		}

	}


	//fonctions !!!

	//supprime un noeud et toutes ses rfrences
	function delete($id_noeud=0) {
		
		global $dbh;

		if(!$id_noeud) $id_noeud = $this->id_noeud; 	

		// Supprime les categories.
		$q = "delete from categories where num_noeud = '".$id_noeud."' ";
		$r = mysql_query($q, $dbh);
		
		// Supprime les renvois voir_aussi vers ce noeud. 
		$q= "delete from voir_aussi where num_noeud_dest = '".$id_noeud."' ";
		$r = mysql_query($q, $dbh);
		
		// Supprime les renvois voir_aussi depuis ce noeud. 
		$q= "delete from voir_aussi where num_noeud_orig = '".$id_noeud."' ";
		$r = mysql_query($q, $dbh);
		
		// Supprime les associations avec des notices. 
		$q= "delete from notices_categories where num_noeud = '".$id_noeud."' ";
		$r = mysql_query($q, $dbh);

		// Supprime le noeud.
		$q = "delete from noeuds where id_noeud = '".$id_noeud."' ";
		$r = mysql_query($q, $dbh);
				
	}


	// recherche si une autorite existe deja dans un thesaurus, 
	// et retourne le noeud associe
	function searchAutorite($num_thesaurus, $autorite) {
		
		global $dbh;
		
		$q = "select id_noeud from noeuds where num_thesaurus = '".$num_thesaurus."' ";
		$q.= "and autorite = '".addslashes($autorite)."' limit 1";
		$r = mysql_query($q, $dbh);
		if (mysql_num_rows($r) == 0) return FALSE;
		$noeud = new noeuds(mysql_result($r, 0, 0));
		return $noeud;
	}
	
	
	//recherche si un noeud a des fils
	function hasChild($id_noeud=0) {
	
		global $dbh;

		if(!$id_noeud) $id_noeud = $this->id_noeud; 	
		$q = "select count(1) from noeuds where num_parent = '".$id_noeud."' ";
		$r = mysql_query($q, $dbh);
		return mysql_result($r, 0, 0);
	}	

		
	//recherche si un noeud est le renvoi voir d'un autre noeud.
	function isTarget($id_noeud=0) {
		
		global $dbh;
		
		if(!$id_noeud) $id_noeud = $this->id_noeud; 
		$q = "select count(1) from noeuds where num_renvoi_voir = '".$id_noeud."' ";
		$r = mysql_query($q, $dbh);
		return mysql_result($r, 0, 0);
	}		


	//Indique si un noeud est protg (TOP, ORPHELINS et NONCLASSES).
	function isProtected($id_noeud=0) {
		
		global $dbh;
		
		if(!$id_noeud) $id_noeud = $this->id_noeud; 
		$q = "select autorite from noeuds where id_noeud = '".$id_noeud."' ";
		$r = mysql_query($q, $dbh);
		$a = mysql_result($r, 0, 0);
		if( $a=='TOP' || $a=='ORPHELINS' || $a=='NONCLASSES') return TRUE;
			else return FALSE;
	}		


	//Indique si un noeud est racine (non modifiable).
	function isRacine($id_noeud=0) {
		
		global $dbh;
		
		if (!$id_noeud) return FALSE;
		$q = "select * from thesaurus where num_noeud_racine = '".$id_noeud."' limit 1 ";
		$r = mysql_query($q, $dbh);
		if( mysql_num_rows($r)) return TRUE;
			else return FALSE;
	}		


	//Liste les ancetres d'un noeud et les retourne sous forme d'un tableau 
	function listAncestors($id_noeud=0) {
		
		global $dbh;
		
		if(!$id_noeud) $id_noeud = $this->id_noeud();
		$thes = thesaurus::getByEltId($id_noeud);

		$id_top = $thes->num_noeud_racine;
		$i = 0;		
		$id_list[$i] = $id_noeud;
		while (true) {
			$q = "select num_parent from noeuds where id_noeud = '".$id_list[$i]."' limit 1";
			$r = mysql_query($q, $dbh);
			$id_cur = mysql_result($r, 0, 0);
			if (!$id_cur || $id_cur == $id_top) break;
			$i++;
			$id_list[$i] = mysql_result($r, 0, 0);
		}
		return $id_list;		
	}
	
	
	//Liste les enfants d'un noeud sous forme de resultset (si $renvoi=0, ne retourne pas les noeuds renvoys)
	function listChilds($id_noeud=0, $renvoi=0) {
	
		global $dbh;

		if(!$id_noeud) $id_noeud = $this->id_noeud; 	
		$q = "select id_noeud from noeuds where num_parent = '".$id_noeud."' ";
		$q.= "and autorite not in ('ORPHELINS', 'NONCLASSES') ";
		if (!$renvoi) $q.= "and num_renvoi_voir = '0' ";
		$r = mysql_query($q, $dbh);
		return $r;
	}	
	
	//recherche si un noeud est utilis dans une notice.
	function isUsedInNotices($id_noeud=0) {
		
		global $dbh;
		
		if(!$id_noeud) $id_noeud = $this->id_noeud; 
		$q = "select count(1) from notices_categories where num_noeud = '".$id_noeud."' ";
		$r = mysql_query($q, $dbh);
		return mysql_result($r, 0, 0);
	}		


	//recherche si un noeud est utilis dans la table voir_aussi.
	function isUsedInSeeAlso($id_noeud=0) {
		
		global $dbh;
		
		if(!$id_noeud) $id_noeud = $this->id_noeud; 
		$q = "select count(1) from voir_aussi where num_noeud_orig = '".$id_noeud."' ";
		$q.= "or num_noeud_dest = '".$id_noeud."' ";
		$r = mysql_query($q, $dbh);
		return mysql_result($r, 0, 0);
	}		

	
	//optimization de la table noeuds
	function optimize() {
		
		global $dbh;
		
		$opt = mysql_query('OPTIMIZE TABLE noeuds', $dbh);
		return $opt;
				
	}

	
	// Fonction statique pour la maj d'un n-uplet dans la table "notices_global_index" lors de la cration ou mise  jour d'une notice.
	// La variable $chaineInseree contient tout ce qui a t inserer depuis le premier
	// appel a cette fonction recursive. Cela permet de faire des tests pour viter les doublons
	function majNoticesGlobalIndex($noeud,$NoIndex = 1, $notice) {	
		global $lang;	
		global $dbh;
		$mesCateg = mysql_query("select libelle_categorie as lib, index_categorie as ind from categories where num_noeud = ".$noeud,$dbh);
		$num = mysql_num_rows($mesCateg);
		if ($num) {
			$maCateg = mysql_fetch_assoc($mesCateg);
			$libelle = $maCateg['lib'];
			$index = $maCateg['ind'];
			// Le libelle n'a pas encore t insr, on peut donc l'y ajouter dans la table :
			mysql_query("UPDATE notices_global_index SET infos_global = CONCAT(infos_global,'".addslashes($libelle)." ') WHERE num_notice = ".$notice." AND no_index = ".$NoIndex, $dbh);
			mysql_query("UPDATE notices_global_index SET index_infos_global = CONCAT(index_infos_global,'".addslashes($index)." ') WHERE num_notice = ".$notice." AND no_index = ".$NoIndex, $dbh);
		}
	}

	
	//vrification de l'unicit du numro d'autorit dans le thsaurus
	function isUnique($num_thesaurus, $num_aut='', $id_noeud=0) {
		
		global $dbh;
		if ($num_aut=='') return true;
		$q = 'select count(1) from noeuds where num_thesaurus=\''.$num_thesaurus.'\' ';
		$q.= 'and autorite=\''.addslashes($num_aut).'\' ';
		if ($id_noeud) $q.= 'and id_noeud != \''.$id_noeud.'\' ';
		$r = mysql_query($q, $dbh);
		if(mysql_result($r, 0, 0)==0) return true;
			else return false;
	}		
	
}
?>