<?php
// +-------------------------------------------------+
//  2002-2004 PMB Services / www.sigb.net pmb@sigb.net et contributeurs (voir www.sigb.net)
// +-------------------------------------------------+
// $Id: notice.class.php,v 1.72 2007/07/28 07:04:29 touraine37 Exp $

if (stristr($_SERVER['REQUEST_URI'], ".class.php")) die("no access");

// classe de gestion des notices
if ( ! defined( 'NOTICE_CLASS' ) ) {
  define( 'NOTICE_CLASS', 1 );

	require_once("$class_path/author.class.php");
	require_once("$class_path/marc_table.class.php");
	require_once("$class_path/category.class.php");
	require_once("$class_path/serie.class.php");
	require_once("$class_path/indexint.class.php");
	require_once($class_path."/parametres_perso.class.php");
	require_once($class_path."/audit.class.php");
	include_once($include_path."/notice_authors.inc.php");
	include_once($include_path."/notice_categories.inc.php");
	require_once($class_path."/thesaurus.class.php");
	require_once($class_path."/noeuds.class.php");
	require_once($include_path."/parser.inc.php");
	
	class notice {
	
		// proprits
		var $libelle_form = '';
		var $id = 0;
		var $duplicate_from_id = 0;
		var $tit1 = '';			// titre propre
		var $tit2 = '';			// titre propre 2
		var $tit3 = '';			// titre parallle
		var $tit4 = '';			// complment du titre
		var $tparent_id = '';		// id du titre parent
		var $tparent = '';		// libell du titre parent
		var $tnvol = '';		// numro de partie
		var $responsabilites =	array("responsabilites" => array(),"auteurs" => array());  // les auteurs
		var $ed1_id = '';		// id diteur 1
		var $ed1 ='';			// libell diteur 1
		var $coll_id = '';		// id collection
		var $coll = '';			// libell collection
		var $subcoll_id = '';		// id sous collection
		var $subcoll = '';		// libell sous collection
		var $year = '';			// anne de publication
		var $nocoll = '';		// no. dans la collection
		var $mention_edition = '';	// mention d'dition (1re, deuxime...)
		var $ed2_id = '';		// id diteur 2
		var $ed2 ='';			// libell diteur 2
		var $code = '';			// ISBN, code barre commercial ou no. commercial
		var $npages = '';		// importance matrielle (nombre de pages, d'lments...)
		var $ill = '';			// mention d'illustration
		var $size = '';			// format
		var $prix = '';			// prix du document
		var $accomp = '';		// matriel d'accompagnement
		var $n_gen = '';		// note gnrale
		var $n_contenu = '';		// note de contenu
		var $n_resume = '';		// resum/extrait
		var $categories =	array();// les categories
		var $indexint = 0;		// indexation interne
		var $index_l = '';		// indexation libre
		var $langues = array();
		var $languesorg = array();
		var $lien = '';			// URL de la ressource lectronique associe
		var $eformat = '';		// format de la ressource lectronique associe
		var $ok = 1;
		var $type_doc = '';
		var $biblio_level = 'm';	// niveau bibliographique
		var $hierar_level = '0';	// niveau hirarchique
		var $action = './catalog.php?categ=update&id=';
		var $link_annul = './catalog.php';
		var $statut = 0 ; // statut 
		var $commentaire_gestion = '' ; // commentaire de gestion 
		var $notice_mere=array();
		var $notice_mere_id=array();
		var $relation_type=array();
		// mthodes
		
		// constructeur
		function notice($id=0, $cb='') {
			global $dbh;
			global $msg;
			global $include_path, $class_path ;
		
			if($id) {
				$fonction = new marc_list('function');
		
				$this->id = $id;
				$this->libelle_form = $msg[278];  // libelle du form : modification d'une notice
		
				$requete = "SELECT * FROM notices WHERE notice_id='$id' LIMIT 1 ";
		
				$result = @mysql_query($requete, $dbh);
		
				if($result) {
					$notice = mysql_fetch_object($result);
		
					$this->type_doc = $notice->typdoc;				// type du document
					$this->tit1		= $notice->tit1;				// titre propre
					$this->tit2		= $notice->tit2;				// titre propre 2
					$this->tit3		= $notice->tit3;				// titre parallle
					$this->tit4		= $notice->tit4;				// complment du titre
					$this->tparent_id	= $notice->tparent_id;				// id du titre parent
		
					// libell du titre parent
					if($this->tparent_id) {
						$serie = new serie($this->tparent_id);
						$this->tparent = $serie->name;
					} else {
						$this->tparent 		= '';
					}
		
					$this->tnvol		= $notice->tnvol;				// numro de partie
					
					$this->responsabilites = get_notice_authors($this->id) ;
					$this->subcoll_id 	= $notice->subcoll_id;				// id sous collection
					$this->coll_id 		= $notice->coll_id;				// id collection
					$this->ed1_id		= $notice->ed1_id	;			// id diteur 1
		
					require_once("$class_path/editor.class.php");
		
					if($this->subcoll_id) {
						require_once("$class_path/subcollection.class.php");
						require_once("$class_path/collection.class.php");
						$collection = new subcollection($this->subcoll_id);
						$this->subcoll = $collection->name;
					}
		
					if($this->coll_id) {
						require_once("$class_path/collection.class.php");
						$collection = new collection($this->coll_id);
						$this->coll = $collection->name;
					}
		
					if($this->ed1_id) {
						$editeur = new editeur($this->ed1_id);
						$this->ed1 = $editeur->display;
					}
		
					$this->year 		= $notice->year;				// anne de publication
					$this->nocoll		= $notice->nocoll;				// no. dans la collection
					$this->mention_edition		= $notice->mention_edition;	// mention d'dition (1re, deuxime...)
					$this->ed2_id		= $notice->ed2_id;				// id diteur 2
		
					if($this->ed2_id) {		// libell diteur 2
						$editeur = new editeur($this->ed2_id);
						$this->ed2 = $editeur->display;
					}
		
					$this->code		= $notice->code;				// ISBN, code barre commercial ou no. commercial
		
					$this->npages		= $notice->npages;				// importance matrielle (nombre de pages, d'lments...)
					$this->ill		= $notice->ill;					// mention d'illustration
					$this->size		= $notice->size;				// format
					$this->prix		= $notice->prix;				// Prix du document
					$this->accomp		= $notice->accomp;				// matriel d'accompagnement
		
					$this->n_gen		= $notice->n_gen;				// note gnrale
					$this->n_contenu	= $notice->n_contenu;				// note de contenu
					$this->n_resume		= $notice->n_resume;				// resum/extrait
		
					$this->categories = get_notice_categories($this->id) ;
		
					$this->indexint		= $notice->indexint;				// indexation interne
					$this->index_l		= $notice->index_l;				// indexation libre
		
					$this->langues	= get_notice_langues($this->id, 0) ;	// langues de la publication
					$this->languesorg	= get_notice_langues($this->id, 1) ; // langues originales
		
					$this->lien	= $notice->lien;				// URL de la ressource lectronique associe
					$this->eformat	= $notice->eformat;				// format de la ressource lectronique associe
					$this->biblio_level = $notice->niveau_biblio;   	    	// niveau bibliographique
					$this->hierar_level = $notice->niveau_hierar;       		// niveau hirarchique
					$this->statut = $notice->statut;
					
					$requete="select linked_notice, relation_type from notices_relations where num_notice=".$id." order by rank";
					$result_rel=mysql_query($requete);
					if (mysql_num_rows($result_rel)) {
						while ($r_rel=mysql_fetch_object($result_rel)) {
							$this->notice_mere[]=$this->get_notice_title($r_rel->linked_notice);
							$this->notice_mere_id[]=$r_rel->linked_notice;
							$this->relation_type[]=$r_rel->relation_type;
						}
					}
					 
					$this->commentaire_gestion = $notice->commentaire_gestion; 
				} else {
					require_once("$include_path/user_error.inc.php");
					error_message("", $msg[280], 1, "./catalog.php");
					$this->ok = 0;
				}
				return;
			} else {
		    	// initialisation des valeurs (vides)
				$this->libelle_form = $msg[270];  // libelle du form : cration d'une notice
				$this->id = 0;
				$this->code = $cb;
				// initialisation avec les paramtres du user :
				global $value_deflt_lang ;
				if ($value_deflt_lang) {
					$lang = new marc_list('lang');
					$this->langues[] = array( 
						'lang_code' => $value_deflt_lang,
						'langue' => $lang->table[$value_deflt_lang]
						) ;
				}
				global $deflt_notice_statut ;
				if ($deflt_notice_statut) $this->statut = $deflt_notice_statut;
					else $this->statut = 1;
				
				global $xmlta_doctype ;
				$this->type_doc = $xmlta_doctype ;
				
				global $notice_parent;
				if ($notice_parent) {
					$this->notice_mere[0]=$this->get_notice_title($notice_parent);
					$this->notice_mere_id[0]=$notice_parent;
					//Recherche d'un type plausible
					$requete="select relation_type from notices_relations where num_notice=$notice_parent order by rank desc limit 1";
					$resultat=mysql_query($requete);
					if (@mysql_num_rows($resultat)) {
						$this->relation_type[0]=mysql_result($resultat,0,0);
					}
				}
				// penser au test d'existence de la notice sur code-barre
				return;
			}
		}
		
		//Rcupration d'un titre de notice
		function get_notice_title($notice_id) {
			$requete="select serie_name, tnvol, tit1, code from notices left join series on serie_id=tparent_id where notice_id=".$notice_id;
			$resultat=mysql_query($requete);
			if (mysql_num_rows($resultat)) {
				$r=mysql_fetch_object($resultat);
				return ($r->serie_name?$r->serie_name." ":"").($r->tnvol?$r->tnvol." ":"").$r->tit1.($r->code?" (".$r->code.")":"");
			}
		}
		
		// affichage du form associ
		function show_form() {
			global $msg;
			global $charset;
			global $include_path, $class_path;
			global $current_module ;
			global $pmb_type_audit,$select_categ_prop, $z3950_accessible ;
			global $value_deflt_fonction;
			global $thesaurus_mode_pmb ;
			global $PMBuserid, $pmb_form_editables,$thesaurus_classement_mode_pmb;
			include("$include_path/templates/catal_form.tpl.php");
			$fonction = new marc_list('function');
			
			// mise  jour de l'action en fonction de l'id
			$this->action .= $this->id;
		
			// mise  jour de l'en-tte du formulaire
			if ($this->notice_mere[0]) $this->libelle_form.=" in ".substr($this->notice_mere[0],0,100).(count($this->notice_mere)>1?", ...":"");
			$form_notice = str_replace('!!libelle_form!!', $this->libelle_form, $form_notice);
		
			// mise  jour des flags de niveau hirarchique
			$form_notice = str_replace('!!b_level!!', $this->biblio_level, $form_notice);
			$form_notice = str_replace('!!h_level!!', $this->hierar_level, $form_notice);
		
			// mise  jour de l'onglet 0
			$ptab[0] = str_replace('!!tit1!!',				htmlentities($this->tit1,ENT_QUOTES, $charset)			, $ptab[0]);
			$ptab[0] = str_replace('!!tit2!!',				htmlentities($this->tit2,ENT_QUOTES, $charset)			, $ptab[0]);
			$ptab[0] = str_replace('!!tit3!!',				htmlentities($this->tit3,ENT_QUOTES, $charset)			, $ptab[0]);
			$ptab[0] = str_replace('!!tit4!!',				htmlentities($this->tit4,ENT_QUOTES, $charset)			, $ptab[0]);
			$ptab[0] = str_replace('!!tparent_id!!',		$this->tparent_id										, $ptab[0]);
			$ptab[0] = str_replace('!!tparent!!',			htmlentities($this->tparent,ENT_QUOTES, $charset)		, $ptab[0]);
			$ptab[0] = str_replace('!!tnvol!!',				htmlentities($this->tnvol,ENT_QUOTES, $charset)			, $ptab[0]);
		
			$form_notice = str_replace('!!tab0!!', $ptab[0], $form_notice);
		
			// mise  jour de l'onglet 1
			// constitution de la mention de responsabilit
			//$this->responsabilites
			
			$as = array_search ("0", $this->responsabilites["responsabilites"]) ;
			if ($as!== FALSE && $as!== NULL) {
				$auteur_0 = $this->responsabilites["auteurs"][$as] ;
				$auteur = new auteur($auteur_0["id"]);
				}
			if ($value_deflt_fonction && $auteur_0["id"]==0) $auteur_0["fonction"] = $value_deflt_fonction ;
		
			$ptab[1] = str_replace('!!aut0_id!!',			$auteur_0["id"], $ptab[1]);
			$ptab[1] = str_replace('!!aut0!!',				htmlentities($auteur->display,ENT_QUOTES, $charset), $ptab[1]);
			$ptab[1] = str_replace('!!f0_code!!',			$auteur_0["fonction"], $ptab[1]);
			$ptab[1] = str_replace('!!f0!!',				$fonction->table[$auteur_0["fonction"]], $ptab[1]);
		
		
			$as = array_keys ($this->responsabilites["responsabilites"], "1" ) ;
			$max_aut1 = (count($as)) ;
			if ($max_aut1==0) $max_aut1=1;
			for ($i = 0 ; $i < $max_aut1 ; $i++) {
				$indice = $as[$i] ;
				$auteur_1 = $this->responsabilites["auteurs"][$indice] ;
				$auteur = new auteur($auteur_1["id"]);
				if ($value_deflt_fonction && $auteur_1["id"]==0 && $i==0) $auteur_1["fonction"] = $value_deflt_fonction ;
				
				$ptab_aut_autres = str_replace('!!iaut!!', $i, $ptab[11]) ;
					
				$ptab_aut_autres = str_replace('!!aut1_id!!',			$auteur_1["id"], $ptab_aut_autres);
				$ptab_aut_autres = str_replace('!!aut1!!',				htmlentities($auteur->display,ENT_QUOTES, $charset), $ptab_aut_autres);
				$ptab_aut_autres = str_replace('!!f1_code!!',			$auteur_1["fonction"], $ptab_aut_autres);
				$ptab_aut_autres = str_replace('!!f1!!',				$fonction->table[$auteur_1["fonction"]], $ptab_aut_autres);
				$autres_auteurs .= $ptab_aut_autres ;
				}
			$ptab[1] = str_replace('!!max_aut1!!', $max_aut1, $ptab[1]);
			
			$as = array_keys ($this->responsabilites["responsabilites"], "2" ) ;
			$max_aut2 = (count($as)) ;
			if ($max_aut2==0) $max_aut2=1;
			for ($i = 0 ; $i < $max_aut2 ; $i++) {
				$indice = $as[$i] ;
				$auteur_2 = $this->responsabilites["auteurs"][$indice] ;
				$auteur = new auteur($auteur_2["id"]);
				if ($value_deflt_fonction && $auteur_2["id"]==0 && $i==0) $auteur_2["fonction"] = $value_deflt_fonction ;
				
				$ptab_aut_autres = str_replace('!!iaut!!', $i, $ptab[12]) ;
					
				$ptab_aut_autres = str_replace('!!aut2_id!!',			$auteur_2["id"], $ptab_aut_autres);
				$ptab_aut_autres = str_replace('!!aut2!!',				htmlentities($auteur->display,ENT_QUOTES, $charset), $ptab_aut_autres);
				$ptab_aut_autres = str_replace('!!f2_code!!',			$auteur_2["fonction"], $ptab_aut_autres);
				$ptab_aut_autres = str_replace('!!f2!!',				$fonction->table[$auteur_2["fonction"]], $ptab_aut_autres);
				$auteurs_secondaires .= $ptab_aut_autres ;
				}
			$ptab[1] = str_replace('!!max_aut2!!', $max_aut2, $ptab[1]);
			
			$ptab[1] = str_replace('!!autres_auteurs!!', $autres_auteurs, $ptab[1]);
			$ptab[1] = str_replace('!!auteurs_secondaires!!', $auteurs_secondaires, $ptab[1]);
			$form_notice = str_replace('!!tab1!!', $ptab[1], $form_notice);
		
			// mise  jour de l'onglet 2
			$ptab[2] = str_replace('!!ed1_id!!',			$this->ed1_id			, $ptab[2]);
			$ptab[2] = str_replace('!!ed1!!',				htmlentities($this->ed1,ENT_QUOTES, $charset)				, $ptab[2]);
			$ptab[2] = str_replace('!!coll_id!!',			$this->coll_id			, $ptab[2]);
			$ptab[2] = str_replace('!!coll!!',				htmlentities($this->coll,ENT_QUOTES, $charset)				, $ptab[2]);
			$ptab[2] = str_replace('!!subcoll_id!!',			$this->subcoll_id		, $ptab[2]);
			$ptab[2] = str_replace('!!subcoll!!',			htmlentities($this->subcoll,ENT_QUOTES, $charset)			, $ptab[2]);
			$ptab[2] = str_replace('!!year!!',				$this->year				, $ptab[2]);
			$ptab[2] = str_replace('!!nocoll!!',			htmlentities($this->nocoll,ENT_QUOTES, $charset)			, $ptab[2]);
			$ptab[2] = str_replace('!!mention_edition!!',			htmlentities($this->mention_edition,ENT_QUOTES, $charset)			, $ptab[2]);
			$ptab[2] = str_replace('!!ed2_id!!',			$this->ed2_id			, $ptab[2]);
			$ptab[2] = str_replace('!!ed2!!',				htmlentities($this->ed2,ENT_QUOTES, $charset)				, $ptab[2]);
		
			$form_notice = str_replace('!!tab2!!', $ptab[2], $form_notice);
		
			// mise  jour de l'onglet 3
			$ptab[3] = str_replace('!!cb!!',				$this->code				, $ptab[3]);
			$ptab[3] = str_replace('!!notice_id!!',			$this->id				, $ptab[3]);
		
			$form_notice = str_replace('!!tab3!!', $ptab[3], $form_notice);
		
			// mise  jour de l'onglet 4
			$ptab[4] = str_replace('!!npages!!',	htmlentities($this->npages	,ENT_QUOTES, $charset)	, $ptab[4]);
			$ptab[4] = str_replace('!!ill!!',		htmlentities($this->ill		,ENT_QUOTES, $charset)	, $ptab[4]);
			$ptab[4] = str_replace('!!size!!',		htmlentities($this->size	,ENT_QUOTES, $charset)	, $ptab[4]);
			$ptab[4] = str_replace('!!prix!!',		htmlentities($this->prix	,ENT_QUOTES, $charset)	, $ptab[4]);
			$ptab[4] = str_replace('!!accomp!!',	htmlentities($this->accomp	,ENT_QUOTES, $charset)	, $ptab[4]);
		
			$form_notice = str_replace('!!tab4!!', $ptab[4], $form_notice);
		
			// mise  jour de l'onglet 5
			$ptab[5] = str_replace('!!n_gen!!',		htmlentities($this->n_gen	,ENT_QUOTES, $charset)	, $ptab[5]);
			$ptab[5] = str_replace('!!n_contenu!!',	htmlentities($this->n_contenu	,ENT_QUOTES, $charset)	, $ptab[5]);
			$ptab[5] = str_replace('!!n_resume!!',	htmlentities($this->n_resume	,ENT_QUOTES, $charset)	, $ptab[5]);
		
			$form_notice = str_replace('!!tab5!!', $ptab[5], $form_notice);
		
			// mise  jour de l'onglet 6
			// catgories
			if (sizeof($this->categories)==0) $max_categ = 1 ;
				else $max_categ = sizeof($this->categories) ; 
			for ($i = 0 ; $i < $max_categ ; $i++) {
				$categ_id = $this->categories[$i]["categ_id"] ;
				$categ = new category($categ_id);
				
				if ($i==0) $ptab_categ = str_replace('!!icateg!!', $i, $ptab[60]) ;
					else $ptab_categ = str_replace('!!icateg!!', $i, $ptab[601]) ;
					
				$ptab_categ = str_replace('!!categ_id!!',			$categ_id, $ptab_categ);
				if ( sizeof($this->categories)==0 ) { 
					$ptab_categ = str_replace('!!categ_libelle!!', '', $ptab_categ);		
					} else {
						if ($thesaurus_mode_pmb) $nom_tesaurus='['.$categ->thes->getLibelle().'] ' ;
							else $nom_tesaurus='' ;
						$ptab_categ = str_replace('!!categ_libelle!!',	htmlentities($nom_tesaurus.$categ->catalog_form,ENT_QUOTES, $charset), $ptab_categ);
						}
				$categ_repetables .= $ptab_categ ;
				}
			$ptab[6] = str_replace('!!max_categ!!', $max_categ, $ptab[6]);
			$ptab[6] = str_replace('!!categories_repetables!!', $categ_repetables, $ptab[6]);
		
			// indexation interne
			$ptab[6] = str_replace('!!indexint_id!!', $this->indexint, $ptab[6]);
			if($this->indexint){
				$indexint = new indexint($this->indexint);
				if ($indexint->comment) $disp_indexint= $indexint->name." - ".$indexint->comment ;
				else $disp_indexint= $indexint->name ;
				if ($thesaurus_classement_mode_pmb != 0) { //classement indexation dcimale autoris en parametrage
					if($indexint->pclassname) $disp_indexint="[".$indexint->pclassname."] ".$disp_indexint;					
				}
				$ptab[6] = str_replace('!!indexint!!', htmlentities($disp_indexint,ENT_QUOTES, $charset), $ptab[6]);
			} else {
				$ptab[6] = str_replace('!!indexint!!', '', $ptab[6]);
			}
		
			// indexation libre
			$ptab[6] = str_replace('!!f_indexation!!', htmlentities($this->index_l,ENT_QUOTES, $charset), $ptab[6]);
			global $pmb_keyword_sep ;
			if (!$pmb_keyword_sep) $pmb_keyword_sep=" ";
			$ptab[6] = str_replace("!!sep!!",htmlentities($pmb_keyword_sep,ENT_QUOTES, $charset),$ptab[6]);
			$form_notice = str_replace('!!tab6!!', $ptab[6], $form_notice);
		
			// mise  jour de l'onglet 7 : langues
			// langues rptables
			if (sizeof($this->langues)==0) $max_lang = 1 ;
				else $max_lang = sizeof($this->langues) ; 
			for ($i = 0 ; $i < $max_lang ; $i++) {
				if ($i) $ptab_lang = str_replace('!!ilang!!', $i, $ptab[701]) ;
					else $ptab_lang = str_replace('!!ilang!!', $i, $ptab[70]) ;
				if ( sizeof($this->langues)==0 ) { 
					$ptab_lang = str_replace('!!lang_code!!', '', $ptab_lang);
					$ptab_lang = str_replace('!!lang!!', '', $ptab_lang);		
					} else {
						$ptab_lang = str_replace('!!lang_code!!', $this->langues[$i]["lang_code"], $ptab_lang);
						$ptab_lang = str_replace('!!lang!!',htmlentities($this->langues[$i]["langue"],ENT_QUOTES, $charset), $ptab_lang);
						}
				$lang_repetables .= $ptab_lang ;
				}
			$ptab[7] = str_replace('!!max_lang!!', $max_lang, $ptab[7]);
			$ptab[7] = str_replace('!!langues_repetables!!', $lang_repetables, $ptab[7]);
		
			// langues originales rptables
			if (sizeof($this->languesorg)==0) $max_langorg = 1 ;
				else $max_langorg = sizeof($this->languesorg) ; 
			for ($i = 0 ; $i < $max_langorg ; $i++) {
				if ($i) $ptab_lang = str_replace('!!ilangorg!!', $i, $ptab[711]) ;
					else $ptab_lang = str_replace('!!ilangorg!!', $i, $ptab[71]) ;
				if ( sizeof($this->languesorg)==0 ) { 
					$ptab_lang = str_replace('!!langorg_code!!', '', $ptab_lang);
					$ptab_lang = str_replace('!!langorg!!', '', $ptab_lang);		
					} else {
						$ptab_lang = str_replace('!!langorg_code!!', $this->languesorg[$i]["lang_code"], $ptab_lang);
						$ptab_lang = str_replace('!!langorg!!',htmlentities($this->languesorg[$i]["langue"],ENT_QUOTES, $charset), $ptab_lang);
						}
				$langorg_repetables .= $ptab_lang ;
				}
			$ptab[7] = str_replace('!!max_langorg!!', $max_langorg, $ptab[7]);
			$ptab[7] = str_replace('!!languesorg_repetables!!', $langorg_repetables, $ptab[7]);
		
			$form_notice = str_replace('!!tab7!!', $ptab[7], $form_notice);
		
			// mise  jour de l'onglet 8
			$ptab[8] = str_replace('!!lien!!',			htmlentities($this->lien	,ENT_QUOTES, $charset)	, $ptab[8]);
			$ptab[8] = str_replace('!!eformat!!',		htmlentities($this->eformat	,ENT_QUOTES, $charset)	, $ptab[8]);
		
			$form_notice = str_replace('!!tab8!!', $ptab[8], $form_notice);
		
			//Mise  jour de l'onglet 9
			$p_perso=new parametres_perso("notices");
			
			if (!$p_perso->no_special_fields) {
				// si on duplique, construire le formulaire avec les donnes de la notice d'origine
				if ($this->duplicate_from_id) $perso_=$p_perso->show_editable_fields($this->duplicate_from_id);
					else $perso_=$p_perso->show_editable_fields($this->id);
				$perso="";
				for ($i=0; $i<count($perso_["FIELDS"]); $i++) {
					$p=$perso_["FIELDS"][$i];
					$perso.="<div id='move_".$p["NAME"]."' movable='yes' title=\"".htmlentities($p["TITRE"],ENT_QUOTES, $charset)."\">
								<div class='row'><label for='".$p["NAME"]."' class='etiquette'>".htmlentities($p["TITRE"],ENT_QUOTES, $charset)."</label></div>
								<div class='row'>".$p["AFF"]."</div>
							 </div>";
				}
				$perso.=$perso_["CHECK_SCRIPTS"];
				$ptab[9]=str_replace("!!champs_perso!!",$perso,$ptab[9]);
			} else 
				$ptab[9]="\n<script>function check_form() { return true; }</script>\n";
			
			$form_notice = str_replace('!!tab9!!', $ptab[9], $form_notice);
		
			//Liens vers d'autres notices
			//Rcupration de la notice mre
			$relations="";
			$n_rel=0;
		
			for ($ir=0; $ir<count($this->notice_mere_id); $ir++) {
				if ($ir==0) $pattern_rel=$ptab[130]; else  $pattern_rel=$ptab[131];
				$pattern_rel=str_replace("!!notice_relations_id!!",$this->notice_mere_id[$ir],$pattern_rel);
				$pattern_rel=str_replace("!!notice_relations_libelle!!",htmlentities($this->notice_mere[$ir],ENT_QUOTES,$charset),$pattern_rel);
				$pattern_rel=str_replace("!!n_rel!!",$ir,$pattern_rel);
				//Rcupration des types de relation
				$liste_type_relation=new marc_select("relationtypeup","f_rel_type_$ir",$this->relation_type[$ir]);
				$type_relation=$liste_type_relation->display;
				$pattern_rel=str_replace("!!f_notice_type_relations!!",$type_relation,$pattern_rel);
				$relations.=$pattern_rel;
				$n_rel++;
			}
			if (!$n_rel) {
				$pattern_rel=$ptab[130];
				$pattern_rel=str_replace("!!notice_relations_id!!","",$pattern_rel);
				$pattern_rel=str_replace("!!notice_relations_libelle!!","",$pattern_rel);
				$pattern_rel=str_replace("!!n_rel!!",$ir,$pattern_rel);
				//Rcupration des types de relation
				$liste_type_relation=new marc_select("relationtypeup","f_rel_type_0");
				$type_relation=$liste_type_relation->display;
				$pattern_rel=str_replace("!!f_notice_type_relations!!",$type_relation,$pattern_rel);
				$relations.=$pattern_rel;
				$n_rel=1;
			}
			
			//Nombre de relations
			$ptab[13]=str_replace("!!max_rel!!",$n_rel,$ptab[13]);
			
			//Liens multiples
			$ptab[13]=str_replace("!!notice_relations!!",$relations,$ptab[13]);
			
			$form_notice = str_replace('!!tab11!!', $ptab[13],$form_notice);
		
			// champs de gestion
			$select_statut = gen_liste_multiple ("select id_notice_statut, gestion_libelle from notice_statut order by 2", "id_notice_statut", "gestion_libelle", "id_notice_statut", "form_notice_statut", "", $this->statut, "", "","","",0) ;
			$ptab[10] = str_replace('!!notice_statut!!', $select_statut, $ptab[10]);
			$ptab[10] = str_replace('!!commentaire_gestion!!',htmlentities($this->commentaire_gestion,ENT_QUOTES, $charset), $ptab[10]);
			$form_notice = str_replace('!!tab10!!', $ptab[10], $form_notice);
		
			// dfinition de la page cible du form
			$form_notice = str_replace('!!action!!', $this->action, $form_notice);
		
			// ajout des selecteurs
			$select_doc = new marc_select('doctype', 'typdoc', $this->type_doc, "get_pos(); expandAll(); ajax_parse_dom(); if (inedit) move_parse_dom(relative); else initIt();");
			$form_notice = str_replace('!!doc_type!!', $select_doc->display, $form_notice);
		
			$form_notice = str_replace('!!notice_id_no_replace!!', $this->id, $form_notice);
		
			// Ajout des localisations pour dition
			$select_loc="";
			if ($PMBuserid==1) {
				$req_loc="select idlocation,location_libelle from docs_location";
				$res_loc=mysql_query($req_loc);
				if (mysql_num_rows($res_loc)>1) {	
					$select_loc="<select name='grille_location' id='grille_location' style='display:none' onChange=\"get_pos(); expandAll(); if (inedit) move_parse_dom(relative); else initIt();\">\n";
					$select_loc.="<option value='0'>Toutes les localisations</option>\n";
					while ($r=mysql_fetch_object($res_loc)) {
						$select_loc.="<option value='".$r->idlocation."'>".$r->location_libelle."</option>\n";
					}
					$select_loc.="</select>\n";
				}
			}	
			$form_notice=str_replace("!!location!!",$select_loc,$form_notice);
		
			// affichage du lien pour suppression et du lien d'annulation
			if ($this->id) {
				$link_supp = "
				<script type=\"text/javascript\">
					function confirm_delete() {
						result = confirm(\"{$msg[confirm_suppr_notice]}\");
		       		if(result)
		           		document.location = './catalog.php?categ=delete&id=".$this->id."'
					}
				</script>
				<input type='button' class='bouton' value=\"{$msg[63]}\" onClick=\"confirm_delete();\" />";
				$link_annul = "<input type='button' class='bouton' value=\"{$msg[76]}\" onClick=\"document.location='./catalog.php?categ=isbd&id=".$this->id."';\" />";
				$link_remplace =  "<input type='button' class='bouton' value='$msg[158]' onclick='document.location=\"./catalog.php?categ=remplace&id=".$this->id."\"' />";
				$link_duplicate =  "<input type='button' class='bouton' value='$msg[notice_duplicate_bouton]' onclick='document.location=\"./catalog.php?categ=duplicate&id=".$this->id."\"' />";
				if ($z3950_accessible) $link_z3950 = "<input type='button' class='bouton' value='$msg[notice_z3950_update_bouton]' onclick='document.location=\"./catalog.php?categ=z3950&id_notice=".$this->id."&isbn=".$this->code."\"' />";
					else $link_z3950="";
				if ($pmb_type_audit) $link_audit =  "<input class='bouton' type='button' onClick=\"window.open('./audit.php?type_obj=1&object_id=$this->id', 'audit_popup', '$select_categ_prop')\" title='$msg[audit_button]' value='$msg[audit_button]' />";
					else $link_audit = "" ;
				} else {
					$link_supp = "";
					$link_remplace = "";
					$link_duplicate = "" ;
					$link_z3950 = "" ;
					$link_audit = "" ;
					if ($this->notice_mere_id) $link_annul = "<input type='button' class='bouton' value=\"{$msg[76]}\" onClick=\"document.location='./catalog.php?categ=isbd&id=".$this->notice_mere_id."';\" />"; 
						else $link_annul = "<input type='button' class='bouton' value=\"{$msg[76]}\" onClick=\"document.location='".$this->link_annul."';\" />";
					}
			$form_notice = str_replace('!!link_supp!!', $link_supp, $form_notice);
			$form_notice = str_replace('!!link_annul!!', $link_annul, $form_notice);
			$form_notice = str_replace('!!link_remplace!!', $link_remplace, $form_notice);
			$form_notice = str_replace('!!link_duplicate!!', $link_duplicate, $form_notice);
			$form_notice = str_replace('!!link_z3950!!', $link_z3950, $form_notice);
			$form_notice = str_replace('!!link_audit!!', $link_audit, $form_notice);
			return $form_notice;
			}
		
		// ---------------------------------------------------------------
		//		replace_form : affichage du formulaire de remplacement
		// ---------------------------------------------------------------
		function replace_form() {
			global $notice_replace;
			global $msg;
			global $include_path;
		
			// a complter
			if(!$this->id) {
				require_once("$include_path/user_error.inc.php");
				error_message($msg[161], $msg[162], 1, './catalog.php');
				return false;
				}
		
			$notice_replace=str_replace('!!old_notice_libelle!!', $this->tit1." - ".$this->code, $notice_replace);
			$notice_replace=str_replace('!!id!!', $this->id, $notice_replace);
			print $notice_replace;
		}
		
		// ---------------------------------------------------------------
		//		replace($by) : remplacement de la notice
		// ---------------------------------------------------------------
		function replace($by) {
		
			global $msg;
			global $dbh;
		
			if($this->id == $by) {
				return $msg[223];
				}
			if (($this->id == $by) || (!$this->id))  {
				return $msg[223];
				}
		
			$by_notice= new notice($by);
			if ($this->biblio_level != $by_notice->biblio_level || $this->hierar_level != $by_notice->hierar_level) {
				return $msg[catal_rep_not_err1];
				}
				
			// remplacement dans les exemplaires
			$requete = "UPDATE exemplaires SET expl_notice='$by' WHERE expl_notice='$this->id' ";
			$res = mysql_query($requete, $dbh);
			
			// remplacement dans les dpouillements
			$requete = "UPDATE analysis SET analysis_notice='$by' WHERE analysis_notice='$this->id' ";
			$res = mysql_query($requete, $dbh);
			
			// remplacement dans les bulletins
			$requete = "UPDATE bulletins SET bulletin_notice='$by' WHERE bulletin_notice='$this->id' ";
			$res = mysql_query($requete, $dbh);
			
			// remplacement dans les notices filles
			$requete = "UPDATE notices_relation SET num_notice='$by' WHERE num_notice='$this->id' ";
			$res = @mysql_query($requete, $dbh);
			$requete = "UPDATE notices_relation SET linked_notice='$by' WHERE linked_notice='$this->id' ";
			$res = @mysql_query($requete, $dbh);
			$requete = "delete from notices_relation where linked_notice='$this->id' or linked_notice='$this->id' ";
			$res = @mysql_query($requete, $dbh);
			
			// remplacement dans les resas
			$requete = "UPDATE resa SET resa_idnotice='$by' WHERE resa_idnotice='$this->id' ";
			$res = mysql_query($requete, $dbh);
			
			// effacement dans la table des notices
			$requete = "DELETE FROM notices WHERE notice_id='$this->id' ";
			$result = mysql_query($requete, $dbh);
			
			// effacement dans la table des responsabilits
			$requete = "delete from responsability where responsability_notice = '$this->id' ";
			$result = mysql_query($requete, $dbh);
			
			// effacement dans les paniers
			$requete = "delete from caddie_content where object_id = '$this->id' ";
			$result = mysql_query($requete, $dbh);
		
			// effacement dans les bannettes
			$requete = "delete from bannette_contenu where num_notice = '$this->id' ";
			$result = mysql_query($requete, $dbh);
			
			// effacement dans les catgories
			$requete = "delete from notices_categories where notcateg_notice = '$this->id' ";
			$result = mysql_query($requete, $dbh);
			
			// effacement dans les audits
			$requete = "delete from audit where object_id = '$this->id' and type_obj=1";
			$result = mysql_query($requete, $dbh);
			
			// effacement des liens
			$requete="delete from notices_relations where linked_notice=".$this->id;
			$result = mysql_query($requete);
			
			//supression des champs personaliss
			$p_perso=new parametres_perso("notices");
			$p_perso->delete_values($this->id);
			
			return FALSE;
		}
		
		function del_notice ($id) {
			global $dbh ;
			
			$p_perso=new parametres_perso("notices");
			$p_perso->delete_values($id);
			
			$requete = "DELETE FROM notices_categories WHERE notcateg_notice='$id'" ;
			@mysql_query($requete, $dbh);
		
			$requete = "DELETE FROM notices_langues WHERE num_notice='$id'" ;
			@mysql_query($requete, $dbh);
			
			$requete = "DELETE FROM notices WHERE notice_id='$id'" ;
			@mysql_query($requete, $dbh);
			audit::delete_audit (1, $id) ;
			
			// Effacement de l'occurence de la notice ds la table notices_global_index :
			$requete = "DELETE FROM notices_global_index WHERE notice_id=".$id;
			@mysql_query($requete, $dbh);
			
			// Effacement des occurences de la notice ds la table notices_mots_global_index :
			$requete = "DELETE FROM notices_mots_global_index WHERE id_notice=".$id;
			@mysql_query($requete, $dbh);
			
			$requete = "delete from notices_relations where num_notice='$id' OR linked_notice='$id' ";
			@mysql_query($requete, $dbh);
					
			// limination des docs numriques
			$requete = "DELETE FROM explnum WHERE explnum_notice='$id'" ;
			@mysql_query($requete, $dbh);
			
			$requete = "DELETE FROM responsability WHERE responsability_notice='$id'" ;
			@mysql_query($requete, $dbh);
				
			$requete = "DELETE FROM bannette_contenu WHERE num_notice='$id'" ;
			@mysql_query($requete, $dbh);
				
			$query_caddie = "select caddie_id from caddie_content, caddie where type='NOTI' and object_id='$id' and caddie_id=idcaddie ";
			$result_caddie = @mysql_query($query_caddie, $dbh);
			while($cad = @mysql_fetch_object($result_caddie)) {
				$req_suppr_caddie="delete from caddie_content where caddie_id = '$cad->caddie_id' and object_id in ($where_in) " ;
				@mysql_query($req_suppr_caddie, $dbh);
			}
			
			$requete="delete from notices_relations where linked_notice=".$id;
			@mysql_query($requete);
		}
			
		// Fonction statique pour la cration / maj d'un n-uplet dans la table "notices_global_index" lors de la cration ou mise  jour d'une notice.
		function majNoticesGlobalIndex($notice, $NoIndex = 1) {
			global $dbh;
			global $opac_thesaurus;
			global $thesaurus_defaut;
			global $lang;
			
			mysql_query("delete from notices_global_index where num_notice = ".$notice." AND no_index = ".$NoIndex,$dbh);
			$titres = mysql_query("select index_serie, tnvol, index_wew, index_sew, index_l, index_matieres, n_gen, n_contenu, n_resume, index_n_gen, index_n_contenu, index_n_resume from notices where notice_id = ".$notice, $dbh);
		   	$mesNotices = mysql_fetch_assoc($titres);
		   	$tit = $mesNotices['index_wew'];
		   	$indTit = $mesNotices['index_sew'];
		   	$indMat = $mesNotices['index_matieres'];
		   	$indL = $mesNotices['index_l'];
		   	$indResume = $mesNotices['index_n_resume'];
		   	$indGen = $mesNotices['index_n_gen'];
		   	$indContenu = $mesNotices['index_n_contenu'];
		   	$resume = $mesNotices['n_resume'];
		   	$gen = $mesNotices['n_gen'];
		   	$contenu = $mesNotices['n_contenu'];
		   	$indSerie = $mesNotices['index_serie'];
		   	$tvol = $mesNotices['tnvol'];
		   	mysql_query("insert into notices_global_index (num_notice, no_index, infos_global, index_infos_global) values(".$notice.",".$NoIndex.",CONCAT(' ".addslashes($tvol)." ','".addslashes($tit)." ','".addslashes($resume)." ','".addslashes($gen)." ','".addslashes($contenu)." ','".addslashes($indL)." '),CONCAT(' ".$indSerie." ','".addslashes($indTit)." ','".addslashes($indResume)." ','".addslashes($indGen)." ','".addslashes($indContenu)." ','".addslashes($indMat)." '))",$dbh);
		   	// Authors : 
		   	$auteurs = mysql_query("select author_name, author_rejete, index_author from authors, responsability WHERE responsability_author = author_id AND responsability_notice = $notice", $dbh);
		   	$numA = mysql_num_rows($auteurs);
		   	for($j=0;$j < $numA; $j++) {
		   		$mesAuteurs = mysql_fetch_assoc($auteurs);
		   		$indAuteur = $mesAuteurs['index_author'];
		   		$auteurName = $mesAuteurs['author_name'];
		   		$auteurRejete = $mesAuteurs['author_rejete'];
		   		mysql_query("UPDATE notices_global_index SET infos_global = CONCAT(infos_global,'".addslashes($auteurName)." ','".addslashes($auteurRejete)." ') WHERE num_notice = ".$notice." AND no_index = ".$NoIndex, $dbh);
		   		mysql_query("UPDATE notices_global_index SET index_infos_global = CONCAT(index_infos_global,'".addslashes($indAuteur)." ') WHERE num_notice = ".$notice." AND no_index = ".$NoIndex, $dbh);
		   	}
		   	mysql_free_result($auteurs);
		   	
		   	// Nom du priodique associe  la notice (si il existe) :
		   	$temp = mysql_query("select bulletin_notice from notices, analysis, bulletins WHERE notice_id = ".$notice." and notice_id = analysis_notice and analysis_bulletin = bulletin_id", $dbh);
		   	$numP = mysql_num_rows($temp);
		   	for($j=0;$j < $numP; $j++) {
				// La notice appartien a un perdiodique, on selectionne le titre de priodique :
		   		$mesTemp = mysql_fetch_assoc($temp);
		   		$monTemp = $mesTemp['bulletin_notice'];
		   		// $monTemp contient le num de notice du priodique, on peut donc obtenir le titre a partir de celui ci :
		   		$periodique = mysql_query("select index_wew, index_sew from notices where notice_id = ".$monTemp,$dbh);
		   		$mesPerios = mysql_fetch_assoc($periodique);
		   		$indWew = $mesPerios['index_wew'];
		   		$indSew = $mesPerios['index_sew'];
		   		mysql_query("UPDATE notices_global_index SET infos_global = CONCAT(infos_global,'".addslashes($indWew)." ') WHERE num_notice= ".$notice." AND no_index = ".$NoIndex, $dbh);
		   		mysql_query("UPDATE notices_global_index SET index_infos_global = CONCAT(index_infos_global,'".addslashes($indSew)." ') WHERE num_notice = ".$notice." AND no_index = ".$NoIndex, $dbh);
		   		mysql_free_result($periodique);
		   	}
		   	mysql_free_result($temp);
		   	
		   	// Categories : 
		   	$noeud = mysql_query("select num_noeud from notices_categories where notcateg_notice = ".$notice, $dbh);
		   	$numNoeuds = mysql_num_rows($noeud); 	
		   	// Pour chaque noeud trouvs on cherche les noeuds parents et les noeuds fils :
		   	for($j=0;$j < $numNoeuds; $j++) {
		   		// On met  jours la table notices_global_index avec le noeud trouv:
			 	$mesNoeuds = mysql_fetch_assoc($noeud);
			   	$noeudInit = $mesNoeuds['num_noeud'];
			 	noeuds::majNoticesGlobalIndex($noeudInit,$NoIndex,$notice);  		
		   		// On cherche tous les noeuds parents du noeud trouv :
		   	}
		   	
		   	// Sous-collection : 
		   	$subColls = mysql_query("select sub_coll_name, index_sub_coll from notices, sub_collections WHERE subcoll_id = sub_coll_id AND notice_id = ".$notice, $dbh);
		   	$numSC = mysql_num_rows($subColls);
		   	for($j=0;$j < $numSC; $j++) {
		   		$mesSubColl = mysql_fetch_assoc($subColls);
		   		$indSubColl = $mesSubColl['index_sub_coll'];
		   		$subCallName = $mesSubColl['sub_coll_name'];
		   		mysql_query("UPDATE notices_global_index SET infos_global = CONCAT(infos_global,'".addslashes($subCallName)." ') WHERE num_notice = ".$notice." AND no_index = ".$NoIndex, $dbh);
		   		mysql_query("UPDATE notices_global_index SET index_infos_global = CONCAT(index_infos_global,'".addslashes($indSubColl)." ') WHERE num_notice = ".$notice." AND no_index = ".$NoIndex, $dbh);
		   	}
		   	mysql_free_result($subColls);
		   	
		   	// Indexation numrique : 
		   	$indexNums = mysql_query("select indexint_name, indexint_comment, index_indexint from notices, indexint WHERE indexint = indexint_id AND notice_id = ".$notice, $dbh);
		   	$numIN = mysql_num_rows($indexNums);
		   	for($j=0;$j < $numIN; $j++) {
		   		$mesindexNums = mysql_fetch_assoc($indexNums);
		   		$indexNum = $mesindexNums['index_indexint'];
		   		$indexIntName = $mesindexNums['indexint_name'];
		   		$indexIntComment = $mesindexNums['indexint_comment'];
		   		mysql_query("UPDATE notices_global_index SET infos_global = CONCAT(infos_global,'".addslashes($indexIntName)." ','".addslashes($indexIntComment)." ') WHERE num_notice = ".$notice." AND no_index = ".$NoIndex, $dbh);
		   		mysql_query("UPDATE notices_global_index SET index_infos_global = CONCAT(index_infos_global,'".addslashes($indexNum)." ') WHERE num_notice = ".$notice." AND no_index = ".$NoIndex, $dbh);
		   	}
		   	mysql_free_result($indexNums);
		   	
		   	// Collection : 
		   	$Colls = mysql_query("select collection_name, index_coll from notices, collections WHERE coll_id = collection_id AND notice_id = ".$notice, $dbh);
		   	$numCo = mysql_num_rows($Colls);
		   	for($j=0;$j < $numCo; $j++) {
		   		$mesColl = mysql_fetch_assoc($Colls);
		   		$Coll = $mesColl['index_coll'];
		   		$CollName = $mesColl['collection_name'];
		   		mysql_query("UPDATE notices_global_index SET infos_global = CONCAT(infos_global,'".addslashes($CollName)." ') WHERE num_notice = ".$notice." AND no_index = ".$NoIndex, $dbh);
		   		mysql_query("UPDATE notices_global_index SET index_infos_global = CONCAT(index_infos_global,'".addslashes($Coll)." ') WHERE num_notice = ".$notice." AND no_index = ".$NoIndex, $dbh);
		   	}
		   	mysql_free_result($Colls);
		    	
		   	// Editeurs : 
		   	$editeurs = mysql_query("select ed_name, index_publisher from notices, publishers WHERE (ed1_id = ed_id OR ed2_id = ed_id) AND notice_id = ".$notice, $dbh);
		   	$numE = mysql_num_rows($editeurs);
		   	for($j=0;$j < $numE; $j++) {
		   		$mesEditeurs = mysql_fetch_assoc($editeurs);
		   		$edIndex = $mesEditeurs['index_publisher'];
		   		$edName = $mesEditeurs['ed_name'];
		   		mysql_query("UPDATE notices_global_index SET infos_global = CONCAT(infos_global,'".addslashes($edName)." ') WHERE num_notice = ".$notice." AND no_index = ".$NoIndex, $dbh);
		   		mysql_query("UPDATE notices_global_index SET index_infos_global = CONCAT(index_infos_global,'".addslashes($edIndex)." ') WHERE num_notice = ".$notice." AND no_index = ".$NoIndex, $dbh);
		   	}
		   	mysql_free_result($editeurs);
		   //}
		   mysql_free_result($titres);
		}
		
		// Fonction statique pour la cration / maj d'un n-uplet dans la table "notices_mots_global_index" lors de la cration ou mise  jour d'une notice.
		function majNoticesMotsGlobalIndex($notice) {
			global $include_path;
			global $msg;
			global $lang;
			$mots = array();
			mysql_query("delete from notices_mots_global_index where id_notice='".$notice."'");
			$fp=fopen($include_path."/indexation/notices/champs_base.xml","r");
    		if ($fp) {
				$xml=fread($fp,filesize($include_path."/indexation/notices/champs_base.xml"));
			}
			fclose($fp);
			$tableau=_parser_text_no_function_($xml,"INDEXATION");
			//analyse des donnes des tables
			for ($i=0;$i<count($tableau['FIELD']);$i++)
			{
				$temp=$tableau['REFERENCEKEY'][0][value]. ", " ;
				if ($tableau['FIELD'][$i]['EXTERNAL']=="yes") {
					for ($y=0;$y<=count($tableau['FIELD'][$i]['TABLEFIELD']);$y++)
					{
						$temp .= $tableau['FIELD'][$i]['TABLEFIELD'][$y][value].", ";
					}
					$temp = substr($temp,0,strlen($temp)-4);
				} else {
					$temp .= $tableau['FIELD'][$i]['TABLEFIELD'][0][value];
				}
				if ($tableau['FIELD'][$i]['EXTERNAL']!="yes") {
					if ($notice) {
						$req=mysql_query("SELECT $temp FROM ".$tableau['REFERENCE'][0][value]." where ".$tableau['REFERENCEKEY'][0][value]."='".$notice."';");
					} else {
						$req=mysql_query("SELECT $temp FROM ".$tableau['REFERENCE'][0][value].";");
					}
				} else {
					switch ($tableau['FIELD'][$i]['LINK'][0]['TYPE'])
					{
					case '1n':
						if ($notice) {
							$req=mysql_query("SELECT $temp FROM ".$tableau['FIELD'][$i]['TABLE'][0][value].", ".$tableau['REFERENCE'][0][value]." where ".$tableau['FIELD'][$i]['TABLE'][0][value].".".$tableau['FIELD'][$i]['TABLEKEY'][0][value]."=".$tableau['REFERENCE'][0][value].".".$tableau['FIELD'][$i]['LINK'][0]['REFERENCEFIELD'][0][value]." and ".$tableau['REFERENCEKEY'][0][value]."='".$notice."';");
						} else {
							$req=mysql_query("SELECT $temp FROM ".$tableau['FIELD'][$i]['TABLE'][0][value].", ".$tableau['REFERENCE'][0][value]." where ".$tableau['FIELD'][$i]['TABLE'][0][value].".".$tableau['FIELD'][$i]['TABLEKEY'][0][value]."=".$tableau['REFERENCE'][0][value].".".$tableau['FIELD'][$i]['LINK'][0]['REFERENCEFIELD'][0][value]);
						}
					break;
					case 'nn':
						if ($notice) {
							$req=mysql_query("SELECT $temp FROM ".$tableau['FIELD'][$i]['TABLE'][0][value].", ".$tableau['REFERENCE'][0][value].", ".$tableau['FIELD'][$i]['LINK'][0]['TABLE'][0][value]." where ".$tableau['FIELD'][$i]['TABLE'][0][value].".".$tableau['FIELD'][$i]['TABLEKEY'][0][value]."=".$tableau['FIELD'][$i]['LINK'][0]['TABLE'][0][value].".".$tableau['FIELD'][$i]['LINK'][0]['EXTERNALFIELD'][0][value]." and ".$tableau['FIELD'][$i]['LINK'][0]['TABLE'][0][value].".".$tableau['FIELD'][$i]['LINK'][0]['REFERENCEFIELD'][0][value]."=".$tableau['REFERENCE'][0][value].".".$tableau['REFERENCEKEY'][0][value]." and ".$tableau['REFERENCEKEY'][0][value]."='".$notice."';");
						} else {
							$req=mysql_query("SELECT $temp FROM ".$tableau['FIELD'][$i]['TABLE'][0][value].", ".$tableau['REFERENCE'][0][value].", ".$tableau['FIELD'][$i]['LINK'][0]['TABLE'][0][value]." where ".$tableau['FIELD'][$i]['TABLE'][0][value].".".$tableau['FIELD'][$i]['TABLEKEY'][0][value]."=".$tableau['FIELD'][$i]['LINK'][0]['TABLE'][0][value].".".$tableau['FIELD'][$i]['LINK'][0]['EXTERNALFIELD'][0][value]." and ".$tableau['FIELD'][$i]['LINK'][0]['TABLE'][0][value].".".$tableau['FIELD'][$i]['LINK'][0]['REFERENCEFIELD'][0][value]."=".$tableau['REFERENCE'][0][value].".".$tableau['REFERENCEKEY'][0][value]);	
						}
					break;	
					}
				}
				if ($req) {
					$result=mysql_fetch_array($req);
					$tableau_mots=explode(" ",strip_empty_words(stripslashes($result[$tableau['FIELD'][$i]['TABLEFIELD'][0][value]])));
					for ($j=0;$j<count($tableau_mots);$j++) {
						if ($tableau_mots[$j]) {
							$mots[$tableau_mots[$j]]++;
						}
					}
					foreach ($mots as $mot=>$nb) {
						$maj=mysql_query("insert into notices_mots_global_index values('".$result[$tableau['REFERENCEKEY'][0][value]]."','".$tableau['FIELD'][$i]['ID']."','".addslashes($mot)."','".$nb."')");
						if (!$maj) {
							print $msg['err_sql']."\n";
							print mysql_error();
						}	
					}
					$mots = array();
				} else {
					print $msg['err_sql']."\n";
					print mysql_error();
				}
			}
			mysql_free_result($req);
		}
	}
} # fin de dclaration
