<?php
// +-------------------------------------------------+
//  2002-2004 PMB Services / www.sigb.net pmb@sigb.net et contributeurs (voir www.sigb.net)
// +-------------------------------------------------+
// $Id: explnum.inc.php,v 1.32 2007/03/10 09:46:46 touraine37 Exp $

if (stristr($_SERVER['REQUEST_URI'], ".inc.php")) die("no access");

// charge le tableau des extensions/mimetypes, on en a besoin en maj comme en affichage
function create_tableau_mimetype() {
	global $lang;
	global $charset;
	global $include_path;
	
	global $_mimetypes_bymimetype_, $_mimetypes_byext_ ;
	
	if (sizeof($_mimetypes_bymimetype_)) return;
	$_mimetypes_bymimetype_ = array();
	$_mimetypes_byext_ = array();

	require_once ("$include_path/parser.inc.php") ;
	
	$fonction = array ("MIMETYPE" => "__mimetype__");
	
	_parser_("$include_path/mime_types/$lang.xml", $fonction, "MIMETYPELIST" ) ;
	
	}

function __mimetype__($param) {
	global $_mimetypes_bymimetype_, $_mimetypes_byext_ ;
	
	$mimetype_rec = array() ;
	$mimetype_rec["plugin"] = $param["PLUGIN"] ;
	$mimetype_rec["icon"] = $param["ICON"] ;
	$mimetype_rec["label"] = $param["LABEL"] ;
	$mimetype_rec["embeded"] = $param["EMBEDED"] ;
	
	$_mimetypes_bymimetype_[$param["NAME"]] = $mimetype_rec ;
	
	for ($i=0; $i<count($param["EXTENSION"]) ; $i++  ) {
		$mimetypeext_rec = array() ;
		$mimetypeext_rec = $mimetype_rec ;
		$mimetypeext_rec["mimetype"] = $param["NAME"] ;
		if ($param["EXTENSION"][$i]["LABEL"]) $mimetypeext_rec["label"] =  $param["EXTENSION"][$i]["LABEL"] ;
		$_mimetypes_byext_[$param["EXTENSION"][$i]["value"]] = $mimetypeext_rec ;
		}
	}

function extension_fichier ($fichier) {
	$f = strrev($fichier);
	$ext = substr($f, 0, strpos($f,"."));
	return strtolower(strrev($ext));
	} // fin extension_fichier

function icone_mimetype ($mimetype, $ext) {
	global $_mimetypes_bymimetype_, $_mimetypes_byext_ ;
	// trouve l'icone associe au mimetype
	// sinon trouve l'icone associe  l'extension
	/*
	echo "<pre>" ;
	print_r ($_mimetypes_bymimetype_) ;
	print_r ( $_mimetypes_byext_ ) ;
	echo "</pre>" ;
	echo "<br>-- $mimetype<br>-- $ext";
	*/
	if ($_mimetypes_bymimetype_[$mimetype]["icon"]) return $_mimetypes_bymimetype_[$mimetype]["icon"] ;
	if ($_mimetypes_byext_[$ext]["icon"]) return $_mimetypes_byext_[$ext]["icon"] ;
	return "unknown.gif" ;
	} // fin icone_mimetype

function trouve_mimetype ($fichier) {
	global $_mimetypes_bymimetype_, $_mimetypes_byext_ ;
	
	$ext = extension_fichier ($fichier) ;
	
	if ($ext!="") {
		// chercher le mimetype associ  l'extension : si trouve nickel, sinon : ""
		if ($_mimetypes_byext_[$ext]["mimetype"]) return $_mimetypes_byext_[$ext]["mimetype"] ;
	}
	if (extension_loaded('mime_magic')) {
		$mime_type = mime_content_type($fichier) ;
		if ($mime_type) return $mime_type ;
	}
	return "";
	} // fin trouve_mimetype

function reduire_image ($userfile_name) {
	
	global $pmb_vignette_x ;
	global $pmb_vignette_y ;
	
	if (!$pmb_vignette_x) $pmb_vignette_x=100 ;
	if (!$pmb_vignette_y) $pmb_vignette_y=100 ;
	
	$bidon = "./temp/$userfile_name";
	$size = @getimagesize($bidon);
	/*   ".gif"=>"1",
	                   ".jpg"=>"2",
	                   ".jpeg"=>"2",
	                   ".png"=>"3",
	                   ".swf"=>"4",
	                   ".psd"=>"5",
	                   ".bmp"=>"6");
	*/
	switch ($size[2]) {
		case 1:
			$src_img = imagecreatefromgif($bidon);
		 	break;
		case 2:
			$src_img = imagecreatefromjpeg($bidon);
			break;
		case 3:
			$src_img = imagecreatefrompng($bidon);
			break;
		case 6:
			$src_img = imagecreatefromwbmp($bidon);
			break;
		default:
			echo "Impossible de crer une vignette avec le fichier $userfile_name ! <!-- ".$size[2]." -->";
			break;
		}
	$erreur_vignette = 0 ;
	if ($src_img) {
		$rs=$pmb_vignette_x/$pmb_vignette_y;
		$taillex=imagesx($src_img);
		$tailley=imagesy($src_img);
		if (!$taillex || !$tailley) return "" ;
		if (($taillex>$pmb_vignette_x)||($tailley>$pmb_vignette_y)) {
			$r=$taillex/$tailley;
			if (($r<1)&&($rs<1)) {
				//Si x plus petit que y et taille finale portrait 
				//Si le format final est plus large en proportion
				if ($rs>$r) {
					$new_h=$pmb_vignette_y; 
					$new_w=$new_h*$r; 
				} else {
					$new_w=$pmb_vignette_x;
					$new_h=$new_w/$r;
				}
			} else if (($r<1)&&($rs>=1)){ 
				//Si x plus petit que y et taille finale paysage
				$new_h=$pmb_vignette_y;
				$new_w=$new_h*$r;  
			} else if (($r>1)&&($rs<1)) {
				//Si x plus grand que y et taille finale portrait
				$new_w=$pmb_vignette_x;
				$new_h=$new_w/$r;
			} else {
				//Si x plus grand que y et taille finale paysage
				if ($rs<$r) {
					$new_w=$pmb_vignette_x;
					$new_h=$new_w/$r;
				} else {
					$new_h=$pmb_vignette_y;
					$new_w=$new_h*$r;
				}
			}
		} else {
			$new_h = $tailley ;
			$new_w = $taillex ;
			}
		$dst_img=imagecreatetruecolor($pmb_vignette_x,$pmb_vignette_y);
		$alpha_color=imagecolorallocate($dst_img,0,0,0);
		imagefilledrectangle($dst_img,0,0,$pmb_vignette_x,$pmb_vignette_y,$alpha_color);
		imagecopyresized($dst_img,$src_img,round(($pmb_vignette_x-$new_w)/2),round(($pmb_vignette_y-$new_h)/2),0,0,$new_w,$new_h,ImageSX($src_img),ImageSY($src_img));
		imagecolortransparent($dst_img,$alpha_color);
		imagepng($dst_img, "./temp/".SESSid);
		$fp = fopen("./temp/".SESSid , "r" ) ;
		$contenu_vignette = fread ($fp, filesize("./temp/".SESSid));
		if (!$fp || $contenu_vignette=="") $erreur_vignette++ ;
		fclose ($fp) ;
		unlink("./temp/".SESSid);
		} else $contenu_vignette = "" ;
	return $contenu_vignette ;
	} // fin reduire_image


function construire_vignette($vignette_name, $userfile_name) {
	if ($vignette_name) {
		$contenu_vignette = reduire_image($vignette_name);
		} elseif ($userfile_name) {
			$contenu_vignette = reduire_image($userfile_name);
			} else $contenu_vignette = "";
	return $contenu_vignette ;
	} // fin construire_vignette


function explnum_update($f_explnum_id, $f_notice, $f_bulletin, $f_nom, $f_url, $retour) {
global $dbh, $msg ;

create_tableau_mimetype() ;

if ($f_explnum_id) {
	$requete = "UPDATE explnum SET ";
	$limiter = " WHERE explnum_id='$f_explnum_id' ";
	} else {
		$requete = "INSERT INTO explnum SET ";
		$limiter = "";
		}

print "<div class=\"row\"><h1>$msg[explnum_doc_associe]</h1>";

$erreur=0;
$userfile_name = $_FILES['f_fichier']['name'] ;
$userfile_temp = $_FILES['f_fichier']['tmp_name'] ;
$vignette_name = $_FILES['f_vignette']['name'] ;
$vignette_temp = $_FILES['f_vignette']['tmp_name'] ;

$userfile_name = preg_replace("/ |'|\\|\"|\//m", "_", $userfile_name);
$vignette_name = preg_replace("/ |'|\\|\"|\//m", "_", $vignette_name);

if ($userfile_name) $userfile_ext = extension_fichier ($userfile_name) ;
	else $userfile_ext = "";

if ($f_explnum_id) {
	// modification
	// si $userfile_name est vide on ne fera pas la maj du data
	if ($userfile_name) {
		if (move_uploaded_file($userfile_temp,"./temp/$userfile_name")) {
			$fic=1;
			$f_url="";
			$maj_data = 1;
			move_uploaded_file($vignette_temp,"./temp/$vignette_name") ;
			$contenu_vignette = construire_vignette($vignette_name, $userfile_name) ;
			$maj_vignette = 1 ;
			$mimetype = trouve_mimetype("./temp/$userfile_name") ;
			if (!$mimetype) $mimetype="application/data";
			$maj_mimetype = 1 ;
			} else $erreur++;
		} else {
			if ($vignette_name) {
				move_uploaded_file($vignette_temp,"./temp/$vignette_name") ;
				$contenu_vignette = construire_vignette($vignette_name, $userfile_name) ;
				$maj_vignette = 1 ;
				}
			if ($f_url) {
				move_uploaded_file($vignette_temp,"./temp/$vignette_name") ;
				$contenu_vignette = construire_vignette($vignette_name, $userfile_name) ;
				$maj_vignette = 1 ;
				$mimetype="URL";
				$maj_mimetype = 1 ;
				$contenu="";
				$maj_data=1 ;
				}
			}

	} else {
		// cration
		if (move_uploaded_file($userfile_temp,"./temp/$userfile_name")) {
			$fic=1;
			$f_url="";
			$maj_data = 1;
			} elseif (!$f_url) $erreur++;
		
		move_uploaded_file($vignette_temp,"./temp/$vignette_name") ;
		$contenu_vignette = construire_vignette($vignette_name, $userfile_name) ;
		$maj_vignette = 1 ;
		
		if (!$f_url && !$fic) $erreur++ ; 
		if ($f_url) {
			$mimetype = "URL" ;
			} else {
				$mimetype = trouve_mimetype("./temp/$userfile_name") ;
				if (!$mimetype) $mimetype="application/data";
				}
		$maj_mimetype = 1 ;
		}
		
if ($fic) {
	$fp = fopen("./temp/$userfile_name" , "r" ) ;
	$contenu = fread ($fp, filesize("./temp/$userfile_name"));
	if (!$fp || $contenu=="") $erreur++ ;
	fclose ($fp) ;
	}

if (!$f_nom) {
	if ($userfile_name) $f_nom = $userfile_name ;
		elseif ($f_url) $f_nom = $f_url ;
			else $f_nom = "-x-x-x-x-" ;
	}

if ($userfile_name) unlink("./temp/$userfile_name");
if ($vignette_name) unlink("./temp/$vignette_name");
	        
if (!$erreur) { 
	$requete .= " explnum_notice='$f_notice'";
	$requete .= ", explnum_bulletin='$f_bulletin'";
	$requete .= ", explnum_nom='$f_nom'";
	$requete .= ", explnum_url='$f_url'";
	if ($maj_mimetype)
		$requete .= ", explnum_mimetype='".$mimetype. "' ";
	if ($maj_data) {
		$requete .= ", explnum_data='".addslashes($contenu)."'";
		$requete .= ", explnum_nomfichier='".addslashes($userfile_name)."'";
		$requete .= ", explnum_extfichier='".addslashes($userfile_ext)."'";
		}
	if ($maj_vignette) 
		$requete .= ", explnum_vignette='".addslashes($contenu_vignette)."'";
	$requete .= $limiter;
	$result = mysql_query($requete, $dbh) ;
	// on raffiche l'ISBD
	print "<div class='row'><div class='msg-perio'>".$msg[maj_encours]."</div></div>";
	$id_form = md5(microtime());
	if (mysql_error()) {
		echo "MySQL error : ".mysql_error() ;
		print "
			<form class='form-$current_module' name=\"dummy\" method=\"post\" action=\"$retour\" >
				<input type='submit' class='bouton' name=\"id_form\" value=\"Ok\">
				</form>";
		print "</div>";
		exit ;
		}
	print "
		<form class='form-$current_module' name=\"dummy\" method=\"post\" action=\"$retour\" style=\"display:none\">
			<input type=\"hidden\" name=\"id_form\" value=\"$id_form\">
			</form>";
	print "<script type=\"text/javascript\">document.dummy.submit();</script>";

	} else {
		eval("\$bid=\"".$msg[explnum_erreurupload]."\";");
		print "<div class='row'><div class='msg-perio'>".$bid."</div></div>";
		print "
			<form class='form-$current_module' name=\"dummy\" method=\"post\" action=\"$retour\" >
				<input type='submit' class='bouton' name=\"id_form\" value=\"Ok\">
				</form>";
		}
		
print "</div>";
}

// fonction retournant les infos d'exemplaires numriques pour une notice ou un bulletin donn
function show_explnum_per_notice($no_notice, $no_bulletin, $link_expl='') {
global $msg;
// params :
// $link_expl= lien associ  l'exemplaire avec !!explnum_id!!  mettre  jour
global $dbh;
global $charset;

if (!$no_notice && !$no_bulletin) return "";

global $_mimetypes_bymimetype_, $_mimetypes_byext_ ;
create_tableau_mimetype() ;

// rcupration du nombre d'exemplaires
$requete = "SELECT explnum_id, explnum_notice, explnum_bulletin, explnum_nom, explnum_mimetype, explnum_url, explnum_data, explnum_vignette, explnum_nomfichier, explnum_extfichier FROM explnum WHERE ";
if ($no_notice) $requete .= "explnum_notice='$no_notice' ";
	else $requete .= "explnum_bulletin='$no_bulletin' ";
$requete .= " order by explnum_mimetype, explnum_id ";
$res = mysql_query($requete, $dbh) or die ($requete." ".mysql_error());
$nb_ex = mysql_num_rows($res);

if($nb_ex) {
	// on rcupre les donnes des exemplaires
	$i = 1 ;
	while ($expl = mysql_fetch_object($res)) {
		if ($i==1) $ligne="<tr><td class='docnum' width='25%'>!!1!!</td><td class='docnum' width='25%'>!!2!!</td><td class='docnum' width='25%'>!!3!!</td><td class='docnum' width='25%'>!!4!!</td></tr>" ;
		if ($link_expl) {
			$tlink = str_replace("!!explnum_id!!", $expl->explnum_id, $link_expl);
			$tlink = str_replace("!!notice_id!!", $expl->explnum_notice, $tlink);					
			$tlink = str_replace("!!bulletin_id!!", $expl->explnum_bulletin, $tlink);					
			} 
		$alt = htmlentities($expl->explnum_nom." - ".$expl->explnum_mimetype,ENT_QUOTES, $charset) ;
		
		global $prefix_url_image ;
		if ($prefix_url_image) $tmpprefix_url_image = $prefix_url_image; 
			else $tmpprefix_url_image = "./" ;

		if ($expl->explnum_vignette) $obj="<img src='".$tmpprefix_url_image."vig_num.php?explnum_id=$expl->explnum_id' alt='$alt' title='$alt' border='0'>";
			else // trouver l'icone correspondant au mime_type
				$obj="<img src='".$tmpprefix_url_image."images/mimetype/".icone_mimetype($expl->explnum_mimetype, $expl->explnum_extfichier)."' alt='$alt' title='$alt' border='0'>";
		
		$expl_liste_obj = "<center>";
		$expl_liste_obj .= "<a href='".$tmpprefix_url_image."doc_num.php?explnum_id=$expl->explnum_id' alt='$alt' title='$alt' target='_blank'>".$obj."</a><br>" ;
		
		if ($_mimetypes_byext_[$expl->explnum_extfichier]["label"]) $explmime_nom = $_mimetypes_byext_[$expl->explnum_extfichier]["label"] ;
			elseif ($_mimetypes_bymimetype_[$expl->explnum_mimetype]["label"]) $explmime_nom = $_mimetypes_bymimetype_[$expl->explnum_mimetype]["label"] ;
				else $explmime_nom = $expl->explnum_mimetype ;
		if ($tlink) {
			$expl_liste_obj .= "<a href='$tlink'>";
			$expl_liste_obj .= htmlentities($expl->explnum_nom,ENT_QUOTES, $charset)."</a><div class='explnum_type'>".htmlentities($explmime_nom,ENT_QUOTES, $charset)."</div>";
			} else {
				$expl_liste_obj .= htmlentities($expl->explnum_nom,ENT_QUOTES, $charset)."<div class='explnum_type'>".htmlentities($explmime_nom,ENT_QUOTES, $charset)."</div>";
				}
		
		$expl_liste_obj .= "</center>";
		$ligne = str_replace("!!$i!!", $expl_liste_obj, $ligne);
		$i++;
		if ($i==5) {
			$ligne_finale .= $ligne ;
			$i=1;
			}
		}
	if (!$ligne_finale) $ligne_finale = $ligne ;
		elseif ($i!=1) $ligne_finale .= $ligne ;
	$ligne_finale = str_replace('!!2!!', "&nbsp;", $ligne_finale);
	$ligne_finale = str_replace('!!3!!', "&nbsp;", $ligne_finale);
	$ligne_finale = str_replace('!!4!!', "&nbsp;", $ligne_finale);
	
	} else return "";
$entry .= "<table class='docnum'>$ligne_finale</table>";
return $entry;

}

