<?php
// +-------------------------------------------------+
//  2002-2004 PMB Services / www.sigb.net pmb@sigb.net et contributeurs (voir www.sigb.net)
// +-------------------------------------------------+
// $Id: fpdf.inc.php,v 1.47 2007/10/30 20:53:34 touraine37 Exp $

if (stristr($_SERVER['REQUEST_URI'], ".inc.php")) die("no access");

require_once($class_path."/amende.class.php");
require_once($class_path."/comptes.class.php");
require_once ("$include_path/notice_authors.inc.php");  
require_once($class_path."/serie.class.php");
require_once ("$class_path/author.class.php");  


// Fonctions fpdf
function biblio_info($x, $y, $short=0) {
	
	global $ourPDF;
	global $biblio_name, $biblio_logo, $biblio_adr1, $biblio_adr2, $biblio_cp, $biblio_town, $biblio_state, $biblio_country, $biblio_phone, $biblio_email, $biblio_website ;
	global $txt_biblio_info ;
	global $pmb_pdf_font;

	if ($short==1) {
			/*
		if ($biblio_adr1 != "") $biblio_name = $biblio_name."\n";
		if ($biblio_adr2 != "") $biblio_adr1 = $biblio_adr1."\n";
		if ($biblio_cp != "") $biblio_cp = $biblio_cp." ";
		if (($biblio_cp != "") || ($biblio_town != "")) $biblio_adr2 = $biblio_adr2."\n";
		if ($biblio_state != "") $biblio_state = $biblio_state." ";
		if (($biblio_state != "") || ($biblio_country != "")) $biblio_town = $biblio_town."\n";
		if ($biblio_phone != "") $biblio_phone = $biblio_phone."\n ";
		if ($biblio_email != "") $biblio_email = "@ : ".$biblio_email."\n ";
		if ($biblio_website != "") $biblio_website = "Web : ".$biblio_website."\n ";
		if (($biblio_phone != "") || ($biblio_email != "")) $biblio_country = $biblio_country."\n";
		$txt_biblio_info_short = $biblio_adr1.$biblio_adr2.$biblio_cp.$biblio_town.$biblio_state.$biblio_country.$biblio_phone.$biblio_email.$biblio_website ;
		*/
		$ourPDF->SetXY ($x,$y);
		$ourPDF->setFont($pmb_pdf_font, 'B', 16);
		$ourPDF->multiCell(120, 8, $biblio_name, 0, 'L', 0);
		/*
		$ourPDF->SetXY ($x,$y+20);
		$ourPDF->setFont('Arial', '', 10);
		$ourPDF->multiCell(0, 8, $txt_biblio_info_short, 0, 'L', 0);
		*/
	} else { 
		// afin de ne gnrer qu'une fois l'adr et compagnie 
		if (!$txt_biblio_info) {
			if ($biblio_adr1 != "") $biblio_name = $biblio_name."\n";
			if ($biblio_adr2 != "") $biblio_adr1 = $biblio_adr1."\n";
			if ($biblio_cp != "") $biblio_cp = $biblio_cp." ";
			if (($biblio_cp != "") || ($biblio_town != "")) $biblio_adr2 = $biblio_adr2."\n";
			if ($biblio_state != "") $biblio_state = $biblio_state." ";
			if (($biblio_state != "") || ($biblio_country != "")) $biblio_town = $biblio_town."\n";
			if ($biblio_phone != "") $biblio_phone = $biblio_phone."\n ";
			if ($biblio_email != "") $biblio_email = "@ : ".$biblio_email."\n ";
			if ($biblio_website != "") $biblio_website = "Web : ".$biblio_website."\n ";
			if (($biblio_phone != "") || ($biblio_email != "")) $biblio_country = $biblio_country."\n";
			$txt_biblio_info = $biblio_adr1.$biblio_adr2.$biblio_cp.$biblio_town.$biblio_state.$biblio_country.$biblio_phone.$biblio_email.$biblio_website ;
		}
		
		if ($biblio_logo) $ourPDF->Image("./images/".$biblio_logo, $x, $y ) ;

		$ourPDF->SetXY ($x+60,$y);
		$ourPDF->setFont($pmb_pdf_font, 'B', 16);
		$ourPDF->multiCell(90, 8, $biblio_name, 0, 'C', 0);
	
	
		//echo "x: $x y: $y txt: <pre>$txt_biblio_info</pre> <br>" ;
		$ourPDF->SetXY ($x,$y+50);
		$ourPDF->setFont($pmb_pdf_font, '', 10);
		$ourPDF->multiCell(0, 6, $txt_biblio_info, 0, 'L', 0);
	}
} /* fin biblio_info */

function lecteur_info($id_empr, $x, $y, $link, $short=0, $droite=0) {
	
	global $ourPDF;
	global $msg;
	global $pmb_pdf_font;
	
	$requete = "SELECT id_empr, empr_cb, empr_nom, empr_prenom, empr_adr1, empr_adr2, empr_cp, empr_ville, empr_pays, empr_mail, empr_tel1, empr_tel2, empr_date_adhesion, empr_date_expiration, date_format(empr_date_adhesion, '".$msg["format_date"]."') as aff_empr_date_adhesion, date_format(empr_date_expiration, '".$msg["format_date"]."') as aff_empr_date_expiration FROM empr WHERE id_empr='$id_empr' ";
	$res = mysql_query($requete, $link);
	$empr = mysql_fetch_object($res);

	$requete = "SELECT group_concat(libelle_groupe SEPARATOR ', ') as_all_groupes, 1 as rien from groupe join empr_groupe on groupe_id=id_groupe WHERE lettre_rappel=1 and empr_id='$id_empr' group by rien ";
	$lib_all_groupes=pmb_sql_value($requete);
	if ($lib_all_groupes) $lib_all_groupes="\n".$lib_all_groupes; 

	$ourPDF->SetXY ($x,$y);
	$ourPDF->setFont($pmb_pdf_font, 'B', 12);
	if ($droite) $ourPDF->multiCell(100, 8, $empr->empr_prenom." ".$empr->empr_nom, 0, 'R', 0);
		else $ourPDF->multiCell(100, 8, $empr->empr_prenom." ".$empr->empr_nom, 0, 'L', 0);

	if ($short==1) return ;
	
	if ($empr->empr_adr2 != "") $empr->empr_adr1 = $empr->empr_adr1."\n" ;
	if (($empr->empr_cp != "") || ($empr->empr_ville != "")) $empr->empr_adr2 = $empr->empr_adr2."\n" ;
	$adr = $empr->empr_adr1.$empr->empr_adr2.$empr->empr_cp." ".$empr->empr_ville ;
	if ($empr->empr_pays != "") $adr = $adr."\n".$empr->empr_pays ;
	if ($empr->empr_tel1 != "") {
		$tel = $tel.$msg['fpdf_tel1']." ".$empr->empr_tel1." " ;
		}
	if ($empr->empr_tel2 != "") {
		$tel = $tel.$msg['fpdf_tel2']." ".$empr->empr_tel2;
		} 
	if ($empr->empr_mail != "") {
		if ($tel) $tel = $tel."\n" ;
		$mail = $msg['fpdf_email']." ".$empr->empr_mail;
		} 
				
	$ourPDF->SetXY ($x,$y+8);
	$ourPDF->setFont($pmb_pdf_font, '', 12);
	$ourPDF->multiCell(100, 8, $adr, 0, 'L', 0);
	
	$ourPDF->SetXY ($x,$y+32);
	$ourPDF->setFont($pmb_pdf_font, '', 12);
	$ourPDF->multiCell(100, 7, "\n".$tel.$mail.$lib_all_groupes, 0, 'L', 0);
	
	$ourPDF->SetXY ($x,$y+58);
	$ourPDF->setFont($pmb_pdf_font, 'I', 12);
	$ourPDF->multiCell(100, 7, $msg['fpdf_carte']." ".$empr->empr_cb."\n".$msg['fpdf_adherent']." ".$empr->aff_empr_date_adhesion." ".$msg['fpdf_adherent_au']." ".$empr->aff_empr_date_expiration.".", 0, 'L', 0);
} /* fin lecteur_info */

// ********************* Imprime l'adresse d'un lecteur **********************************
function lecteur_adresse($id_empr, $x, $y, $link, $no_cb=false) {
	global $ourPDF;
	global $msg;
	global $pmb_pdf_font;
	
	$requete = "SELECT id_empr, empr_cb, empr_nom, empr_prenom, empr_adr1, empr_adr2, empr_cp, empr_ville, empr_pays, empr_mail, empr_tel1, empr_tel2  FROM empr WHERE id_empr='$id_empr' LIMIT 1 ";
	$res = mysql_query($requete, $link);
	$empr = mysql_fetch_object($res);
	
	$requete = "SELECT group_concat(libelle_groupe SEPARATOR ', ') as_all_groupes, 1 as rien from groupe join empr_groupe on groupe_id=id_groupe WHERE lettre_rappel=1 and empr_id='$id_empr' group by rien ";
	$lib_all_groupes=pmb_sql_value($requete);
	if ($lib_all_groupes) $lib_all_groupes="\n".$lib_all_groupes; 

	$ourPDF->SetXY ($x,$y);
	$ourPDF->setFont($pmb_pdf_font, '', 12);
	$ourPDF->multiCell(100, 8, $empr->empr_prenom." ".$empr->empr_nom, 0, 'L', 0);
	
	$ourPDF->SetXY ($x,$y+8);
	$ourPDF->setFont($pmb_pdf_font, '', 12);
	if ($empr->empr_adr2 != "") $empr->empr_adr1 = $empr->empr_adr1."\n" ;
	if (($empr->empr_cp != "") || ($empr->empr_ville != "")) $empr->empr_adr2 = $empr->empr_adr2."\n" ;
	$adr = $empr->empr_adr1.$empr->empr_adr2.$empr->empr_cp." ".$empr->empr_ville ;
	
	
	if ($empr->empr_pays != "") $adr = $adr."\n".$empr->empr_pays ;
	if ($empr->empr_tel1 != "") {
		$tel = "\n".$msg['fpdf_tel1']." ".$empr->empr_tel1;
		} elseif ($empr->empr_tel2 != "") {
			$adr = $adr."\n" ;
			$tel = $tel.$msg['fpdf_tel2']." ".$empr->empr_tel2;
			} else {
				$tel = "" ;
				}
	if ($empr->empr_mail != "") {
		$tel = $tel."\n" ;
		$mail = $msg['fpdf_email']." ".$empr->empr_mail;
		} else {
			$mail = "" ;
			}
	
	// -------------------- LliureX ----------------------------------------	
	// Modificado por: David Prez Lled
	// Fecha: 10/Enero/2011
	// Descripcin: Se comenta la linea siguiente, para eliminar que aparezcan
	// los datos personales (dom, loc, telefono etc..) en la carta de retraso
	// de la devolucin de ejemplares, para evitar que la carta (con sus datos 
	// personales puedan caer en manos de otro usuario.
	
	// $ourPDF->multiCell(100, 8, $adr, 0, 'L', 0);

	// -------------------- LliureX ----------------------------------------
	
	if ($no_cb==false)
	{
	$ourPDF->SetXY ($x,$y+50);
	$ourPDF->setFont($pmb_pdf_font, 'I', 10);

	// -------------------- LliureX ----------------------------------------	
	// Modificado por: David Prez Lled
	// Fecha: 14/Enero/2011
	// Descripcin: Se comenta la linea siguiente, para eliminar que aparezcan
	// los datos personales (telefono, mail etc..) en la carta de retraso
	// de la devolucin de ejemplares, para evitar que la carta (con sus datos 
	// personales puedan caer en manos de otro usuario.

	//$ourPDF->multiCell(100, 7, $msg['fpdf_carte']." ".$empr->empr_cb.$tel.$mail.$lib_all_groupes, 0, 'L', 0);

	// -------------------- LliureX ----------------------------------------

	$ourPDF->multiCell(100, 7, $msg['fpdf_carte']." ".$empr->empr_cb.$lib_all_groupes, 0, 'L', 0);
	}
	} /* fin lecteur_adresse */

// ******************** Imprime le libell du groupe suivi le cas chant des coordonnes du responsable
function groupe_adresse($id_groupe, $x, $y, $link, $no_cb=false) {
	global $ourPDF;
	global $pmb_pdf_font;
	
	$requete = "SELECT libelle_groupe, resp_groupe  FROM groupe WHERE id_groupe='$id_groupe' ";
	$res = mysql_query($requete, $link);
	$groupe = mysql_fetch_object($res);
	
	$ourPDF->SetXY ($x,$y);
	$ourPDF->setFont($pmb_pdf_font, '', 12);
	$ourPDF->multiCell(100, 8, $groupe->libelle_groupe, 0, 'L', 0);
	
	if ($groupe->resp_groupe) {
		$y=$y+8;
		lecteur_adresse($groupe->resp_groupe, $x, $y, $link, $no_cb) ;
		}
	} /* fin groupe_adresse */

function expl_info($cb_doc, $x, $y, $link, $short=0, $longmax=99999) {
	global $ourPDF;
	global $msg ;
	global $pmb_pdf_font;
	
	$requete = "SELECT notices_m.notice_id as m_id, notices_s.notice_id as s_id, expl_cb, expl_cote, pret_date, pret_retour, tdoc_libelle, section_libelle, location_libelle, trim(concat(ifnull(notices_m.tit1,''),ifnull(notices_s.tit1,''),' ',ifnull(bulletin_numero,''), if (mention_date, concat(' (',mention_date,')') ,''))) as tit, ";
	$requete.= " date_format(pret_date, '".$msg["format_date"]."') as aff_pret_date, ";
	$requete.= " date_format(pret_retour, '".$msg["format_date"]."') as aff_pret_retour, "; 
	$requete.= " IF(pret_retour>sysdate(),0,1) as retard, notices_m.tparent_id, notices_m.tnvol " ; 
	$requete.= " FROM (((exemplaires LEFT JOIN notices AS notices_m ON expl_notice = notices_m.notice_id ) LEFT JOIN bulletins ON expl_bulletin = bulletins.bulletin_id) LEFT JOIN notices AS notices_s ON bulletin_notice = notices_s.notice_id), docs_type, docs_section, docs_location, pret ";
	$requete.= " WHERE expl_cb='".$cb_doc."' and expl_typdoc = idtyp_doc and expl_section = idsection and expl_location = idlocation and pret_idexpl = expl_id  ";

	$res = mysql_query($requete, $link) or die ("<br>".mysql_error());
	$expl = mysql_fetch_object($res);
	
	$responsabilites = get_notice_authors(($expl->m_id+$expl->s_id)) ;
	$as = array_search ("0", $responsabilites["responsabilites"]) ;
	if ($as!== FALSE && $as!== NULL) {
		$auteur_0 = $responsabilites["auteurs"][$as] ;
		$auteur = new auteur($auteur_0["id"]);
		$header_aut .= $auteur->isbd_entry;
		} else {
			$aut1_libelle=array();
			$as = array_keys ($responsabilites["responsabilites"], "1" ) ;
			for ($i = 0 ; $i < count($as) ; $i++) {
				$indice = $as[$i] ;
				$auteur_1 = $responsabilites["auteurs"][$indice] ;
				$auteur = new auteur($auteur_1["id"]);
				$aut1_libelle[]= $auteur->isbd_entry;
				}
			
			$header_aut .= implode (", ",$aut1_libelle) ;
			}
	$header_aut ? $auteur=" / ".$header_aut : $auteur="";
	
	// rcupration du titre de srie
	if ($expl->tparent_id && $expl->m_id) {
		$parent = new serie($expl->tparent_id);
		$tit_serie = $parent->name;
		if($expl->tnvol)
			$tit_serie .= ', '.$expl->tnvol;
		}
	if($tit_serie) {
		$expl->tit = $tit_serie.'. '.$expl->tit;
		}

	if ($short==1) {
		$ourPDF->SetXY ($x,$y);
		$ourPDF->setFont($pmb_pdf_font, 'B', 10);
		$ourPDF->multiCell(190, 8, substr($expl->tit.$auteur,0,$longmax) , 0, 'L', 0);
	
		$ourPDF->SetXY ($x+10,$y+4);
		$ourPDF->setFont($pmb_pdf_font, '', 9);
		$ourPDF->multiCell(140, 8, $msg['fpdf_date_pret']." ".$expl->aff_pret_date, 0, 'L', 0);
		$ourPDF->SetXY ($x+70,$y+4);
		$ourPDF->setFont($pmb_pdf_font, 'B', 9);
		$ourPDF->multiCell(70, 8, $msg['fpdf_retour_prevu']." ".$expl->aff_pret_retour, 0, 'L', 0);
		$ourPDF->SetXY ($x+10,$y+8);
		$ourPDF->setFont($pmb_pdf_font, 'I', 8);
		$ourPDF->multiCell(190, 8, $expl->location_libelle.": ".$expl->section_libelle.": ".$expl->expl_cote." (".$expl->expl_cb.")", 0, 'L', 0);
		} else {

			$ourPDF->SetXY ($x,$y);
			$ourPDF->setFont($pmb_pdf_font, 'BU', 14);
			$ourPDF->multiCell(190, 8, substr($expl->tit." (".$expl->tdoc_libelle.")",0,$longmax), 0, 'L', 0);
		
			$ourPDF->SetXY ($x+10,$y+6);
			$ourPDF->setFont($pmb_pdf_font, '', 10);
			$ourPDF->multiCell(190-30, 8, $msg['fpdf_date_pret']." ".$expl->aff_pret_date, 0, 'L', 0);
			$ourPDF->SetXY ($x+70,$y+6);
			$ourPDF->setFont($pmb_pdf_font, 'B', 10);
			$ourPDF->multiCell((190 - 70), 8, $msg['fpdf_retour_prevu']." ".$expl->aff_pret_retour, 0, 'L', 0);

			$ourPDF->SetXY ($x+10,$y+10);
			$ourPDF->setFont($pmb_pdf_font, 'I', 8);
			$ourPDF->multiCell(190, 8, $expl->location_libelle.": ".$expl->section_libelle.": ".$expl->expl_cote." (".$expl->expl_cb.")", 0, 'L', 0);

			}
	
	} /* fin expl_info */

function not_bull_info_resa ($id_empr, $notice, $bulletin, $x, $y, $link, $longmax=99999) {
	global $ourPDF;
	global $msg;
	global $pmb_pdf_font;
	
	$dates_resa_sql = "date_format(resa_date, '".$msg["format_date"]."') as date_pose_resa, IF(resa_date_fin>sysdate() or resa_date_fin='0000-00-00',0,1) as perimee, if(resa_date_debut='0000-00-00', '', date_format(resa_date_debut, '".$msg["format_date"]."')) as aff_resa_date_debut, if(resa_date_fin='0000-00-00', '', date_format(resa_date_fin, '".$msg["format_date"]."')) as aff_resa_date_fin " ;
	if ($notice) {
		$requete = "SELECT notice_id, resa_date, resa_idempr, tit1 as tit, ".$dates_resa_sql;
		$requete.= "FROM notices, resa ";
		$requete.= "WHERE notice_id='".$notice."' and resa_idnotice=notice_id order by resa_date ";
		} else {
			$requete = "SELECT notice_id, resa_date, resa_idempr, trim(concat(tit1,' ',ifnull(bulletin_numero,''), if (mention_date, concat(' (',mention_date,')') ,''))) as tit, ".$dates_resa_sql;
			$requete.= "FROM bulletins, resa, notices ";
			$requete.= "WHERE resa_idbulletin='$bulletin' and resa_idbulletin = bulletins.bulletin_id and bulletin_notice = notice_id order by resa_date ";
			}
			
	$res = mysql_query($requete, $link) or die ("<br>".mysql_error());
	$nb_resa = mysql_num_rows($res) ;
	
	for ($j=0 ; $j<$nb_resa ; $j++ ) {
		$resa = mysql_fetch_object($res);
		if ($resa->resa_idempr == $id_empr) {
			$responsabilites = get_notice_authors($resa->notice_id) ;
			$as = array_search ("0", $responsabilites["responsabilites"]) ;
			if ($as!== FALSE && $as!== NULL) {
				$auteur_0 = $responsabilites["auteurs"][$as] ;
				$auteur = new auteur($auteur_0["id"]);
				$header_aut .= $auteur->isbd_entry;
				} else {
					$aut1_libelle=array();
					$as = array_keys ($responsabilites["responsabilites"], "1" ) ;
					for ($i = 0 ; $i < count($as) ; $i++) {
						$indice = $as[$i] ;
						$auteur_1 = $responsabilites["auteurs"][$indice] ;
						$auteur = new auteur($auteur_1["id"]);
						$aut1_libelle[]= $auteur->isbd_entry;
						}
					
					$header_aut .= implode (", ",$aut1_libelle) ;
					}
			$header_aut ? $auteur=" / ".$header_aut : $auteur="";
			
			$ourPDF->SetXY ($x,$y);
			$ourPDF->setFont($pmb_pdf_font, 'BU', 14);
			$ourPDF->multiCell(190, 8, substr($resa->tit.$auteur,0,$longmax), 0, 'L', 0);
			
			if ($resa->aff_resa_date_debut) $tmpmsg_res = $msg['fpdf_reserve_du']." ".$resa->aff_resa_date_debut." ".$msg['fpdf_adherent_au']." ".$resa->aff_resa_date_fin;
				else $tmpmsg_res = $msg['fpdf_attente_valid'];
			$ourPDF->SetXY ($x+10,$y+6);
			$ourPDF->setFont('Arial', '', 10);
			$ourPDF->multiCell(140, 8, $tmpmsg_res, 0, 'L', 0);
			
			$date_resa = " ".$msg['fpdf_reserv_enreg']." ".$resa->date_pose_resa."." ;
			$ourPDF->SetXY ($x+10,$y+10);
			$ourPDF->setFont('Arial', '', 8);
			$ourPDF->multiCell(140, 8, $msg['fpdf_rang']." ".($j+1).$date_resa, 0, 'L', 0);
			return ;
			}
		} // fin for
	} /* fin not_bull_info_resa */

// ************************* Imprime la ligne de retard pour un exemplaire sur la lettre du lecteur
function expl_retard($cb_doc, $x, $y, $largeur, $retrait, $link) {
	
	global $ourPDF;
	global $msg;
	global $pmb_gestion_financiere, $pmb_gestion_amende;
	global $pmb_pdf_font;
	
	$valeur=0;
	
	$dates_resa_sql = " date_format(pret_date, '".$msg["format_date"]."') as aff_pret_date, date_format(pret_retour, '".$msg["format_date"]."') as aff_pret_retour " ;
	$requete = "SELECT notices_m.notice_id as m_id, notices_s.notice_id as s_id, pret_idempr, expl_id, expl_cb, pret_date, pret_retour, tdoc_libelle, section_libelle, location_libelle, trim(concat(ifnull(notices_m.tit1,''),ifnull(notices_s.tit1,''),' ',ifnull(bulletin_numero,''), if (mention_date, concat(' (',mention_date,')') ,''))) as tit, ".$dates_resa_sql.", " ;
	$requete.= " notices_m.tparent_id, notices_m.tnvol " ; 
	$requete.= " FROM (((exemplaires LEFT JOIN notices AS notices_m ON expl_notice = notices_m.notice_id ) LEFT JOIN bulletins ON expl_bulletin = bulletins.bulletin_id) LEFT JOIN notices AS notices_s ON bulletin_notice = notices_s.notice_id), docs_type, docs_section, docs_location, pret ";
	$requete.= " WHERE expl_cb='".$cb_doc."' and expl_typdoc = idtyp_doc and expl_section = idsection and expl_location = idlocation and pret_idexpl = expl_id  ";
	
	$res = mysql_query($requete, $link) or die (mysql_error()." $requete");
	$expl = mysql_fetch_object($res);
	
	// rcupration du titre de srie
	if ($expl->tparent_id && $expl->m_id) {
		$parent = new serie($expl->tparent_id);
		$tit_serie = $parent->name;
		if($expl->tnvol)
			$tit_serie .= ', '.$expl->tnvol;
		}
	if($tit_serie) {
		$expl->tit = $tit_serie.'. '.$expl->tit;
		}

	$ourPDF->SetXY ($x,$y);
	$ourPDF->setFont($pmb_pdf_font, 'BU', 10);
	$ourPDF->multiCell(($largeur - $x), 8, $expl->tit." (".$expl->tdoc_libelle.")", 0, 'L', 0);
		
	$ourPDF->SetXY ($x+$retrait,$y+4);
	$ourPDF->setFont($pmb_pdf_font, '', 10);
	$ourPDF->multiCell(($largeur - $retrait - $x), 8, $msg['fpdf_date_pret']." ".$expl->aff_pret_date, 0, 'L', 0);
	$ourPDF->SetXY (($x+$retrait+52),$y+4);
	$ourPDF->setFont($pmb_pdf_font, 'B', 10);
	$ourPDF->multiCell(($largeur - $x - $retrait - 52), 8, $msg['fpdf_retour_prevu']." ".$expl->aff_pret_retour, 0, 'L', 0);

	$ourPDF->SetXY ($x+$retrait,$y+8);
	$ourPDF->setFont($pmb_pdf_font, 'I', 8);
	$ourPDF->multiCell(($largeur - $retrait - $x), 8, $expl->location_libelle.": ".$expl->section_libelle." (".$expl->expl_cb.")", 0, 'L', 0);

	if (($pmb_gestion_financiere)&&($pmb_gestion_amende)) {
		$amende=new amende($expl->pret_idempr);
		$amd=$amende->get_amende($expl->expl_id);
		if ($amd["valeur"]) {
			$ourPDF->SetXY (($x+$retrait+120),$y+4);
			$ourPDF->multiCell(($largeur - $x - $retrait - 120), 8, sprintf($msg["relance_lettre_retard_amende"],comptes::format_simple($amd["valeur"])), 0, 'R', 0);
			$valeur=$amd["valeur"];
		}
	}
	return $valeur;
} /* fin expl_retard */

// ************************* Imprime la ligne de retard pour un exemplaire sur la lettre du lecteur
function expl_retard_empr($id_empr, $cb_doc, $x, $y, $largeur, $retrait, $link) {
	
	global $ourPDF;
	global $msg;
	global $pmb_pdf_font;
	
	$requete = "SELECT id_empr, empr_cb, empr_nom, empr_prenom, empr_adr1, empr_adr2, empr_cp, empr_ville, empr_pays, empr_mail, empr_tel1, empr_tel2  FROM empr WHERE id_empr='$id_empr' LIMIT 1 ";
	$res = mysql_query($requete, $link);
	$empr = mysql_fetch_object($res);
	$ourPDF->SetXY ($x,$y);
	$ourPDF->setFont($pmb_pdf_font, '', 12);
	$ourPDF->multiCell(100, 8, $empr->empr_prenom." ".$empr->empr_nom, 0, 'L', 0);
	$y=$y+4;
	expl_retard($cb_doc, $x, $y, $largeur, $retrait+10, $link) ;
	} // fin expl_retard_empr

function date_edition($x, $y) {
	global $ourPDF;
	global $msg;
	global $pmb_pdf_fontfixed;
	
	$ourPDF->SetXY ($x,$y);
	$ourPDF->setFont($pmb_pdf_fontfixed, 'I', 12);
	$ourPDF->multiCell(140, 8, $msg['fpdf_edite']." ".formatdate(date("Y-m-d",time())), 0, 'L', 0);
	}
	
function date_jour($x, $y) {

	global $ourPDF;
	global $pmb_pdf_fontfixed;
	$ourPDF->SetXY ($x,$y);
	$ourPDF->setFont($pmb_pdf_fontfixed, 'I', 12);
	$ourPDF->multiCell(30, 8, formatdate(date("Y-m-d",time())), 0, 'L', 0);	
}

function lettre_retard_par_lecteur($id_empr) {

global $ourPDF, $dbh, $msg , $nb_page, $nb_1ere_page, $nb_par_page, $pmb_gestion_financiere, $pmb_gestion_amende, $niveau;
global $pmb_pdf_font;
// les variables sont lues en dehors
global $marge_page_gauche, $marge_page_droite, $largeur_page, $fdp, $after_list, $limite_after_list, $before_list, $madame_monsieur, $nb_1ere_page, $nb_par_page, $taille_bloc_expl, $debut_expl_1er_page, $debut_expl_page, $before_recouvrement;

//Pour les amendes
$valeur=0;

$ourPDF->addPage();

date_jour($largeur_page-$marge_page_droite-30,10);
biblio_info( $marge_page_gauche, 15) ;
lecteur_adresse($id_empr, ($marge_page_gauche+90), 45, $dbh);

$ourPDF->SetXY ($marge_page_gauche,125);
$ourPDF->setFont($pmb_pdf_font, '', 12);
$ourPDF->multiCell(($largeur_page - $marge_page_droite - $marge_page_gauche), 8, $madame_monsieur, 0, 'L', 0);
$ourPDF->multiCell(($largeur_page - $marge_page_droite - $marge_page_gauche), 8, $before_list, 0, 'J', 0);
$rqt = "select expl_cb from pret, exemplaires where pret_idempr='".$id_empr."' and pret_retour < curdate() and pret_idexpl=expl_id order by pret_date " ;
$req = mysql_query($rqt, $dbh) or die($msg['err_sql'].'<br>'.$rqt.'<br>'.mysql_error()); 

$i=0;
$nb_page=0;
$indice_page = 0 ;
while ($data = mysql_fetch_array($req)) {
	if ($nb_page==0 && $i==$nb_1ere_page) {
		$ourPDF->addPage();
		$nb_page++;
		$indice_page = 0 ;
		} elseif (($nb_page>=1) && ((($i-$nb_1ere_page) % $nb_par_page)==0)) { 
			$ourPDF->addPage();
			$nb_page++;
			$indice_page = 0 ;
			}
	if ($nb_page==0) $pos_page = $debut_expl_1er_page+$taille_bloc_expl*$indice_page;
		else $pos_page = $debut_expl_page+$taille_bloc_expl*$indice_page;
	$valeur+=expl_retard ($data['expl_cb'],$marge_page_gauche,$pos_page,($largeur_page - $marge_page_droite - $marge_page_gauche), 10,$dbh);
	// echo "Element $i en position $pos_page en page $nb_page ----- ".(($nb_page>=1) && ((($i-$nb_1ere_page) % $nb_par_page)==0))."<br><br>";
	$i++;
	$indice_page++;
	}

//Calcul des frais de relance
if (($pmb_gestion_financiere)&&($pmb_gestion_amende)) {
	$id_compte=comptes::get_compte_id_from_empr($id_empr,2);
	if ($id_compte) {
		$cpte=new comptes($id_compte);
		$frais_relance=$cpte->summarize_transactions("","",0,$realisee=-1);
		if ($frais_relance<0) $frais_relance=-$frais_relance; else $frais_relance=0;
	}
}
$ourPDF->setFont($pmb_pdf_font, '', 12);
// dpassement sur autre page de cette partie
if (($pos_page+$taille_bloc_expl)>$limite_after_list) {
	$ourPDF->addPage();
	$pos_after_list = $debut_expl_page;
	} else {
		$pos_after_list = $pos_page+$taille_bloc_expl;
		}
$ourPDF->SetXY ($marge_page_gauche,($pos_after_list));
//Si il y a des amendes
if ($valeur) {
	$ourPDF->multiCell(($largeur_page - $marge_page_droite - $marge_page_gauche-50), 8, $msg["relance_lettre_retard_total_amendes"], 0, 'R', 0);
	$ourPDF->SetXY ($largeur_page-$marge_page_droite- $marge_page_gauche - 50,($pos_after_list));
	$ourPDF->multiCell(50, 8, comptes::format_simple($valeur),0,'R',0);
	$pos_after_list+=8;
	$ourPDF->SetXY ($marge_page_gauche,($pos_after_list));
}
if ($frais_relance) {
	$ourPDF->multiCell(($largeur_page - $marge_page_droite - $marge_page_gauche-50), 8, $msg["relance_lettre_retard_frais_relance"],0,'R', 0);
	$ourPDF->SetXY ($largeur_page-$marge_page_droite-$marge_page_gauche-50,($pos_after_list));
	$ourPDF->multiCell(50, 8, comptes::format_simple($frais_relance), 0, 'R', 0);
	$pos_after_list+=8;
	$ourPDF->SetXY ($marge_page_gauche,($pos_after_list));
}
if (($frais_relance)||($valeur)) {
	$ourPDF->multiCell(($largeur_page - $marge_page_droite - $marge_page_gauche - 50), 8, $msg["relance_lettre_retard_total_du"], 0, 'R', 0);
	$ourPDF->SetXY ($largeur_page-$marge_page_droite-$marge_page_gauche-50,($pos_after_list));
	$ourPDF->multiCell(50, 8, comptes::format_simple($valeur+$frais_relance)."\n\n", 0, 'R', 0);
	$pos_after_list+=8;
	$ourPDF->SetXY ($marge_page_gauche,($pos_after_list));
}
if (($niveau==3)&&(($pmb_gestion_financiere)&&($pmb_gestion_amende))) {
	$ourPDF->multiCell(($largeur_page - $marge_page_droite - $marge_page_gauche), 8, $before_recouvrement."\n\n", 0, 'J', 0);
	$y_liste=$ourPDF->getY();
	$requete="select expl_cb from exemplaires, pret where pret_idempr=$id_empr and pret_idexpl=expl_id and niveau_relance=3";
	$res_recouvre=mysql_query($requete);
	while ($rrc=mysql_fetch_object($res_recouvre)) {
		expl_retard($rrc->expl_cb,$marge_page_gauche,$y_liste,($largeur_page - $marge_page_droite - $marge_page_gauche), 10,$dbh);
		$y_liste=$ourPDF->getY();
	}
}
$ourPDF->setFont($pmb_pdf_font, '', 12);
$ourPDF->multiCell(($largeur_page - $marge_page_droite - $marge_page_gauche), 8, $after_list."\n\n", 0, 'J', 0);
$ourPDF->setFont($pmb_pdf_font, 'I', 12);
$ourPDF->multiCell(($largeur_page - $marge_page_droite - $marge_page_gauche), 8, $fdp, 0, 'R', 0);
} // fin lettre_retard_par_lecteur


// ******************** Imprime les lettres de retard pour un groupe ****************************
function lettre_retard_par_groupe($id_groupe) {

global $ourPDF, $dbh, $msg;
global $pmb_pdf_font;

// les variables sont lues en dehors
global $marge_page_gauche, $marge_page_droite, $largeur_page, $fdp, 
	$after_list, $limite_after_list, $before_list, $madame_monsieur, $nb_1ere_page, 
	$nb_par_page, $taille_bloc_expl, $debut_expl_1er_page, $debut_expl_page;

$ourPDF->addPage();

date_jour($largeur_page-$marge_page_droite-30,10);
biblio_info( $marge_page_gauche, 15) ;
groupe_adresse($id_groupe, ($marge_page_gauche+90), 45, $dbh);

$ourPDF->SetXY ($marge_page_gauche,125);
$ourPDF->setFont($pmb_pdf_font, '', 12);
$ourPDF->multiCell(($largeur_page - $marge_page_droite - $marge_page_gauche), 8, $madame_monsieur, 0, 'L', 0);
$ourPDF->multiCell(($largeur_page - $marge_page_droite - $marge_page_gauche), 8, $before_list, 0, 'J', 0);
$rqt = "select  empr_id, expl_cb from pret, exemplaires, empr_groupe, empr where groupe_id='".$id_groupe."' and pret_retour < curdate() and pret_idexpl=expl_id and empr_id=pret_idempr and empr_id=id_empr order by empr_nom, empr_prenom, pret_date " ;
$req = mysql_query($rqt, $dbh) or die ($msg['err_sql'].'<br>'.$rqt.'<br>'.mysql_error()); 

$i=0;
$nb_page=0;
$indice_page = 0 ;
while ($data = mysql_fetch_array($req)) {
	if ($nb_page==0 && $i==$nb_1ere_page) {
		$ourPDF->addPage();
		$nb_page++;
		$indice_page = 0 ;
		} elseif (($nb_page>=1) && ((($i-$nb_1ere_page) % $nb_par_page)==0)) { 
			$ourPDF->addPage();
			$nb_page++;
			$indice_page = 0 ;
			}
	if ($nb_page==0) $pos_page = $debut_expl_1er_page+$taille_bloc_expl*$indice_page;
		else $pos_page = $debut_expl_page+$taille_bloc_expl*$indice_page;
	expl_retard_empr ($data['empr_id'], $data['expl_cb'], $marge_page_gauche,$pos_page,($largeur_page - $marge_page_droite - $marge_page_gauche), 10,$dbh);
	$i++;
	$indice_page++;
	}
$ourPDF->setFont($pmb_pdf_font, '', 12);
if (($pos_page+$taille_bloc_expl)>$limite_after_list) {
	$ourPDF->addPage();
	$pos_after_list = $debut_expl_page;
	} else {
		$pos_after_list = $pos_page+$taille_bloc_expl;
		}
$ourPDF->SetXY ($marge_page_gauche,($pos_after_list));
$ourPDF->multiCell(($largeur_page - $marge_page_droite - $marge_page_gauche), 8, $after_list."\n\n", 0, 'J', 0);
$ourPDF->setFont($pmb_pdf_font, 'I', 12);
$ourPDF->multiCell(($largeur_page - $marge_page_droite - $marge_page_gauche), 8, $fdp, 0, 'R', 0);
} // fin lettre_retard_par_groupe

// **************** Rservations *************************************

function lettre_resa_par_lecteur($id_empr) {

global $ourPDF, $dbh, $msg , $nb_page, $nb_1ere_page, $nb_par_page;

// les variables sont lues en dehors
global $marge_page_gauche, $marge_page_droite, $largeur_page, $fdp, $after_list, $limite_after_list, $before_list, $madame_monsieur, $nb_1ere_page, $nb_par_page, $taille_bloc_expl, $debut_expl_1er_page, $debut_expl_page;
global $pmb_pdf_font;

$ourPDF->addPage();
biblio_info( $marge_page_gauche, 10) ;
lecteur_adresse($id_empr, ($marge_page_gauche+90), 45, $dbh);

$ourPDF->SetXY ($marge_page_gauche,125);
$ourPDF->setFont($pmb_pdf_font, '', 12);
$ourPDF->multiCell(($largeur_page - $marge_page_droite - $marge_page_gauche), 8, $madame_monsieur, 0, 'L', 0);
$ourPDF->multiCell(($largeur_page - $marge_page_droite - $marge_page_gauche), 8, $before_list, 0, 'J', 0);
$rqt = "select id_resa from resa where resa_idempr='$id_empr' and resa_cb is not null and resa_cb!='' order by resa_date_debut " ;

$req = mysql_query($rqt, $dbh) or die('Erreur SQL !<br>'.$rqt.'<br>'.mysql_error()); 

$i=0;
$nb_page=0;
while ($data = mysql_fetch_array($req)) {
	if ($nb_page==0 && $i<$nb_1ere_page) {
		$pos_page = $debut_expl_1er_page+$taille_bloc_expl*$i;
		}
	if ($nb_page==0 && $i==$nb_1ere_page) {
		$ourPDF->addPage();
		$nb_page++;
		}
	if ($nb_page=1 && $i>=$nb_1ere_page) {
		$pos_page = $debut_expl_page+($taille_bloc_expl*($i-$nb_1ere_page));
		}
	if ($nb_page>1 && $i>$nb_1ere_page) {
		$pos_page = $debut_expl_page+($taille_bloc_expl*($i-$nb_1ere_page-$nb_page*$nb_par_page));
		}
	if ($nb_page>1 && (($i-$nb_1ere_page) % $nb_par_page)==0) {
		$ourPDF->addPage();
		$nb_page++;
		}
	notice_resa ($data['id_resa'],$marge_page_gauche,$pos_page,($largeur_page - $marge_page_droite - $marge_page_gauche), 10,$dbh);
	$i++;
	//echo "<br> $i "; 
	}
//echo "<br>pos_page: $pos_page <br>taille_bloc_expl: $taille_bloc_expl <br>limite_after_list: $limite_after_list "; exit ;
$ourPDF->setFont($pmb_pdf_font, '', 12);
// dpassement sur autre page de cette partie
if (($pos_page+$taille_bloc_expl)>$limite_after_list) {
	$ourPDF->addPage();
	$pos_after_list = $debut_expl_page;
	} else {
		$pos_after_list = $pos_page+$taille_bloc_expl;
		}
$ourPDF->SetXY ($marge_page_gauche,($pos_after_list));
$ourPDF->multiCell(($largeur_page - $marge_page_droite - $marge_page_gauche), 8, $after_list."\n\n", 0, 'J', 0);
$ourPDF->setFont($pmb_pdf_font, 'I', 12);
$ourPDF->multiCell(($largeur_page - $marge_page_droite - $marge_page_gauche), 8, $fdp, 0, 'R', 0);
} // fin lettre_resa_par_lecteur


function lettre_resa_planning_par_lecteur($id_empr) {

global $ourPDF, $dbh, $msg , $nb_page, $nb_1ere_page, $nb_par_page;

// les variables sont lues en dehors
global $marge_page_gauche, $marge_page_droite, $largeur_page, $fdp, $after_list, $limite_after_list, $before_list, $madame_monsieur, $nb_1ere_page, $nb_par_page, $taille_bloc_expl, $debut_expl_1er_page, $debut_expl_page;
global $pmb_pdf_font;

$ourPDF->addPage();
biblio_info( $marge_page_gauche, 10) ;
lecteur_adresse($id_empr, ($marge_page_gauche+90), 45, $dbh);

$ourPDF->SetXY ($marge_page_gauche,125);
$ourPDF->setFont($pmb_pdf_font, '', 12);
$ourPDF->multiCell(($largeur_page - $marge_page_droite - $marge_page_gauche), 8, $madame_monsieur, 0, 'L', 0);
$ourPDF->multiCell(($largeur_page - $marge_page_droite - $marge_page_gauche), 8, $before_list, 0, 'J', 0);
$rqt = "select id_resa from resa_planning where resa_idempr='$id_empr' order by resa_date_debut " ;

$req = mysql_query($rqt, $dbh) or die('Erreur SQL !<br>'.$rqt.'<br>'.mysql_error()); 

$i=0;
$nb_page=0;
while ($data = mysql_fetch_array($req)) {
	if ($nb_page==0 && $i<$nb_1ere_page) {
		$pos_page = $debut_expl_1er_page+$taille_bloc_expl*$i;
		}
	if ($nb_page==0 && $i==$nb_1ere_page) {
		$ourPDF->addPage();
		$nb_page++;
		}
	if ($nb_page=1 && $i>=$nb_1ere_page) {
		$pos_page = $debut_expl_page+($taille_bloc_expl*($i-$nb_1ere_page));
		}
	if ($nb_page>1 && $i>$nb_1ere_page) {
		$pos_page = $debut_expl_page+($taille_bloc_expl*($i-$nb_1ere_page-$nb_page*$nb_par_page));
		}
	if ($nb_page>1 && (($i-$nb_1ere_page) % $nb_par_page)==0) {
		$ourPDF->addPage();
		$nb_page++;
		}
	notice_resa_planning ($data['id_resa'],$marge_page_gauche,$pos_page,($largeur_page - $marge_page_droite - $marge_page_gauche), 10,$dbh);
	$i++;
	//echo "<br> $i "; 
	}
//echo "<br>pos_page: $pos_page <br>taille_bloc_expl: $taille_bloc_expl <br>limite_after_list: $limite_after_list "; exit ;
$ourPDF->setFont($pmb_pdf_font, '', 12);
// dpassement sur autre page de cette partie
if (($pos_page+$taille_bloc_expl)>$limite_after_list) {
	$ourPDF->addPage();
	$pos_after_list = $debut_expl_page;
	} else {
		$pos_after_list = $pos_page+$taille_bloc_expl;
		}
$ourPDF->SetXY ($marge_page_gauche,($pos_after_list));
$ourPDF->multiCell(($largeur_page - $marge_page_droite - $marge_page_gauche), 8, $after_list."\n\n", 0, 'J', 0);
$ourPDF->setFont($pmb_pdf_font, 'I', 12);
$ourPDF->multiCell(($largeur_page - $marge_page_droite - $marge_page_gauche), 8, $fdp, 0, 'R', 0);
} // fin lettre_resa_planning_par_lecteur



// ************************* Imprime la ligne de resa pour une notice sur la lettre de confirmation de rservation
function notice_resa($id_resa_print, $x, $y, $largeur, $retrait, $link) {
	
	global $ourPDF;
	global $msg;
	global $pmb_pdf_font;
	
	$dates_resa_sql = " date_format(resa_date_debut, '".$msg["format_date"]."') as aff_resa_date_debut, date_format(resa_date_fin, '".$msg["format_date"]."') as aff_resa_date_fin " ;
	$requete = "SELECT notices_m.notice_id as m_id, notices_s.notice_id as s_id, resa_date_debut, resa_date_fin, trim(concat(ifnull(notices_m.tit1,''),ifnull(notices_s.tit1,''),' ',ifnull(bulletin_numero,''), if (mention_date, concat(' (',mention_date,')') ,''))) as tit, ".$dates_resa_sql ;
	$requete.= "FROM (((resa LEFT JOIN notices AS notices_m ON resa_idnotice = notices_m.notice_id ) LEFT JOIN bulletins ON resa_idbulletin = bulletins.bulletin_id) LEFT JOIN notices AS notices_s ON bulletin_notice = notices_s.notice_id) ";
	$requete.= "WHERE id_resa='".$id_resa_print."' ";
	
	$res = mysql_query($requete, $link) or die (mysql_error()." $requete");
	$expl = mysql_fetch_object($res);
	
	$responsabilites = get_notice_authors(($expl->m_id+$expl->s_id)) ;
	$as = array_search ("0", $responsabilites["responsabilites"]) ;
	if ($as!== FALSE && $as!== NULL) {
		$auteur_0 = $responsabilites["auteurs"][$as] ;
		$auteur = new auteur($auteur_0["id"]);
		$header_aut .= $auteur->isbd_entry;
		} else {
			$aut1_libelle=array();
			$as = array_keys ($responsabilites["responsabilites"], "1" ) ;
			for ($i = 0 ; $i < count($as) ; $i++) {
				$indice = $as[$i] ;
				$auteur_1 = $responsabilites["auteurs"][$indice] ;
				$auteur = new auteur($auteur_1["id"]);
				$aut1_libelle[]= $auteur->isbd_entry;
				}
			
			$header_aut .= implode (", ",$aut1_libelle) ;
			}
	$header_aut ? $auteur=" / ".$header_aut : $auteur="";
	
	$ourPDF->SetXY ($x,$y);
	$ourPDF->setFont($pmb_pdf_font, 'BU', 10);
	$ourPDF->multiCell(($largeur - $x), 8, $expl->tit.$auteur, 0, 'L', 0);
	
	$ourPDF->SetXY ($x+$retrait,$y+4);
	$ourPDF->setFont($pmb_pdf_font, '', 10);
	$ourPDF->multiCell(($largeur - $retrait - $x), 8, $msg['fpdf_valide']." ".$expl->aff_resa_date_debut." ".$msg['fpdf_valable']." ", 0, 'L', 0);
	$ourPDF->SetXY (($x+$retrait+82),$y+4);
	$ourPDF->setFont($pmb_pdf_font, 'B', 10);
	$ourPDF->multiCell(($largeur - $x - $retrait - 82), 8, $expl->aff_resa_date_fin, 0, 'L', 0);
	} /* fin notice_resa */


function notice_resa_planning($id_resa_print, $x, $y, $largeur, $retrait, $link) {
	
	global $ourPDF;
	global $msg;
	global $pmb_pdf_font;
	
	$dates_resa_sql = " date_format(resa_date_debut, '".$msg["format_date"]."') as aff_resa_date_debut, date_format(resa_date_fin, '".$msg["format_date"]."') as aff_resa_date_fin " ;
	$requete = "SELECT notice_id, resa_date_debut, resa_date_fin, trim(tit1) as tit, ".$dates_resa_sql ;
	$requete.= "FROM resa_planning LEFT JOIN notices ON resa_idnotice = notice_id  ";
	$requete.= "WHERE id_resa='".$id_resa_print."' ";
	
	$res = mysql_query($requete, $link) or die (mysql_error()." $requete");
	$expl = mysql_fetch_object($res);
	
	$responsabilites = get_notice_authors($expl->notice_id) ;
		
	$as = array_search ("0", $responsabilites["responsabilites"]) ;
	if ($as!== FALSE && $as!== NULL) {
		$auteur_0 = $responsabilites["auteurs"][$as] ;
		$auteur = new auteur($auteur_0["id"]);
		$header_aut .= $auteur->isbd_entry;
	} else {
		$aut1_libelle=array();
		$as = array_keys ($responsabilites["responsabilites"], "1" ) ;
		for ($i = 0 ; $i < count($as) ; $i++) {
			$indice = $as[$i] ;
			$auteur_1 = $responsabilites["auteurs"][$indice] ;
			$auteur = new auteur($auteur_1["id"]);
			$aut1_libelle[]= $auteur->isbd_entry;
		}
		$header_aut .= implode (", ",$aut1_libelle) ;
	}
	$header_aut ? $auteur=" / ".$header_aut : $auteur="";
	
	$ourPDF->SetXY ($x,$y);
	$ourPDF->setFont($pmb_pdf_font, 'BU', 10);
	$ourPDF->multiCell(($largeur - $x), 8, $expl->tit.$auteur, 0, 'L', 0);
	
	$ourPDF->SetXY ($x+$retrait,$y+4);
	$ourPDF->setFont($pmb_pdf_font, '', 10);
	$ourPDF->multiCell(($largeur - $retrait - $x), 8, $msg['resa_planning_date_debut']." ".$expl->aff_resa_date_debut." ".$msg['resa_planning_date_fin']." ".$expl->aff_resa_date_fin, 0, 'L', 0);
	} /* fin notice_resa */

