<?php
// +-------------------------------------------------+
//  2002-2004 PMB Services / www.sigb.net pmb@sigb.net et contributeurs (voir www.sigb.net)
// +-------------------------------------------------+
// $Id: search.class.php,v 1.1 2007/11/11 19:49:26 gueluneau Exp $

if (stristr($_SERVER['REQUEST_URI'], ".class.php")) die("no access");

global $msg,$lang,$charset,$base_path,$class_path,$include_path;
require_once($class_path."/searcher.class.php");

//Classe de gestion de la recherche spcial "combine"

class combine_search_unimarc {
	var $id;
	var $n_ligne;
	var $params;
	var $search;

	//Constructeur
    function combine_search_unimarc($id,$n_ligne,$params,&$search) {
    	$this->id=$id;
    	$this->n_ligne=$n_ligne;
    	$this->params=$params;
    	$this->search=&$search;
    }
    
    //fonction de rcupration des oprateurs disponibles pour ce champ spcial (renvoie un tableau d'oprateurs)
    function get_op() {
    	$operators = array();
    	if (count($_SESSION["session_history"])!=0) {
    		$operators["EQ"]="=";
    	}
    	return $operators;
    }
    
    //fonction de rcupration de l'affichage de la saisie du critre
    function get_input_box() {
    	global $msg;
    	global $charset;
    	
    	//Rcupration de la valeur de saisie
    	$valeur_="field_".$this->n_ligne."_s_".$this->id;
    	global $$valeur_;
    	$valeur=$$valeur_;
    	
    	//parcours de l'historique des recherches
    	if (count($_SESSION["session_history"])) {
    		$r="<select name='field_".$this->n_ligne."_s_".$this->id."[]'>";
    		
    		$r.="<option value='-1' alt=\"".$msg["default_search_histo"]."\" title=\"".$msg["default_search_histo"]."\"";
    		if ($valeur) {
    			if ($valeur[0]=='-1') {
    				$r .= " selected";
    			}
    		} else {
    			$r .= " selected";
    		}
    		$r.=">".$msg["default_search_histo"]."</option>";
    		
    		for ($i=count($_SESSION["session_history"])-1; $i>=0; $i--) {
    			if ($_SESSION["session_history"][$i]["NOTI"]) {
    				$temp=html_entity_decode(strip_tags(($i+1).") ".$_SESSION["session_history"][$i]["QUERY"]["HUMAN_QUERY"]),ENT_QUOTES,$charset);
    				$r.="<option value='".$i."' alt='".$temp."' title='".$temp."'";
    				if ($valeur) {
    					if ($valeur[0]==$i) {
    						$r .= " selected";
    					}
    				} 
    				$r.=">".$this->cutlongwords($temp)."</option>";	
    			}
    		}
    		$r.="</select>";
    	} else {
    		$r .= "<b>".$msg["histo_empty"]."</b>";
    	}
    	return $r;
    }
    
    //fonction de conversion de la saisie en quelque chose de compatible avec l'environnement
    function transform_input() {
    }
    
    //fonction de cration de la requte (retourne une table temporaire)
    function make_search() {
    	global $search;
    	    	    	
    	//Rcupration de la valeur de saisie
    	$valeur_="field_".$this->n_ligne."_s_".$this->id;
    	global $$valeur_;
    	$valeur=$$valeur_;
    	
    	if (!$this->is_empty($valeur[0])) {
    		
    		//enregistrement de l'environnement courant
    		$this->search->push();
    		//Rcupration et mise en variables globales des valeurs de l'historique
    		if ($_SESSION["session_history"][$valeur[0]]["QUERY"]["POST"]["search"][0]) {
    			$search=$_SESSION["session_history"][$valeur[0]]["QUERY"]["POST"]["search"];
    			//Pour chaque champ
    			for ($i=0; $i<count($search); $i++) {
    			
    				//Rcupration de l'oprateur
    				$op="op_".$i."_".$search[$i];
    				global $$op;
    				$$op=$_SESSION["session_history"][$valeur[0]]["QUERY"]["POST"][$op];
    			    			
    				//Rcupration du contenu de la recherche
    				$field_="field_".$i."_".$search[$i];
    				global $$field_;
    				$$field_=$_SESSION["session_history"][$valeur[0]]["QUERY"]["POST"][$field_];
    				$field=$$field_;
    		
    				//Rcupration de l'oprateur inter-champ
    				$inter="inter_".$i."_".$search[$i];
    				global $$inter;
    				$$inter=$_SESSION["session_history"][$valeur[0]]["QUERY"]["POST"][$inter];
    			    		
    				//Rcupration des variables auxiliaires
    				$fieldvar_="fieldvar_".$i."_".$search[$i];
    				global $$fieldvar_;
    				$$fieldvar_=$_SESSION["session_history"][$valeur[0]]["QUERY"]["POST"][$fieldvar_];
    				$fieldvar=$$fieldvar_;
    			}
    		} else {
    			if (!$_SESSION["session_history"][$valeur[0]]["NOTI"]["GET"]["idcaddie"]) {
    				switch ($_SESSION["session_history"][$valeur[0]]["NOTI"]["GET"]["mode"])
    				{
    					case 0:
    						searcher_title::convert_simple_multi_unimarc($valeur[0]);	
    					break;
    					case 1:			
    						searcher_subject::convert_simple_multi_unimarc($valeur[0]);	
    					break;
    					case 2:
    						searcher_publisher::convert_simple_multi_unimarc($valeur[0]);	
    					break;
    				}
    			} else {
    				$op_="EQ";
    				$valeur_champ=$_SESSION["session_history"][$valeur[0]]["NOTI"]["GET"]["idcaddie"];
    				$search[0]="f_11";
					//oprateur
    				$op="op_0_".$search[0];
    				global $$op;
    				$$op=$op_;
    		    			
    				//contenu de la recherche
    				$field="field_0_".$search[0];
    				$field_=array();
    				$field_[0]=$valeur_champ;
    				global $$field;
    				$$field=$field_;
    	    	
    				//oprateur inter-champ
    				$inter="inter_0_".$search[0];
    				global $$inter;
    				$$inter="";
    			    		
    				//variables auxiliaires
    				$fieldvar_="fieldvar_0_".$search[0];
    				global $$fieldvar_;
    				$$fieldvar_="";
    				$fieldvar=$$fieldvar_;	
    			}	
    		}
    			    		    		    		
    		//on instancie la classe search avec le nom de la nouvelle table temporaire
			if ($_SESSION["session_history"][$valeur[0]]["QUERY"]["POST"]["search"][0]) {
				$sc=new search(false,"search_fields_unimarc");
			} else {
				$sc=new search(false,"search_simple_fields_unimarc");
			}
				
			$table_tempo=$sc->make_search("tempo_".$valeur[0]);
						
			//restauration de l'environnement courant
			$this->search->pull();
			return $table_tempo;
    	} 
    }
    
    function make_unimarc_query() {
    	global $search;
    	    	    	
    	//Rcupration de la valeur de saisie
    	$valeur_="field_".$this->n_ligne."_s_".$this->id;
    	global $$valeur_;
    	$valeur=$$valeur_;
    	
    	if (!$this->is_empty($valeur[0])) {
    		
    		//enregistrement de l'environnement courant
    		$this->search->push();
    		//Rcupration et mise en variables globales des valeurs de l'historique
    		if ($_SESSION["session_history"][$valeur[0]]["QUERY"]["POST"]["search"][0]) {
    			$search=$_SESSION["session_history"][$valeur[0]]["QUERY"]["POST"]["search"];
    			//Pour chaque champ
    			for ($i=0; $i<count($search); $i++) {
    			
    				//Rcupration de l'oprateur
    				$op="op_".$i."_".$search[$i];
    				global $$op;
    				$$op=$_SESSION["session_history"][$valeur[0]]["QUERY"]["POST"][$op];
    			    			
    				//Rcupration du contenu de la recherche
    				$field_="field_".$i."_".$search[$i];
    				global $$field_;
    				$$field_=$_SESSION["session_history"][$valeur[0]]["QUERY"]["POST"][$field_];
    				$field=$$field_;
    		
    				//Rcupration de l'oprateur inter-champ
    				$inter="inter_".$i."_".$search[$i];
    				global $$inter;
    				$$inter=$_SESSION["session_history"][$valeur[0]]["QUERY"]["POST"][$inter];
    			    		
    				//Rcupration des variables auxiliaires
    				$fieldvar_="fieldvar_".$i."_".$search[$i];
    				global $$fieldvar_;
    				$$fieldvar_=$_SESSION["session_history"][$valeur[0]]["QUERY"]["POST"][$fieldvar_];
    				$fieldvar=$$fieldvar_;
    			}
    		} else {
    			if (!$_SESSION["session_history"][$valeur[0]]["NOTI"]["GET"]["idcaddie"]) {
    				switch ($_SESSION["session_history"][$valeur[0]]["NOTI"]["GET"]["mode"])
    				{
    					case 0:
    						searcher_title::convert_simple_multi($valeur[0]);	
    					break;
    					case 1:			
    						searcher_subject::convert_simple_multi($valeur[0]);	
    					break;
    					case 2:
    						searcher_publisher::convert_simple_multi($valeur[0]);	
    					break;
    				}
    			} else {
    				$op_="EQ";
    				$valeur_champ=$_SESSION["session_history"][$valeur[0]]["NOTI"]["GET"]["idcaddie"];
    				$search[0]="f_11";
					//oprateur
    				$op="op_0_".$search[0];
    				global $$op;
    				$$op=$op_;
    		    			
    				//contenu de la recherche
    				$field="field_0_".$search[0];
    				$field_=array();
    				$field_[0]=$valeur_champ;
    				global $$field;
    				$$field=$field_;
    	    	
    				//oprateur inter-champ
    				$inter="inter_0_".$search[0];
    				global $$inter;
    				$$inter="";
    			    		
    				//variables auxiliaires
    				$fieldvar_="fieldvar_0_".$search[0];
    				global $$fieldvar_;
    				$$fieldvar_="";
    				$fieldvar=$$fieldvar_;	
    			}	
    		}
    			    		    		    		
    		//on instancie la classe search avec le nom de la nouvelle table temporaire
			if ($_SESSION["session_history"][$valeur[0]]["QUERY"]["POST"]["search"][0]) {
				$sc=new search(false,"search_fields_unimarc");
			} else {
				$sc=new search(false,"search_simple_fields_unimarc");
			}
				
			$mt=$es->make_unimarc_query();
						
			//restauration de l'environnement courant
			$this->search->pull();
			return $mt;
    	} 
    }
    
    //fonction de traduction littrale de la requte effectue (renvoie un tableau des termes saisis)
    function make_human_query() {
    	
    	$litteral=array();
    			
    	//Rcupration de la valeur de saisie 
    	$valeur_="field_".$this->n_ligne."_s_".$this->id;
    	global $$valeur_;
    	$valeur=$$valeur_;
    	if (!$this->is_empty($valeur[0])) {
			$litteral[0]= $_SESSION["session_history"][$valeur[0]]["NOTI"]["HUMAN_QUERY"];
    	}	
		return $litteral;    
    }
    
    //fonction de vrification du champ saisi ou slectionn
    function is_empty($valeur) {
    	if ($valeur!="0") {
    		if ($valeur=="-1") return true;
    			else return empty($valeur);
    	} else {
    		return false;
    	}	
    }
    
     //fonction de dcoupage d'une chaine trop longue
    function cutlongwords($valeur) {
    	if (strlen($valeur)>=50) {
    		$pos=strrpos(substr($valeur,0,50)," ");
    		if ($pos) {
    			$valeur=substr($valeur,0,$pos+1)."...";
    		} 
    	} 
    	return $valeur;		
    }
}
?>