<?php
// +-------------------------------------------------+
//  2002-2004 PMB Services / www.sigb.net pmb@sigb.net et contributeurs (voir www.sigb.net)
// +-------------------------------------------------+
// $Id: search.class.php,v 1.1 2007/11/11 19:49:26 gueluneau Exp $

if (stristr($_SERVER['REQUEST_URI'], ".class.php")) die("no access");

global $class_path,$include_path,$base_path;
require_once($class_path."/connecteurs.class.php");

//Classe de gestion de la recherche spcial "combine"

class external_sources {
	var $id;
	var $n_ligne;		//Numro de ligne du critre dans la multi-critre
	var $params;		//
	var $search;		//Classe d'origine de la recherche

	//Constructeur
    function external_sources($id,$n_ligne,$params,&$search) {
    	$this->id=$id;
    	$this->n_ligne=$n_ligne;
    	$this->params=$params;
    	$this->search=&$search;
    }
    
    //fonction de rcupration des oprateurs disponibles pour ce champ spcial (renvoie un tableau d'oprateurs)
    function get_op() {
    	$operators = array();
    	$operators["EQ"]="=";
    	return $operators;
    }
    
    //fonction de rcupration de l'affichage de la saisie du critre
    function get_input_box() {
    	global $msg,$charset;
    	
    	//Rcupration de la valeur de saisie
    	$valeur_="field_".$this->n_ligne."_s_".$this->id;
    	global $$valeur_;
    	$valeur=$$valeur_;
    	
    	if ((!$valeur)&&($_SESSION["checked_sources"])) $valeur=$_SESSION["checked_sources"];
    	if (!is_array($valeur)) $valeur=array();
    	
    	//Recherche des sources
    	$requete="select id_connector,source_id,name,comment from connectors_sources";
    	$resultat=mysql_query($requete);
    	$r="<select name='field_".$this->n_ligne."_s_".$this->id."[]' multiple='yes'>";
    	while ($source=mysql_fetch_object($resultat)) {
    		$r.="<option value='".$source->source_id."'".(array_search($source->source_id,$valeur)!==false?" selected":"").">".htmlentities($source->name.($source->comment?" : ".$source->comment:""),ENT_QUOTES,$charset)."</option>\n";
    	}
    	$r.="</select>";
    	return $r;
    }
    
    //fonction de conversion de la saisie en quelque chose de compatible avec l'environnement
    function transform_input() {
    }
    
    //fonction de cration de la requte (retourne une table temporaire)
    function make_search() {	
    	//Rcupration de la valeur de saisie
    	$valeur_="field_".$this->n_ligne."_s_".$this->id;
    	global $$valeur_;
    	$valeur=$$valeur_;
    	global $charset, $class_path,$include_path,$base_path;
    	
    	$conn=new connecteurs();
    	
    	for ($i=0; $i<count($valeur); $i++) {
    		//Recherche de la source
    		$source=$conn->get_class_name($valeur[$i]);
    		require_once($base_path."/admin/connecteurs/in/$source/$source.class.php");
    		eval("\$src=new $source(\"".$base_path."/admin/connecteurs/in/".$source."\");");
    		$params=$src->get_source_params($valeur[$i]);
    		if ($params["REPOSITORY"]==2) {
    			$source_id=$valeur[$i];
    			$unimarc_query=$this->search->make_unimarc_query();
    			$search_id=md5(serialize($unimarc_query));
    			$requete="select count(1) from entrepots where search_id='".addslashes($search_id)."' and source_id=$source_id";
				$resultat=mysql_query($requete);
				$search_exists=mysql_result($resultat,0,0);
				//Vrification du ttl
				$ttl=$params["TTL"];
				$requete="select count(1) from entrepots where search_id='".addslashes($search_id)."' and source_id=$source_id and unix_timestamp(now())-unix_timestamp(date_import)>".$ttl;
				$resultat=mysql_query($requete);
				if ((mysql_result($resultat,0,0))||((!mysql_result($resultat,0,0))&&(!$search_exists))) {
					if (mysql_result($resultat,0,0)) {
						//Suppression des notices
						$requete="delete from entrepots where search_id='".addslashes($search_id)."' and source_id=$source_id";
						mysql_query($requete);
					}
					//Recherche si on a le droit
					$flag_search=true;
					$requete="select (unix_timestamp(now())-unix_timestamp(date_sync)) as sec from source_sync where source_id=$source_id";
					$res_sync=mysql_query($requete);
					if (mysql_num_rows($res_sync)) {
						$rsync=mysql_fetch_object($res_sync);
						if ($rsync->sec>300) {
							mysql_query("delete from source_sync where source_id=".$source_id);
						} else $flag_search=false;
					}
					if ($flag_search) {
						$flag_error=false;
						for ($i=0; $i<$params["RETRY"]; $i++) {
    						$src->search($valeur[$i],$unimarc_query,$search_id);
    						if (!$src->error) break; else $flag_error=true;
						}
						//Il y a eu trois essais infructueux, on dsactive pendant 5 min !!
						if ($flag_error) {
							mysql_query("insert into source_sync (source_id,date_sync,cancel) values($source_id,now(),2)");
						}
					}
    			}
    		}
       	}
    	$t_table="t_sources_".$this->n_ligne;
    	$requete="create temporary table ".$t_table." select distinct recid as notice_id from entrepots where source_id in (".implode(",",$valeur).")";
    	mysql_query($requete);
		return $t_table; 
    }
    
    //fonction de traduction littrale de la requte effectue (renvoie un tableau des termes saisis)
    function make_human_query() {
    	global $msg;
    	global $include_path;
    	
    	$litteral=array();
    	
    	//Rcupration de la valeur de saisie 
    	$valeur_="field_".$this->n_ligne."_s_".$this->id;
    	global $$valeur_;
    	$valeur=$$valeur_;
    	
    	$requete="select name from connectors_sources where source_id in (".implode(",",$valeur).")";
    	$resultat=mysql_query($requete);
    	while ($r=mysql_fetch_object($resultat)) {
    		$litteral[]=$r->name;
    	}	
		return $litteral;    
    }
     
    function make_unimarc_query() {
    	return array();
    }
    
	//fonction de vrification du champ saisi ou slectionn
    function is_empty($valeur) {
    	if (count($valeur)) return true; else return false;
    }
}
?>