<?php
// +-------------------------------------------------+
//  2002-2004 PMB Services / www.sigb.net pmb@sigb.net et contributeurs (voir www.sigb.net)
// +-------------------------------------------------+
// $Id: common.tpl.php,v 1.50 2007/10/31 11:36:49 touraine37 Exp $

if (stristr($_SERVER['REQUEST_URI'], ".tpl.php")) die("no access");

function link_styles($style) {
	// o $rep = rpertoire de stockage des feuilles

	global $feuilles_style_deja_lu ;
	if ($feuilles_style_deja_lu) return $feuilles_style_deja_lu ;
	
	// mise en forme du rpertoire
	global $styles_path;
	global $charset;
	
	if($styles_path) $rep = $styles_path;
		else $rep = './styles/';
	
	if(!preg_match('/\/$/', $rep)) $rep .= '/';
	
	$handle = @opendir($rep.$style);
	
	if(!$handle) {
		$result = array();
		return $result;
		}
	$feuilles_style="";
	while($css = readdir($handle)) {
		if(is_file($rep.$style."/".$css) && preg_match('/css$/', $css)) {
			$result[] = $css;
			$feuilles_style.="\n\t<link rel='stylesheet' type='text/css' href='".$rep.$style."/".$css." ' title='lefttoright' />";
	    		}
		}
	
	closedir($handle);

	// RTL / LTR
	global $pmb_show_rtl;
	if ($pmb_show_rtl) {
		$handlertl = @opendir($rep.$style."/rtl/");
		if($handlertl) {
			while($css = readdir($handlertl)) {
				if(is_file($rep.$style."/rtl/".$css) && preg_match('/css$/', $css)) {
					$result[] = $css;
					$feuilles_style.="\n\t<link rel='alternate stylesheet' type='text/css' href='".$rep.$style."/rtl/".$css." ' title='righttoleft' />";
		    		}
				}
			$feuilles_style.="\n\t<script type='text/javascript' src='./javascript/styleswitcher.js'></script>";
			closedir($handlertl);
			}
		}
	$feuilles_style_deja_lu = $feuilles_style; 
	return $feuilles_style;
	}

// Get current page...  pour marquer l'onglet...
if (!$current_alert) {
	$current = current_page();
	$current_module=str_replace(".php","",$current);
	} else  $current_module = $current_alert ; 

if (!$current_module) $current_module = "index" ;

//	----------------------------------
// $std_header : template header standard
// attention : il n'y a plus le <body> : est envoy par le fichier init.inc.php, c'est bien un header
$std_header = "
<!DOCTYPE html PUBLIC '-//W3C//DTD XHTML 1.0 Strict//EN'
'http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd'>
<html xmlns='http://www.w3.org/1999/xhtml' lang='$msg[1002]' charset='".$charset."'>
  <head>
    <title>
      $msg[1001]
    </title>
	<meta name='author' content='PMB Group' />
	<meta name='description' content='Logiciel libre de gestion de mdiathque' />
	<meta name='keywords' content='logiciel, gestion, bibliothque, mdiathque, libre, free, software, mysql, php, linux, windows, mac' />
	<!--<meta http-equiv='Pragma' content='no-cache' />
	<meta http-equiv='Cache-Control' content='no-cache' />-->
 	<meta http-equiv=Content-Type content=\"text/html; charset=".$charset."\" />
	<meta http-equiv='Content-Language' content='$lang' />";
$std_header.= link_styles($stylesheet); 
$std_header.="
	<link rel=\"SHORTCUT ICON\" href=\"images/favicon.ico\" />
	<script src=\"".$base_path."/javascript/drag_n_drop.js\" type=\"text/javascript\"></script>
	<script src=\"".$base_path."/javascript/handle_drop.js\" type=\"text/javascript\"></script>
	</head>";

//	----------------------------------
// $selector_header : template header selecteur
$selector_header = "
<!DOCTYPE html PUBLIC '-//W3C//DTD XHTML 1.0 Strict//EN'
'http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd'>
<html xmlns='http://www.w3.org/1999/xhtml' lang='$msg[1002]' charset='".$charset."'>
  <head>
  	<meta name='author' content='PMB Group' />
	<meta name='description' content='Logiciel libre de gestion de mdiathque' />
	<meta name='keywords' content='logiciel, gestion, bibliothque, mdiathque, libre, free, software, mysql, php, linux, windows, mac' />
  	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=".$charset."\">
    <title>
      PMB-Selector
    </title>";
$selector_header.= link_styles($stylesheet); //"    <link rel='stylesheet' type='text/css' href='./styles/$stylesheet'>";
$selector_header.="  </head>
  </head>
  <body>
";

//	----------------------------------
// $selector_header_no_cache : template header selecteur (no cache)
$selector_header_no_cache = "
<!DOCTYPE html PUBLIC '-//W3C//DTD XHTML 1.0 Strict//EN'
'http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd'>
<html xmlns='http://www.w3.org/1999/xhtml' lang='$msg[1002]' charset='".$charset."'>
  <head>
    <title>
      PMB-selector
    </title>
	<meta name='author' content='PMB Group' />
	<meta name='description' content='Logiciel libre de gestion de mdiathque' />
	<meta name='keywords' content='logiciel, gestion, bibliothque, mdiathque, libre, free, software, mysql, php, linux, windows, mac' />
	<!--<meta http-equiv='Pragma' content='no-cache'>
    <meta http-equiv='Cache-Control' content='no-cache'>-->
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=".$charset."\">";
$selector_header_no_cache.= link_styles($stylesheet);
$selector_header_no_cache.="
  </head>
  <body>
";

//	----------------------------------
// $footer : template footer standard
$footer = "
<div id='footer'>
<div class='row'>
	
</div>	
</div>
<script type=\"text/javascript\">if (init_drag) init_drag();</script>
  </body>
</html>
";

//	----------------------------------
// $menu_bar : template menu bar
//	Gnrer le $menu_bar selon les droits...
//	Par dfaut : la page d'accueil.

$menu_bar = "
<!--	Menu bar	-->
<div id='navbar'>
<h3>$msg[1913]</h3>
	<ul>";

//	L'utilisateur fait la CIRCULATION ?
if (SESSrights & CIRCULATION_AUTH) {
	$menu_bar = $menu_bar."\n<span id='navbar-circ'><li ";
	if ("$current" == "circ.php") $menu_bar = $menu_bar." class='current'><a class='current' ";
		else $menu_bar = $menu_bar."><a ";
	$menu_bar.= "title='$msg[742]' href='./circ.php?categ=' accesskey='$msg[2001]'>$msg[5]</a></li></span>";
	}

//	L'utilisateur fait le CATALOGAGE ?
if (SESSrights & CATALOGAGE_AUTH) {
	$menu_bar = $menu_bar."\n<span id='navbar-catalog'><li ";
	if ("$current" == "catalog.php") $menu_bar = $menu_bar." class='current'><a class='current' ";
		else $menu_bar = $menu_bar."><a ";
	$menu_bar.= "title='$msg[743]' href='./catalog.php' accesskey='$msg[2002]'>$msg[6]</a></li></span>";
	}

//	L'utilisateur fait les AUTORITS ?
if (SESSrights & AUTORITES_AUTH) {
	$menu_bar = $menu_bar."\n<span id='navbar-autorites'><li ";
	if ("$current" == "autorites.php") $menu_bar = $menu_bar." class='current'><a class='current' ";
		else $menu_bar = $menu_bar."><a ";
	$menu_bar.= "title='$msg[744]' href='./autorites.php?categ=&sub=&id=' accesskey='$msg[2003]'>$msg[132]</a></li></span>";
	}

//	L'utilisateur fait l'DITIONS ?
if (SESSrights & EDIT_AUTH) {
	$menu_bar = $menu_bar."\n<span id='navbar-edit'><li ";
	if ("$current" == "edit.php") $menu_bar = $menu_bar." class='current'><a class='current' ";
		else $menu_bar = $menu_bar."><a ";
	$menu_bar.= "title='$msg[745]' href='./edit.php?categ=procs' accesskey='$msg[2004]'>$msg[1100]</a></li></span>";
	}

//	L'utilisateur fait la DSI ?
if ($dsi_active && (SESSrights & DSI_AUTH)) {
	$menu_bar = $menu_bar."\n<span id='navbar-dsi'><li ";
	if ("$current" == "dsi.php") $menu_bar = $menu_bar." class='current'><a class='current' ";
		else $menu_bar = $menu_bar."><a ";
	$menu_bar.= "title='".htmlentities($msg[dsi_menu_title],ENT_QUOTES, $charset)."' href='./dsi.php' >$msg[dsi_menu]</a></li></span>";
	}

//	L'utilisateur fait l'ACQUISITION ?
if ($acquisition_active && (SESSrights & ACQUISITION_AUTH)) {
	$menu_bar = $menu_bar."\n<span id='navbar-acquisition'><li ";
	if ("$current" == "acquisition.php") $menu_bar = $menu_bar." class='current'><a class='current' ";
		else $menu_bar = $menu_bar."><a ";
	$menu_bar.= "title='".htmlentities($msg[acquisition_menu_title],ENT_QUOTES, $charset)."' href='./acquisition.php' >$msg[acquisition_menu]</a></li></span>";
}


//	L'utilisateur fait l'ADMINISTRATION ?
if (SESSrights & ADMINISTRATION_AUTH) {


	$menu_bar = $menu_bar."\n<span id='navbar-admin'><li ";
	if ("$current" == "admin.php") $menu_bar = $menu_bar." class='current'><a class='current' ";
		else $menu_bar = $menu_bar."><a ";
	$menu_bar.= "title='$msg[746]' href='./admin.php?categ=' accesskey='$msg[2005]'>$msg[7]</a></li></span>";
	}

$menu_bar = $menu_bar."
	</ul>
</div>";
if (SESSrights & CATALOGAGE_AUTH) {
	$extra.="<iframe id='history' style='display:none;'></iframe>";
}
$extra.="
<div id='extra'>
<span id=\"keystatus\">&nbsp;</span>&nbsp;&nbsp;&nbsp;";
if (SESSrights & CATALOGAGE_AUTH) 
	$extra.="<a href=# onClick=\"document.getElementById('history').style.display=''; document.getElementById('history').src='./history.php'; return false;\" alt=\"".$msg["menu_bar_title_histo"]."\" title=\"".$msg["menu_bar_title_histo"]."\"><img src=./images/historique.gif align=middle hspace=3></a>";


//affichage du lien d'aide, c'est un "?" pour l'instant
if ($pmb_show_help) {
    // remplacement de !!help_link!! par le lien correspondant
    $request_uri  = $_SERVER["REQUEST_URI"];
	$doc_params_explode = explode("?", $request_uri);
	$doc_params = $doc_params_explode[1]; 
 	$pos = strrpos($doc_params_explode[0], "/") + 1;
	$script_name=substr($doc_params_explode[0],$pos);
   /* **************************************************************************
   /* Aadido en el enlace de la ayuda del PMB el pdf en castellano y valenciano
   /* Autor: David Prez Lled
   /* **************************************************************************
   //$extra .= "<a href=# onclick=\"window.open('doc/index.php?script_name=".$script_name."&".$doc_params."&lang=".$lang."', 'documentation', 'width=480,height=550,toolbar=0,menubar=0,dependent=0,resizable=1,alwaysRaised=1');return false;\" alt=\"".$msg["1900"]."\" title=\"".$msg["1900"]."\">"; */
    $extra .= "<a href=# onclick=\"window.open('doc/" . $msg[user_manual] . "', 'documentation', 'width=600,height=700,toolbar=0,menubar=0,dependent=0,resizable=1,alwaysRaised=1');return false;\" alt=\"".$msg["1900"]."\" title=\"".$msg["1900"]."\">";

   /* ***************************************************************** */

    $extra .= "<img src=./images/aide.gif align=middle hspace=3></a>";
	}
if (SESSrights & PREF_AUTH)	
	$extra .="<a href='./account.php' accesskey='$msg[2006]' alt=\"$msg[934]\" title=\"$msg[934]\"><img src=./images/parametres.gif align=middle hspace=3></a>";

$extra .="<a title='$msg[1027]' href='$pmb_opac_url' target='_opac_' accesskey='$msg[2007]'><img src=./images/opac2.gif align=middle hspace=3></a>";

if (SESSrights & SAUV_AUTH)
	$extra .="<a title='$msg[sauv_shortcuts_title]' href='#' onClick='w=window.open(\"./admin.php?categ=sauvegarde&sub=lliurexp\",\"sauv_launch\",\"menubar=no,scrollbars=yes,width=780,height=500\"); w.focus(); return false;'><img src=./images/sauv.gif align=middle hspace=3></a>";

if ($pmb_show_rtl) {
	$extra .= "<a title='".$msg['rtl']."' href='#' onclick=\"setActiveStyleSheet('lefttoright'); window.location.reload(false); return false;\"><img src=./images/rtl.gif align=middle hspace=3></a>";
	$extra .= "<a title='".$msg['ltr']."' href='#' onclick=\"setActiveStyleSheet('righttoleft'); window.location.reload(false); return false;\"><img src=./images/ltr.gif align=middle hspace=3></a>";
}

$extra .= "<a title='$msg[747] : ".LOCATION."' href='./logout.php' accesskey='$msg[2008]'><img src=./images/close.png align=middle hspace=3></a>";

$extra .= "</div>";

// Rcupration de l'url active et test de prsence sur la chaine cir.php'

	$url_active = $_SERVER['PHP_SELF'];
	$presence_chaine = strpos($url_active,'circ.php');

// Masquage de l'iframe d'alerte dans le cas 
// ou l'onglet courant est circulation et utilisateur en circulation restreinte' 
	
if ((SESSrights & RESTRICTCIRC_AUTH) && ($categ!="pret") && ($categ!="pretrestrict") &&  ($presence_chaine != false)) {
	$extra_info = ''; 
} else {
	$extra_info ="
		<iframe frameborder='0' scrolling='auto' name='alerte' id='alerte' src='$base_path/alert.php?current_alert=$current_module' class='$current_module'></iframe>
		";
}

/* listes dpliables et tris */
// ici, templates de gestion des listes dpliables et tris en rsultat de recherche catalogage ou autres
$begin_result_liste = "
<script type=\"text/javascript\" src=\"".$javascript_path."/tablist.js\"></script>
<a href=\"javascript:expandAll()\"><img src='./images/expand_all.gif' border='0' id=\"expandall\"></a>
<a href=\"javascript:collapseAll()\"><img src='./images/collapse_all.gif' border='0' id=\"collapseall\"></a>
";

$affich_tris_result_liste = "<a href=# onClick=\"document.getElementById('history').src='./sort.php?action=0'; document.getElementById('history').style.display='';return false;\" alt=\"".$msg['tris_dispos']."\" title=\"".$msg['tris_dispos']."\"><img src=./images/orderby_az.gif align=middle hspace=3></a>";
			
if ($_SESSION["tri"]) {
	$result=mysql_query("SELECT nom_tri, tri_par_texte FROM tris WHERE id_tri='".$_SESSION["tri"]."'");
	if ($result) {
		if (mysql_num_rows($result)!=0) {
			$row=mysql_fetch_array($result);
			$affich_tris_result_liste .= $msg['tri_par']." ".$row['nom_tri']." ".$row['tri_par_texte'];
		}
	}
	mysql_free_result($result);
}

$affich_tris_result_liste .="<br>";
$expand_result="
<script type=\"text/javascript\" src=\"./javascript/tablist.js\"></script>
";

$end_result_list = "
"; 

	
/* /listes dpliables et tris */
