<?php
// +-------------------------------------------------+
//  2002-2004 PMB Services / www.sigb.net pmb@sigb.net et contributeurs (voir www.sigb.net)
// +-------------------------------------------------+
// $Id: cart_info.php,v 1.30 2007/11/07 17:05:37 gueluneau Exp $

//Actions et affichage du rsultat pour un panier de l'opac

$base_path=".";
require_once($base_path."/includes/init.inc.php");

include($base_path."/includes/error_report.inc.php") ;

include($base_path."/includes/global_vars.inc.php");
require_once($base_path.'/includes/opac_config.inc.php');
	
// rcupration paramtres MySQL et connection  la base
require_once($base_path.'/includes/opac_db_param.inc.php');
require_once($base_path.'/includes/opac_mysql_connect.inc.php');
$dbh = connection_mysql();

include($base_path."/includes/misc.inc.php");

//Sessions !! Attention, ce doit tre imprativement le premier include ( cause des cookies)
include($base_path."/includes/session.inc.php");

require_once($base_path.'/includes/start.inc.php');
require_once($base_path.'/includes/opac_config.inc.php');
require_once($base_path."/includes/check_session_time.inc.php");

// rcupration localisation
require_once($base_path.'/includes/localisation.inc.php');

// version actuelle de l'opac
require_once($base_path.'/includes/opac_version.inc.php');

require_once($base_path."/classes/search.class.php");

?>
<html>
<body>
<span id='cart_info_iframe_content'>
<?php

function add_query($requete) {
	global $cart_;
	global $opac_max_cart_items;
	global $msg;
	global $charset;
	
	$resultat=mysql_query($requete);
	$nbtotal=@mysql_num_rows($resultat);
	$n=0; $na=0;
	while ($r=mysql_fetch_object($resultat)) {
		if (count($cart_)<$opac_max_cart_items) {
			$as=array_search($r->notice_id,$cart_);
			if (($as===null)||($as===false)) {
				$cart_[]=$r->notice_id;
				$n++;	
			} else $na++;
		}
	}
	$message=sprintf($msg["cart_add_notices"],$n,$nbtotal);
	if ($na) $message.=", ".sprintf($msg["cart_already_in"],$na);
	if (count($cart_)==$opac_max_cart_items) $message.=", ".$msg["cart_full"];
	return $message;
}


print "<link rel=\"stylesheet\" href=\"./styles/".$css."/".$css.".css\" />
<img src='images/basket_small_20x20.gif' border='0' valign='center'/>&nbsp;";
$cart_=$_SESSION["cart"];
if (!count($cart_)) $cart_=array();
if (($id)&&(!$lvl)) {
	if (count($cart_)<$opac_max_cart_items) {
		$as=array_search($id,$cart_);
		$notice_header=htmlentities(substr(strip_tags(stripslashes($header)),0,45),ENT_QUOTES,$charset);
		if ($notice_header!=$header) $notice_header.="...";
		if (($as!==null)&&($as!==false)) {
			$message=sprintf($msg["cart_notice_exists"],$notice_header);
		} else {
			$cart_[]=$id;
			$message=sprintf($msg["cart_notice_add"],$notice_header);
		}
	} else {
		$message=$msg["cart_full"];
	}
} else if ($lvl) {
	switch ($lvl) {
		case "more_results":
			switch ($mode) {
				case "tous" :
					$requete="select notice_id, ".stripslashes($pert)." from notices, notice_statut, notices_global_index ".stripslashes($clause)." and notice_id = num_notice group by notice_id ".stripslashes($tri);
					$message=add_query($requete);
					break;
				case "titre":
					$requete="select notice_id, ".stripslashes($pert)." from notices, notice_statut ".stripslashes($clause)." group by notice_id ".stripslashes($tri);
					$message=add_query($requete);
					break;
				case "keyword":
					$requete="select notice_id, ".stripslashes($pert)." from notices, notice_statut ".stripslashes($clause)." group by notice_id ".stripslashes($tri);
					$message=add_query($requete);
					break;
				case "abstract":
					$requete="select notice_id, ".stripslashes($pert)." from notices, notice_statut ".stripslashes($clause)." group by notice_id ".stripslashes($tri);
					$message=add_query($requete);
					break;
				case "extended":
					$es=new search();
					$table=$es->make_search();
					$requete="select notices.notice_id, tit1 from $table,notices, notice_statut where notices.notice_id=$table.notice_id and statut=id_notice_statut and ((notice_visible_opac=1 and notice_visible_opac_abon=0)".( $_SESSION["user_code"]? " or (notice_visible_opac_abon=1 and notice_visible_opac=1)" : "").")" ;
					$message=add_query($requete);
					break;
				case "external":
					if ($_SESSION["external_type"]=="multi") $es=new search("search_fields_unimarc"); else $es=new search("search_simple_fields_unimarc");
					$table=$es->make_search();
					$requete="select entrepots.recid as notice_id, value from $table,entrepots where $table.notice_id=entrepots.recid and ufield='200' and usubfield='a' order by field_order,subfield_order";
					$message=add_query($requete);
					break;
			}
			break;
		case "author_see":
			$rqt_auteurs = "select author_id as aut from authors where author_see='$id' and author_id!=0 union select author_see as aut from authors where author_id='$id' and author_see!=0 " ;
			$res_auteurs = mysql_query($rqt_auteurs, $dbh);
			$clause_auteurs = "responsability_author in ('$id' ";
			while($id_aut=mysql_fetch_object($res_auteurs)) 
				$clause_auteurs .= ", '".$id_aut->aut."' "; 
			$clause_auteurs .= " ) " ;
			$requete = "SELECT distinct notices.notice_id FROM notices, responsability, notice_statut ";
			$requete .= " where $clause_auteurs and notice_id=responsability_notice and statut=id_notice_statut and ((notice_visible_opac=1 and notice_visible_opac_abon=0)".( $_SESSION["user_code"]? " or (notice_visible_opac_abon=1 and notice_visible_opac=1)" : "").")" ;
			$message=add_query($requete);
			break;
		case "categ_see":
//TODO
//			$requete = "SELECT distinct notices.notice_id FROM notices, notices_categories, notice_statut WHERE notcateg_categorie='$id' and notcateg_notice=notice_id and statut=id_notice_statut and ((notice_visible_opac=1 and notice_visible_opac_abon=0)".( $_SESSION["user_code"]? " or (notice_visible_opac_abon=1 and notice_visible_opac=1)" : "").")" ;
			$requete = "SELECT distinct notices.notice_id FROM notices, notices_categories, notice_statut WHERE num_noeud='$id' and notcateg_notice=notice_id and statut=id_notice_statut and ((notice_visible_opac=1 and notice_visible_opac_abon=0)".( $_SESSION["user_code"]? " or (notice_visible_opac_abon=1 and notice_visible_opac=1)" : "").")" ;

			$requete .= " ORDER BY $opac_categories_categ_sort_records";
			$message=add_query($requete);
			break;
		case "indexint_see":
			$requete = "SELECT notice_id FROM notices, notice_statut WHERE indexint='$id' and statut=id_notice_statut and ((notice_visible_opac=1 and notice_visible_opac_abon=0)".( $_SESSION["user_code"]? " or (notice_visible_opac_abon=1 and notice_visible_opac=1)" : "").")" ;
			$requete .= " ORDER BY $opac_categories_categ_sort_records";
			$message=add_query($requete);
			break;
		case "coll_see":
			$requete = "SELECT notices.notice_id FROM notices, notice_statut WHERE coll_id=$id and statut=id_notice_statut and ((notice_visible_opac=1 and notice_visible_opac_abon=0)".( $_SESSION["user_code"]? " or (notice_visible_opac_abon=1 and notice_visible_opac=1)" : "").")" ;
			$message=add_query($requete);
			break;
		case "publisher_see":
			$requete  = "SELECT distinct notice_id FROM notices, notice_statut WHERE (ed1_id=$id or ed2_id=$id) and statut=id_notice_statut and ((notice_visible_opac=1 and notice_visible_opac_abon=0)".( $_SESSION["user_code"]? " or (notice_visible_opac_abon=1 and notice_visible_opac=1)" : "").")" ;
			$message=add_query($requete);
			break;
		case "serie_see":
			$requete  = "SELECT distinct notice_id FROM notices, notice_statut WHERE tparent_id=$id and statut=id_notice_statut and ((notice_visible_opac=1 and notice_visible_opac_abon=0)".( $_SESSION["user_code"]? " or (notice_visible_opac_abon=1 and notice_visible_opac=1)" : "").")" ;
			$message=add_query($requete);
			break;
		case "subcoll_see":
			$requete = "SELECT notice_id FROM notices, notice_statut WHERE subcoll_id=$id and statut=id_notice_statut and ((notice_visible_opac=1 and notice_visible_opac_abon=0)".( $_SESSION["user_code"]? " or (notice_visible_opac_abon=1 and notice_visible_opac=1)" : "").")" ;
			$message=add_query($requete);
			break;
		case "etagere_see":
			$requete = "SELECT distinct notice_id FROM caddie_content, etagere_caddie, notices, notice_statut where etagere_id=$id and caddie_content.caddie_id=etagere_caddie.caddie_id and notice_id=object_id and statut=id_notice_statut and ((notice_visible_opac=1 and notice_visible_opac_abon=0)".( $_SESSION["user_code"]? " or (notice_visible_opac_abon=1 and notice_visible_opac=1)" : "").")" ;
			$message=add_query($requete);
			break;
		case "dsi":
			$requete = "select distinct notice_id from bannette_contenu, notices, notice_statut where num_bannette=$id and notice_id=num_notice and statut=id_notice_statut and ((notice_visible_opac=1 and notice_visible_opac_abon=0)".( $_SESSION["user_code"]? " or (notice_visible_opac_abon=1 and notice_visible_opac=1)" : "").")" ;
			$message=add_query($requete);
			break;
		case "section_see":
			//Table temporaire de tous les id
			$requete="create temporary table temp_n_id ENGINE=MyISAM select notice_id FROM notices, exemplaires, notice_statut  WHERE expl_location=$location and expl_section=$id and notice_id=expl_notice and statut=id_notice_statut and ((notice_visible_opac=1 and notice_visible_opac_abon=0)".( $_SESSION["user_code"]? " or (notice_visible_opac_abon=1 and notice_visible_opac=1)" : "").")" ;
			if (strlen($dcote)) {
				$requete.=" and expl_cote regexp '(^".$dcote.str_repeat(".",$lcote-strlen($dcote)).")|( ".$dcote.str_repeat(".",$lcote-strlen($dcote))."[0-9\.]* )'";
				$level_ref=strlen($dcote)+1;
			}
			$requete.=" group by notice_id ";
			$requete .= " ORDER BY index_serie,tnvol,index_sew";
			@mysql_query($requete);
			
			//Calcul du classement
			$rq_index="select expl_cote from exemplaires, temp_n_id where expl_location=$location and expl_section=$id and expl_notice=temp_n_id.notice_id";
			$rq_index.=" group by expl_cote";
			$res_index=mysql_query($rq_index);
	
			if ($level_ref==0) $level_ref=1;
	
			while ($ct=mysql_fetch_object($res_index)) {
				if (preg_match("/([0-9\.])+/",$ct->expl_cote,$c)) {
					$found=false;
					$lcote=(strlen($c[0])>=3) ? 3 : strlen($c[0]);
					$level=$level_ref;
					while ((!$found)&&($level<=$lcote)) {
						$cote=substr($c[0],0,$level);
						$compl=str_repeat("0",$lcote-$level);
						$rq_index="select indexint_name,indexint_comment from indexint where indexint_name='".$cote.$compl."' and length(indexint_name)>=$lcote order by indexint_name limit 1";
						$res_index_1=mysql_query($rq_index);
						if (mysql_num_rows($res_index_1)) {
							if (!$nc) {
								$found=true;
							} else {
								$rq_del="select distinct notice_id from notices, exemplaires where expl_cote='".$ct->expl_cote."' and expl_notice=notice_id group by notice_id ";
								$res_del=mysql_query($rq_del);
								while (list($n_id)=mysql_fetch_row($res_del)) {
									mysql_query("delete from temp_n_id where notice_id=".$n_id);
								}
								$found=true;
							}
						} else $level++;
					}
				}
			}
			$requete = "SELECT notice_id FROM temp_n_id " ;	
			$message=add_query($requete);
			break;
	}
} else $message="";
if(!count($cart_)) echo $msg["cart_empty"]; else echo $message." <a href='#' onClick=\"parent.document.location='index.php?lvl=show_cart'; return false;\">".sprintf($msg["cart_contents"],count($cart_))."</a>.";
$_SESSION["cart"]=$cart_;
?>
</span>
</body>
</html>
