<?php
// +-------------------------------------------------+
//  2002-2004 PMB Services / www.sigb.net pmb@sigb.net et contributeurs (voir www.sigb.net)
// +-------------------------------------------------+
// $Id: notice_display.class.php,v 1.24 2007/03/11 09:46:09 touraine37 Exp $

if (stristr($_SERVER['REQUEST_URI'], ".class.php")) die("no access");

//fichiers  inclure (faites un copier-coller)
// classes pour notice_display.class.php
require_once($base_path."/classes/author.class.php");
require_once($base_path."/classes/publisher.class.php");
require_once($base_path."/classes/collection.class.php");
require_once($base_path."/classes/subcollection.class.php");
require_once($base_path."/classes/serie.class.php");
require_once($base_path."/classes/categorie.class.php");
require_once($base_path."/classes/publisher.class.php");
require_once($base_path."/classes/marc_table.class.php");

if ( ! defined( 'NOTICE_DISPLAY' ) ) {
  define( 'NOTICE_DISPLAY', 1 );

// proprits pour le selecteur de panier (kinda template)

$selector_prop = "toolbar=no, dependent=yes, width=500, height=400, resizable=yes";
$cart_click = "onclick=\"window.open('./cart.php?object_type=NOTI&item=!!item!!', 'cart', '$selector_prop')\"";

class notice_display {

// proprits

	var $id = 0;
	var $type_doc = '';
	var $tit1 = '';			// titre propre
	var $tit2 = '';			// titre propre 2
	var $tit3 = '';			// titre parallle
	var $tit4 = '';			// complment du titre
	var $tparent_id = '';		// id du titre parent
	var $tparent = '';		// libell du titre parent
	var $tnvol = '';		// numro de partie

	var $responsabilites =	array("responsabilites" => array(),"auteurs" => array());  // les auteurs

	var $ed1_id = '';		// id diteur 1
	var $ed1 ='';			// libell diteur 1
	var $coll_id = '';		// id collection
	var $coll = '';			// libell collection
	var $subcoll_id = '';		// id sous collection
	var $subcoll = '';		// libell sous collection
	var $year = '';			// anne de publication
	var $nocoll = '';		// no. dans la collection
	var $ed2_id = '';		// id diteur 2
	var $ed2_name ='';		// nom diteur 2
	var $ed2_isbd = '';		// isbd diteur 2
	var $code = '';			// ISBN, code barre commercial ou no. commercial
	var $npages = '';		// importance matrielle (nombre de pages, d'lments...)
	var $ill = '';			// mention d'illustration
	var $size = '';			// format
	var $prix = '';			// prix
	var $accomp = '';		// matriel d'accompagnement
	var $n_gen = '';		// note gnrale
	var $n_contenu = '';		// note de contenu
	var $n_resume = '';		// resum/extrait
	var $lien = '';			// URL de la ressource lectronique associe
	var $eformat = '';		// format de la ressource lectronique associe
	var $authorities ='';		// liste des autorits

	var $categories =array();	// les categories
 	var $langues = array();
	var $languesorg = array();
  	

	var $action = './catalog.php?categ=update&id=';
	var $header = '';	// forme sur une ligne (titre/auteur principal);
	var $display = '';	// affichage final
	var $isbd = '';		// isbd "traditionnel"

// mthodes

	// constructeur

	// le level comprend les valeurs suivantes :
	// 0 = titre / auteur (rf. pour exemplaire). niveau minimum gnr par dfaut
	// 1 = isbd seul
	// 2 = isbd complet (comprend responsabilits et indexation)
	// 3 = isbd pour listes notices en catalogage, il y a un lien vers l'affichage notice
	// 4 = isbd pour listes rservations, avec lien adaptable vers la page de cration rservation

	function notice_display($id, $level=0) {

		global $dbh;
		global $msg;
		global $cart_click;
		$tdoc = new marc_list('doctype');
		
		global $fonction_auteur;
		// rcupration des codes de fonction
		if (!count($fonction_auteur)) {
			$fonction_auteur = new marc_list('function');
			$fonction_auteur = $fonction_auteur->table;
			}


		if($id) {
			if(is_object($id)) {
				// l'objet-notice est fourni directement
				$this->id			=	$id->notice_id;
				$this->type_doc			= 	$id->typdoc;
				$this->tit1			=	$id->tit1;
				$this->tit2			=	$id->tit2;
				$this->tit3			=	$id->tit3;
				$this->tit4			=	$id->tit4;
				$this->tnvol			=	$id->tnvol;
				$this->responsabilites 		= 	get_notice_authors($this->id) ;
				$this->ed1_id			=	$id->ed1_id;
				$this->tparent_id		=	$id->tparent_id;
				$this->coll_id			=	$id->coll_id;
				$this->subcoll_id		=	$id->subcoll_id;
				$this->year			=	$id->year;
				$this->nocoll			=	$id->nocoll;
				$this->ed2_id			=	$id->ed2_id;
				$this->code			=	$id->code;
				$this->npages			=	$id->npages;
				$this->ill			=	$id->ill;
				$this->size			=	$id->size;
				$this->prix			=	$id->prix;
				$this->accomp			=	$id->accomp;
				$this->n_gen			=	$id->n_gen;
				$this->n_contenu		=	$id->n_contenu;
				$this->n_resume			=	$id->n_resume;
				$this->lien			=	$id->lien;
				$this->eformat			=	$id->eformat;
			} else {
				// requte pour rcuprer les infos notices
				$requete = 'SELECT * FROM notices WHERE notice_id='.$id.' ';
				$result = mysql_query($requete, $dbh);
				if($result) {
					$src = mysql_fetch_object($result);

					// les infos suivantes sont trouves dans la base
					$this->id			=	$src->notice_id;
					$this->type_doc			= 	$src->typdoc;
					$this->tit1			=	$src->tit1;
					$this->tit2			=	$src->tit2;
					$this->tit3			=	$src->tit3;
					$this->tit4			=	$src->tit4;
					$this->tnvol			=	$src->tnvol;
					$this->responsabilites 		= 	get_notice_authors($this->id) ;
					$this->ed1_id			=	$src->ed1_id;
					$this->tparent_id		=	$src->tparent_id;
					$this->coll_id			=	$src->coll_id;
					$this->subcoll_id		=	$src->subcoll_id;
					$this->year			=	$src->year;
					$this->nocoll			=	$src->nocoll;
					$this->ed2_id			=	$src->ed2_id;
					$this->code			=	$src->code;
					$this->npages			=	$src->npages;
					$this->ill			=	$src->ill;
					$this->size			=	$src->size;
					$this->prix			=	$src->prix;
					$this->accomp			=	$src->accomp;
					$this->n_gen			=	$src->n_gen;
					$this->n_contenu		=	$src->n_contenu;
					$this->n_resume			=	$src->n_resume;
					$this->lien			=	$src->lien;
					$this->eformat			=	$src->eformat;
					} else {
						$this->display = $msg[200];
						return;
						}
			}

			// le reste doit tre rcupr ailleurs

			// type du document
			$this->type_doc = $tdoc->table[$this->type_doc];

			// titre parent
			if($this->tparent_id) {
				$serie = new serie($this->tparent_id);
				$this->tparent = $serie->name;
				}
			
			// mise  jour des catgories
			$this->categories = get_notice_categories($this->id) ;
	
			// ******************
			// constitution de la mention de responsabilit
			//$this->responsabilites
			$as = array_search ("0", $this->responsabilites["responsabilites"]) ;
			if ($as!== FALSE && $as!== NULL) {
				$auteur_0 = $this->responsabilites["auteurs"][$as] ;
				$auteur = new auteur($auteur_0["id"]);
				if ($auteur_0["fonction"]) $f_auteur =" (".$fonction_auteur[$auteur_0["fonction"]].")";
					else $f_auteur="";
				$mention_resp_lib = "<b>".$msg[auteur_start]."</b> "."<a href='index.php?lvl=author_see&id=".$auteur_0["id"]."'>$auteur->isbd_entry</a> ".$f_auteur."<br/>";
				$mention_resp[] = $mention_resp_lib ;
				}
			
			$as = array_keys ($this->responsabilites["responsabilites"], "1" ) ;
			for ($i = 0 ; $i < count($as) ; $i++) {
				$indice = $as[$i] ;
				$auteur_1 = $this->responsabilites["auteurs"][$indice] ;
				$auteur = new auteur($auteur_1["id"]);
				if ($auteur_1["fonction"]) $f_auteur =" (".$fonction_auteur[$auteur_1["fonction"]].")";
					else $f_auteur="";
				$mention_resp_lib = "<b>".$msg[auteur_start]."</b> "."<a href='index.php?lvl=author_see&id=".$auteur_1["id"]."'>$auteur->isbd_entry</a> ".$f_auteur."<br/>";
				$mention_resp[] = $mention_resp_lib ;
				}
			
			$as = array_keys ($this->responsabilites["responsabilites"], "2" ) ;
			for ($i = 0 ; $i < count($as) ; $i++) {
				$indice = $as[$i] ;
				$auteur_2 = $this->responsabilites["auteurs"][$indice] ;
				$auteur = new auteur($auteur_2["id"]);
				if ($auteur_2["fonction"]) $f_auteur =" (".$fonction_auteur[$auteur_2["fonction"]].")";
					else $f_auteur="";
				$mention_resp_lib = "<b>".$msg[auteur_start]."</b> "."<a href='index.php?lvl=author_see&id=".$auteur_2["id"]."'>$auteur->isbd_entry</a> ".$f_auteur."<br/>";
				$mention_resp[] = $mention_resp_lib ;
				}
				
			$libelle_mention_resp = implode (" ",$mention_resp) ;
			// *************
			if($this->subcoll_id) {
				$scollection = new subcollection($this->subcoll_id);
				// $this->subcoll = $scollection->isbd_entry;
				$this->subcoll = $scollection->name;
				}
			if($this->coll_id) {
				$collection = new collection($this->coll_id);
				$this->coll = $collection->isbd_entry;
				}
			if($this->ed1_id) {
				$editeur = new publisher($this->ed1_id);
				$this->ed1 = $editeur->isbd_entry;
				}

			// diteur 2
			if($this->ed2_id) {
				$ed = new publisher($this->ed2_id);
				$this->ed2_name = $ed->name;
				$this->ed2_isbd = $ed->isbd_entry;
				}

			// codes langues
			$this->fetch_langues(0) ;
			$this->fetch_langues(1) ;

			// gnration de l'affichage minimum (titre/auteur principal)
			$this->do_header();

			switch($level) {
				case 1 :
					$this->do_isbd(0);
					$this->display = $this->isbd;
					break;
				case 2 : // isbd complet avec autorits
					$this->do_isbd(0);
					$autorites = $this->authorities;
					$this->display = $this->isbd;
					$categories = $this->get_categories();
					if($autorites) $this->display .= "\n<h4>$msg[201]</h4>".$autorites;
					if($categories) $this->display .= "\n<h4>$msg[110]</h4>".$categories;
					break;
				case 3 : // liste de notices (ajout du lien pour modification)
					$this->do_isbd(0);
					$link = "<a href='./catalog.php?categ=isbd&id=".$this->id."'>".$this->header.'</a>';
					$click = str_replace('!!item!!', $this->id, $cart_click);
					$cart_link = "<img src='./images/basket_small_20x20.gif' align='right'  title=\"".$msg[notice_title_basket]."\" alt=\"".$msg[notice_title_basket]."\" $click>";
					$this->display = "<table border='0' width='100%'>
						<tr><td align='left'><strong>".$link."</strong></td>
						<td align='left'>$cart_link</td></tr>
						<tr><td colspan='2' align='left'>".$this->isbd."
						</td></tr>
					</table>";
					break;
				case 4 : // liste pour les rservations (ajout du lien pour la cration resa
					$this->do_isbd(0);
					$link = "<a href='./circ.php?categ=resa&id_empr=!!id_empr!!&id_notice=".$this->id."'>".$this->header.'</a>';
					$click = str_replace('!!item!!', $this->id, $cart_click);
					$cart_link = "<img src='./images/basket_small_20x20.gif' align='right'  title=\"".$msg[notice_title_basket]."\" alt=\"".$msg[notice_title_basket]."\" $click>";
					$this->display = "<table border='0' width='100%'>
						<tr><td align='left'><strong>".$link."</strong></td>
						<td align='left'>$cart_link</td></tr>
						<tr><td colspan='2' align='left'>".$this->isbd."
						</td></tr>
					</table>";
					break;
				default:
					$this->display = $this->header;
					break;
			}
		} else {
			$this->display = $msg[200];
			return;
		}
	}

function fetch_langues($quelle_langues=0) {
	global $dbh;

	global $marc_liste_langues ;
	if (!$marc_liste_langues) $marc_liste_langues=new marc_list('lang');

	$langues = array() ;
	$rqt = "select code_langue from notices_langues where num_notice='$this->id' and type_langue=$quelle_langues ";
	$res_sql = mysql_query($rqt, $dbh);
	while ($notice=mysql_fetch_object($res_sql)) {
		if ($notice->code_langue)
			$langues[] = array( 
				'lang_code' => $notice->code_langue,
				'langue' => $marc_liste_langues->table[$notice->code_langue]
				) ;
		}
	if (!$quelle_langues) $this->langues = $langues;
		else $this->languesorg = $langues;
}

function construit_liste_langues($tableau) {
	$langues = "";
	for ($i = 0 ; $i < sizeof($tableau) ; $i++) {
		if ($langues) $langues.=" ";
		$langues .= $tableau[$i]["langue"]." (<i>".$tableau[$i]["lang_code"]."</i>)";
		}
	return $langues;
}

	// routine pour gnerer l'affichage sur une ligne
	function do_header() {
		$this->tparent ? $this->header = $this->tparent : $this->header = '';
		$this->tnvol && $this->header ? $this->header .= ", $this->tnvol" : $this->header = '';
		$this->header ? $this->header .= '. ' : $this->header = '';
		
		//$this->responsabilites
		$as = array_search ("0", $this->responsabilites["responsabilites"]) ;
		if ($as!== FALSE && $as!== NULL) {
			$auteur_0 = $this->responsabilites["auteurs"][$as] ;
			$auteur = new auteur($auteur_0["id"]);
			$mention_resp = $auteur->isbd_entry;
			} else {
				$as = array_keys ($this->responsabilites["responsabilites"], "1" ) ;
				for ($i = 0 ; $i < count($as) ; $i++) {
					$indice = $as[$i] ;
					$auteur_1 = $this->responsabilites["auteurs"][$indice] ;
					$auteur = new auteur($auteur_1["id"]);
					$aut1_libelle[]= $auteur->isbd_entry;
					}
				
				$mention_resp = implode (", ",$aut1_libelle) ;
				}
		
		$mention_resp ? $this->header .= $this->tit1.' / '.$mention_resp : $this->header .= $this->tit1;
		}

	// routine pour gnrer l'ISBD

	function do_isbd($compact=0) {

		global $msg;
 		global $charset;
		global $fonction_auteur ;
		
		if($this->tparent) $isbd = $this->tparent;
		if($isbd && $this->tnvol) $isbd .= ", $this->tnvol";
		if($isbd) $isbd .= '. ';
		$isbd .= $this->tit1.' ['.$this->type_doc.']';
		if($this->tit3) $isbd .= '&nbsp;= '.$this->tit3;
		if($this->tit2) $isbd .= '&nbsp;; '.$this->tit2;
		if($this->tit4) $isbd .= '&nbsp;: '.$this->tit4;
		
		// *********
		$mention_resp = array() ;
	
		// constitution de la mention de responsabilit
		//$this->responsabilites
		$as = array_search ("0", $this->responsabilites["responsabilites"]) ;
		if ($as!== FALSE && $as!== NULL) {
			$auteur_0 = $this->responsabilites["auteurs"][$as] ;
			$auteur = new auteur($auteur_0["id"]);
			$mention_resp_lib = $auteur->isbd_entry;
			if ($auteur_0["fonction"])
				$mention_resp_lib .= ", ".$fonction_auteur[$auteur_0["fonction"]];
			$mention_resp[] = $mention_resp_lib ;
			}
		
		$as = array_keys ($this->responsabilites["responsabilites"], "1" ) ;
		for ($i = 0 ; $i < count($as) ; $i++) {
			$indice = $as[$i] ;
			$auteur_1 = $this->responsabilites["auteurs"][$indice] ;
			$auteur = new auteur($auteur_1["id"]);
			$mention_resp_lib = $auteur->isbd_entry;
			if ($auteur_1["fonction"])
				$mention_resp_lib .= ", ".$fonction_auteur[$auteur_1["fonction"]];
			$mention_resp[] = $mention_resp_lib ;
			}
		
		$as = array_keys ($this->responsabilites["responsabilites"], "2" ) ;
		for ($i = 0 ; $i < count($as) ; $i++) {
			$indice = $as[$i] ;
			$auteur_2 = $this->responsabilites["auteurs"][$indice] ;
			$auteur = new auteur($auteur_2["id"]);
			$mention_resp_lib = $auteur->isbd_entry;
			if ($auteur_2["fonction"])
				$mention_resp_lib .= ", ".$fonction_auteur[$auteur_2["fonction"]];
			$mention_resp[] = $mention_resp_lib ;
			}
			
		$libelle_mention_resp = implode ("; ",$mention_resp) ;
		
		if($libelle_mention_resp) $isbd .= " / ".$author_mention;

		$this->ed1 ? $adresse = $this->ed1 : $adresse .= '';
		$this->ed2_isbd && $adresse ? $adresse .= '. '.$this->ed2_isbd : $adresse .= $this->ed2->isbd;
		$this->year && $adresse ? $adresse .= ', '.$this->year : $adresse .= $this->year;

		if($adresse) $isbd .= '.&nbsp;- '.$adresse;

		$this->npages ? $isbd_collation = $this->npages : $isbd_collation = '[n.p]';
		if($this->ill) $isbd_collation .= '&nbsp;: '.$this->ill;
		if($this->size) $isbd_collation .= '&nbsp;; '.$this->size;
		if($this->prix) $isbd_collation .= '&nbsp;+ '.$this->prix;
		if($this->accomp) $isbd_collation .= '&nbsp;+ '.$this->accomp;

		$isbd .= ".&nbsp;- $isbd_collation";

		$collection = $this->coll;
		if($this->subcoll) $collection .= '. '.$this->subcoll;
		if($this->nocoll) $collection .= '; '.$this->nocoll;

		preg_match('/\.$/', $isbd) ? $sep = '- ' : $sep = '.&nbsp;- ';
		if($collection) $isbd .= "$sep($collection)";
		if(!preg_match('/\.$/', $isbd)) $isbd .= '.';

		// si $compact est non null, on n'affiche pas les zones de notes

		if(!$compact) {
			// zone des notes
 			if($this->n_contenu) $note = "${msg[203]}&nbsp;: ".nl2br(htmlentities($this->n_contenu,ENT_QUOTES, $charset));
			if($this->n_gen) {
 				$note ? $note .= '.&nbsp;- '.nl2br(htmlentities($this->n_gen,ENT_QUOTES, $charset)) : $note = nl2br(htmlentities($this->n_gen,ENT_QUOTES, $charset));
			}

			$numbers = $this->code;
			$numbers && $note ? $note .= '.&nbsp;- '.$numbers : $note .= $numbers;

			if($note && !preg_match('/\.$/', $note)) $note .= '.';

			if($note) $isbd .= '<br/><br/>'.$note;

			// ajout du lien vers une ressource lectronique

			if($this->lien) {
				$tlien = "<br/><a href='".$this->lien."' target='_doc_'>";
				$tlien .= "<img src='./images/docweb.gif' border='0' hspace='3' align='middle'>";
				$tlien .= $this->lien;
				$tlien .= '</a>';
				$isbd .= $tlien;
			}

			// ajout de la zone de rsum (Houda OK)
			if($this->n_resume) {
 				$isbd .= "\n<h4>${msg[204]}</h4><font class=number_results>".nl2br(htmlentities($this->n_resume,ENT_QUOTES, $charset)).'</font>';
			}
		}

		$this->isbd = $isbd;
	}

function get_categories() {

	// rcupration des catgories pour affichage complet
	$max_categ = sizeof($this->categories) ; 
	$categ_repetables = "" ;
	for ($i = 0 ; $i < $max_categ ; $i++) {
		$categ_id = $this->categories[$i]["categ_id"] ;
		$categ = new category($categ_id);
		if ($categ_repetables) $categ_repetables .= "<br/>" ;
		$categ_repetables .= $categ->catalog_form;
		}
	if($categ_repetables)
		$categories = "<br/><br/>$categ_repetables";
	return $categories;
	}
}

} # fin de dclaration
