<?php
// +-------------------------------------------------+
//  2002-2004 PMB Services / www.sigb.net pmb@sigb.net et contributeurs (voir www.sigb.net)
// +-------------------------------------------------+
// $Id: do_resa.php,v 1.25 2007/10/27 08:13:19 touraine37 Exp $

$base_path=".";

//Changement

require_once($base_path."/includes/init.inc.php");
require_once($base_path."/includes/error_report.inc.php") ;
require_once($base_path."/includes/global_vars.inc.php");
require_once($base_path.'/includes/opac_config.inc.php');

// rcupration paramtres MySQL et connection  la base
require_once($base_path.'/includes/opac_db_param.inc.php');
require_once($base_path.'/includes/opac_mysql_connect.inc.php');
$dbh = connection_mysql();

require_once($base_path."/includes/misc.inc.php");

//Sessions !! Attention, ce doit tre imprativement le premer include ( cause des cookies)
require_once($base_path."/includes/session.inc.php");
require_once($base_path.'/includes/start.inc.php');

require_once($base_path."/includes/notice_authors.inc.php");
require_once($base_path."/includes/notice_categories.inc.php");

require_once($base_path."/includes/check_session_time.inc.php");

// rcupration localisation
require_once($base_path.'/includes/localisation.inc.php');

// version actuelle de l'opac
require_once($base_path.'/includes/opac_version.inc.php');

// fonctions de gestion de formulaire
require_once($base_path.'/includes/javascript/form.inc.php');

require_once($base_path.'/includes/templates/common.tpl.php');
require_once($base_path.'/includes/divers.inc.php');

// classe de gestion des catgories
require_once($base_path.'/classes/categorie.class.php');
require_once($base_path.'/classes/notice.class.php');
require_once($base_path.'/classes/notice_display.class.php');

// classe indexation interne
require_once($base_path.'/classes/indexint.class.php');

// classe d'affichage des tags
require_once($base_path.'/classes/tags.class.php');

// classe de gestion des rservations
require_once($base_path.'/classes/resa.class.php');

// pour l'affichage correct des notices
require_once($base_path."/includes/templates/notice.tpl.php");
require_once($base_path."/includes/navbar.inc.php");
require_once($base_path."/includes/explnum.inc.php");
require_once($base_path."/includes/notice_affichage.inc.php");
require_once($base_path."/includes/bulletin_affichage.inc.php");

require_once($base_path."/includes/connexion_empr.inc.php");

// autenticazione LDAP - by MaxMan
require_once($base_path."/includes/ldap_auth.inc.php");

// RSS
require_once($base_path."/includes/includes_rss.inc.php");


if ( ($lvl=='make_sugg' || $lvl=='valid_sugg') && $opac_show_suggest == 2) {
	//Suggestion possible sans authentification
	$log_ok = 1;
	
} else {

	//Vrification de la session
	$log_ok=0;
	if (!$_SESSION["user_code"]) {
		if ($time_expired==0) {
			//Si pas de session en cours, vrification du login
			if ($_POST['login']) {
				$verif_query = "SELECT id_empr, empr_cb, empr_nom, empr_prenom, empr_password, empr_lang, empr_date_expiration<sysdate() as isexp , empr_login, empr_ldap, allow_opac FROM empr, empr_statut WHERE empr_login='".$_POST['login']."' and idstatut=empr_statut";
				$verif_result = mysql_query($verif_query) or die(mysql_error());
				// rcupration des valeurs MySQL du lecteur et injection dans les variables
				while ($verif_line = mysql_fetch_array($verif_result)) {
					$verif_empr_cb = $verif_line['empr_cb'];
					$verif_empr_login = $verif_line['empr_login'];
					$verif_empr_ldap = $verif_line['empr_ldap'];
					$verif_empr_password = $verif_line['empr_password'];
					$verif_lang = ($verif_line['empr_lang']?$verif_line['empr_lang']:"fr_FR");
					$verif_id_empr = $verif_line['id_empr'];
					$verif_isexp = $verif_line['isexp'];
					$allow_opac=$verif_line['allow_opac'];
					}
	
			if ($allow_opac) {
				if (($verif_empr_ldap)) { // auth by server ldap
					$auth_ok=auth_ldap($_POST['login'],$password);
					} else { //auth standard
						$auth_ok=(($verif_empr_password==$password)&&($verif_empr_login!="")&&(!$verif_isexp));
						}
				} else $auth_ok=false ;

				} else {
					$verif_empr_cb = '';
					$verif_empr_login = '';
					$verif_empr_ldap = 0;
					$verif_empr_password = '';
					$verif_lang = "fr_FR";
					$verif_id_empr = 0;
					$verif_isexp = 0;
					}					
			if ($auth_ok) {
				//Si mot de passe correct, enregistrement dans la session de l'utilisateur
				$log_ok=1;
				//Rcupration de l'environnement prcdent
				$requete="select session from opac_sessions where empr_id=".$verif_id_empr;
				$res_session=mysql_query($requete);
	
				if (@mysql_num_rows($res_session)) {
					$temp_session=unserialize(mysql_result($res_session,0,0));
					$_SESSION=$temp_session;
					} else $_SESSION=array();
	
				$_SESSION["user_code"]=$verif_empr_login;
				$_SESSION["id_empr_session"]=$verif_id_empr;
				$_SESSION["connect_time"]=time();
				$_SESSION["lang"]=$verif_lang;
				
				// change language and charset after login
				$lang=$_SESSION["lang"]; 
				set_language($lang);
				
				$query0 = "select * from empr, empr_statut where empr_login='".$_SESSION['user_code']."' and idstatut=empr_statut ";
				$req0 = mysql_query($query0,$dbh);
				$data = mysql_fetch_array($req0);
				$id_empr = $verif_id_empr;
				$empr_cb = $data['empr_cb'];
				$empr_nom = $data['empr_nom'];
				$empr_prenom= $data['empr_prenom'];
				$empr_adr1= $data['empr_adr1'];
				$empr_adr2= $data['empr_adr2'];
				$empr_cp= $data['empr_cp'];
				$empr_ville= $data['empr_ville'];
				$empr_mail= $data['empr_mail'];
				$empr_tel1= $data['empr_tel1'];
				$empr_tel2= $data['empr_tel2'];
				$empr_prof= $data['empr_prof'];
				$empr_year= $data['empr_year'];
				$empr_categ= $data['empr_categ'];
				$empr_codestat= $data['empr_codestat'];
				$empr_sexe= $data['empr_sexe'];
				$empr_login= $data['empr_login'];
				$empr_ldap= $data['empr_ldap'];
	
				// droits de l'utilisateur
				$allow_loan= $data['allow_loan'];
				$allow_book= $data['allow_book'];
				$allow_opac= $data['allow_opac'];
				$allow_dsi= $data['allow_dsi'];
				$allow_dsi_priv= $data['allow_dsi_priv'];
				$allow_sugg= $data['allow_sugg'];
				$allow_prol= $data['allow_prol'];
				$allow_avis= $data['allow_avis'];
				$allow_tag= $data['allow_tag'];
				$allow_pwd= $data['allow_pwd'];

				} else { // $aut_ok=0, pas encore authentifi
					//Sinon, on dtruit la session cre
					@session_destroy();
					if ($verif_isexp) echo "<script>alert(\"".$msg["empr_expire"]."\");</script>";
					if (!$allow_opac && $_SESSION["user_code"]) echo "<script>alert(\"".$msg["empr_no_allow_opac"]."\");</script>";
					// si pas de session
					$erreur_session = $empr_erreur_header;
					$erreur_session .= $msg["empr_type_card_number"]."<br/>";
					$erreur_session .= $empr_erreur_footer;
					$log_ok=0 ;
					$time_expired = 0 ;
					}
		} else { // la session a expir, on va le lui dire
			echo "<script>alert(\"".sprintf($msg["session_expired"],round($opac_duration_session_auth/60))."\");</script>";
		}
	} else {
		//Si session en cours, pas de problme...
		$log_ok=1;
		$login=$_SESSION["user_code"];
		// droits de l'utilisateur
		$query0 = "select allow_loan, allow_book, allow_opac, allow_dsi, allow_dsi_priv, allow_sugg, allow_prol, allow_avis, allow_tag, allow_pwd from empr, empr_statut where empr_login='".$_SESSION['user_code']."' and idstatut=empr_statut ";
		$req0 = mysql_query($query0,$dbh);
		$data = mysql_fetch_array($req0);
		$allow_loan= $data['allow_loan'];
		$allow_book= $data['allow_book'];
		$allow_opac= $data['allow_opac'];
		$allow_dsi= $data['allow_dsi'];
		$allow_dsi_priv= $data['allow_dsi_priv'];
		$allow_sugg= $data['allow_sugg'];
		$allow_prol= $data['allow_prol'];
		$allow_avis= $data['allow_avis'];
		$allow_tag= $data['allow_tag'];
		$allow_pwd= $data['allow_pwd'];
		}
	
}	

	
if ($opac_resa_popup) {
	print $popup_header;
} else {
	if ($opac_show_homeontop==1) $std_header= str_replace("!!home_on_top!!",$home_on_top,$std_header);
		else $std_header= str_replace("!!home_on_top!!","",$std_header);
	$std_header= str_replace("!!liens_rss!!",genere_link_rss(),$std_header);
	print $std_header ;
	include($base_path.'/includes/navigator.inc.php');
}
$popup_resa = 1 ;


if ($log_ok) {
	
	switch($lvl) {
		case 'make_sugg' :
			if ($allow_sugg || $opac_show_suggest==2) include($base_path.'/includes/make_sugg.inc.php');
				else print $msg[empr_no_allow_sugg];
			break;
		case 'valid_sugg' :
			if ($allow_sugg || $opac_show_suggest==2) include($base_path.'/includes/valid_sugg.inc.php');
				else print $msg[empr_no_allow_sugg];
			break;
		case 'resa_planning' : 
			if ($allow_book) include($base_path.'/includes/resa_planning.inc.php');
				else print $msg[empr_no_allow_book];
			break;
		default:
		case 'resa':
			if ($allow_book) include($base_path.'/includes/resa.inc.php');
				else print $msg[empr_no_allow_book];
			break;
	}

} else {

	if (!$time_expired) {
		$erreur_session = "" ;
		if ($login) print "<br/>".$msg["empr_bad_login"]."<br/><br/><br/>";
			else {
				print do_formulaire_connexion() ;
			}
	} else {
		print "<br/>".sprintf($msg["session_expired"],round($opac_duration_session_auth/60))."<br/><br/><br/>";
		print do_formulaire_connexion() ;
	}
}

if ($erreur_session) print $erreur_session ;

if ($opac_resa_popup) print $popup_footer;
	else {
		//insertions des liens du bas dans le $footer si $opac_show_liensbas
		if ($opac_show_liensbas==1) $footer = str_replace("!!div_liens_bas!!",$liens_bas,$footer);
			else $footer = str_replace("!!div_liens_bas!!","",$footer);

		//affichage du bandeau de gauche si $opac_show_bandeaugauche = 1
		if ($opac_show_bandeaugauche==0)
			$footer= str_replace("!!contenu_bandeau!!","",$footer);
			else {
				$home_on_left=str_replace("!!welcome_page!!",$msg["welcome_page"],$home_on_left);
				$adresse=str_replace("!!common_tpl_address!!",$msg["common_tpl_address"],$adresse);
				$adresse=str_replace("!!common_tpl_contact!!",$msg["common_tpl_contact"],$adresse);
				$loginform=str_replace("!!common_tpl_login_invite!!",$msg["common_tpl_login_invite"],$loginform);
		
				// loading the languages avaiable in OPAC - martizva >> Eric
				require_once($base_path.'/includes/languages.inc.php');
				$home_on_left = str_replace("!!common_tpl_lang_select!!", show_select_languages("empr.php"), $home_on_left);
		
				if (!$_SESSION["user_code"]) {
					$loginform__ ="<form action=\"empr.php\" method=\"post\" name=\"myform\"><label>$msg[common_tpl_cardnumber_default]</label><br/>";
					$loginform__.="<input type=\"text\" name=\"login\" size=\"14\" border=\"0\" value=\"".$msg[common_tpl_cardnumber]."\" onFocus=\"this.value='';\"><br/>
						<input type=\"password\" name=\"password\" size=\"8\" border=\"0\" value=\"\" >&nbsp;&nbsp;<input type='submit' name='ok' value='".$msg[11]."' class='bouton'></form>"."<a href=./askmdp.php>".$msg[mdp_forgotten]."</a>";
				} else {
					$loginform__.="<b>".$empr_prenom." ".$empr_nom."</b><br/>\n";
					$loginform__.="<a href=\"empr.php\">".$msg["empr_my_account"]."</a><br/>
							<a href=\"index.php?logout=1\">".$msg["empr_logout"]."</a>";
				}
				$loginform = str_replace("!!login_form!!",$loginform__,$loginform);
				$footer= str_replace("!!contenu_bandeau!!",$home_on_left.$loginform.$meteo.$adresse,$footer);
			}
			
		print $footer ;
	}


/* Fermeture de la connexion */
mysql_close();
