<?php
// +-------------------------------------------------+
//  2002-2004 PMB Services / www.sigb.net pmb@sigb.net et contributeurs (voir www.sigb.net)
// +-------------------------------------------------+
// $Id: categ_see.inc.php,v 1.43 2007/11/06 17:06:05 gueluneau Exp $

if (stristr($_SERVER['REQUEST_URI'], ".inc.php")) die("no access");

// affichage recherche
require_once($base_path.'/includes/simple_search.inc.php');
require_once($base_path.'/includes/rec_history.inc.php');
global $base_path;

//recuperation du thesaurus session 
if (!$id_thes) {
	$id_thes = thesaurus::getSessionThesaurusId();
} else {
	thesaurus::setSessionThesaurusId($id_thes);
}
$thes = new thesaurus($id_thes);
$id_top = $thes->num_noeud_racine;

print "<div id='aut_details'>\n
		<h3><span>$msg[categ_see_tpl_categ]</span></h3>\n";

print "<div id='aut_details_container'>\n";

if ($id) {
	// affichage du path de la catgorie
	print "	<div id='aut_see'>\n
			<a href=\"./index.php?lvl=categ_see&id=$id_top\"><img src='./images/home.gif' border='0'></a>\n"; 


	// instanciation de la catgorie
	$ourCateg = new categorie($id);

	print pmb_bidi($ourCateg->categ_path($opac_categories_categ_path_sep,$css));

	// si la catgorie  des enfants, on les affiche
	if($ourCateg->has_child) print pmb_bidi($ourCateg->child_list('./images/folder.gif',$css));
	
	$q = "select ";
	$q.= "distinct catdef.num_noeud,catdef.note_application, ";
	$q.= "if (catlg.num_noeud is null, catdef.libelle_categorie, catlg.libelle_categorie) as libelle_categorie ";
	$q.= "from voir_aussi left join noeuds on noeuds.id_noeud=voir_aussi.num_noeud_dest ";
	$q.= "left join categories as catdef on noeuds.id_noeud=catdef.num_noeud and catdef.langue = '".$thes->langue_defaut."' "; 
	$q.= "left join categories as catlg on catdef.num_noeud = catlg.num_noeud and catlg.langue = '".$lang."' "; 
	$q.= "where ";
	$q.= "voir_aussi.num_noeud_orig = '".$id."' ";
	$q.= "order by libelle_categorie limit ".$opac_categories_max_display;

	$found_see_too = mysql_query($q, $dbh);
	
	if (mysql_num_rows($found_see_too)) {
		print "<br>".$msg['term_show_see_also']." " ;
		$deb = 0 ;
		while ($mesCategories_see_too = mysql_fetch_object($found_see_too)) {
			if ($deb) print " / " ;
			$note = $mesCategories_see_too->note_application;
			$c_categ =  new category($mesCategories_see_too->num_noeud);
			
			// Affichage du commentaire par le layer sur les "Voir aussi"
			 $result_com = categorie::zoom_categ($mesCategories_see_too->num_noeud, $note);			
		
			print "<a href=./index.php?lvl=categ_see&id=".$mesCategories_see_too->num_noeud.">";
		
			if($c_categ->has_notices())
				print " <img src='$base_path/images/folder_search.gif' border=0 align='absmiddle'>";	
			else
				print  " <img src='./images/folder.gif' border='0' align='middle'>";	
			
			print pmb_bidi("</a><a href=./index.php?lvl=categ_see&id=".$mesCategories_see_too->num_noeud."".$result_com['java_com'].">".$mesCategories_see_too->libelle_categorie.'</a>'.$result_com['zoom']);
			$deb = 1 ;
		}
	}
	
	print "</div><!-- //fermeture aut_see -->\n";
	print "<div id='aut_details_liste'>\n";
	
	// comptage des notices associes
	if(!$nbr_lignes) {
		$requete = "SELECT count(1) FROM notices_categories, notices, notice_statut ";
		$requete.= "where (notices_categories.num_noeud = '".$id."' and notices_categories.notcateg_notice = notices.notice_id) ";
		$requete.= "and (notices.statut = notice_statut.id_notice_statut and ((notice_statut.notice_visible_opac = 1 and notice_statut.notice_visible_opac_abon=0)".($_SESSION["user_code"]?" or (notice_statut.notice_visible_opac_abon=1 and notice_statut.notice_visible_opac = 1)":"").")) ";
		$res = mysql_query($requete, $dbh);
		$nbr_lignes = mysql_result($res, 0, 0);
		
		//Recherche des types doc
		$requete="select distinct notices.typdoc FROM notices_categories, notices, notice_statut ";
		$requete.= "where (notices_categories.num_noeud = '".$id."' and notices_categories.notcateg_notice = notices.notice_id) ";
		$requete.= "and (notices.statut = notice_statut.id_notice_statut and ((notice_statut.notice_visible_opac = 1 and notice_statut.notice_visible_opac_abon=0)".($_SESSION["user_code"]?" or (notice_statut.notice_visible_opac_abon=1 and notice_statut.notice_visible_opac = 1)":"").")) ";
		$res = mysql_query($requete, $dbh);
		$t_typdoc=array();
		while ($tpd=mysql_fetch_object($res)) {
			$t_typdoc[]=$tpd->typdoc;
		}
		$l_typdoc=implode(",",$t_typdoc);
	}

	if(!$page) $page=1;
	$debut =($page-1)*$opac_nb_aut_rec_per_page;
	print pmb_bidi(str_replace("!!categ_libelle!!",$ourCateg->libelle,$categ_notices));
	if($nbr_lignes) {
		if ($opac_notices_depliable) print $begin_result_liste;
				
		//gestion du tri
		if (isset($_GET["sort"])) {	
			$_SESSION["last_sort"]=$_GET["sort"];
		}
		if ($nbr_lignes>$opac_nb_max_tri) {
			$_SESSION["last_sort"]="";
			print "&nbsp;";
		} else {
			$pos=strpos($_SERVER['REQUEST_URI'],"?");
			$pos1=strpos($_SERVER['REQUEST_URI'],"get");
			if ($pos1==0) $pos1=strlen($_SERVER['REQUEST_URI']);
			else $pos1=$pos1-3;
			$para=urlencode(substr($_SERVER['REQUEST_URI'],$pos+1,$pos1-$pos+1));
			$affich_tris_result_liste=str_replace("!!page_en_cours!!",$para,$affich_tris_result_liste); 
			print $affich_tris_result_liste;
			if ($_SESSION["last_sort"]!="") {
				print " ".$msg['tri_par']." ".$_SESSION["sort_text".$_SESSION["last_sort"]]."&nbsp;"; 
			}
		} 
		//fin gestion du tri
		
		print $add_cart_link;
		
		if ($opac_show_suggest) {
			$bt_sugg = "&nbsp;&nbsp;&nbsp;<a href=# ";		
			if ($opac_resa_popup) $bt_sugg .= " onClick=\"w=window.open('./do_resa.php?lvl=make_sugg&oresa=popup','doresa','scrollbars=yes,width=500,height=600,menubar=0,resizable=yes'); w.focus(); return false;\"";
				else $bt_sugg .= "onClick=\"document.location='./do_resa.php?lvl=make_sugg&oresa=popup' \" ";			
			$bt_sugg.= " >".$msg[empr_bt_make_sugg]."</a>";
				print $bt_sugg;
		
		}		
		
		//affinage
		if ($main) {
			//enregistrement de l'endroit actuel dans la session
			$_SESSION["last_module_search"]["search_mod"]="categ_see";
			$_SESSION["last_module_search"]["search_id"]=$id;
			$_SESSION["last_module_search"]["search_page"]=$page;
			
			//affichage
			print "&nbsp;&nbsp;<a href='$base_path/index.php?search_type_asked=extended_search&mode_aff=aff_module'>".$msg["affiner_recherche"]."</a>";	
			//Etendre
			if ($opac_allow_external_search) print "&nbsp;&nbsp;<a href='$base_path/index.php?search_type_asked=external_search&mode_aff=aff_module&external_type=simple'>".$msg["connecteurs_external_search_sources"]."</a>";
			//fin etendre
		
		} else {
			//enregistrement de l'endroit actuel dans la session
			if ($_SESSION["last_query"]) {	$n=$_SESSION["last_query"]; } else { $n=$_SESSION["nb_queries"]; }
			
			$_SESSION["notice_view".$n]["search_mod"]="categ_see";
			$_SESSION["notice_view".$n]["search_id"]=$id;
			$_SESSION["notice_view".$n]["search_page"]=$page;	

			//affichage
			print "&nbsp;&nbsp;<a href='$base_path/index.php?search_type_asked=extended_search&mode_aff=aff_simple_search'>".$msg["affiner_recherche"]."</a>";
			//Etendre
			if ($opac_allow_external_search) print "&nbsp;&nbsp;<a href='$base_path/index.php?search_type_asked=external_search&mode_aff=aff_simple_search'>".$msg["connecteurs_external_search_sources"]."</a>";
			//fin etendre
		}
		//fin affinage
		
		print "<blockquote>\n";
		// on lance la vraie requte
		$requete = "SELECT distinct notices.notice_id FROM notices, notices_categories, notice_statut ";
		$requete.= "WHERE (notices_categories.num_noeud = '".$id."' and notices_categories.notcateg_notice = notices.notice_id) "; 
		$requete.= "and (notices.statut = notice_statut.id_notice_statut and ((notice_statut.notice_visible_opac = 1 and notice_statut.notice_visible_opac_abon=0)".($_SESSION["user_code"]?" or (notice_statut.notice_visible_opac_abon=1 and notice_statut.notice_visible_opac = 1)":"").")) ";
		$requete .= " ORDER BY $opac_categories_categ_sort_records";
		//gestion du tri
		if ($_SESSION["last_sort"]!="") {
			$requete .=" LIMIT 0,$nbr_lignes ";
			$creer_table_tempo="CREATE TEMPORARY TABLE tri_tempo ENGINE=MyISAM (".$requete.")";
			@mysql_query ($creer_table_tempo);
			$modif_primaire="ALTER TABLE tri_tempo PRIMARY KEY notice_id";
			@mysql_query ($modif_primaire);	
			$sort=new sort('notices');
			$sort->table_tri_tempo="tri_tempo";
			$sort->table_primary_tri_tempo="notice_id";
			$sort->limit=" LIMIT $debut,$opac_nb_aut_rec_per_page ";
			$requete=$sort->appliquer_tri();		
		} else {
			$requete .= " LIMIT $debut,$opac_nb_aut_rec_per_page ";
		}
		//fin gestion du tri

		$res = @mysql_query($requete, $dbh);
		print aff_notice(-1);
		while ($obj=mysql_fetch_object($res)) {
			print pmb_bidi(aff_notice($obj->notice_id));
			}
		print aff_notice(-2);
		mysql_free_result($res);

		// constitution des liens
		$nbepages = ceil($nbr_lignes/$opac_nb_aut_rec_per_page);
		print "</blockquote>\n";
		print "</div><!-- fermeture aut_details_liste -->\n";
		print "<hr>\n<center>".printnavbar($page, $nbepages, "./index.php?lvl=categ_see&id=$id&page=!!page!!&nbr_lignes=$nbr_lignes&main=$main&l_typdoc=".rawurlencode($l_typdoc))."</center>";	

		} else {
			print $msg['categ_empty'];
			print "</div><!-- fermeture aut_details_liste -->\n";
			}
	} else {
		$ourCateg = new categorie(0);
		print pmb_bidi($ourCateg->child_list('./images/folder.gif',$css));
		}

print "</div><!-- fermeture aut_details_container -->\n";
print "</div><!-- fermeture aut_details -->\n";
