<?php
// +-------------------------------------------------+
//  2002-2004 PMB Services / www.sigb.net pmb@sigb.net et contributeurs (voir www.sigb.net)
// +-------------------------------------------------+
// $Id: mail.inc.php,v 1.7 2007/09/11 21:10:13 touraine37 Exp $

if (stristr($_SERVER['REQUEST_URI'], ".inc.php")) die("no access");

if (!defined('PHP_EOL')) define ('PHP_EOL', strtoupper(substr(PHP_OS,0,3) == 'WIN') ? "\r\n" : "\n");

function mailpmb($to_nom="", $to_mail, $obj="", $corps="", $from_name="", $from_mail, $headers, $copie_CC="", $copie_BCC="", $faire_nl2br=0) {

	global $class_path ;
	global $opac_mail_methode ;
	global $charset;
	
	$param = explode(",",$opac_mail_methode) ;
	if ($copie_CC) $destinataires_CC = explode(";",$copie_CC) ;
		else $destinataires_CC = array();
	if ($copie_BCC) $destinataires_BCC = explode(";",$copie_BCC) ;
		else $destinataires_BCC = array();
	$destinataires = explode(";",$to_mail) ;
	if (!$param) $param=array() ;
	// $param[0] = mailfunc
	switch ($param[0]) {
		case 'smtp':
			require_once($class_path."/class.phpmailer.php") ;
			// $pmb_mail_methode = mthode, hote:port, auth, name, pass
			$mail = new PHPmailer();
			$mail->CharSet = $charset;
			$mail->IsSMTP();
			$mail->IsHTML(true);
			$mail->Host=$param[1];
			if ($param[2]) {
				$mail->SMTPAuth=true ;
				$mail->Username=$param[3] ;
				$mail->Password=$param[4] ;
				}
			$mail->From=$from_mail;
			$mail->FromName=$from_name;
			for ($i=0; $i<count($destinataires); $i++) {
				$mail->AddAddress($destinataires[$i], $to_nom);
				}
			for ($i=0; $i<count($destinataires_CC); $i++) {
				$mail->AddCC($destinataires_CC[$i]);
				}
			for ($i=0; $i<count($destinataires_BCC); $i++) {
				$mail->AddBCC($destinataires_BCC[$i]);
				}
			$mail->AddReplyTo($from_mail, $from_name);	
			$mail->Subject=$obj;
			if ($faire_nl2br) $mail->Body=wordwrap(nl2br($corps),70);
				else $mail->Body=wordwrap($corps,70);
		
			if(!$mail->Send()) {
				$retour=false;
				global $error_send_mail ;
				$error_send_mail[] = $mail->ErrorInfo ;
				} else $retour=true ;
			$mail->SmtpClose();
			unset($mail);
			break ;
		default:
		case 'php':
			for ($i=0; $i<count($destinataires); $i++) {
				// $dest_php[] = "".$to_nom." <".$destinataires[$i].">";
				$dest_php[] = $destinataires[$i];
				}
			$dest_php_final=implode(", ", $dest_php) ;

			$headers_copie = "";
			for ($i=0; $i<count($destinataires_CC); $i++) {
				$headers_copie .= "Cc: ".$destinataires_CC[$i].PHP_EOL;
				}
			for ($i=0; $i<count($destinataires_BCC); $i++) {
				$headers_copie .= "Bcc: ".$destinataires_BCC[$i].PHP_EOL;
				}
			$corps = wordwrap($corps, 70);
			if ($headers) $res_envoi=mail($dest_php_final,$obj,$corps,$headers_copie."From: \"".$from_name."\" <".$from_mail.">".PHP_EOL.$headers);
				else $res_envoi=mail($dest_php_final,$obj,$corps,$headers_copie."From: \"".$from_name."\" <".$from_mail.">");
			$retour=$res_envoi ;
			break ;
		}
	return $retour ;
	}
