<?php
// +-------------------------------------------------+
//  2002-2004 PMB Services / www.sigb.net pmb@sigb.net et contributeurs (voir www.sigb.net)
// +-------------------------------------------------+
// $Id: valid_sugg.inc.php,v 1.8 2007/05/03 21:57:42 dbellamy Exp $

if (stristr($_SERVER['REQUEST_URI'], ".inc.php")) die("no access");

// classes de gestion des suggestions
require_once($base_path.'/classes/suggestions.class.php');
require_once($base_path.'/classes/suggestions_origine.class.php');
require_once($base_path.'/classes/suggestions_map.class.php');
require_once($base_path.'/classes/suggestions_categ.class.php');


$sug_map = new suggestions_map();


$sug_form = "<h3>".htmlentities($msg["empr_make_sugg"], ENT_QUOTES, $charset)."</h3>\n";

// Contrle des donnes saisies 

if ( ($tit != "") && ($aut != "" || $edi != "") ) {		//Les donnes minimun ont t saisies	

	$userid = $_SESSION["id_empr_session"];
	if (!$userid) {
		$type = '2';	//Visiteur non authentifi
		$userid= $mail;	
	} else {
		$type = '1';	//Abonn
	}

	//Mise en forme des donnes pour r-affichage
	$tit = stripslashes($tit);
	$edi = stripslashes($edi);
	$aut = stripslashes($aut);
	$code = stripslashes($code);
	$url_sug = stripslashes($url_sug);
	$comment = stripslashes($comment);
	
	//On vite de saisir 2 fois la mme suggestion
	if (!suggestions::exists($userid, $tit)) {

		$su = new suggestions();
		$su->titre = $tit;
		$su->editeur = $edi;
		$su->auteur = $aut;
		$su->code = $code;
		$prix = str_replace(',','.',$prix);
		if (is_numeric($prix)) $su->prix = $prix;
		$su->nb = 0;
		$su->statut = $sug_map->getFirstStateId();
		$su->url_suggestion = $url_sug;
		$su->commentaires = $comment;
		$su->date_creation = today();
		
		if ($opac_sugg_categ == '1' ) {
			
			if (!suggestions_categ::exists($num_categ) ){
				$num_categ = $opac_sugg_categ_default;
			}
			 if (!suggestions_categ::exists($num_categ) ) {
				$num_categ = '1';
			}
			$su->num_categ = $num_categ;	
		}
		
		$su->save();
		
		
		$orig = new suggestions_origine($userid, $su->id_suggestion);
		$orig->type_origine = $type;
		$orig->save();

	}

	//R-affichage de la suggestion
	$sug_form.= "
		<table width='60%' cellpadding='5'>
			<tr>	
				<td align=right>".htmlentities($msg["empr_sugg_tit"], ENT_QUOTES, $charset)."</td>
				<td>".htmlentities($tit, ENT_QUOTES, $charset)."</td>
			</tr>
			<tr>
				<td align=right>".htmlentities($msg["empr_sugg_aut"], ENT_QUOTES, $charset)."</td>
				<td>".htmlentities($aut, ENT_QUOTES, $charset)."</td>
			</tr>
			<tr>
				<td align=right>".htmlentities($msg["empr_sugg_edi"], ENT_QUOTES, $charset)."</td>
				<td>".htmlentities($edi, ENT_QUOTES, $charset)."</td>
			</tr>
			<tr>
				<td align=right>".htmlentities($msg["empr_sugg_code"], ENT_QUOTES, $charset)."</td>
				<td>".htmlentities($code, ENT_QUOTES, $charset)."</td>
			</tr>
			<tr>
				<td align=right>".htmlentities($msg["empr_sugg_prix"], ENT_QUOTES, $charset)."</td>
				<td>".htmlentities($prix, ENT_QUOTES, $charset)."</td>
			</tr>
			<tr>
				<td align=right>".htmlentities($msg['empr_sugg_url'], ENT_QUOTES, $charset)."</td>
				<td>".htmlentities($url_sug, ENT_QUOTES, $charset)."</td>
			</tr>
			<tr>
				<td align=right>".htmlentities($msg['empr_sugg_comment'], ENT_QUOTES, $charset)."</td>
				<td>".htmlentities($comment, ENT_QUOTES, $charset)."</td>
			</tr>";
			
	if(!$_SESSION["id_empr_session"]) {
		
		$sug_form.= "	
			<tr>
				<td align=right>".htmlentities($msg["empr_sugg_mail"], ENT_QUOTES, $charset)."</td>
				<td>".htmlentities($mail, ENT_QUOTES, $charset)."</td>
			</tr>";
	}
	if ($opac_sugg_categ=='1') {
		$categ = new suggestions_categ($su->num_categ); 
		$sug_form.= "	
			<tr>
				<td align=right>".htmlentities($msg['acquisition_categ'], ENT_QUOTES, $charset)."</td>
				<td>".htmlentities($categ->libelle_categ, ENT_QUOTES, $charset)."</td>
			</tr>";
	}
	
	$sug_form.= "</table><br />";
	$sug_form.= "<b>".htmlentities($msg["empr_sugg_ok"], ENT_QUOTES, $charset)."</b><br /><br />";
	
	
} else {	// Les donnes minimun n'ont pas t saisies

	$sug_form.= htmlentities($msg["empr_sugg_ko"], ENT_QUOTES, $charset)."<br /><br />";	

}

print $sug_form;
 
?>
