<?php
// +-------------------------------------------------+
//  2002-2004 PMB Services / www.sigb.net pmb@sigb.net et contributeurs (voir www.sigb.net)
// +-------------------------------------------------+
// $Id: opac_included.inc.php,v 1.30 2007/10/27 08:13:19 touraine37 Exp $

$base_path=".";
require_once($base_path."/includes/init.inc.php");

require_once($base_path.'/includes/error_report.inc.php') ;

require_once($base_path.'/includes/global_vars.inc.php');
require_once($base_path.'/includes/opac_config.inc.php');
	
// rcupration paramtres MySQL et connection  la base
require_once($base_path.'/includes/opac_db_param.inc.php');
require_once($base_path.'/includes/opac_mysql_connect.inc.php');
$dbh = connection_mysql();

require_once($base_path.'/includes/misc.inc.php');

//Sessions !! Attention, ce doit tre imprativement le premier include ( cause des cookies)
require_once($base_path.'/includes/session.inc.php');

require_once($base_path.'/includes/start.inc.php');
require_once($base_path.'/includes/opac_config.inc.php');
require_once($base_path.'/includes/check_session_time.inc.php');

// rcupration localisation
require_once($base_path.'/includes/localisation.inc.php');

// version actuelle de l'opac
require_once($base_path.'/includes/opac_version.inc.php');

// fonctions de gestion de formulaire
require_once($base_path.'/includes/javascript/form.inc.php');

require_once($base_path.'/includes/templates/common.tpl.php');
require_once($base_path.'/includes/divers.inc.php');

// classe de gestion des catgories
require_once($base_path.'/classes/categorie.class.php');
require_once($base_path.'/classes/notice.class.php');
require_once($base_path.'/classes/notice_display.class.php');

// classe indexation interne
require_once($base_path.'/classes/indexint.class.php');

// classe d'affichage des tags
require_once($base_path.'/classes/tags.class.php');

require_once($base_path.'/includes/marc_tables/'.$lang.'/empty_words');

// pour l'affichage correct des notices
require_once($base_path."/includes/templates/common.tpl.php");
require_once($base_path."/includes/templates/notice.tpl.php");
require_once($base_path."/includes/navbar.inc.php");
require_once($base_path."/includes/notice_authors.inc.php");
require_once($base_path."/includes/notice_categories.inc.php");

require_once($base_path."/includes/notice_affichage.inc.php");

require_once($base_path.'/classes/analyse_query.class.php');


//Premier accs ??
if ($search_type_asked) $_SESSION["search_type"]=$search_type_asked;

if (($_SESSION["search_type"]=="")||((($lvl=="")||($lvl=="index"))&&($search_type_asked==""))) {
	$_SESSION["search_type"]="simple_search";
}

if (!$_SESSION["nb_sort"]) $_SESSION["nb_sort"]=0; 

//Rcupration du type de recherche
$search_type=$_SESSION["search_type"];

//Si vidage historique demand ?
if ($raz_history) {
	if ((isset($_POST['cases_suppr'])) && !empty($_POST['cases_suppr'])) {
		$cases_a_suppr=$_POST['cases_suppr'];
		$t = array();
		
		//remplissage du tableau temporaire  de l'historique des recherches $t, si une recherche est slectionne, la valeur l'lment du tableau temporaire sera  -1 
		
		for ($i=1;$i<=$_SESSION["nb_queries"];$i++) {
			$bool=false;
			for ($j=0;$j<count($cases_a_suppr);$j++) {
				if ($i==$cases_a_suppr[$j]) {
					$bool=true;
					$j=count($cases_a_suppr);
				} else {
					$t[$i]=$i;
				}
			}
			if ($bool==true) {
				$t[$i]=-1;
			}
		}
		//parcours du tableau temporaire, et rcriture des variables de session
		$x=0;
		for ($i=count($t);$i>=1;$i--) {
			if ($t[$i]=="-1") {
				for ($y=$i;$y<=$_SESSION["nb_queries"];$y++) {
					$_SESSION["human_query".(string)$i]=$_SESSION["human_query".(string)$x];	
					$_SESSION["search_type".(string)$i]=$_SESSION["search_type".(string)$x];
					$_SESSION["user_query".(string)$i]=$_SESSION["user_query".(string)$x];
					$_SESSION["typdoc".(string)$i]=$_SESSION["typdoc".(string)$x];
					$_SESSION["look_TITLE".(string)$i]=$_SESSION["look_TITLE".(string)$x];
	       			$_SESSION["look_AUTHOR".(string)$i]=$_SESSION["look_AUTHOR".(string)$x];
	      			$_SESSION["look_PUBLISHER".(string)$i]=$_SESSION["look_PUBLISHER".(string)$x];
	       			$_SESSION["look_COLLECTION".(string)$i]=$_SESSION["look_COLLECTION".(string)$x];
	       			$_SESSION["look_SUBCOLLECTION".(string)$i]=$_SESSION["look_SUBCOLLECTION".(string)$x];
	        		$_SESSION["look_CATEGORY".(string)$i]=$_SESSION["look_CATEGORY".(string)$x];
	       			$_SESSION["look_INDEXINT".(string)$i]=$_SESSION["look_INDEXINT".(string)$x];
	       			$_SESSION["look_KEYWORDS".(string)$i]=$_SESSION["look_KEYWORDS".(string)$x];
	       			$_SESSION["look_ABSTRACT".(string)$i]=$_SESSION["look_ABSTRACT".(string)$x];
	       			$_SESSION["look_CONTENT".(string)$i]=$_SESSION["look_CONTENT".(string)$x];
	       			$_SESSION["look_ALL".(string)$i]=$_SESSION["look_ALL".(string)$x];
	       			$_SESSION["search_type".(string)$i]=$_SESSION["search_type".(string)$x];
	       			$_SESSION["l_typdoc".(string)$i]=$_SESSION["l_typdoc".(string)$x];
				}
				$_SESSION["nb_queries"]--;
				$x++;
			}
		}
		
		//si il ne subsiste plus d'historique de recherches, mise  null des variables de session
		if ($_SESSION["nb_queries"]==0) {
			$_SESSION["last_query"]="";
		} 
	}
}

//Si vidage historique des tris demand ?
if ($raz_sort) {
	if ((isset($_POST['cases_suppr'])) && !empty($_POST['cases_suppr'])) {
		$cases_a_suppr=$_POST['cases_suppr'];
		$t = array();
		
		//remplissage du tableau temporaire  de l'historique des tris $t, si un tri est slectionn, la valeur l'lment du tableau temporaire sera  -1 
		
		for ($i=0;$i<$_SESSION["nb_sort"];$i++) {
			$bool=false;
			for ($j=0;$j<count($cases_a_suppr);$j++) {
				if ($i==$cases_a_suppr[$j]) {
					$bool=true;
					$j=count($cases_a_suppr);
				} else {
					$t[$i]=$i;
				}
			}
			if ($bool==true) {
				$t[$i]=-1;
			}
		}
		//parcours du tableau temporaire, et rcriture des variables de session
		$x=0;
		for ($i=count($t);$i>=0;$i--) {
			if ($t[$i]=="-1") {
				for ($y=$i;$y<=$_SESSION["nb_sort"];$y++) {
					$_SESSION["sort".(string)$i]=$_SESSION["sort".(string)$x];	
					$_SESSION["sort_text".(string)$i]=$_SESSION["sort_text".(string)$x];
				}
				$_SESSION["nb_sort"]--;
				$x++;
			}
		}
		
		//si il ne subsiste plus d'historique de tris, mise  null des variables de session
		if ($_SESSION["nb_sort"]==0) {
			$_SESSION["last_sort"]="";
		} 
	} 
}

//Stripslashes de la requte simple si ncessaire
//if ($user_query) $user_query=stripslashes($user_query);

//Enregistrement dans historique si visualisation en mode term_search
if (($search_type=="term_search")&&($lvl=="categ_see")&&($rec_history==1)) {
	require_once("./includes/rec_history.inc.php");
	rec_history();
}
// pour les tagres et les nouveaux affichages
require_once($base_path."/includes/isbn.inc.php");
require_once($base_path."/classes/notice_affichage.class.php");
require_once($base_path."/includes/etagere_func.inc.php");
require_once($base_path."/includes/templates/etagere.tpl.php");

// RSS
require_once($base_path."/includes/includes_rss.inc.php");

// pour OPAC_INCLUS :
$std_header = $inclus_header ;
$footer = $inclus_footer ;


// si $opac_show_homeontop est  1 alors on affiche le lien retour  l'accueil sous le nom de la bibliothque
if ($opac_show_homeontop==1) $std_header= str_replace("!!home_on_top!!",$home_on_top,$std_header);
	else $std_header= str_replace("!!home_on_top!!","",$std_header);

// RSS
$std_header= str_replace("!!liens_rss!!",genere_link_rss(),$std_header);

print $std_header;

if ($time_expired) echo "<script>alert(\"".sprintf($msg["session_expired"],round($opac_duration_session_auth/60))."\");</script>";

if ($lvl=="etagere_see") $navig.="<td><a href=\"index.php?lvl=etageres_see\">".$msg["etageres_see"]."</a></td>\n";
if (($_SESSION["nb_queries"])&&($lvl!="search_result")) $navig.="<td ><a href=\"index.php?lvl=search_result&get_query=".$_SESSION["nb_queries"]."\">".$msg["actions_last_search"]."</a></td>\n";
if (($lvl!="more_results")&&($_SESSION["last_query"]!="")) {
	if ($_SESSION["last_query"]==$_SESSION["nb_queries"]) 
		$search_name=" ".$msg["actions_last_page_last_search"]; 
	else {
		if ($_SESSION["lq_mode"]=="extended")
			$search_name=" ".$msg["actions_last_page_extended_search"]." ";
		else
			$search_name=" ".$msg["actions_last_page_simple_search"]." ";
		$search_name.="n".$_SESSION["last_query"];
	}
	$navig.="<td ><a href=\"index.php?lvl=more_results&get_last_query=1\">".sprintf($msg["actions_last_page"],$_SESSION["lq_page"],$_SESSION["list_name"],$search_name);
	
	$navig.="</a></td>\n";
}
if (($_SESSION["nb_queries"])&&($lvl!="search_history")) $navig.="<td ><a href=\"index.php?lvl=search_history\">".$msg["actions_history"]."</a></td>\n";
if (($lvl!="index")&&($lvl!="")) {
	$item="";
	if ($opac_show_categ_browser) $item=$msg["navig_categ"];
	if (($opac_show_dernieresnotices)&&(!$item)) $item=$msg["navig_lastnotices"];
	if (($opac_show_etageresaccueil)&&(!$item)) $item=$msg["navig_etageres"];
	if (($opac_show_marguerite_browser)&&(!$item)) $item=$msg["navig_marguerite"];
	if (($opac_show_100cases_browser)&&(!$item)) $item=$msg["navig_100cases"];
	$navig.="<td ><a href=\"./index.php?lvl=index\">".sprintf($msg["actions_first_screen"],$item)."</a></td>\n";
}
if ($navig) {
	print "<div id='navigator'>";
	print "<strong>".$msg["actions_you_can"]."</strong>\n";
	print "<table width='100%'>";
	print "<tr>";
	print $navig;
	print("</tr>");
	print("</table>");
	print "</div>";
}

switch($lvl) {
	case 'author_see':	
		require_once($base_path.'/includes/author_see.inc.php');
		break;
	case 'categ_see':
		require_once($base_path.'/includes/categ_see.inc.php');
		break;		
	case 'indexint_see':	
		require_once($base_path.'/includes/indexint_see.inc.php');
		break;		
	case 'coll_see':	
		require_once($base_path.'/includes/coll_see.inc.php');
		break;		
	case 'more_results':	
		require_once($base_path.'/includes/more_results.inc.php');
		break;		
	case 'notice_display':	
		require_once($base_path.'/includes/notice_display.inc.php');
		break;
	case 'bulletin_display':
		require_once($base_path.'/includes/bulletin_display.inc.php');
		break;			
	case 'publisher_see':	
		require_once($base_path.'/includes/publisher_see.inc.php');
		break;		
	case 'serie_see':	
		require_once($base_path.'/includes/serie_see.inc.php');
		break;		
	case 'search_result':	
		require_once($base_path.'/includes/search_result.inc.php');
		break;		
	case 'subcoll_see':	
		require_once($base_path.'/includes/subcoll_see.inc.php');
		break;
	case 'search_history':
		require_once($base_path.'/includes/search_history.inc.php');
		break;	
	case 'etagere_see':
		require_once($base_path.'/includes/etagere_see.inc.php');
		break;	
	case 'etageres_see':
		require_once($base_path.'/includes/etageres_see.inc.php');
		break;
	case 'show_cart':
		require_once($base_path.'/includes/show_cart.inc.php');
		break;
	case 'section_see':
		require_once($base_path.'/includes/show_localisation.inc.php');
		break;
	case 'index':
	default:
		$lvl='index';
		require_once($base_path.'/includes/index.inc.php');
		break;
	}
	
//insertions des liens du bas dans le $footer si $opac_show_liensbas
if ($opac_show_liensbas==1) $footer = str_replace("!!div_liens_bas!!",$liens_bas,$footer);
	else $footer = str_replace("!!div_liens_bas!!","",$footer);

//si ce n'est pas un popup qui est affich, alors on affiche $footer
if ($opac_show_bandeaugauche==0) {
	print str_replace("!!contenu_bandeau!!","",$footer);
	} else {
		$home_on_left=str_replace("!!welcome_page!!",$msg["welcome_page"],$home_on_left);
		$adresse=str_replace("!!common_tpl_address!!",$msg["common_tpl_address"],$adresse);
		$adresse=str_replace("!!common_tpl_contact!!",$msg["common_tpl_contact"],$adresse);
		$loginform=str_replace("!!common_tpl_login_invite!!",$msg["common_tpl_login_invite"],$loginform);
		
		// loading the languages avaiable in OPAC - martizva >> Eric
		require_once($base_path.'/includes/languages.inc.php');
		$home_on_left = str_replace("!!common_tpl_lang_select!!", show_select_languages("index.php"), $home_on_left);
		
		if (!$_SESSION["user_code"]) {
			$loginform__ ="<form action=\"empr.php\" method=\"post\" name=\"myform\"><label>$msg[common_tpl_cardnumber_default]</label><br/>";
			$loginform__.="<input type=\"text\" name=\"login\" size=\"14\" border=\"0\" value=\"".$msg[common_tpl_cardnumber]."\" onFocus=\"this.value='';\"><br/>
			<input type=\"password\" name=\"password\" size=\"8\" border=\"0\" value=\"\" />&nbsp;&nbsp;<input type='submit' name='ok' value='".$msg[11]."' class='bouton'>"."<a href=./askmdp.php>".$msg[mdp_forgotten]."</a>";
			} else {
				$loginform__.="<b>".$empr_prenom." ".$empr_nom."</b><br/>\n";
				$loginform__.="<a href=\"empr.php\">".$msg["empr_my_account"]."</a><br/>
					<a href=\"index.php?logout=1\">".$msg["empr_logout"]."</a>";
				}
		$loginform = str_replace("!!login_form!!",$loginform__,$loginform);
		print str_replace("!!contenu_bandeau!!",$home_on_left.$loginform.$meteo.$adresse,$footer);
		} 

mysql_close($dbh);

?>