<?php
// +--------------------------------------------------------------------------+
// | PMB est sous licence GPL, la rutilisation du code est cadre            |
// +--------------------------------------------------------------------------+
// $Id: print.php,v 1.28 2007/11/07 17:05:37 gueluneau Exp $

$base_path=".";
require_once($base_path."/includes/init.inc.php");

include ("./includes/error_report.inc.php") ;

include ("./includes/global_vars.inc.php");
require_once('./includes/opac_config.inc.php');
	
// rcupration paramtres MySQL et connection  la base
require_once('./includes/opac_db_param.inc.php');
require_once('./includes/opac_mysql_connect.inc.php');
$dbh = connection_mysql();
// (si la connection est impossible, le script die ici).

include ("./includes/misc.inc.php");

//Sessions !! Attention, ce doit tre imprativement le premier include ( cause des cookies)
include("./includes/session.inc.php");
require_once('./includes/start.inc.php');
require_once('./includes/opac_config.inc.php');
require_once("./includes/check_session_time.inc.php");

// rcupration localisation
require_once('./includes/localisation.inc.php');

// version actuelle de l'opac
require_once('./includes/opac_version.inc.php');

// fonctions de gestion de formulaire
require_once('./includes/javascript/form.inc.php');
require_once('./includes/templates/common.tpl.php');
require_once('./includes/divers.inc.php');
require_once('./includes/notice_categories.inc.php');

// classe de gestion des catgories
require_once($base_path.'/classes/categorie.class.php');
require_once($base_path.'/classes/notice.class.php');
require_once($base_path.'/classes/notice_display.class.php');

// classe indexation interne
require_once($base_path.'/classes/indexint.class.php');

// classe d'affichage des tags
require_once($base_path.'/classes/tags.class.php');

require_once($base_path."/includes/marc_tables/".$lang."/empty_words");

// pour l'affichage correct des notices
require_once($base_path."/includes/templates/common.tpl.php");
require_once($base_path."/includes/templates/notice.tpl.php");
require_once($base_path."/includes/navbar.inc.php");
require_once($base_path."/includes/notice_authors.inc.php");
require_once($base_path."/includes/notice_categories.inc.php");
require_once($base_path."/includes/explnum.inc.php");

require_once('./classes/notice_affichage.class.php');
require_once('./classes/notice_affichage_unimarc.class.php');
require_once('./classes/notice_affichage.ext.class.php');

require_once($include_path."/mail.inc.php") ;

if (($action=="print")&&($output=="tt")) {
	header("Content-Type: application/word");
	header("Content-Disposition: attachement; filename=liste.doc");
}
$output_final = "<html><head><title>".$msg["print_title"]."</title>" .
			 	'<meta http-equiv=Content-Type content="text/html; charset='.$charset.'" />'.
				"</head><body>" ;

if ($action!="print") {
	$output_final .= "<link rel=\"stylesheet\" href=\"./styles/".$css."/$css.css\" />";
	$output_final .= "<h3>".$msg["print_options"]."</h3>";
	$output_final .= "<form name='print_options' action='print.php?action=print' method='post'>
	<b>".$msg["print_type_title"]."</b>
	<blockquote>
		<input type='radio' name='type' value='ISBD' id='isbd' checked/><label for='isbd'>&nbsp;".$msg["print_type_isbd"]."</label><br/>
		<input type='radio' name='type' value='PUBLIC' id='public' /><label for='public'>&nbsp;".$msg["print_type_public"]."</label>
	</blockquote>
	<b>".$msg["print_format_title"]."</b>
	<blockquote>
		<input type='radio' name='short' id='s1' value='1' checked/><label for='s1'>&nbsp;".$msg["print_short_format"]."</label><br/>
		<input type='radio' name='short' id='s0' value='0'/><label for='s0'>&nbsp;".$msg["print_long_format"]."</label><br/>
		<input type='checkbox' name='header' id='header' value='1' checked/>&nbsp;<label for='header'>".$msg["print_header"]."</label>
	</blockquote>
	<b>".$msg["print_ex_title"]."</b>
	<blockquote>
		<input type='radio' name='ex' id='ex1' value='1'/><label for='ex1'>&nbsp;".$msg["print_ex"]."</label><br/>
		<input type='radio' name='ex' id='ex0' value='0' checked/><label for='ex0'>&nbsp;".$msg["print_no_ex"]."</label>
	</blockquote>
	<b>".$msg["print_output_title"]."</b>
	<blockquote>
		<input type='radio' name='output' id='outp' value='printer' checked /><label for='outp'>&nbsp;".$msg["print_output_printer"]."</label><br/>
		<input type='radio' name='output' id='outt' value='tt'/><label for='outt'>&nbsp;".$msg["print_output_writer"]."</label><br/>
		<input type='radio' name='output' id='oute' value='email' /><label for='oute'>&nbsp;".$msg["print_email"]."</label><br/>
			&nbsp;&nbsp;".$msg["print_emaildest"]."<input type='text' name='emaildest' value='' /><br/>
	</blockquote>
	<center><input type='submit' value='".$msg["print_print"]."' class='bouton'/>&nbsp;<input type='button' value='".$msg["print_cancel"]."' class='bouton' onClick='self.close();'/></center>
	";
	$output_final .= "</form>"; 
} else {
	//print "<link rel=\"stylesheet\" href=\"./styles/".$css."/print.css\" />";
	$output_final .= "<style type='text/css'>
	BODY { 	
	font-size: 10pt;
	font-family: verdana, geneva, helvetica, arial;
	color:#000000;
	}
td {
	font-size: 10pt;
	font-family: verdana, geneva, helvetica, arial;
	color:#000000;
}
th {
	font-size: 10pt;
	font-family: verdana, geneva, helvetica, arial;
	font-weight:bold;
	color:#000000;
	background:#DDDDDD;
	text-align:left;
}
hr {
	border:none;
	border-bottom:1px solid #000000;
}
h3 {
	font-size: 12pt;
}
	</style>";
	$cart_=$_SESSION["cart"];
	$date_today = formatdate(today()) ;
	$output_final .= "<h3>".$date_today."&nbsp;".sprintf($msg["show_cart_n_notices"],count($cart_))."</h3><hr style='border:none; border-bottom:solid #000000 3px;'/>";
	//print "<table width='100%'>";
	for ($i=0; $i<count($cart_); $i++) {
		if (strpos($cart_[$i]," ")===false) {
			if (!$opac_notice_affichage_class) $opac_notice_affichage_class="notice_affichage";
		} else $opac_notice_affichage_class="notice_affichage_unimarc";
		$current = new $opac_notice_affichage_class($cart_[$i],array(),0,1);
		$current->do_header();
		if ($type=='PUBLIC') $current->do_public($short,$ex); else $current->do_isbd($short,$ex);
		if ($header) $output_final .= "<h3>".$current->notice_header."</h3>";
		if ($current->notice->niveau_biblio =='s') {
			$perio="<span class='fond-mere'>[".$msg['isbd_type_perio'].$bulletins."]</span>&nbsp;";
		} elseif ($current->notice->niveau_biblio =='a') {
			$perio="<span class='fond-article'>[".$msg['isbd_type_art']."]</span>&nbsp;"; 
			} else $perio="";
		if ($type=='PUBLIC') $output_final .= $perio.$current->notice_public; else $output_final .= $perio.$current->notice_isbd;
		if ($ex) $output_final .= $current->affichage_expl ;
		$output_final .= "<hr/> ";
	}
	//print "</table>";
	if ($output=="printer")
		$output_final .= "<script>self.print();</script>";
}

if ($output!="email") print pmb_bidi($output_final."</body></html>") ;
	else {
	$headers  = "MIME-Version: 1.0\n";
	$headers .= "Content-type: text/html; charset=".$charset."\n";
	// $res_envoi=mail("$emaildest",$msg["print_emailobj"]." $opac_biblio_name - $date_today ",$output_final."</body></html> ","From: ".$opac_biblio_name." <".$opac_biblio_email.">\r\n".$headers);
	$res_envoi=mailpmb("", $emaildest,$msg["print_emailobj"]." $opac_biblio_name - $date_today ",$output_final."</body></html> ",$opac_biblio_name, $opac_biblio_email, $headers);
	if ($res_envoi) print "<html><head><title>".$msg["print_title"]."</title></head><body><link rel=\"stylesheet\" href=\"./styles/".$css."/$css.css\" />\n<br/><br/><center><h3>".sprintf($msg["print_emailsucceed"],$emaildest)."</h3><br><a href=\"\" onClick=\"self.close(); return false;\">".$msg["print_emailclose"]."</a></center></body></html>" ;
		else echo "<html><head><title>".$msg["print_title"]."</title></head><body><link rel=\"stylesheet\" href=\"./styles/".$css."/$css.css\" />\n<br/><br/><center><h3>".sprintf($msg["print_emailfailed"],$emaildest)."</h3><br><a href=\"\" onClick=\"self.close(); return false;\">".$msg["print_emailclose"]."</a></center></body></html>" ;
	}		

