<?php
// +-------------------------------------------------+
//  2002-2004 PMB Services / www.sigb.net pmb@sigb.net et contributeurs (voir www.sigb.net)
// +-------------------------------------------------+
// $Id: acquisition_notice.inc.php,v 1.13 2007/10/02 19:32:49 gueluneau Exp $


if (stristr($_SERVER['REQUEST_URI'], "inc.php")) die("no access");

// la variable $caller, passe par l'URL, contient le nom du form appelant
$base_url = "./select.php?what=acquisition_notice&caller=$caller&sub=$sub&param1=$param1&param2=$param2&param3=$param3&param4=$param4&param5=$param5&param6=$param6&param7=$param7&param8=$param8&param9=$param9&param10=$param10&no_display=$no_display&bt_ajouter=$bt_ajouter";

//$caller 		nom de la fenetre appellante
//$sub			type de recherche (notice, bulletin, frais)
//$param1		identifiant de notice ou de bulletin
//$param2		code
//$param3		libelle
//$param4		prix
//$param5		quantit
//$param6		type_ligne (0=texte, 1=notice, 2=bulletin, 3=frais)
//$param7		taux tva
//$param8		taux remise
//$param9		type produit
//$param10		libelle produit

// contenu popup slection emprunteur
require_once('./selectors/templates/sel_acquisition_notice.tpl.php');
require_once('./classes/notice.class.php');
require_once('./classes/frais.class.php');
require_once('./classes/tva_achats.class.php');
require_once('./includes/isbn.inc.php');



switch ($sub) {

	case 'bulletin' :

		// affichage du header
		$sel_header = str_replace('!!is_current_notice!!','', $sel_header);
		$sel_header = str_replace('!!is_current_bulletin!!',"class='sel_navbar_current'", $sel_header);
		$sel_header = str_replace('!!is_current_frais!!','', $sel_header);
		print $sel_header;

		// traitement en entre des requtes utilisateur
		if ($deb_rech) $f_user_input = $deb_rech ;
		if($f_user_input=="" && $user_input=="") {
			$user_input='';
		} else {
			// traitement de la saisie utilisateur
			if ($user_input) $f_user_input=$user_input;
			if (($f_user_input)&&(!$user_input)) $user_input=$f_user_input;	
		}
		
		
		// affichage des membres de la page
		
		$sel_search_form = str_replace("!!deb_rech!!", stripslashes($f_user_input), $sel_search_form);
		print $sel_search_form;
		print $jscript;
		show_bulletin_results($dbh, $user_input, $nbr_lignes, $page);

		break;

	
	case 'frais' :
		$sel_header = str_replace('!!is_current_notice!!','', $sel_header);
		$sel_header = str_replace('!!is_current_bulletin!!','', $sel_header);
		$sel_header = str_replace('!!is_current_frais!!',"class='sel_navbar_current'", $sel_header);
		print $sel_header;
		print $jscript;
		show_frais_results($dbh, $nbr_lignes, $page);
		break;

	
	case 'notice' :
	default	:
		$sel_header = str_replace('!!is_current_notice!!',"class='sel_navbar_current'", $sel_header);
		$sel_header = str_replace('!!is_current_bulletin!!','', $sel_header);
		$sel_header = str_replace('!!is_current_frais!!','', $sel_header);
		print $sel_header;
	
		// traitement en entre des requtes utilisateur
		if ($deb_rech) $f_user_input = $deb_rech ;
		if($f_user_input=="" && $user_input=="") {
			$user_input='';
		} else {
			// traitement de la saisie utilisateur
			if ($user_input) $f_user_input=$user_input;
			if (($f_user_input)&&(!$user_input)) $user_input=$f_user_input;	
		}
		
		
		// affichage des membres de la page
		
		$sel_search_form = str_replace("!!deb_rech!!", stripslashes($f_user_input), $sel_search_form);
		print $sel_search_form;
		print $jscript;
		show_notice_results($dbh, $user_input, $nbr_lignes, $page);
				
		break;

}

print $sel_footer;	
	



function show_notice_results ($dbh, $user_input, $nbr_lignes=0, $page=0, $id = 0) {
	global $nb_per_page;
	global $base_url;
	global $caller;
	global $msg;
	global $no_display ;
	global $charset;
	global $deb_rech,$close;


	$fromCode = false;
	if ($deb_rech) { //On a saisi un code, on vrifie qu'il existe dans les notices 
		$isbn_verif=traite_code_isbn(stripslashes($user_input));
		$suite_rqt="";
		if (isISBN($isbn_verif)) {
			if (strlen($isbn_verif)==13)
				$suite_rqt=" or code='".formatISBN($isbn_verif,13)."' ";
			else $suite_rqt="or code='".formatISBN($isbn_verif,10)."' ";
		}
		$requete = "select count(1) from notices where (code like '".addslashes($isbn_verif)."' ".$suite_rqt.") and notice_id!='".$no_display."' ";
		$requete.= "and notices.niveau_biblio='m' ";
		$res = mysql_query($requete, $dbh);
		$nbr_lignes = mysql_result($res, 0, 0);
		if($nbr_lignes) $fromCode = true;  
	
	}


	if (!$fromCode) {	//Pas de saisie de code ou code inexistant dans les notices >> recherche normale
		
		// on rcupre le nombre de lignes qui vont bien
		if($user_input=="") {
			$requete = "SELECT COUNT(1) FROM notices where notice_id!='".$no_display."' ";
			$requete.= "and notices.niveau_biblio='m' ";
			
		} else {
			$aq=new analyse_query(stripslashes($user_input));
			if ($aq->error) {
				error_message($msg["searcher_syntax_error"],sprintf($msg["searcher_syntax_error_desc"],$aq->current_car,$aq->input_html,$aq->error_message));
				exit;
			}
			$members=$aq->get_query_members("notices","index_wew","index_sew","notice_id");
			$isbn_verif=traite_code_isbn(stripslashes($user_input));	
			$suite_rqt="";
			if (isISBN($isbn_verif)) {
				if (strlen($isbn_verif)==13)
					$suite_rqt=" or code='".formatISBN($isbn_verif,13)."' ";
				else $suite_rqt="or code='".formatISBN($isbn_verif,10)."' ";
			}
			$requete = "select count(1) from notices where (".$members["where"]." or (code like '".addslashes($isbn_verif)."' ".$suite_rqt.")) and notice_id!='".$no_display."' ";
			$requete.= "and notices.niveau_biblio='m' ";
			
		}
		$res = mysql_query($requete, $dbh);
		$nbr_lignes = mysql_result($res, 0, 0);

		
		if(!$page) $page=1;
		$debut =($page-1)*$nb_per_page;
	
	
		if($nbr_lignes) {
			// on lance la vraie requte
	
			if($user_input=="") {
				$requete = "SELECT notice_id FROM notices where notice_id!='".$no_display."' ";
				$requete.= "and notices.niveau_biblio='m' ";
				$requete.= "ORDER BY tit1, code LIMIT $debut,$nb_per_page ";
			} else {
				$requete = "select notice_id, ".$members["select"]." as pert from notices where (".$members["where"]." or code like '".traite_code_isbn(stripslashes($user_input))."') and notice_id!='".$no_display."' ";
				$requete.= "and notices.niveau_biblio='m' ";
				$requete.= "group by notice_id order by pert desc, index_serie, tnvol, index_sew, code limit $debut,$nb_per_page";
			}
			$res = @mysql_query($requete, $dbh);

			// Affichage des rsultats	
			print "<table><tr><th>".htmlentities($msg['acquisition_act_tab_lib'], ENT_QUOTES, $charset)."</th><th>".htmlentities($msg['acquisition_act_tab_code'], ENT_QUOTES, $charset)."</th><th>".htmlentities($msg['acquisition_nb_expl'], ENT_QUOTES, $charset)."</th></tr><tr>";
			while(($row=mysql_fetch_object($res))) {
				
				$notice = new notice($row->notice_id);
			
				$q = "select count(1) from exemplaires where expl_notice = '".$row->notice_id."' ";
				$r = mysql_query($q, $dbh);
				$nb_expl = mysql_result($r, 0, 0);
			
				//recherche auteur
				$responsabilites = get_notice_authors($notice->id) ;
				$as = array_search ("0", $responsabilites["responsabilites"]);
				if ($as!== FALSE && $as!== NULL) {
					$auteur_0 = $responsabilites["auteurs"][$as] ;
					$auteur = new auteur($auteur_0["id"]);
					$lib_auteur = $auteur->display;
				} else {
					$lib_auteur = '';
				}

				$taec= htmlentities(addslashes($notice->tit1),ENT_QUOTES,$charset);
				if ($lib_auteur!="") $taec.= "\\n".htmlentities(addslashes($lib_auteur),ENT_QUOTES,$charset);
				if ($notice->ed1 != "") $taec.= "\\n".htmlentities(addslashes($notice->ed1),ENT_QUOTES,$charset);
				if ($notice->coll != "") $taec.= "\\n".htmlentities(addslashes($notice->coll),ENT_QUOTES,$charset);

				if (is_numeric($notice->prix)) $prix = $notice->prix;
					else $prix = '0.00';
							
				print pmb_bidi("
					<tr>
						<td>
							<a href='#' onclick=\"set_parent('$caller', '".$notice->id."','".htmlentities(addslashes($notice->code),ENT_QUOTES,$charset)."', '".$taec."', '".$prix."', '1', '') \">".htmlentities($notice->tit1,ENT_QUOTES,$charset)."</a></td>
						<td>$notice->code</td><td style='text-align:right' >".$nb_expl."</td>");
				print "</tr>";
			}
			print "</table>";
			mysql_free_result($res);
	
			// constitution des liens
	
			$nbepages = ceil($nbr_lignes/$nb_per_page);
			$suivante = $page+1;
			$precedente = $page-1;
	
			// affichage du lien prcdent si ncssaire
			print '<hr><div align=center>';
			if($precedente > 0)
			print "<a href='$base_url&page=$precedente&nbr_lignes=$nbr_lignes&user_input=".rawurlencode(stripslashes($user_input))."'><img src='./images/left.gif' border='0' title='$msg[48]' alt='[$msg[48]]' hspace='3' align='middle' /></a>";
			for($i = 1; $i <= $nbepages; $i++) {
				if($i==$page)
					print "<b>$i/$nbepages</b>";
			}
	
			if($suivante<=$nbepages)
				print "<a href='$base_url&page=$suivante&nbr_lignes=$nbr_lignes&user_input=".rawurlencode(stripslashes($user_input))."'><img src='./images/right.gif' border='0' title='$msg[49]' alt='[$msg[49]]' hspace='3' align='middle' /></a>";
		}
		print '</div>';

		
	} else { //Le code saisi existe dans une ou plusieurs notices
		
		if(!$page) $page=1;
		$debut =($page-1)*$nb_per_page;	
	
		if($nbr_lignes) {
			// on lance la vraie requte
			$isbn_verif=traite_code_isbn(stripslashes($user_input));
			$suite_rqt="";
			if (isISBN($isbn_verif)) {
				if (strlen($isbn_verif)==13)
					$suite_rqt=" or code='".formatISBN($isbn_verif,13)."' ";
				else $suite_rqt="or code='".formatISBN($isbn_verif,10)."' ";
			}
			$requete = "select notice_id from notices where (code like ('".addslashes($isbn_verif)."' ".$suite_rqt.")) and notice_id!='".$no_display."' ";
			$requete.= "and notices.niveau_biblio='m' ";
			$requete.= "group by notice_id order by tit1, code limit $debut,$nb_per_page";
			$res = @mysql_query($requete, $dbh);		

			// Affichage de tous les rsultats	
			print "<table><tr>";
			while(($row=mysql_fetch_object($res))) {
				
				$notice = new notice($row->notice_id);
			
				//recherche auteur
				$responsabilites = get_notice_authors($notice->id) ;
				$as = array_search ("0", $responsabilites["responsabilites"]);
				if ($as!== FALSE && $as!== NULL) {
					$auteur_0 = $responsabilites["auteurs"][$as] ;
					$auteur = new auteur($auteur_0["id"]);
					$lib_auteur = $auteur->display;
				} else {
					$lib_auteur = '';
				}
				
				$taec= addslashes($notice->tit1);
				if ($lib_auteur!="") $taec.= "\\n".addslashes($lib_auteur);
				if ($notice->ed1 != "") $taec.= "\\n".addslashes($notice->ed1);
				if ($notice->coll != "") $taec.= "\\n".addslashes($notice->coll);
				
				if (is_numeric($notice->prix)) $prix = $notice->prix;
					else $prix = '0.00';
				
				print pmb_bidi("
					<tr>
						<td>
							<a href='#' onclick=\"set_parent('".$caller."', '".$notice->id."','".htmlentities(addslashes($notice->code),ENT_QUOTES,$charset)."','".htmlentities($taec, ENT_QUOTES, $charset)."', '".$prix."', '1', '' ) \">".htmlentities($notice->tit1,ENT_QUOTES,$charset)."</a></td>
						<td>$notice->code</td>");
				print "</tr>";
			}
			print "</table>";
			mysql_free_result($res);
	
			// constitution des liens
	
			$nbepages = ceil($nbr_lignes/$nb_per_page);
			$suivante = $page+1;
			$precedente = $page-1;
	
			// affichage du lien prcdent si ncssaire
			print '<hr><div align=center>';
			if($precedente > 0)
			print "<a href='$base_url&page=$precedente&nbr_lignes=$nbr_lignes&deb_rech=".rawurlencode(stripslashes($user_input))."'><img src='./images/left.gif' border='0' title='$msg[48]' alt='[$msg[48]]' hspace='3' align='middle' /></a>";
			for($i = 1; $i <= $nbepages; $i++) {
				if($i==$page)
					print "<b>$i/$nbepages</b>";
			}
	
			if($suivante<=$nbepages)
				print "<a href='$base_url&page=$suivante&nbr_lignes=$nbr_lignes&deb_rech=".rawurlencode(stripslashes($user_input))."'><img src='./images/right.gif' border='0' title='$msg[49]' alt='[$msg[49]]' hspace='3' align='middle' /></a>";

		}
		print '</div>';
	}		
}		



function show_bulletin_results ($dbh, $user_input, $nbr_lignes=0, $page=0, $id = 0) {
	global $nb_per_page;
	global $base_url;
	global $caller;
	global $msg;
	global $no_display ;
	global $charset;
	global $close;


	// on rcupre le nombre de lignes qui vont bien
	if($user_input=="") {
		$requete = "SELECT COUNT(1) FROM notices, bulletins where notice_id!='".$no_display."' ";
		$requete.= "and notices.niveau_biblio='s' and notices.niveau_hierar='1' ";
		$requete.= "and notices.notice_id=bulletins.bulletin_notice ";
		
	} else {
		$aq=new analyse_query(stripslashes($user_input));
		if ($aq->error) {
			error_message($msg["searcher_syntax_error"],sprintf($msg["searcher_syntax_error_desc"],$aq->current_car,$aq->input_html,$aq->error_message));
			exit;
		}
		$members=$aq->get_query_members("notices","index_wew","index_sew","notice_id");
		$code = traite_code_isbn(stripslashes($user_input));
		$suite_rqt="";
		if (isISBN($code)) {
			if (strlen($code)==13)
				$suite_rqt=" or code='".formatISBN($code,13)."' ";
			else $suite_rqt="or code='".formatISBN($code,10)."' ";
		}
		$requete = "select count(1) from notices, bulletins where notice_id!='".$no_display."' ";
		$requete.= "and ( ".$members["where"]." or (code like '".$code."' ".$suite_rqt.") or bulletin_cb like '".$code."' or bulletin_numero like '".$code."' ) ";
		$requete.= "and notices.niveau_biblio='s' and notices.niveau_hierar='1' ";
		$requete.= "and notices.notice_id=bulletins.bulletin_notice ";

	}
	$res = mysql_query($requete, $dbh);
	$nbr_lignes = mysql_result($res, 0, 0);
	
	if(!$page) $page=1;
	$debut =($page-1)*$nb_per_page;


	if($nbr_lignes) {
		// on lance la vraie requte

		if($user_input=="") {
			$requete = "SELECT notice_id,  bulletins.*  FROM notices, bulletins where notice_id!='".$no_display."' ";
			$requete.= "and notices.niveau_biblio='s' and notices.niveau_hierar='1' ";
			$requete.= "and notices.notice_id=bulletins.bulletin_notice ";
			$requete.= "ORDER BY tit1, code, bulletin_numero LIMIT $debut,$nb_per_page ";
		} else {
			$requete = "select notice_id,bulletins.*, ".$members["select"]." as pert from notices, bulletins where notice_id!='".$no_display."' ";
			$requete.= "and ( ".$members["where"]." or code like '".$code."' or bulletin_cb like '".$code."' or bulletin_numero like '".$code."' ) ";
			$requete.= "and notices.niveau_biblio='s' and notices.niveau_hierar='1' ";
			$requete.= "and notices.notice_id=bulletins.bulletin_notice ";
			$requete.= "order by pert desc, index_serie, tnvol, index_sew, code, bulletin_numero limit $debut,$nb_per_page";
		}
		$res = @mysql_query($requete, $dbh);

		// Affichage des rsultats	
		print "<table><tr><th>".htmlentities($msg['acquisition_act_tab_lib'], ENT_QUOTES, $charset)."</th><th>".htmlentities($msg['acquisition_nb_expl'], ENT_QUOTES, $charset)."</th></tr><tr>";
		while(($row=mysql_fetch_object($res))) {
			
			$notice = new notice($row->notice_id);
	
			$q = "select count(1) from exemplaires where expl_bulletin = '".$row->bulletin_id."' ";
			$r = mysql_query($q, $dbh);
			$nb_expl = mysql_result($r, 0, 0);
		
			//recherche auteur
			$responsabilites = get_notice_authors($notice->id) ;
			$as = array_search ("0", $responsabilites["responsabilites"]);
			if ($as!== FALSE && $as!== NULL) {
				$auteur_0 = $responsabilites["auteurs"][$as] ;
				$auteur = new auteur($auteur_0["id"]);
				$lib_auteur = $auteur->display;
			} else {
				$lib_auteur = '';
			}

			$taec= htmlentities(addslashes($notice->tit1),ENT_QUOTES,$charset);
			$info_bull = $msg['selector_bull_tpl'];
			$info_bull = str_replace('!!numero!!', $row->bulletin_numero, $info_bull);
			$info_bull = str_replace('!!date!!', formatdate($row->date_date), $info_bull);
			$info_bull = str_replace ('!!lib_periode!!', $row->mention_date, $info_bull);
			
			$taec.= htmlentities(addslashes($info_bull),ENT_QUOTES,$charset);
			
			if ($row->bulletin_titre) $taec.= "\\n".htmlentities(addslashes($row->bulletin_titre),ENT_QUOTES,$charset); 
			if ($lib_auteur!="") $taec.= "\\n".htmlentities(addslashes($lib_auteur),ENT_QUOTES,$charset);
			if ($notice->ed1 != "") $taec.= "\\n".htmlentities(addslashes($notice->ed1),ENT_QUOTES,$charset);
			if ($notice->coll != "") $taec.= "\\n".htmlentities(addslashes($notice->coll),ENT_QUOTES,$charset);

			$prix = '0.00';
						
			print pmb_bidi("
				<tr>
					<td>
						<a href='#' onclick=\"set_parent('$caller', '".$notice->id."','".htmlentities(addslashes($notice->code),ENT_QUOTES,$charset)."', '".$taec."', '".$prix."', '2', '' ) \">".htmlentities($notice->tit1.$info_bull,ENT_QUOTES,$charset)."</a></td>
					<td style='text-align:right' >".$nb_expl."</td>");
			print "</tr>";
		}
		print "</table>";
		mysql_free_result($res);

		// constitution des liens

		$nbepages = ceil($nbr_lignes/$nb_per_page);
		$suivante = $page+1;
		$precedente = $page-1;

		// affichage du lien prcdent si ncessaire
		print '<hr><div align=center>';
		if($precedente > 0)
		print "<a href='$base_url&page=$precedente&nbr_lignes=$nbr_lignes&user_input=".rawurlencode(stripslashes($user_input))."'><img src='./images/left.gif' border='0' title='$msg[48]' alt='[$msg[48]]' hspace='3' align='middle' /></a>";
		for($i = 1; $i <= $nbepages; $i++) {
			if($i==$page)
				print "<b>$i/$nbepages</b>";
		}

		if($suivante<=$nbepages)
			print "<a href='$base_url&page=$suivante&nbr_lignes=$nbr_lignes&user_input=".rawurlencode(stripslashes($user_input))."'><img src='./images/right.gif' border='0' title='$msg[49]' alt='[$msg[49]]' hspace='3' align='middle' /></a>";
	}
	print '</div>';
		
}


function show_frais_results ($dbh, $nbr_lignes=0, $page=0, $id = 0) {
	global $nb_per_page;
	global $base_url;
	global $caller;
	global $msg;
	global $charset;
	global $close;

	$res = frais::listFrais();
	$nbr_lignes = mysql_num_rows($res);
	
	if(!$page) $page=1;
	$debut =($page-1)*$nb_per_page;	
	
	
	if($nbr_lignes) {

		print "<table><tr>";
		
		while(($row=mysql_fetch_object($res))) {
			$tva = new tva_achats($row->num_tva_achat);
			print pmb_bidi("
				<tr>
					<td>
						<a href='#' onclick=\"set_parent('".$caller."', '".$row->id_frais."','','".htmlentities(addslashes($row->libelle), ENT_QUOTES, $charset)."', '".$row->montant."', '3', '".$tva->taux_tva."') \">".htmlentities($row->libelle,ENT_QUOTES,$charset)."</a>
					</td>");
			print "<td>".$row->montant."</td>";
			print "</tr>";
		}
		print "</table>";
		mysql_free_result($res);

		
		// constitution des liens
	
		$nbepages = ceil($nbr_lignes/$nb_per_page);
		$suivante = $page+1;
		$precedente = $page-1;

		// affichage du lien prcdent si ncssaire
		print '<hr><div align=center>';
		if($precedente > 0)
			print "<a href='$base_url&page=$precedente&nbr_lignes=$nbr_lignes'><img src='./images/left.gif' border='0' title='$msg[48]' alt='[$msg[48]]' hspace='3' align='middle' /></a>";
			
		for($i = 1; $i <= $nbepages; $i++) {
			if($i==$page)
				print "<b>$i/$nbepages</b>";
		}
	
		if($suivante<=$nbepages)
			print "<a href='$base_url&page=$suivante&nbr_lignes=$nbr_lignes'><img src='./images/right.gif' border='0' title='$msg[49]' alt='[$msg[49]]' hspace='3' align='middle' /></a>";
	}	
	print '</div>';
	

}
