<?php
// +-------------------------------------------------+
//  2002-2004 PMB Services / www.sigb.net pmb@sigb.net et contributeurs (voir www.sigb.net)
// +-------------------------------------------------+
// $Id: commandes.inc.php,v 1.46 2007/11/05 15:23:22 dbellamy Exp $

if (stristr($_SERVER['REQUEST_URI'], ".inc.php")) die("no access");

// gestion des commandes
require_once("$class_path/entites.class.php");
require_once("$class_path/exercices.class.php");
require_once("$class_path/paiements.class.php");
require_once("$class_path/frais.class.php");
require_once("$class_path/types_produits.class.php");
require_once("$class_path/offres_remises.class.php");
require_once("$class_path/actes.class.php");
require_once("$class_path/lignes_actes.class.php");
require_once("$class_path/liens_actes.class.php");
require_once("$class_path/suggestions.class.php");
require_once("$class_path/suggestions_map.class.php");
require_once("$include_path/templates/actes.tpl.php");
require_once("$include_path/templates/commandes.tpl.php");
require_once("$base_path/acquisition/achats/func_achats.inc.php");
require_once("$base_path/acquisition/suggestions/func_suggestions.inc.php");

//Rcupration des parametres utilisateur
$q = "SELECT * FROM users where username='".SESSlogin."' limit 1 ";
$r = mysql_query($q, $dbh);
$p_user=mysql_fetch_object($r);

//Affiche la liste des bibliothques
function show_list_biblio() {
	
	global $dbh;
	global $msg, $charset;
	global $p_user;
	global $current_module;

	//Affichage de la liste des bibliothques auxquelles a accs l'utilisateur
	$res = entites::list_biblio($p_user->userid);
	$nbr = mysql_num_rows($res);
	
	if ($nbr == '1') {
		$row = mysql_fetch_object($res);
		show_list_cde($row->id_entite);		
	} else {
		$aff = "<form class='form-".$current_module."' id='list_biblio_form' name='list_biblio_form' method='post' action=\"\" >";
		$aff.= "<h3>".htmlentities($msg['acquisition_menu_chx_ent'], ENT_QUOTES, $charset)."</h3>	<div class='row'></div>";
		$aff.= "<table>";

		$parity=1;
		while($row=mysql_fetch_object($res)){
			if ($parity % 2) {
				$pair_impair = "even";
			} else {
				$pair_impair = "odd";
			}
			$parity += 1;
			$tr_javascript=" onmouseover=\"this.className='surbrillance'\" onmouseout=\"this.className='".$pair_impair."'\" onmousedown=\"document.forms['list_biblio_form'].setAttribute('action','./acquisition.php?categ=ach&sub=cmde&action=list&id_bibli=".$row->id_entite."');document.forms['list_biblio_form'].submit(); \" ";
	        $aff.= "<tr class='".$pair_impair."' ".$tr_javascript." style='cursor: pointer'><td><i>".htmlentities($row->raison_sociale, ENT_QUOTES, $charset)."</i></td></tr>";
		}
			
		$aff.=" </table></form>";
		print $aff;
	}
}


//Affiche la liste des commandes pour une bibliotheque
function show_list_cde($id_bibli) {
	
	global $dbh;
	global $msg;
	global $lang, $charset;
	global $search_form, $cmde_search_form;
	global $nb_per_page_acq;
	global $include_path, $class_path;
	global $user_input, $statut, $page, $nbr_lignes, $tri_param, $limit_param, $last_param;

	//Affichage form de recherche
	$titre = htmlentities($msg['recherche'].' : '.$msg['acquisition_ach_cde'], ENT_QUOTES, $charset);
	$action ="./acquisition.php?categ=ach&sub=cmde&action=list&id_bibli=".$id_bibli."&user_input=";
	$bouton_add = "<input class='bouton' type='button' value='".$msg['acquisition_ajout_cde']."' onclick=\"document.location='./acquisition.php?categ=ach&sub=cmde&action=modif&id_bibli=".$id_bibli."&id_cde=0';\" />";
	$lien_last_cde = "";
	$search_form = str_replace('!!form_title!!', $titre, $search_form);
	$search_form = str_replace('!!action!!', $action, $search_form);
	$search_form = str_replace('<!-- recherche -->', $cmde_search_form, $search_form);
	$search_form = str_replace('<!-- bouton_add -->', $bouton_add, $search_form);
	$search_form = str_replace('<!-- lien_last -->', $lien_last_cde, $search_form);
	
	print $search_form;
	if(!$statut) $statut = STA_ACT_ENC;		//Affichage par dfaut des commandes en cours
	print "<script type='text/javascript' >document.forms['search'].elements['statut'].value = ".$statut.";document.forms['search'].elements['user_input'].focus();</script>";
	
	//Prise en compte du formulaire de recherche
	// nombre de rfrences par pages
	if ($nb_per_page_acq != "") $nb_per_page = $nb_per_page_acq ;
	else $nb_per_page = 10;
	
	// traitement de la saisie utilisateur
	require_once($class_path."/analyse_query.class.php");
	
	// on rcupre le nombre de lignes qui vont bien
	if(!$nbr_lignes) {

		if(!$user_input) {
			$nbr_lignes = entites::getNbActes($id_bibli, TYP_ACT_CDE, $statut);
		} else {
			$aq=new analyse_query(stripslashes($user_input));
			if ($aq->error) {
				error_message($msg["searcher_syntax_error"],sprintf($msg["searcher_syntax_error_desc"],$aq->current_car,$aq->input_html,$aq->error_message));
				exit;
			}
			$nbr_lignes = entites::getNbActes($id_bibli, TYP_ACT_CDE, $statut, $aq);
		}

	} else {
		$aq=new analyse_query(stripslashes($user_input));
	}

	
	if(!$page) $page=1;
	$debut =($page-1)*$nb_per_page;


	if($nbr_lignes) {
	
		$url_base = "$PHP_SELF?categ=ach&sub=cmde&action=list&id_bibli=$id_bibli&user_input=".rawurlencode(stripslashes($user_input))."&statut=$statut" ;
		
		// on lance la vraie requte
		if(!$user_input) {
			$res = entites::listActes($id_bibli, TYP_ACT_CDE, $statut, $debut, $nb_per_page);
		} else {
			$res = entites::listActes($id_bibli, TYP_ACT_CDE, $statut, $debut, $nb_per_page, $aq);
		}

	
	//Affichage liste des commandes
	print "<table>
				<th>".htmlentities($msg['38'], ENT_QUOTES, $charset)."</th>
				<th>".htmlentities($msg['acquisition_ach_fou2'], ENT_QUOTES, $charset)."</th>
				<th>".htmlentities($msg['acquisition_cde_date_cde'], ENT_QUOTES, $charset)."</th>
				<th>".htmlentities($msg['acquisition_cde_date_ech'], ENT_QUOTES, $charset)."</th>
				<th>".htmlentities($msg['acquisition_statut'], ENT_QUOTES, $charset)."</th>
				<th>&nbsp;</th>
				<th>&nbsp;</th>";

	$nbr = mysql_num_rows($res);
	
	$parity=1;
	for($i=0;$i<$nbr;$i++) {
		$row=mysql_fetch_object($res);
		$fourn = new entites($row->num_fournisseur);
		$dateech = actes::getNextLivr($row->id_acte);
		if ($dateech) $dateech=formatdate($dateech); else $dateech = '';

		$st = ( ($row->statut) & ~(STA_ACT_FAC+STA_ACT_PAY+STA_ACT_ARC) );
		
		switch ($st) {
			case STA_ACT_AVA :
				$statut = htmlentities($msg['acquisition_cde_aval'], ENT_QUOTES, $charset);
				break;
			case STA_ACT_ENC :
				$statut = htmlentities($msg['acquisition_cde_enc'], ENT_QUOTES, $charset);
				break;
			case STA_ACT_REC :
				$statut = htmlentities($msg['acquisition_cde_liv'], ENT_QUOTES, $charset);
				break;
			default :
				$statut = '';
		}

		if( ($row->statut & STA_ACT_ARC) == STA_ACT_ARC ) $statut = '<s>'.$statut.'</s>';	

		if( ($row->statut & STA_ACT_PAY) == STA_ACT_PAY ) {
			$statut_fac = htmlentities($msg['acquisition_act_pay'], ENT_QUOTES, $charset); 
		} elseif( ($row->statut & STA_ACT_FAC) == STA_ACT_FAC ) {
			$statut_fac = htmlentities($msg['acquisition_act_fac'], ENT_QUOTES, $charset); 
		} else $statut_fac = '';
		
		if ($parity % 2) {
			$pair_impair = "even";
		} else {
			$pair_impair = "odd";
		}
		$parity += 1;
		$tr_javascript = "onmouseover=\"this.className='surbrillance'\" onmouseout=\"this.className='".$pair_impair."'\" ";
		$dn_javascript = "onmousedown=\"document.location='./acquisition.php?categ=ach&sub=cmde&action=modif&id_bibli=".$id_bibli."&id_cde=".$row->id_acte."' \" ";
        print ("<tr class='".$pair_impair."' ".$tr_javascript." style='cursor: pointer' >
					<td ".$dn_javascript." ><i>".$row->numero."</i></td>
					<td ".$dn_javascript." ><i>".htmlentities($fourn->raison_sociale, ENT_QUOTES, $charset)."</i></td>
					<td ".$dn_javascript." ><i>".formatdate($row->date_acte)."</i></td>
					<td ".$dn_javascript." ><i>".$dateech."</i></td>
					<td ".$dn_javascript." ><i>$statut</i></td>
					<td ".$dn_javascript." ><i>$statut_fac</i></td>
					<td>
						<a href=# onclick=\"window.open('./pdf.php?pdfdoc=cmde&id_cde=".$row->id_acte."' ,'print_PDF', 'toolbar=no, dependent=yes, width=600, height=500, resizable=yes');\" >
							<img src='./images/print.gif' border='0' align='center' alt='".htmlentities(addslashes($msg['imprimer']),ENT_QUOTES, $charset)."' title='".htmlentities(addslashes($msg['imprimer']),ENT_QUOTES, $charset)."' />
						</a>
					</td>
				</tr>");
	}
	print "</table>";
		if (!$last_param) $nav_bar = aff_pagination ($url_base, $nbr_lignes, $nb_per_page, $page) ;
	        else $nav_bar = "";
	    print $nav_bar;
			
	
	} else {
		// la requte n'a produit aucun rsultat
		error_message($msg['acquisition_cde_rech'], str_replace('!!cde_cle!!', stripslashes($user_input), $msg['acquisition_cde_rech_error']), 0, './categ=ach&sub=cmde&action=list&id_bibli='.$id_bibli);
	}

}


//Affiche le formulaire de cration/modification de commande
function show_form_cde($id_bibli, $id_exer, $id_cde, $from_devis= 0) {

	global $msg;
	global $lang, $charset;
	global $dbh;
	global $cmde_modif_form, $cmde_valid_form, $frame_show, $frame_valid, $bt_enr, $bt_val, $bt_sup, $bt_enr_valid, $bt_rec;
	global $bt_fac, $bt_sol, $bt_arc;
	global $pmb_gestion_devise;
	global $acquisition_default_adress;
	global $p_user;
	global $pmb_type_audit, $bt_audit;
	
	$form = $cmde_modif_form;
	
	$liens_liv = '';
	$liens_fac = '';

	$bibli = new entites($id_bibli);

	//Prise en compte des adresses utilisateurs par dfaut 	
	$tab1 = explode('|', $p_user->speci_coordonnees_etab);
	$tab_adr=array();
	foreach ($tab1 as $key=>$value) {
		$tab2=explode(',', $value);
		$tab_adr[$tab2[0]]['id_adr_fac']=$tab2[1];
		$tab_adr[$tab2[0]]['id_adr_liv']=$tab2[2];
	}

	$def_id_adr_fac=$tab_adr[$id_bibli]['id_adr_fac'];
	$def_id_adr_liv=$tab_adr[$id_bibli]['id_adr_liv'];
	
	if(!$id_cde) {		//creation de commmande
	
		$titre = htmlentities($msg['acquisition_cde_cre'], ENT_QUOTES, $charset);
		$date_cre = formatdate(today());
		$numero = ''; 
		$id_fou = '0';
		$lib_fou = '';
		$id_adr_fou = '0';
		$adr_fou = '';
		$date_liv = '';
		$date_pay = '';
		$num_pay = '';
		$devise = $pmb_gestion_devise;

		//Rcupration exercice
		$exer = new exercices($id_exer);

		if ($def_id_adr_fac) {
			$id_adr_fac = $def_id_adr_fac;
			$coord = new coordonnees($def_id_adr_fac);
		} else {
			$coord_fac = entites::get_coordonnees($id_bibli, '1');
			if (mysql_num_rows($coord_fac) != 0) {
				$coord = mysql_fetch_object($coord_fac);
				$id_adr_fac = $coord->id_contact;
			} else {
				$id_adr_fac='0';
			}
		}
		if ($id_adr_fac) {
			if($coord->libelle != '') $adr_fac = htmlentities($coord->libelle, ENT_QUOTES, $charset)."\n";
			if($coord->contact != '') $adr_fac.= htmlentities($coord->contact, ENT_QUOTES, $charset)."\n";
			if($coord->adr1 != '') $adr_fac.= htmlentities($coord->adr1, ENT_QUOTES, $charset)."\n";
			if($coord->adr2 != '') $adr_fac.= htmlentities($coord->adr2, ENT_QUOTES, $charset)."\n";
			if($coord->cp !='') $adr_fac.= htmlentities($coord->cp, ENT_QUOTES, $charset).' ';
			if($coord->ville != '') $adr_fac.= htmlentities($coord->ville, ENT_QUOTES, $charset);
		} else {
			$adr_fac = '';
		}

		if ($def_id_adr_liv) {
			$id_adr_liv = $def_id_adr_liv;
			$coord = new coordonnees($def_id_adr_liv);
		} else {
			$coord_liv = entites::get_coordonnees($id_bibli, '2');
			if (mysql_num_rows($coord_liv) != 0) {
				$coord = mysql_fetch_object($coord_liv);
				$id_adr_liv = $coord->id_contact;
			} else {
				$id_adr_liv='0';
			}
		}
		if ($id_adr_liv) {
			if($coord->libelle != '') $adr_liv = htmlentities($coord->libelle, ENT_QUOTES, $charset)."\n";
			if($coord->contact != '') $adr_liv.= htmlentities($coord->contact, ENT_QUOTES, $charset)."\n"; 
			if($coord->adr1 != '') $adr_liv.= htmlentities($coord->adr1, ENT_QUOTES, $charset)."\n";
			if($coord->adr2 != '') $adr_liv.= htmlentities($coord->adr2, ENT_QUOTES, $charset)."\n";
			if($coord->cp !='') $adr_liv.= htmlentities($coord->cp, ENT_QUOTES, $charset).' ';
			if($coord->ville != '') $adr_liv.= htmlentities($coord->ville, ENT_QUOTES, $charset);
		} else {
			$id_adr_liv = $id_adr_fac;
			$adr_liv = $adr_fac;
		}

		
		$comment = '';
		$comment_i = '';
		$ref = '';
		
		$id_dev = '0';
		
		$form = str_replace('<!-- bouton_enr -->', $bt_enr, $form);
		$form = str_replace('<!-- bouton_val -->', $bt_val, $form);
		$form = str_replace('<!-- bouton_sup -->', $bt_sup, $form);

		
	} else {		//visualisation ou modification de commmande

		$cde = new actes($id_cde);

		//Rcupration exercice
		$exer = new exercices($cde->num_exercice);

		
		if (($cde->statut & (~(STA_ACT_FAC | STA_ACT_PAY))) >= STA_ACT_ENC) {	//Commande non modifiable.
			$form = $cmde_valid_form; 
			$frame_show = $frame_valid;
			$titre = htmlentities($msg['acquisition_cde_visu'], ENT_QUOTES, $charset);

			if ( !($cde->statut & STA_ACT_ARC) == STA_ACT_ARC ){	//Commande non archive

				$form = str_replace('<!-- bouton_enr -->', $bt_enr_valid, $form);
		
				if ( !( ($cde->statut & STA_ACT_REC) == STA_ACT_REC) ) { //Commande non solde
					
					$form = str_replace('<!-- bouton_sol -->', $bt_sol, $form); //Commande non solde ->affichage bouton solder en l'tat					
					$form = str_replace('<!-- bouton_rec -->', $bt_rec, $form); //Commande non solde ->affichage bouton rception	
				}

				//Commande non facture
				if ( !( ($cde->statut & STA_ACT_FAC) == STA_ACT_FAC) ) $form = str_replace('<!-- bouton_fac -->', $bt_fac, $form); //Commande non facture -> affichage bouton de facturation

				//Commande solde et paye
				if ( ( ($cde->statut & (STA_ACT_REC | STA_ACT_PAY)) == (STA_ACT_REC | STA_ACT_PAY)) ) $form = str_replace('<!-- bouton_arc -->', $bt_arc, $form); //Commande non facture -> affichage bouton de facturation
				

			}					
		} else {	//Commande modifiable						
						
			$titre = htmlentities($msg['acquisition_cde_mod'], ENT_QUOTES, $charset);
			$form = str_replace('<!-- bouton_enr -->', $bt_enr, $form);
			$form = str_replace('<!-- bouton_val -->', $bt_val, $form);
			$form = str_replace('<!-- bouton_sup -->', $bt_sup, $form);
						
		}
		 
		 
		$date_cre = formatdate($cde->date_acte);
		$numero = htmlentities($cde->numero, ENT_QUOTES, $charset);

		$id_fou = $cde->num_fournisseur;
		$fou = new entites($id_fou);
		$lib_fou = htmlentities($fou->raison_sociale, ENT_QUOTES, $charset);

		$coord = entites::get_coordonnees($fou->id_entite, '1');
		if (mysql_num_rows($coord) != 0) {
			$coord = mysql_fetch_object($coord);
			$id_adr_fou = $coord->id_contact;
			if($coord->libelle != '') $adr_fou = htmlentities($coord->libelle, ENT_QUOTES, $charset)."\n";
			if($coord->contact !='') $adr_fou.=  htmlentities($coord->contact, ENT_QUOTES, $charset)."\n";
			if($coord->adr1 != '') $adr_fou.= htmlentities($coord->adr1, ENT_QUOTES, $charset)."\n";
			if($coord->adr2 != '') $adr_fou.= htmlentities($coord->adr2, ENT_QUOTES, $charset)."\n";
			if($coord->cp !='') $adr_fou.= htmlentities($coord->cp, ENT_QUOTES, $charset).' ';
			if($coord->ville != '') $adr_fou.= htmlentities($coord->ville, ENT_QUOTES, $charset);

		} else {
			$id_adr_fou = '0';
			$adr_fou = '';
		}

		$date_liv = actes::getNextLivr($id_cde);
		if (!$date_liv) $date_liv = ''; else $date_liv = formatdate($date_liv);

		if ($cde->date_paiement=='0000-00-00') $date_pay = ''; else $date_pay = formatdate($cde->date_paiement);
		if ($cde->num_paiement != '0') $num_pay = htmlentities($cde->num_paiement, ENT_QUOTES, $charset);
			else $num_pay = '';

		$id_adr_fac = $cde->num_contact_fact;
		if ($id_adr_fac) {
			$coord_fac = new coordonnees($id_adr_fac);
			if($coord_fac->libelle != '') $adr_fac = htmlentities($coord_fac->libelle, ENT_QUOTES, $charset)."\n";
			if($coord->contact !='') $adr_fac.=  htmlentities($coord_fac->contact, ENT_QUOTES, $charset)."\n";
			if($coord_fac->adr1 != '') $adr_fac.= htmlentities($coord_fac->adr1, ENT_QUOTES, $charset)."\n";
			if($coord_fac->adr2 != '') $adr_fac.= htmlentities($coord_fac->adr2, ENT_QUOTES, $charset)."\n";
			if($coord_fac->cp !='') $adr_fac.= htmlentities($coord_fac->cp, ENT_QUOTES, $charset).' ';
			if($coord_fac->ville != '') $adr_fac.= htmlentities($coord_fac->ville, ENT_QUOTES, $charset);

		} else {
			$id_adr_fac = '0';
			$adr_fac = '';
		}

		$id_adr_liv = $cde->num_contact_livr;
		if ($id_adr_liv) {
			$coord_liv = new coordonnees($id_adr_liv);
			if($coord_liv->libelle != '') $adr_liv = htmlentities($coord_liv->libelle, ENT_QUOTES, $charset)."\n";
			if($coord_liv->contact != '') $adr_liv.= htmlentities($coord_liv->contact, ENT_QUOTES, $charset)."\n";
			if($coord_liv->adr1 != '') $adr_liv.= htmlentities($coord_liv->adr1, ENT_QUOTES, $charset)."\n";
			if($coord_liv->adr2 != '') $adr_liv.= htmlentities($coord_liv->adr2, ENT_QUOTES, $charset)."\n";
			if($coord_liv->cp !='') $adr_liv.= htmlentities($coord_liv->cp, ENT_QUOTES, $charset).' ';
			if($coord_liv->ville != '') $adr_liv.= htmlentities($coord_liv->ville, ENT_QUOTES, $charset);

		} else {
			$id_adr_liv = '0';
			$adr_liv = '';
		}
		
		$comment = htmlentities($cde->commentaires, ENT_QUOTES, $charset);	
		$comment_i = htmlentities($cde->commentaires_i, ENT_QUOTES, $charset);
		$ref = htmlentities($cde->reference, ENT_QUOTES, $charset);
		
		$id_dev = liens_actes::getParent($id_cde); 				
		
		$tab_liens = liens_actes::getChilds($id_cde);

		while($row_liens = mysql_fetch_object($tab_liens) ){

			if( ($row_liens->type_acte) == TYP_ACT_LIV ) $liens_liv.= "<br /><a href=\"./acquisition.php?categ=ach&sub=livr&action=modif&id_bibli=".$id_bibli."&id_liv=".$row_liens->num_acte_lie."\">".$row_liens->numero."</a>"; 
			if( ($row_liens->type_acte) == TYP_ACT_FAC ) $liens_fac.= "<br /><a href=\"./acquisition.php?categ=ach&sub=fact&action=modif&id_bibli=".$id_bibli."&id_fac=".$row_liens->num_acte_lie."\">".$row_liens->numero."</a>"; 				
			
		}
		$devise = htmlentities($cde->devise, ENT_QUOTES, $charset);
			
		$form = str_replace('<!-- frame_show -->', $frame_show, $form);
		if ($pmb_type_audit) $form = str_replace('<!-- bouton_audit -->', $bt_audit, $form);
		
	}

	$form = str_replace('!!form_title!!', $titre, $form);		
	$form = str_replace('!!id_bibli!!', $id_bibli, $form);	
	$form = str_replace('!!lib_bibli!!', htmlentities($bibli->raison_sociale, ENT_QUOTES, $charset), $form);	

	//Affichage exercice
	$form = str_replace('!!id_exer!!', $exer->id_exercice, $form);
	$form = str_replace('!!lib_exer!!', htmlentities($exer->libelle, ENT_QUOTES, $charset), $form);

	$form = str_replace('!!id_cde!!', $id_cde, $form);
	$form = str_replace('!!date_cre!!', $date_cre, $form);
	$form = str_replace('!!dat_def_lib!!', formatdate(today()), $form);
	$form = str_replace('!!dat_def!!', preg_replace('/-/', '', today()), $form);
	$form = str_replace('!!numero!!', $numero, $form);
	$form = str_replace('!!id_fou!!', $id_fou, $form);
	$form = str_replace('!!lib_fou!!', $lib_fou, $form);
	$form = str_replace('!!id_adr_fou!!', $id_adr_fou, $form);
	$form = str_replace('!!adr_fou!!', $adr_fou, $form);
	$form = str_replace('!!date_liv!!', $date_liv, $form);
	$form = str_replace('!!date_pay!!', $date_pay, $form);
	$form = str_replace('!!num_pay!!', $num_pay, $form);
	$form = str_replace('!!id_adr_liv!!', $id_adr_liv, $form);
	$form = str_replace('!!adr_liv!!', $adr_liv, $form);
	$form = str_replace('!!id_adr_fac!!', $id_adr_fac, $form);
	$form = str_replace('!!adr_fac!!', $adr_fac, $form);
	$form = str_replace('!!comment!!', $comment, $form);
	$form = str_replace('!!comment_i!!', $comment_i, $form);
	$form = str_replace('!!ref!!', $ref, $form);
	$form = str_replace('!!id_dev!!', $id_dev, $form);	
	$form = str_replace('!!devise!!', $devise, $form);
	$form = str_replace('!!liens_fac!!', $liens_fac, $form);
	$form = str_replace('!!liens_liv!!', $liens_liv, $form);
		
	$form = str_replace('!!sugchk!!', '', $form);
	
	print $form;
}


//Affiche le formulaire de cration de commande  partir d'un devis
function show_from_devis($id_bibli, $id_exer, $id_dev) {

	global $msg;
	global $dbh;
	global $lang, $charset;
	global $cmde_modif_form, $frame_show, $frame_valid, $bt_enr, $bt_val, $bt_sup, $bt_enr_valid;
	global $frame_show_from_devis, $popup_dat_liv;
	global $pmb_gestion_devise;
	
	$form = $cmde_modif_form;
	
	$bibli = new entites($id_bibli);
	$dev = new actes($id_dev);

	$titre = htmlentities($msg['acquisition_cde_cre'], ENT_QUOTES, $charset);
	$date_cre = formatdate(today());
	$numero = '';
	$id_fou = $dev->num_fournisseur;
	$fou = new entites($id_fou);
	$lib_fou = htmlentities($fou->raison_sociale, ENT_QUOTES, $charset);
	$coord = entites::get_coordonnees($fou->id_entite, '1');
	if (mysql_num_rows($coord) != 0) {
		$coord = mysql_fetch_object($coord);
		$id_adr_fou = $coord->id_contact;
		if($coord->libelle != '') $adr_fou = htmlentities($coord->libelle, ENT_QUOTES, $charset)."\n";
		if($coord->contact != '') $adr_fou.= htmlentities($coord->contact, ENT_QUOTES, $charset)."\n";
		if($coord->adr1 != '') $adr_fou.= htmlentities($coord->adr1, ENT_QUOTES, $charset)."\n";
		if($coord->adr2 != '') $adr_fou.= htmlentities($coord->adr2, ENT_QUOTES, $charset)."\n";
		if($coord->cp !='') $adr_fou.= htmlentities($coord->cp, ENT_QUOTES, $charset).' ';
		if($coord->ville != '') $adr_fou.= htmlentities($coord->ville, ENT_QUOTES, $charset);

	} else {
		$id_adr_fou = '0';
		$adr_fou = '';
	}
	$date_liv = '';
	$date_pay = '';
	$num_pay = '';
	$devise = htmlentities($dev->devise, ENT_QUOTES, $charset);

	//Rcupration exercice
	$exer = new exercices($id_exer);

	$coord_fac = entites::get_coordonnees($id_bibli, '1');
	if (mysql_num_rows($coord_fac) != 0) {
		$coord = mysql_fetch_object($coord_fac);
		$id_adr_fac = $coord->id_contact;
		if($coord->libelle != '') $adr_fac = htmlentities($coord->libelle, ENT_QUOTES, $charset)."\n";
		if($coord->contact != '') $adr_fac.= htmlentities($coord->contact, ENT_QUOTES, $charset)."\n";
		if($coord->adr1 != '') $adr_fac.= htmlentities($coord->adr1, ENT_QUOTES, $charset)."\n";
		if($coord->adr2 != '') $adr_fac.= htmlentities($coord->adr2, ENT_QUOTES, $charset)."\n";
		if($coord->cp !='') $adr_fac.= htmlentities($coord->cp, ENT_QUOTES, $charset).' ';
		if($coord->ville != '') $adr_fac.= htmlentities($coord->ville, ENT_QUOTES, $charset);

	} else {
		$id_adr_fac = '0';
		$adr_fac = '';
	}

	$coord_liv = entites::get_coordonnees($id_bibli, '2');
	if (mysql_num_rows($coord_liv) != 0) {
		$coord = mysql_fetch_object($coord_liv);
		$id_adr_liv = $coord->id_contact;
		if($coord->libelle != '') $adr_liv = htmlentities($coord->libelle, ENT_QUOTES, $charset)."\n";
		if($coord->contact != '') $adr_liv.= htmlentities($coord->contact, ENT_QUOTES, $charset)."\n";
		if($coord->adr1 != '') $adr_liv.= htmlentities($coord->adr1, ENT_QUOTES, $charset)."\n";
		if($coord->adr2 != '') $adr_liv.= htmlentities($coord->adr2, ENT_QUOTES, $charset)."\n";
		if($coord->cp !='') $adr_liv.= htmlentities($coord->cp, ENT_QUOTES, $charset).' ';
		if($coord->ville != '') $adr_liv.= htmlentities($coord->ville, ENT_QUOTES, $charset);

	} else {
		$id_adr_liv = $id_adr_fac;
		$adr_liv = $adr_fac;
	}
	
	$comment = '';
	$comment_i = '';
	$ref = htmlentities($dev->reference, ENT_QUOTES, $charset);

	
	$form = str_replace('<!-- bouton_enr -->', $bt_enr, $form);
	$form = str_replace('<!-- bouton_val -->', $bt_val, $form);
	$form = str_replace('<!-- bouton_sup -->', $bt_sup, $form);

	$form = str_replace('<!-- frame_show -->', $frame_show_from_devis, $form);

	$form = str_replace('!!form_title!!', $titre, $form);		
	$form = str_replace('!!id_bibli!!', $id_bibli, $form);	
	$form = str_replace('!!lib_bibli!!', htmlentities($bibli->raison_sociale, ENT_QUOTES, $charset), $form);	

	//Affichage exercice
	$form = str_replace('!!id_exer!!', $exer->id_exercice, $form);
	$form = str_replace('!!lib_exer!!', htmlentities($exer->libelle, ENT_QUOTES, $charset), $form);

	$form = str_replace('!!id_cde!!', 0, $form);
	$form = str_replace('!!date_cre!!', $date_cre, $form);
	$form = str_replace('!!dat_def_lib!!', formatdate(today()), $form);
	$form = str_replace('!!dat_def!!', preg_replace('/-/', '', today()), $form);
	$form = str_replace('!!numero!!', $numero, $form);
	$form = str_replace('!!id_fou!!', $id_fou, $form);
	$form = str_replace('!!lib_fou!!', $lib_fou, $form);
	$form = str_replace('!!id_adr_fou!!', $id_adr_fou, $form);
	$form = str_replace('!!adr_fou!!', $adr_fou, $form);
	$form = str_replace('!!date_liv!!', $date_liv, $form);
	$form = str_replace('!!date_pay!!', $date_pay, $form);
	$form = str_replace('!!num_pay!!', $num_pay, $form);
	$form = str_replace('!!id_adr_liv!!', $id_adr_liv, $form);
	$form = str_replace('!!adr_liv!!', $adr_liv, $form);
	$form = str_replace('!!id_adr_fac!!', $id_adr_fac, $form);
	$form = str_replace('!!adr_fac!!', $adr_fac, $form);
	$form = str_replace('!!comment!!', $comment, $form);
	$form = str_replace('!!comment_i!!', $comment_i, $form);
	$form = str_replace('!!ref!!', $ref, $form);
	$form = str_replace('!!id_dev!!', $id_dev, $form);
	$form = str_replace('!!devise!!', $devise, $form);

	$form = str_replace('!!sugchk!!', '', $form);
				
	print $form;
}


//Vrification qu'un exercice actif existe pour cration commande
function verif_exercice($id_bibli) {
	
	global $charset;
	global $msg;
	global $dbh;
	
	$q =  entites::getCurrentExercices($id_bibli);
	$r = mysql_query($q, $dbh);
	$n = mysql_num_rows($r);
	if ($n) return $n;

	//Pas d'exercice actif pour la bibliothque
	$error_msg.= htmlentities($msg["acquisition_err_exer"],ENT_QUOTES, $charset)."<div class='row'></div>";	
	error_message($msg[321], $error_msg.htmlentities($msg["acquisition_err_par"],ENT_QUOTES, $charset), '1', './admin.php?categ=acquisition');
	die;
}


//Vrification qu'un exercice actif existe pour cration commande
function show_list_exercices($id_bibli, $fct, $url, $id_dev=0) {
	
	global $dbh;
	global $msg, $charset;
	global $current_module;
	
	$q =  entites::getCurrentExercices($id_bibli);
	$r = mysql_query($q, $dbh);
	$n = mysql_num_rows($r);
	switch ($n) {
		case 0 :
			//Pas d'exercice actif pour la bibliothque
			$error_msg.= htmlentities($msg["acquisition_err_exer"],ENT_QUOTES, $charset)."<div class='row'></div>";	
			error_message($msg[321], $error_msg.htmlentities($msg["acquisition_err_par"],ENT_QUOTES, $charset), '1', './admin.php?categ=acquisition');
			die;
			break;
		case 1 :
			//1 seul exercice actif pour la bibliotheque
			$row = mysql_fetch_object($r);
			eval($fct."(".$id_bibli.", ".$row->id_exercice.", ".$id_dev.");");
			break;
		default :
			$aff = "<form class='form-".$current_module."' id='list_exe_form' name='list_exe_form' method='post' action=\"\" >";
			$aff.= "<h3>".htmlentities($msg['acquisition_menu_chx_exe'], ENT_QUOTES, $charset)."</h3><div class='row'></div>";
			$aff.= "<table>";
			$parity=1;
			while($row=mysql_fetch_object($r)){
				if ($parity % 2) {
					$pair_impair = "even";
				} else {
					$pair_impair = "odd";
				}
				$parity += 1;
				$tr_javascript=" onmouseover=\"this.className='surbrillance'\" onmouseout=\"this.className='".$pair_impair."'\" onmousedown=\"document.forms['list_exe_form'].setAttribute('action','".$url."&id_exer=".$row->id_exercice."');document.forms['list_exe_form'].submit(); \" ";
		        $aff.= "<tr class='".$pair_impair."' ".$tr_javascript." style='cursor: pointer'><td><i>".htmlentities($row->libelle, ENT_QUOTES, $charset)."</i></td></tr>";
			}
				
			$aff.=" </table></form>";
			print $aff;
			break;
	}
}


//Solde la commande en l'tat
function sold_cde() {
	
	global $id_cde;
	
	if(!$id_cde) return;
	
	$cde = new actes($id_cde);
	
	//Commande considre comme solde
	$cde->statut = ( ($cde->statut) & (~STA_ACT_ENC) | STA_ACT_REC );
	
	//Les quantits livres sur la commande sont-elles entirement factures
	//Si oui statut commande >> factur
	$tab_cde = actes::getLignes($id_cde);
	$facture = true;
	while($row_cde = mysql_fetch_object($tab_cde)) {

		$tab_liv = lignes_actes::getLivraisons($row_cde->id_ligne);
		$tab_fac = lignes_actes::getFactures($row_cde->id_ligne);

		$nb_liv = 0;
		while($row_liv = mysql_fetch_object($tab_liv)) {
			$nb_liv = $nb_liv + $row_liv->nb;
		}

		$nb_fac = 0;
		while($row_fac = mysql_fetch_object($tab_fac)) {
			$nb_fac = $nb_fac + $row_fac->nb;
		}
		
		if ($nb_liv > $nb_fac) {
			$facture = false;
			break;
		}	
	}
	
	if ($facture) {

		$cde->statut = ($cde->statut | STA_ACT_FAC); //Pas de reste  facturer >>Statut commande = facture	

		//Si de plus toutes les factures sont payes, Statut commande=pay
		$tab_pay = liens_actes::getChilds($id_cde, TYP_ACT_FAC);
		$paye= true;
		while($row_pay = mysql_fetch_object($tab_pay)){
			if(($row_pay->statut & STA_ACT_PAY) != STA_ACT_PAY){
				$paye = false;
				break;
			}
		}
		if ($paye) $cde->statut = ($cde->statut | STA_ACT_PAY);		

	} else {

		$cde->statut = ($cde->statut & (~STA_ACT_FAC));	//Reste  facturer >>Statut commande = non facture 	

	}

	$cde->save();
}


//Archive la commande
function arc_cde(){
	global $id_cde;

	if(!$id_cde) return;
	
	$cde = new actes($id_cde);
	
	//Commande archive
	$cde->statut = ($cde->statut | STA_ACT_ARC);
	$cde->save();
	
	//Archivage des factures et bl correspondants
	$list_childs = liens_actes::getChilds($id_cde);
	while($row = mysql_fetch_object($list_childs)) {
		$act = new actes($row->num_acte_lie);
		$act->statut = ($act->statut | STA_ACT_ARC);
		$act->save();
	}
}


//Affiche la liste des bibliothques pour choix depuis suggestions
function show_list_biblio_from_sug($sugchk) {
	
	global $dbh;
	global $msg, $charset;
	global $p_user;
	global $current_module;
	
	$sugchk = rawurlencode(serialize($sugchk));

	//Affichage de la liste des bibliothques auxquelles a accs l'utilisateur
	$rb = entites::list_biblio($p_user->userid);
	
	$te = array();
	while ($rowb=mysql_fetch_object($rb)) {
		$qe =  entites::getCurrentExercices($rowb->id_entite);
		$re = mysql_query($qe, $dbh);
		while($rowe=mysql_fetch_object($re)){
			$te[$rowe->id_exercice][0]=$rowb->id_entite;
			$te[$rowe->id_exercice][1]=$rowb->raison_sociale;
			$te[$rowe->id_exercice][2]=$rowe->libelle; 
		}
 
	}

	switch (count($te)){
		case 0 :
			//Pas d'exercice actif
			$error_msg.= htmlentities($msg["acquisition_err_exer"],ENT_QUOTES, $charset)."<div class='row'></div>";	
			error_message($msg[321], $error_msg.htmlentities($msg["acquisition_err_par"],ENT_QUOTES, $charset), '1', './admin.php?categ=acquisition');
			die;
			break;

		default:

			$aff = "<form class='form-".$current_module."' id='list_biblio_form' name='list_biblio_form' method='post' action=\"\" >";
			$aff.= "<input type='hidden' id='sugchk' name='sugchk' value='".$sugchk."' />";
			$aff.= "<h3>".htmlentities($msg['acquisition_menu_chx_ent_exe'], ENT_QUOTES, $charset)."</h3><div class='row'></div>";
			$aff.= "<table>";
			$parity = 1;
			$tb = array();
			foreach($te as $key=>$value) {
				if (!in_array($value[0], $tb)) {
					
					$tb[]=$value[0];

					if ($parity % 2) {
						$pair_impair = "even";
					} else {
						$pair_impair = "odd";
					}
					$parity += 1;
					$aff.= "<tr class='".$pair_impair."' ><th>".htmlentities($value[1], ENT_QUOTES, $charset)."</th></tr>";

				}

				if ($parity % 2) {
					$pair_impair = "even";
				} else {
					$pair_impair = "odd";
				}
				$parity += 1;
				$tr_javascript=" onmouseover=\"this.className='surbrillance'\" onmouseout=\"this.className='".$pair_impair."'\" onmousedown=\"document.forms['list_biblio_form'].setAttribute('action','./acquisition.php?categ=ach&sub=cmde&action=from_sug_next&id_bibli=".$value[0]."&id_exer=".$key."');document.forms['list_biblio_form'].submit(); \" ";
				$aff.= "<tr class='".$pair_impair."' ".$tr_javascript." style='cursor: pointer' ><td><i>".htmlentities($value[2], ENT_QUOTES, $charset)."</i></td></tr>";
			}

			$aff.=" </table></form>";
			if (count($te) == '1') $aff.= "<script type='text/javascript'>document.forms['list_biblio_form'].setAttribute('action','./acquisition.php?categ=ach&sub=cmde&action=from_sug_next&id_bibli=".$value[0]."&id_exer=".$key."');document.forms['list_biblio_form'].submit();</script>";
			print $aff;
			break;		
	}

}


function show_from_sug($id_bibli, $id_exer, $sugchk) {

	global $msg;
	global $lang, $charset;
	global $cmde_modif_form, $frame_show, $frame_valid, $bt_enr, $bt_val, $bt_sup, $bt_enr_valid;
	global $popup_dat_liv, $acquisition_email_sugg, $pmb_gestion_devise;
	
	
	$sugchk = stripslashes($sugchk);

	$form = $cmde_modif_form;
	
	$titre = htmlentities($msg['acquisition_cde_cre'], ENT_QUOTES, $charset);

	$bibli = new entites($id_bibli);

	//Rcupration exercice
	$exer = new exercices($id_exer);
			
	$form = str_replace('<!-- bouton_enr -->', $bt_enr, $form);
	$form = str_replace('<!-- bouton_val -->', $bt_val, $form);
	$form = str_replace('<!-- bouton_sup -->', $bt_sup, $form);

	$coord_fac = entites::get_coordonnees($id_bibli, '1');
	if (mysql_num_rows($coord_fac) != 0) {
		$coord = mysql_fetch_object($coord_fac);
		$id_adr_fac = $coord->id_contact;
		if($coord->libelle != '') $adr_fac = htmlentities($coord->libelle, ENT_QUOTES, $charset)."\n";
		if($coord->contact != '') $adr_fac.= htmlentities($coord->contact, ENT_QUOTES, $charset)."\n";
		if($coord->adr1 != '') $adr_fac.= htmlentities($coord->adr1, ENT_QUOTES, $charset)."\n";
		if($coord->adr2 != '') $adr_fac.= htmlentities($coord->adr2, ENT_QUOTES, $charset)."\n";
		if($coord->cp !='') $adr_fac.= htmlentities($coord->cp, ENT_QUOTES, $charset).' ';
		if($coord->ville != '') $adr_fac.= htmlentities($coord->ville, ENT_QUOTES, $charset);

	} else {
		$id_adr_fac = '0';
		$adr_fac = '';
	}

	$coord_liv = entites::get_coordonnees($id_bibli, '2');
	if (mysql_num_rows($coord_liv) != 0) {
		$coord = mysql_fetch_object($coord_liv);
		$id_adr_liv = $coord->id_contact;
		if($coord->libelle != '') $adr_liv = htmlentities($coord->libelle, ENT_QUOTES, $charset)."\n";
		if($coord->contact != '') $adr_liv.= htmlentities($coord->contact, ENT_QUOTES, $charset)."\n";
		if($coord->adr1 != '') $adr_liv.= htmlentities($coord->adr1, ENT_QUOTES, $charset)."\n";
		if($coord->adr2 != '') $adr_liv.= htmlentities($coord->adr2, ENT_QUOTES, $charset)."\n";
		if($coord->cp !='') $adr_liv.= htmlentities($coord->cp, ENT_QUOTES, $charset).' ';
		if($coord->ville != '') $adr_liv.= htmlentities($coord->ville, ENT_QUOTES, $charset);

	} else {
		$id_adr_liv = $id_adr_fac;
		$adr_liv = $adr_fac;
	}
	
	$form = str_replace('!!form_title!!', $titre, $form);		
	$form = str_replace('!!id_bibli!!', $id_bibli, $form);	
	$form = str_replace('!!lib_bibli!!', htmlentities($bibli->raison_sociale, ENT_QUOTES, $charset), $form);	

	//Affichage exercice
	$form = str_replace('!!id_exer!!', $exer->id_exercice, $form);
	$form = str_replace('!!lib_exer!!', htmlentities($exer->libelle, ENT_QUOTES, $charset), $form);

	$form = str_replace('!!id_cde!!', 0, $form);
	$form = str_replace('!!date_cre!!', formatdate(today()), $form);
	$form = str_replace('!!dat_def_lib!!', formatdate(today()), $form);
	$form = str_replace('!!dat_def!!', preg_replace('/-/', '', today()), $form);
	$form = str_replace('!!numero!!', '', $form);
	$form = str_replace('!!id_fou!!', -1, $form);
	$form = str_replace('!!lib_fou!!', '', $form);
	$form = str_replace('!!id_adr_fou!!', '', $form);
	$form = str_replace('!!adr_fou!!', '', $form);
	$form = str_replace('!!date_liv!!', '', $form);
	$form = str_replace('!!date_pay!!', '', $form);
	$form = str_replace('!!num_pay!!', '', $form);
	$form = str_replace('!!id_adr_liv!!', $id_adr_liv, $form);
	$form = str_replace('!!adr_liv!!', $adr_liv, $form);
	$form = str_replace('!!id_adr_fac!!', $id_adr_fac, $form);
	$form = str_replace('!!adr_fac!!', $adr_fac, $form);
	$form = str_replace('!!comment!!', '', $form);
	$form = str_replace('!!comment_i!!', '', $form);
	$form = str_replace('!!id_dev!!', 0, $form);
	$form = str_replace('!!ref!!', '', $form);
	$form = str_replace('!!devise!!', $pmb_gestion_devise, $form);
	
	$form = str_replace('!!sugchk!!', $sugchk, $form);
 	
	print $form;
}


//Traitement des actions
print "<h1>".htmlentities($msg['acquisition_ach_ges'],ENT_QUOTES, $charset)."&nbsp;:&nbsp;".htmlentities($msg['acquisition_ach_cde'],ENT_QUOTES, $charset)."</h1>";

switch($action) {

	case 'list':
		show_list_cde($id_bibli);
		break;

	case 'modif':
		if(!$id_cde && !$id_exer) {
			$url = "./acquisition.php?categ=ach&sub=cmde&action=modif&id_bibli=".$id_bibli."&id_cde=0";
			show_list_exercices($id_bibli, 'show_form_cde', $url, 0);
		} else {
			show_form_cde($id_bibli, $id_exer, $id_cde);
		}
		break;

	case 'delete' :
		actes::delete($id_cde);
		liens_actes::delete($id_cde);
		show_list_cde($id_bibli);
		break;

	case 'update' :
		$cde = new actes($id_cde);
		$cde->commentaires = $comment_Child;
		$cde->reference = $ref;
		$cde->date_paiement = extraitdate($date_pay);
		$cde->num_paiement = $num_pay;
		$cde->save();
		show_list_cde($id_bibli);
		break;

	case 'from_devis' :
		if (!$id_exer) {
			$url = "./acquisition.php?categ=ach&sub=cmde&action=from_devis&id_bibli=".$id_bibli."&id_dev=".$id_dev;
			show_list_exercices($id_bibli, 'show_from_devis', $url, $id_dev);
		} else {
			show_from_devis($id_bibli, $id_exer, $id_dev);
		}
		break; 
		
	case 'from_sug' :
		show_list_biblio_from_sug($chk);
		break; 

	case 'from_sug_next' :
		show_from_sug($id_bibli, $id_exer, $sugchk);
		break; 

	case 'sold':
		sold_cde();
		$statut = STA_ACT_REC;
		show_list_cde($id_bibli);
		break;		

	case 'arc':
		arc_cde();
		$statut = STA_ACT_ARC;
		show_list_cde($id_bibli);
		break;		

	default:
		show_list_biblio();	
		break;
		
}
?>
