<?php
// +-------------------------------------------------+
//  2002-2004 PMB Services / www.sigb.net pmb@sigb.net et contributeurs (voir www.sigb.net)
// +-------------------------------------------------+
// $Id: suggestions.inc.php,v 1.27 2007/09/07 09:30:37 dbellamy Exp $

if (stristr($_SERVER['REQUEST_URI'], ".inc.php")) die("no access");

//URL de retour du form de cration/modification de suggestion
$back_url = './acquisition.php?categ=sug&action=list';

require_once($base_path.'/acquisition/suggestions/func_suggestions.inc.php');
require_once($class_path.'/suggestions_map.class.php');

if ($acquisition_sugg_display) {
	require_once($acquisition_sugg_display);
} else {
	require_once('suggestions_display.inc.php');
}

$sug_map = new suggestions_map();

//Traitement des transitions
if ($transition) {
	$sug_map->doTransition($transition, $chk);

	if ($sug_map->getState_DISPLAY($transition)!='NO') {
		$statut = $sug_map->getState_ID($transition);
	} else {
		$statut=-1;
	}
}

//Traitement des changements de categories
if ($acquisition_sugg_categ== '1' && $action == 'to_categ') {
	$sug_map->changeCateg($chk, $to_categ);
}


//Traitement des actions
print "<h1>".htmlentities($msg['acquisition_sug_ges'],ENT_QUOTES, $charset)."</h1>";

switch($action) {

	case 'list':
		show_list_sug();
		break;

	case 'modif':
		$update_action ="./acquisition.php?categ=sug&action=update&id_bibli=".$id_bibli."&id_sug=".$id_sug;
		show_form_sug($update_action);
		break;
	
	case 'update' :
		update_sug();
		show_list_sug();
		break;

	case 'delete' :
		sup_sug();
		show_list_sug();
		break;

	case 'fusChk':
		sug_fusChk();
		break;

	case 'fusVal':
		sug_fusVal();
		show_list_sug();
		break;

	case 'catalog':
		update_sug();
		include($base_path.'/acquisition/suggestions/notice_form.inc.php');
		break;		
		
	case 'upd_notice':
		include($base_path.'/acquisition/suggestions/update_notice.inc.php');
		$update_action ="./acquisition.php?categ=sug&action=update&id_bibli=".$id_bibli."&id_sug=".$id_sug;
		show_form_sug($update_action);
		break;		

	default:
		show_list_sug();	
		break;
		
}

?>

