<?php
// +-------------------------------------------------+
//  2002-2004 PMB Services / www.sigb.net pmb@sigb.net et contributeurs (voir www.sigb.net)
// +-------------------------------------------------+
// $Id: export.class.php,v 1.22 2007/05/03 09:39:25 touraine37 Exp $

if (stristr($_SERVER['REQUEST_URI'], ".class.php")) die("no access");

//Export d'une notice PMB en XML PMB MARC

// le fichier spcifique d'import contient la fonction d'export spcifique des exemplairess
if (!$pmb_import_modele)  $pmb_import_modele= "func_bdp.inc.php" ;
require_once ("$base_path/admin/import/$pmb_import_modele") ;

class export {

	var $notice;
	var $xml_array = array();
	var $notice_list = array();
	var $current_notice = 0;
	
	//Initialisation avec une liste de numros de notices (si liste vide alors on prend toute la base)
	function export($l_idnotices) {

		if (is_array($l_idnotices)) {
			$this -> notice_list = $l_idnotices;
		} else {
			if ($l_idnotices != "") {
				$this -> notice_list[] = $l_idnotices;
			} else {
				$requete = "select distinct notice_id from notices";
				$resultat = mysql_query($requete);
				while ($res = mysql_fetch_object($resultat)) {
					$this -> notice_list[] = $res -> notice_id;
				}
			}
		}
	}
	
	//Conversion au format XML du tableau de donnes
	function toxml() {
		$this -> notice = "<notice>\n";
		//Record descriptor
		$desc=array("rs","dt","bl","hl","el","ru");
		for ($i=0; $i<count($desc); $i++) {
			$this->notice.="  <".$desc[$i].">";
			if ($this->xml_array[$desc[$i]]["value"]=="") $this->xml_array[$desc[$i]]["value"]="*";
			$this->notice.=$this->xml_array[$desc[$i]]["value"]."</".$desc[$i].">\n";
		}
		for ($i = 0; $i < count($this -> xml_array["f"]); $i ++) {
			$this -> notice.= "  <f c=\"".$this -> xml_array["f"][$i]["c"]."\" ";
			if ($this -> xml_array["f"][$i][value] == "") {
				$this -> notice.= "ind=\"".$this -> xml_array["f"][$i]["ind"]."\"";
			}
			$this -> notice.= ">";
			if ($this -> xml_array["f"][$i]["value"] == "") {
				$this->notice.="\n";
				for ($j = 0; $j < count($this -> xml_array["f"][$i]["s"]); $j ++) {
					$this -> notice.= "    <s c=\"".$this -> xml_array["f"][$i]["s"][$j]["c"]."\">".htmlspecialchars($this -> xml_array["f"][$i]["s"][$j]["value"])."</s>\n";
				}
				$this->notice.="  ";
			} else {
				$this -> notice.=htmlspecialchars($this -> xml_array["f"][$i]["value"]);
			}

			$this -> notice.= "</f>\n";
		}
		$this -> notice.= "</notice>\n";
	}
	
	//Ajout d'un champ dans le tableau de donnes
	function add_field($field_code, $field_ind, $sub_fields, $value = "") {
		$f_ = array();
		$f_["c"] = $field_code;
		if ($field_ind)
			$f_["ind"] = $field_ind;
		if ($value == "") {
			$flag_s = 0;
			while (list ($key, $val) = each($sub_fields)) {
				if ($val) {
					$s = array();
					$s["c"] = $key;
					$s["value"] = $val;
					$f_["s"][] = $s;
					$flag_s = 1;
				}
			}
		} else {
			$f_["value"] = $value;
			$flag_s = 1;
		}
		if ($flag_s)
			$this -> xml_array["f"][] = $f_;
	}

	//Gnration XML de la prochaine notice (renvoi true si prochaine notice, false si plus de notices disponibles)
	function get_next_notice($lender = "", $td = array(), $sd = array(), $keep_expl = false) {
		global $is_expl_caddie;
		
		if (!$is_expl_caddie)  {
			$requete_panier="select count(*) from expl_cart_id";
			$res_panier=@mysql_query($requete_panier);
			if ($res_panier) $is_expl_caddie=2; else $is_expl_caddie=1;
		}
		
		unset($this->xml_array);
		$this -> xml_array = array();
		$this -> notice = "";

		if ($this -> current_notice != -1) {
						
			//Rcupration des infos de la notice
			$requete = "select * from notices where notice_id=".$this -> notice_list[$this -> current_notice];
			$resultat = mysql_query($requete);
			$res = mysql_fetch_object($resultat);
			
			//Remplissage des champs immdiats

			//Numro unique de la base
			$this -> add_field("001", "", "", $res -> notice_id);
			
			//Champ de traitement
			$c100=date("Ymd")."u        u  u0frey0103    ba";
			$this-> add_field("100","  ",array("a"=>$c100),"");
			
			//Titre
			$titre[c] = "200";
			$titre[ind] = "1 ";
			$labels = array("a", "c", "d", "e");
			$subfields = array();
			for ($i = 1; $i < 5; $i ++) {
				eval("\$v=\$res->tit$i;");
				$subfields[$labels[$i -1]] = $v;
			}
			$this -> add_field("200", "1 ", $subfields);
			
			//isbn
			$subfields = array();
			$subfields["a"] = $res -> code;
			$subfields["d"] = $res -> prix;
			$this -> add_field("010", "  ", $subfields);

			// URL
			$subfields = array();
			$subfields["u"] = $res -> lien;
			$subfields["q"] = $res -> eformat;
			$this -> add_field("856", "  ", $subfields);

			$rqttmp_lang = "select code_langue from notices_langues where num_notice='$res->notice_id' and type_langue=0 ";
			$restmp_lang = mysql_query($rqttmp_lang);
			if ($tmp_lang = mysql_fetch_object($restmp_lang)) $res -> lang_code = $tmp_lang->code_langue ; 

			$rqttmp_lang = "select code_langue from notices_langues where num_notice='$res->notice_id' and type_langue=1 ";
			$restmp_lang = mysql_query($rqttmp_lang);
			if ($tmp_lang = mysql_fetch_object($restmp_lang)) $res -> org_lang_code = $tmp_lang->code_langue ; 
			
			//Langage
			if ($res -> lang_code && $res -> org_lang_code)
				$ind = "1 ";
			else
				$ind = "0 ";
			$subfields = array();
			$subfields["a"] = $res -> lang_code;
			$subfields["c"] = $res -> org_lang_code;
			$this -> add_field("101", $ind, $subfields);
			
			//Collation
			$subfields = array();
			$subfields["a"] = $res -> npages;
			$subfields["c"] = $res -> ill;
			$subfields["d"] = $res -> size;
			$subfields["e"] = $res -> accomp;
			
			$this -> add_field("215", "  ", $subfields);
	
			//Notes
			$subfields = array();
			$subfields["a"] = $res -> n_gen;
			$this -> add_field("300", "  ", $subfields);
			$subfields["a"] = $res -> n_contenu;
			$this -> add_field("327", "  ", $subfields);
			$subfields["a"] = $res -> n_resume;
			$this -> add_field("330", "  ", $subfields);
			
			//Auteurs
			
			//Recherche des auteurs;
			$requete = "select author_type, author_name, author_rejete, author_date, responsability_fonction, responsability_type from authors, responsability where responsability_notice=".$res->notice_id." and responsability_author=author_id";
			$resultat = mysql_query($requete);
			
			$subfields = array();
			
			while ($auth=mysql_fetch_object($resultat)) {
				//Si c'est un 70 (individuel) ou 71 (collectif) alors on l'exporte
				if (($auth->author_type == "70")||($auth->author_type == "71")) {
					//Champ = author_type + responsability_type (70 + 0 pour auteur principal = 700 !)
					$auth_code = $auth->author_type.$auth->responsability_type;
					$subfields["a"] = $auth->author_name;
					$subfields["b"] = $auth->author_rejete;
					//Fonction
					$subfields["4"] = $auth->responsability_fonction;
					//Dates
					if ($auth->author_date!="") {
						$subfields["f"] = $auth->author_date ;
					}
					$this->add_field($auth_code," 1", $subfields);
				}
			}
			
			//Editeurs
			$requete = "select * from publishers where ed_id =".$res -> ed1_id;
			$resultat = mysql_query($requete);
			$subfields = array();
			if ($ed1 = mysql_fetch_object($resultat)) {
				$subfields["c"] = $ed1 -> ed_name;
				$subfields["a"] = $ed1 -> ed_ville;
				$subfields["d"] = $res -> year;
			}
			$this -> add_field("210", "  ", $subfields);

			$requete = "select * from publishers where ed_id =".$res -> ed2_id;
			$resultat = mysql_query($requete);
			$subfields = array();
			if ($ed1 = mysql_fetch_object($resultat)) {
				$subfields["c"] = $ed1 -> ed_name;
				$subfields["a"] = $ed1 -> ed_ville;
				$subfields["d"] = $res -> year;
			}
			$this -> add_field("210", "  ", $subfields);

			//Collections
			$requete = "select * from collections where collection_id=".$res -> coll_id;
			$resultat = mysql_query($requete);
			$subfields = array();
			$subfields_410 = array();
			$subfields_411 = array();
			$subfields_s = array();
			if ($col = mysql_fetch_object($resultat)) {
				$subfields["a"] = $col -> collection_name;
				$subfields_410["t"] = $col -> collection_name;
				$subfields["v"] = $res -> nocoll;
				$subfields["x"] = $col -> collection_issn;
			}
			//Recherche des sous collections
			$requete = "select * from sub_collections where sub_coll_id=".$res -> subcoll_id;
			$resultat = mysql_query($requete);
			if ($subcol = mysql_fetch_object($resultat)) {
				$subfields_s["i"] = $subcol -> sub_coll_name;
				$subfields_411["t"] = $subcol -> sub_coll_name;
				$subfields_s["x"] = $subcol -> sub_coll_issn;
			}

			$this -> add_field("225", "2 ", $subfields);
			$this -> add_field("410", " 0", $subfields_410);
			$this -> add_field("225", "2 ", $subfields_s);
			$this -> add_field("411", " 0", $subfields_411);

			$requete = "select * from series where serie_id=".$res -> tparent_id;
			$resultat = mysql_query($requete);
			$subfields = array();
			if ($serie = mysql_fetch_object($resultat)) {
				$subfields["t"] = $series -> serie_name;
				$subfields["v"] = $res -> tnvol;
			}
			$this -> add_field("461", " 0", $subfields);

			//dewey
			$subfields = array();
			//Recher du code dewey
			$requete = "select * from indexint where indexint_id=".$res -> indexint;
			$resultat = mysql_query($requete);
			if ($code_dewey=mysql_fetch_object($resultat)) {
				$subfields["a"] = $code_dewey -> indexint_name;
				$this -> add_field("676", "  ", $subfields);
			}

			if ($keep_expl) {
				//Traitement des exemplaires
				$requete = "select expl_cb,expl_cote,expl_statut,statut_libelle, statusdoc_codage_import, expl_typdoc, tdoc_libelle, tdoc_codage_import, expl_note, expl_section, section_libelle, sdoc_codage_import, expl_owner, lender_libelle, codestat_libelle, statisdoc_codage_import, expl_date_retour, expl_date_depot, expl_note, pret_flag, location_libelle, locdoc_codage_import from exemplaires, docs_statut, docs_type, docs_section, docs_codestat, lenders, docs_location".($is_expl_caddie==2?",expl_cart_id":"")." where expl_notice=".$res -> notice_id." and expl_statut=idstatut and expl_typdoc=idtyp_doc and expl_section=idsection and expl_owner=idlender and expl_codestat=idcode and expl_location=idlocation".($is_expl_caddie==2?" and expl_id=id":"");
				if (($lender != "x")&&($lender!=""))
					$requete.= " and expl_owner=".$lender;
				if (count($td) != 0)
					$requete.= " and expl_typdoc in (".implode(",", $td).")";
				if (count($sd) != 0)
					$requete.= " and expl_statut in (".implode(",", $sd).")";
				$resultat = mysql_query($requete);
				while ($ex = mysql_fetch_object($resultat)) {
					$subfields = array();
					global $export996 ;
					$export996 = array() ;
					$subfields = export_traite_exemplaires ($ex);
					$this -> add_field("995", "  ", $subfields);
					if (count($export996) != 0) $this -> add_field("996", "  ", $export996);
				}
			}

			//Mots cles
			$subfields = array();
			$subfields["a"] = $res -> index_l;
			$this -> add_field("610", "0 ", $subfields);

			//Descripteurs
			$requete="select libelle_categorie from categories, notices_categories where notcateg_notice=".$res->notice_id." and categories.num_noeud = notices_categories.num_noeud";
			$resultat=mysql_query($requete);
			if (mysql_num_rows($resultat)) {
	  			for ($i=0; $i<mysql_num_rows($resultat); $i++) {
	  				$subfields=array();
	  				$subfields["a"]=mysql_result($resultat,$i);
	  				$this -> add_field("606"," 1",$subfields);
				}
			}
			
			//Record field
			$this->xml_array['rs']['value']="n";
			$this->xml_array['dt']['value']=$res->typdoc;
			$this->xml_array['bl']['value']=$res->niveau_biblio;
			$this->xml_array['hl']['value']="*";
			$this->xml_array['el']['value']=1;
			$this->xml_array['ru']['value']="i";
			$this -> toxml();
			$this -> current_notice++;
			if ($this -> current_notice >= count($this -> notice_list))
				$this -> current_notice = -1;
			return true;
		} else {
			$this -> current_notice = -1;
			return false;
		}
	}
}
?>
