<?php
// +-------------------------------------------------+
//  2002-2004 PMB Services / www.sigb.net pmb@sigb.net et contributeurs (voir www.sigb.net)
// +-------------------------------------------------+
// $Id: expl.inc.php,v 1.20 2007/10/03 15:00:34 gueluneau Exp $

if (stristr($_SERVER['REQUEST_URI'], ".inc.php")) die("no access");

// accs  une notice par code-barre, ISBN, ou numro commercial ou  par CB exemplaire

// on commence par voir ce que la saisie utilisateur est ($ex_query)
$ex_query = clean_string($ex_query);

$EAN = '';
$isbn = '';
$code = '';

function f_rellena_ceros($as_dato) {
	if(strlen($as_dato)>0 && strlen($as_dato)<9){
		for($i=strlen($as_dato); $i<9; $i++)
			$as_dato="0".$as_dato;}
	
	return $as_dato; 
	
}

if(isEAN($ex_query)) {
	// la saisie est un EAN -> on tente de le formater en ISBN
	$EAN=$ex_query;
	$isbn = EANtoISBN($ex_query);
	// si chec, on prend l'EAN comme il vient
	if(!$isbn) 
		$code = str_replace("*","%",$ex_query);
	else {
		$code=$isbn;
		$code10=formatISBN($code,10);
	}
} else {
	if(isISBN($ex_query)) {
		// si la saisie est un ISBN
		$isbn = formatISBN($ex_query);
		// si chec, ISBN erron on le prend sous cette forme
		if(!$isbn) 
			$code = str_replace("*","%",$ex_query);
		else {
			$code10=$isbn ;
			$code=formatISBN($code10,13);
		}
	} else {
		// ce n'est rien de tout a, on prend la saisie telle quelle
		$code = str_replace("*","%",$ex_query);
	}
}

// echo "EAN : $EAN<br> isbn : $isbn<br>code : $code<br>";

if ($EAN && $isbn) {
	// cas des EAN purs : constitution de la requte
	$requete = "SELECT distinct notices.* FROM (notices left join exemplaires on notices.notice_id=exemplaires.expl_notice)";
	$requete .= " WHERE niveau_biblio='m' AND (exemplaires.expl_cb like '$code' OR exemplaires.expl_cb='$ex_query' OR notices.code in ('$code','$EAN'".($code10?",'$code10'":"").")) limit 10";
	$myQuery = mysql_query($requete, $dbh);
} elseif ($isbn) {
	// recherche d'un isbn
	$requete = "SELECT distinct notices.* FROM (notices left join exemplaires on notices.notice_id=exemplaires.expl_notice)";
	$requete .= " WHERE niveau_biblio='m' AND (exemplaires.expl_cb like '$code' OR exemplaires.expl_cb='$ex_query' OR notices.code in ('$code'".($code10?",'$code10'":"").")) limit 10";
	$myQuery = mysql_query($requete, $dbh);
} elseif ($code) {
	// recherche d'un exemplaire
	// note : le code est recherch aussi dans le champ code des notices
	// (cas des code-barres disques qui chappent  l'EAN)
	//
	$requete = "SELECT distinct notices.* FROM (notices left join exemplaires on notices.notice_id=exemplaires.expl_notice)";
	$requete .= " WHERE niveau_biblio='m' AND (exemplaires.expl_cb like '$code' OR notices.code like '$code') limit 10";
	$myQuery = mysql_query($requete, $dbh);

	if(mysql_num_rows($myQuery)==0) {
		$requete = "SELECT distinct notices.* FROM (notices left join exemplaires on notices.notice_id=exemplaires.expl_notice)";
		$requete .= " WHERE niveau_biblio='m' AND (exemplaires.expl_cb like '".f_rellena_ceros($code)."' OR notices.code like '".f_rellena_ceros($code)."') limit 10";
		$myQuery = mysql_query($requete, $dbh);
	}

	if(mysql_num_rows($myQuery)==0) {
		// rien trouv en monographie
		$requete = 'SELECT distinct notices.*, bulletin_id FROM notices left join bulletins on bulletin_notice=notice_id left join exemplaires on (bulletin_id=expl_bulletin and expl_notice=0) ';
		$requete .= " WHERE niveau_biblio='s' AND (exemplaires.expl_cb like '$code' OR bulletin_numero like '$code' OR bulletin_cb like '$code' OR notices.code like '$code') ";
		$requete .= " GROUP BY bulletin_id limit 10";
		$rqt_bulletin=1;
	}
} else {
	error_message($msg[235], $msg[307]." $ex_query", 1, "./catalog.php?categ=search&mode=0");
	die();
}

if ($rqt_bulletin!=1) {
	if(mysql_num_rows($myQuery)) {
		if(mysql_num_rows($myQuery) > 1) {
			// la recherche fournit plusieurs rsultats !!!
			// boucle de parcours des notices trouves
			// inclusion du javascript de gestion des listes dpliables
			// dbut de liste
			print $begin_result_liste;
			while($notice = mysql_fetch_object($myQuery)) {
				if($notice->niveau_biblio != 's' && $notice->niveau_biblio != 'a') {
					// notice de monographie (les autres n'ont pas de code ni d'exemplaire !!! ;-)
					$link = './catalog.php?categ=isbd&id=!!id!!';
					$link_expl = './catalog.php?categ=edit_expl&id=!!notice_id!!&cb=!!expl_cb!!&expl_id=!!expl_id!!'; 
					$link_explnum = './catalog.php?categ=edit_explnum&id=!!notice_id!!&explnum_id=!!explnum_id!!';   
					$display = new mono_display($notice, 6, $link, 1, $link_expl, '', $link_explnum,1);
					print pmb_bidi($display->result);
					}
				}
			print $end_result_liste;
			} else {
				$notice = mysql_fetch_object($myQuery);
				print "<div class=\"row\"><div class=\"msg-perio\">".$msg[recherche_encours]."</div></div>";
				// un seul rsultat : je balance le user direct sur la notice concerne
				print "<script type=\"text/javascript\">";
				print "document.location = \"./catalog.php?categ=isbd&id=".$notice->notice_id."\"";
				print "</script>";
				}
		} else {
			error_message($msg[235], $msg[307]." $ex_query", 1, "./catalog.php?categ=search&mode=0");
			}
	} else {
		// C'est un prio !
		$res = @mysql_query($requete, $dbh);
		if (mysql_num_rows($res)) {
			print $begin_result_liste;
			while(($n=mysql_fetch_object($res))) {
				$link_serial = "./catalog.php?categ=serials&sub=view&serial_id=!!id!!";
				$link_analysis = "";
				$link_bulletin = "";
				require_once ("$include_path/bull_info.inc.php") ;
				require_once ("$class_path/serials.class.php") ;
				$n->isbd = show_bulletinage_info($n->bulletin_id);
				print pmb_bidi($n->isbd) ;

				}	
			print $end_result_liste;
			} else {
				error_message($msg[235], $msg[307]." $ex_query", 1, "./catalog.php?categ=search&mode=0");   
				}
		}
