<?php

echo "<style type='text/css'>
<!--
pre
{
 color: #000;
 background-color: #f0f0f0;
}
.resultat
{
 font-style: italic;
 font-size: 0.9em;
}
-->
</style>
<h2>Programmation oriente objet&nbsp;: illustration de la notion d'hritage en PHP</h2>
<b>Franois Lemarchand <balno@users.sourceforge.net>. 2003. Projet PMB</b><hr>
<h3>code PHP des classes d'exemple</h3>
<p>
<b>Classe 'parent'</b>
<pre>
class parent
{
      var \$nom_parent = '';
      // constructeur
      function parent(\$value='le parent') {
               \$this->nom_parent = \$value;
      }
      // une mthode
      function parent_modif() {
               \$this->nom_parent .= '. modifi';
      }
}
</pre>
</p>
<p>
<b>Classe 'enfant'</b>
<pre>
class enfant extends parent {
      var \$nom_enfant = '';
      // constructeur
      function enfant(\$value='enfant'){
         \$this->nom_enfant=\$value;
      }
      // une mthode
      function enfant_modif() {
               \$this->nom_enfant.= '. modifi';
      }
}
</pre>
</p>
";

class parent
{
      var $nom_parent = '';
      // constructeur
      function parent($value='le parent') {
               $this->nom_parent = $value;
      }
      // une mthode
      function parent_modif() {
               $this->nom_parent .= '. modifi';
      }
}

class enfant extends parent {
      var $nom_enfant = '';
      // constructeur
      function enfant($value='enfant'){
         $this->nom_enfant=$value;
      }
      // une mthode
      function enfant_modif() {
               $this->nom_enfant.= '. modifi';
      }
}


// test des classes

echo "
<h3>La notion d'hritage par l'exemple</h3>
<table border=\"1\"><tr><td>";
echo "cration d'une instance de <b>parent</b><hr>";

$monParent = new parent();

echo "<pre>\$monParent = new parent();</pre>";
echo "<div class='resultat'>rsultat</div>";
echo 'monParent->nom_parent = '.$monParent->nom_parent;
echo "<hr><u>appel d'une mthode de la classe</u>";

$monParent->parent_modif();

echo "<pre>\$monParent->parent_modif();</pre>";
echo "<div class='resultat'>rsultat</div>";
echo 'monParent->nom_parent = '.$monParent->nom_parent;
echo '</td><td>';
echo "cration d'une instance de <b>enfant</b><hr>";

$monEnfant = new enfant();

echo "<pre>\$monEnfant = new enfant();</pre>";
echo "<div class='resultat'>rsultat</div>";
echo 'monEnfant->nom_enfant = '.$monEnfant->nom_enfant;
echo "<hr><u>appel d'une mthode de la classe</u>";

$monEnfant->enfant_modif();
echo "<pre>\$monEnfant->enfant_modif();</pre>";
echo "<div class='resultat'>rsultat</div>";
echo 'monEnfant->nom_enfant = '.$monEnfant->nom_enfant;
echo "</td></tr><tr><th colspan=\"2\">";
echo "on vient de voir que les classes fonctionnent de manire autonome";
echo '</th></tr></table>';

echo "<h4>Illustration de la notion d'hritage</h4>";
echo "<p>on cre une instance de la classe <b>enfant</b>.</p>";

$monEnfantHerit = new enfant("enfant nouveau");

echo "<pre>\$monEnfantHerit = new enfant(\"enfant nouveau\");</pre>";
echo "<div class='resultat'>rsultat</div>monEnfantHerit->nom_enfant = ";
echo $monEnfantHerit->nom_enfant;
echo "<p>appel d'une mthode de la classe <b>enfant</b>.</p>";

$monEnfantHerit->enfant_modif();

echo "<pre>\$monEnfantHerit->enfant_modif();</pre>";
echo "<div class='resultat'>rsultat</div>monEnfantHerit->nom_enfant = ";
echo $monEnfantHerit->nom_enfant;
echo "<p>La classe <b>enfant</b> hrite de la classe <b>parent</b> au niveau
des mthodes et des proprits. On peut donc mettre  jour la proprit <i>nom_parent</i>
 de <b>monEnfantHerit</b>&nbsp;:</p>";

$monEnfantHerit->parent("parent de cet enfant");

echo "<pre>\$monEnfantHerit->parent(\"parent de cet enfant\");</pre>";
echo "<div class='resultat'>rsultat</div>monEnfantHerit->nom_parent = ";
echo $monEnfantHerit->nom_parent;
echo "<p>Et mme appeler une mthode de la classe <b>parent</b> via une instance
de la classe <b>enfant</b>&nbsp;:</p>";

$monEnfantHerit->parent_modif();
echo "<pre>\$monEnfantHerit->parent_modif();</pre>";
echo "<div class='resultat'>rsultat</div>monEnfantHerit->nom_parent = ";
echo $monEnfantHerit->nom_parent."</p>";



?>

