<?php
// +-------------------------------------------------+
//  2002-2004 PMB Services / www.sigb.net pmb@sigb.net et contributeurs (voir www.sigb.net)
// +-------------------------------------------------+
// $Id: author.class.php,v 1.31 2007/06/05 13:15:10 jlesaint Exp $

if (stristr($_SERVER['REQUEST_URI'], ".class.php")) die("no access");

// dfinition de la classe de gestion des 'auteurs'
if ( ! defined( 'AUTEUR_CLASS' ) ) {
  define( 'AUTEUR_CLASS', 1 );
  
require_once($class_path."/notice.class.php");

class auteur {
	
	// ---------------------------------------------------------------
	//		proprits de la classe
	// ---------------------------------------------------------------
	
	var $id;		// MySQL id in table 'authors'
	var $type;		// author type (70 or 71)
	var $name;		// author name
	var $rejete;		// author name (rejected element)
	var $date;		// dates
	var $author_web;	// web de l'auteur
	var $author_web_link;	// lien web de l'auteur
	var $see;		// 'see' author MySQL id
	var $see_libelle;	// printable form of 'see' author (in fact 'display' of retained form)
	var $display;		// usable form for displaying ( _name_, _rejete_ (_date1_-_date2_) )
	var $isbd_entry;	// isbd like version ( _rejete_ _name_ (_date1_-_date2_))
	var $isbd_entry_lien_gestion ; // lien sur le nom vers la gestion
	var $author_comment ; // Commentaire, peut contenir du HTML
	
	// ---------------------------------------------------------------
	//		auteur($id) : constructeur
	// ---------------------------------------------------------------
	function auteur($id=0) {
		// echo "AUTHOR.CLASS $id<br>" ;
		if($id) {
			// on cherche  atteindre une notice existante
			$this->id = $id;
			$this->getData();
			} else {
				// la notice n'existe pas
				$this->id = 0;
				$this->getData();
				}
		}
	
	// ---------------------------------------------------------------
	//		getData() : rcupration infos auteur
	// ---------------------------------------------------------------
	function getData() {
		global $dbh;
		if(!$this->id) {
			// pas d'identifiant.
			$this->id		= 0;
			$this->type		= '';
			$this->name		= '';
			$this->rejete		= '';
			$this->date		= '';
			$this->author_web	= '';
			$this->see		= '';
			$this->see_libelle	= '';
			$this->display		= '';
			$this->isbd_entry	= '';
			$this->author_comment	= '';
			} else {
				$requete = "SELECT * FROM authors WHERE author_id=$this->id LIMIT 1 ";
				$result = @mysql_query($requete, $dbh);
				if(mysql_num_rows($result)) {
					$temp = mysql_fetch_object($result);
					mysql_free_result($result);
					$this->id		= $temp->author_id;
					$this->type		= $temp->author_type;
					$this->name		= $temp->author_name;
					$this->rejete		= $temp->author_rejete;
					$this->date		= $temp->author_date;
					$this->author_web	= $temp->author_web;
					$this->see		= $temp->author_see;
					$this->author_comment	= $temp->author_comment	;
	
					if($temp->author_rejete) {
						$this->isbd_entry = "$temp->author_rejete $temp->author_name";
						$this->display = "$temp->author_name, $temp->author_rejete";
					} else {
						$this->isbd_entry = $temp->author_name;
						$this->display = $temp->author_name;
					}
					
					// Ajoute un lien sur la fiche auteur si l'utilisateur  accs aux autorits
					if (SESSrights & AUTORITES_AUTH) $this->isbd_entry_lien_gestion = "<a href='./autorites.php?categ=auteurs&sub=author_form&id=".$this->id."' class='lien_gestion'>".$this->display."</a>";
						else $this->isbd_entry_lien_gestion = $this->display;
	
					if($temp->author_date) {
						$this->isbd_entry .= ' ('.$temp->author_date.')';
						}
						
					if($temp->author_web) $this->author_web_link = " <a href='$temp->author_web' target=_blank><img src='./images/globe.gif' border=0 /></a>";
						else $this->author_web_link = "" ;
						
					if($temp->author_see) {
						$see = new auteur($temp->author_see);
						$this->see_libelle = $see->display;
						} else {
							$this->see_libelle = '';
							}
					} else {
						// pas d'auteur avec cette cl
						$this->id		= 0;
						$this->type		= '';
						$this->name		= '';
						$this->rejete		= '';
						$this->date		= '';
						$this->author_web	= '';
						$this->see		= '';
						$this->see_libelle	= '';
						$this->display		= '';
						$this->isbd_entry	= '';
						$this->author_web_link = "" ;
						$this->author_comment	= '';
						}
				}
		}
	
	// ---------------------------------------------------------------
	//		show_form : affichage du formulaire de saisie
	// ---------------------------------------------------------------
	function show_form() {
	
		global $msg;
		global $author_form;
		global $dbh;
		global $charset;
		
		$liste_renvoyes = "";
		if($this->id) {
			$action = "./autorites.php?categ=auteurs&sub=update&id=$this->id";
			$libelle = $msg[199];
			$button_remplace = "<input type='button' class='bouton' value='$msg[158]' ";
			$button_remplace .= "onclick='document.location=\"./autorites.php?categ=auteurs&sub=replace&id=$this->id\"'>";
			
			$button_voir = "<input type='button' class='bouton' value='$msg[voir_notices_assoc]' ";
			$button_voir .= "onclick='document.location=\"./catalog.php?categ=search&mode=0&etat=aut_search&aut_id=$this->id\"'>";
			
			$button_delete = "<input type='button' class='bouton' value='$msg[63]' ";
			$button_delete .= "onClick=\"confirm_delete();\">";
			
			$requete = "SELECT * FROM authors WHERE ";
			$requete .= "author_see = '$this->id' ";
			$requete .= "ORDER BY author_name, author_rejete ";
			$res = @mysql_query($requete, $dbh);
			$nbr_lignes = mysql_num_rows($res);
			if ($nbr_lignes) {
				$liste_renvoyes = "<br /><div class='row'><h3>$msg[aut_list_renv_titre]</h3><table>" ;
				$parity=1;
				while(($author_renvoyes=mysql_fetch_object($res))) {
					$author_renvoyes->author_name = $author_renvoyes->author_name;
					$author_renvoyes->author_rejete = $author_renvoyes->author_rejete;
					if($author_renvoyes->author_rejete) $author_entry = $author_renvoyes->author_name.',&nbsp;'.$author_renvoyes->author_rejete;
						else $author_entry = $author_renvoyes->author_name;
					if($author_renvoyes->author_date)
						$author_entry .= "&nbsp;($author_renvoyes->author_date)";
					$link_auteur = "./autorites.php?categ=auteurs&sub=author_form&id=$author_renvoyes->author_id";
					if ($parity % 2) {
						$pair_impair = "even";
						} else {
							$pair_impair = "odd";
							}
					$parity += 1;
						$tr_javascript=" onmouseover=\"this.className='surbrillance'\" onmouseout=\"this.className='$pair_impair'\" onmousedown=\"document.location='$link_auteur';\" ";
							$liste_renvoyes .= "<tr class='$pair_impair' $tr_javascript style='cursor: pointer'>
										<td valign='top'>
									$author_entry
									</td>
								</tr>";
						
					} // fin while
				$liste_renvoyes .= "</table></div>";  
				}
			} else {
				$action = './autorites.php?categ=auteurs&sub=update&id=';
				$libelle = $msg[207];
				$button_remplace = '';
				$button_delete ='';
				}
	
		// mise  jour de la zone type
		switch($this->type) {
			case 71:
				$sel_coll = " SELECTED";
				break;
			default:
				$sel_pp = " SELECTED";
				break;
			}
	
		$author_form = str_replace('!!id!!',						$this->id,															$author_form);
		$author_form = str_replace('!!action!!',					$action,															$author_form);
		$author_form = str_replace('!!libelle!!',					$libelle,															$author_form);
		$author_form = str_replace('!!author_nom!!',				htmlentities($this->name,ENT_QUOTES, $charset),						$author_form);
		$author_form = str_replace('!!author_rejete!!',				htmlentities($this->rejete,ENT_QUOTES, $charset),					$author_form);
		$author_form = str_replace('!!voir_id!!',					$this->see,															$author_form);
		$author_form = str_replace('!!voir_libelle!!',				htmlentities($this->see_libelle,ENT_QUOTES, $charset),	$author_form);
		$author_form = str_replace('!!date!!',						htmlentities($this->date,ENT_QUOTES, $charset),						$author_form);
		$author_form = str_replace('!!author_web!!',				htmlentities($this->author_web,ENT_QUOTES, $charset),				$author_form);
		$author_form = str_replace('!!sel_pp!!',					$sel_pp,															$author_form);
		$author_form = str_replace('!!sel_coll!!',					$sel_coll,															$author_form);
		$author_form = str_replace('!!remplace!!',					$button_remplace,													$author_form);
		$author_form = str_replace('!!voir_notices!!',				$button_voir,														$author_form);
		$author_form = str_replace('!!delete!!',					$button_delete,														$author_form);
		$author_form = str_replace('!!liste_des_renvoyes_vers!!',	$liste_renvoyes,													$author_form);
		// pour retour  la bonne page en gestion d'autorits
		// &user_input=".rawurlencode(stripslashes($user_input))."&nbr_lignes=$nbr_lignes&page=$page
		global $user_input, $nbr_lignes, $page ;
		$author_form = str_replace('!!user_input_url!!',			rawurlencode(stripslashes($user_input)),							$author_form);
		$author_form = str_replace('!!user_input!!',				htmlentities($user_input,ENT_QUOTES, $charset),						$author_form);
		$author_form = str_replace('!!nbr_lignes!!',				$nbr_lignes,														$author_form);
		$author_form = str_replace('!!page!!',						$page,																$author_form);
		$author_form = str_replace('!!author_comment!!',						$this->author_comment,									$author_form);
		print $author_form;
		}
	
	// ---------------------------------------------------------------
	//		replace_form : affichage du formulaire de remplacement
	// ---------------------------------------------------------------
	function replace_form() {
		global $author_replace;
		global $msg;
		global $include_path;
	
		// a complter
	
		if(!$this->id || !$this->name) {
			require_once("$include_path/user_error.inc.php");
			error_message($msg[161], $msg[162], 1, './autorites.php?categ=auteurs&sub=&id=');
			return false;
		}
	
		$author_replace=str_replace('!!old_author_libelle!!', $this->display, $author_replace);
		$author_replace=str_replace('!!id!!', $this->id, $author_replace);
		print $author_replace;
	}
	
	
	// ---------------------------------------------------------------
	//		delete() : suppression de l'auteur
	// ---------------------------------------------------------------
	function delete() {
		global $dbh;
		global $msg;
		
		if(!$this->id)	// impossible d'accder  cette notice auteur
			return $msg[403]; 
	
		// effacement dans les notices
		// rcupration du nombre de notices affectes
		$requete = "SELECT count(1) FROM responsability WHERE ";
		$requete .= "responsability_author='$this->id' ";
	
		$res = mysql_query($requete, $dbh);
		$nbr_lignes = mysql_result($res, 0, 0);
		if($nbr_lignes) {
			// Cet auteur est utilis dans des notices, impossible de le supprimer
			return '<strong>'.$this->display."</strong><br>${msg[402]}";
		}
	
		// effacement dans la table des auteurs
		$requete = "DELETE FROM authors WHERE author_id='$this->id' ";
		$result = mysql_query($requete, $dbh);
		return false;
	}
	
	
	// ---------------------------------------------------------------
	//		replace($by) : remplacement de l'auteur
	// ---------------------------------------------------------------
	function replace($by) {
	
		global $msg;
		global $dbh;
	
		if (($this->id == $by) || (!$this->id))  {
			return $msg[223];
		}
	
		// remplacement dans les responsabilits
		$requete = "UPDATE responsability SET responsability_author='$by' WHERE responsability_author='$this->id' ";
		$res = @mysql_query($requete, $dbh);
		
		// effacement dans les responsabilits
		$requete = "delete from responsability WHERE responsability_author='$this->id' ";
		$res = @mysql_query($requete, $dbh);
		
		// effacement dans la table des auteurs
		$requete = "DELETE FROM authors WHERE author_id='$this->id' ";
		$result = mysql_query($requete, $dbh);
		
		auteur::update_index($by);
		
		return FALSE;
	}
	
	// ---------------------------------------------------------------
	//		update($value) : mise  jour de l'auteur
	// ---------------------------------------------------------------
	function update($value) {
	
		global $dbh;
		global $msg;
		global $include_path;
		
		if(!$value['name'])
			return false;
	
		// nettoyage des chanes en entre
		
		$value['name'] = clean_string($value['name']);
		$value['rejete'] = clean_string($value['rejete']);
		$value['date'] = clean_string($value['date']);
		
		// construction de la requte
	
		// s'assurer que l'auteur n'existe pas dj
		$dummy = "SELECT * FROM authors WHERE author_name='{value['name']}'";
		$dummy .= " AND author_rejete='{value['rejete']}' ";
		$dummy .= "AND author_date='$value[date]' LIMIT 1 ";
		$check = mysql_query($dummy, $dbh);
		if(@mysql_num_rows($check)) {
			require_once("$include_path/user_error.inc.php");
			warning($msg[200], $msg[220]);
			return FALSE;
		}
	
	
		$requete  = "SET author_type='$value[type]', ";
		$requete .= "author_name='$value[name]', ";
		$requete .= "author_rejete='$value[rejete]', ";
		$requete .= "author_date='$value[date]', ";
		$requete .= "author_web='$value[author_web]', ";
		$requete .= "author_see='$value[voir_id]', ";
		$requete .= "author_comment='$value[author_comment]', ";
		$requete .= "index_author=' ".strip_empty_words($value[name]." ".$value[rejete])." '";
	
	
		if($this->id) {
			// update
			// on checke s'il n'y a pas un renvoi circulaire
			if($this->id == $value['voir_id']) {
				require_once("$include_path/user_error.inc.php"); 
				warning($msg[199], $msg[222]);
				return FALSE;
			}
	
			$requete = 'UPDATE authors '.$requete;
			$requete .= ' WHERE author_id='.$this->id.' ;';
			if(mysql_query($requete, $dbh)) {
				auteur::update_index($this->id);
				return TRUE;
			} else {
				require_once("$include_path/user_error.inc.php"); 
				warning($msg[199], $msg[208]);
				return FALSE;
			}
		} else {
			// creation
			$requete = 'INSERT INTO authors '.$requete.' ';
			if(mysql_query($requete, $dbh)) {
				$this->id=mysql_insert_id();
				return TRUE;
			} else {
				require_once("$include_path/user_error.inc.php"); 
				warning($msg[200], $msg[221]);
				return FALSE;
			}
		}
	}
		
	// ---------------------------------------------------------------
	//		import() : import d'un auteur
	// ---------------------------------------------------------------
	// fonction d'import de notice auteur (membre de la classe 'author');
	function import($data) {
	
		// cette mthode prend en entre un tableau constitu des informations diteurs suivantes :
		//  $data['type']  type de l'autorit (70 ou 71)
		//	$data['name'] 	lment d'entre de l'autorit
		//	$data['rejete']	lment rejet
		//	$data['date']	dates de l'autorit
		//	$data['voir_id']	id de la forme retenue (sans objet pour l'import de notices)
		//	$data['author_comment']	commentaire
	
		global $dbh;
	
		// check sur le type de  la variable passe en paramtre
		if(!sizeof($data) || !is_array($data)) {
			// si ce n'est pas un tableau ou un tableau vide, on retourne 0
			return 0;
		}
	
		// check sur les lments du tableau (data['name'] ou data['rejete'] est requis).
		
		$long_maxi_name = mysql_field_len(mysql_query("SELECT author_name FROM authors limit 1"),0);
		$long_maxi_rejete = mysql_field_len(mysql_query("SELECT author_rejete FROM authors limit 1"),0);
			
		$data['name'] = rtrim(substr(preg_replace('/\[|\]/', '', rtrim(ltrim($data['name']))),0,$long_maxi_name));
		$data['rejete'] = rtrim(substr(preg_replace('/\[|\]/', '', rtrim(ltrim($data['rejete']))),0,$long_maxi_rejete));
	
	
		if(!$data['name'] && !$data['rejete'])
			return 0;
	
		// check sur le type d'autorit
		if(!$data['type']==70 && !$data['type']==71)
			return 0;	
	
		// tentative de rcuprer l'id associe dans la base (implique que l'autorit existe)
	
		// prparation de la requte
	
		$key0 = $data['type'];
		$key1 = addslashes($data['name']);
		$key2 = addslashes($data['rejete']);
		$key3 = addslashes($data['date']);
		$data['author_comment'] = addslashes($data['author_comment']);
		
		$query = "SELECT author_id FROM authors WHERE author_type='${key0}' AND author_name='${key1}' AND author_rejete='${key2}' LIMIT 1 ";
		$result = @mysql_query($query, $dbh);
		if(!$result) die("can't SELECT in database");
		// rsultat
	
		// rcupration du rsultat de la recherche
		$aut  = mysql_fetch_object($result);
		// du rsultat et rcupration ventuelle de l'id
		if($aut->author_id)
			return $aut->author_id;
	
		// id non-rcupre, il faut crer l'auteur
		$query = "INSERT INTO authors SET author_type='$key0', ";
		$query .= "author_name='$key1', ";
		$query .= "author_rejete='$key2', ";
		$query .= "author_date='$key3', ";
		$query .= "author_comment='".$data['author_comment']."', ";
		$query .= "index_author=' ".strip_empty_words($key1." ".$key2)." ' ";
		$result = @mysql_query($query, $dbh);
		if(!$result) die("can't INSERT into table authors :<br><b>$query</b> ");
	
		return mysql_insert_id($dbh);
	}
		
	// ---------------------------------------------------------------
	//		search_form() : affichage du form de recherche
	// ---------------------------------------------------------------
	function search_form() {
		global $user_query;
		global $msg;
		$user_query = str_replace ('!!user_query_title!!', $msg[357]." : ".$msg[133] , $user_query);
		$user_query = str_replace ('!!action!!', './autorites.php?categ=auteurs&sub=reach&id=', $user_query);
		$user_query = str_replace ('!!add_auth_msg!!', $msg[207] , $user_query);
		$user_query = str_replace ('!!add_auth_act!!', './autorites.php?categ=auteurs&sub=author_form', $user_query);
		$user_query = str_replace ('<!-- lien_derniers -->', "<a href='./autorites.php?categ=auteurs&sub=author_last'>$msg[1310]</a>", $user_query);
		print pmb_bidi($user_query) ;
		}
	//---------------------------------------------------------------
	// update_index($id) : maj des n-uplets la table notice_global_index en rapport avec cet author	
	//---------------------------------------------------------------
	function update_index($id) {
		global $dbh;
		// On cherche tous les n-uplet de la table notice correspondant  cet auteur.
		$found = mysql_query("select responsability_notice from responsability where responsability_author = ".$id,$dbh);
		// Pour chaque n-uplet trouvs on met a jour la table notice_global_index avec l'auteur modifi :
		while($mesNotices = mysql_fetch_object($found)) {
			$notice_id = $mesNotices->responsability_notice;
			notice::majNoticesGlobalIndex($notice_id);
			notice::majNoticesMotsGlobalIndex($notice_id);
		}
	}
	}
	
} // class auteur


