<?php
// +-------------------------------------------------+
//  2002-2004 PMB Services / www.sigb.net pmb@sigb.net et contributeurs (voir www.sigb.net)
// +-------------------------------------------------+
// $Id: mono_display.class.php,v 1.122 2007/10/01 08:15:57 touraine37 Exp $

if (stristr($_SERVER['REQUEST_URI'], ".class.php")) die("no access");

require_once("$class_path/marc_table.class.php");
require_once("$class_path/author.class.php");
require_once("$class_path/editor.class.php");
require_once("$class_path/collection.class.php");
require_once("$class_path/subcollection.class.php");
require_once("$class_path/indexint.class.php");
require_once("$class_path/serie.class.php");
require_once("$class_path/category.class.php");
require_once($class_path."/parametres_perso.class.php");
require_once($class_path."/emprunteur.class.php");
require_once($include_path."/notice_authors.inc.php");
require_once($include_path."/notice_categories.inc.php");
require_once($include_path."/explnum.inc.php");
require_once($include_path."/isbn.inc.php");
require_once($include_path."/resa_func.inc.php");


if (!sizeof($tdoc)) $tdoc = new marc_list('doctype');
if (!count($fonction_auteur)) {
	$fonction_auteur = new marc_list('function');
	$fonction_auteur = $fonction_auteur->table;
	}
if (!count($langue_doc)) {
	$langue_doc = new marc_list('lang');
	$langue_doc = $langue_doc->table;
	}
// proprits pour le selecteur de panier 
$selector_prop = "toolbar=no, dependent=yes, width=500, height=400, resizable=yes, scrollbars=yes";
$cart_click = "onClick=\"window.open('./cart.php?object_type=NOTI&item=!!id!!&unq=!!unique!!', 'cart', '$selector_prop')\"";


// dfinition de la classe d'affichage des monographies en liste
class mono_display {
	var $notice_id		= 0;	// id de la notice  afficher
	var $isbn		= 0;	// isbn ou code EAN de la notice  afficher
  	var $notice;			// objet notice (tel que fetch dans la table 'notices'
	var $langues = array();
	var $languesorg = array();
  	var $action		= '';	// URL  associer au header
	var $header		= '';	// chaine accueillant le chapeau de notice (peut-tre cliquable)
	var $tit_serie		= '';	// titre de srie si applicable
	var $tit1		= '';	// valeur du titre 1
	var $result		= '';	// affichage final
	var $level		= 1;	// niveau d'affichage
	var $isbd		= '';	// isbd de la notice en fonction du level dfini
	var $expl		= 0;	// flag indiquant si on affiche les infos d'exemplaire
	var $nb_expl	= 0;	//nombre d'exemplaires
	var $link_expl		= '';	// lien associ  un exemplaire
	var $responsabilites =	array("responsabilites" => array(),"auteurs" => array());  // les auteurs
	var $categories =	array();// les categories
	var $show_resa		= 0;	// flag indiquant si on affiche les infos de resa
	var $p_perso;
	var $print_mode=0;
	var $show_explnum=1;
	var $show_statut=0;
	var $aff_statut = '' ; // carr de couleur pour signaler le statut de la notice
	var $tit_serie_lien_gestion ;
	var $childs=array(); //Filles de la notice
	var $anti_loop="";
	var $drag=""; //Notice draggable ?
	var $no_link;
	var $show_opac_hidden_fields=true;
// constructeur------------------------------------------------------------
function mono_display($id, $level=1, $action='', $expl=1, $expl_link='', $lien_suppr_cart="", $explnum_link='', $show_resa=0, $print=0, $show_explnum=1, $show_statut=0, $anti_loop='', $draggable=0, $no_link=false, $show_opac_hidden_fields=true ) {
  	// $id = id de la notice  afficher
  	// $action	 = URL associe au header
	// $level :
	//		0 : juste le header (titre  / auteur principal avec le lien si applicable) 
	// 			suppression des niveaux entre 1 et 6, seul reste level
	//		1 : ISBD seul, pas de note, bouton modif, expl, explnum et rsas
	// 		6 : cas gnral dtaill avec notes, categ, langues, indexation... + boutons
	// $expl -> affiche ou non les exemplaires associs
	// $expl_link -> lien associ  l'exemplaire avec !!expl_id!!, !!notice_id!! et !!expl_cb!!  mettre  jour
  	// $lien_suppr_cart -> lien de suppression de la notice d'un caddie
  	//
  	// $show_resa = affichage des resa ou pas
  	
   	if(!$id)
  		return;
	else {
		if (is_object($id)){
			$this->notice_id = $id->notice_id;
			$this->notice = $id;
			$this->isbn = $id->code ;
		} else {
			$this->notice_id = $id;
			$this->mono_display_fetch_data();
		}
		$this->childs=array();
		$requete="select num_notice as notice_id,relation_type from notices_relations where linked_notice=".$this->notice_id." order by relation_type, rank";
		$resultat=mysql_query($requete);
		if (mysql_num_rows($resultat)) {
			while ($r=mysql_fetch_object($resultat)) {
				$this->childs[$r->relation_type][]=$r->notice_id;
			}
		} 
   	}
	
	$this->p_perso=new parametres_perso("notices");
	
	$this->level = $level;
	$this->expl  = $expl;
	$this->show_resa  = $show_resa;
	$this->link_expl = $expl_link;
	$this->link_explnum = $explnum_link;
	$this->lien_suppr_cart = $lien_suppr_cart;
	$this->print_mode=$print;
	$this->show_explnum=$show_explnum;
	$this->show_statut=$show_statut;
	$this->no_link=$no_link;
	
	$this->anti_loop=$anti_loop;
	
	$this->drag=$draggable;
	
	// mise  jour des liens
	$this->action = $action;
	
	//affichage ou pas des champs persos OPAC masqus
	$this->show_opac_hidden_fields=$show_opac_hidden_fields;

	$this->action = str_replace('!!id!!', $this->notice_id, $this->action);
		
	$this->responsabilites = get_notice_authors($this->notice_id) ;
	
	// mise  jour des catgories
	$this->categories = get_notice_categories($this->notice_id) ;
				
	$this->do_header();

	switch($level) {
		case 0:
			// l, c'est le niveau 0 : juste le header
			$this->result = $this->header;
			break;
		default:
			// niveau 1 et plus : header + isbd  gnrer
			$this->init_javascript();
			$this->do_isbd();
			$this->finalize();
			break;
		}	
	return;

	}


// finalisation du rsultat (criture de l'isbd)
function finalize() {
	$this->result = str_replace('!!ISBD!!', $this->isbd, $this->result);
	}

// gnration du template javascript---------------------------------------
function init_javascript() {
	global $msg;
	
	// proprits pour le selecteur de panier 
	$selector_prop = "toolbar=no, dependent=yes, width=500, height=400, resizable=yes, scrollbars=yes";
	$cart_click = "onClick=\"window.open('./cart.php?object_type=NOTI&item=!!id!!', 'cart', '$selector_prop')\"";
	
	$javascript_template ="
		<div id=\"el!!id!!Parent\" class=\"notice-parent\">
    		<img src=\"./images/plus.gif\" name=\"imEx\" id=\"el!!id!!Img\" title=\"".$msg['admin_param_detail']."\" border=\"0\" onClick=\"expandBase('el!!id!!', true); return false;\" hspace=\"3\">
    		<span class=\"notice-heada\">!!heada!!</span>
    		<br>
		</div>
		<div id=\"el!!id!!Child\" class=\"notice-child\" style=\"margin-bottom:6px;display:none;\">
        <img src='./images/basket_small_20x20.gif' align='middle' alt='basket' title=\"${msg[400]}\" $cart_click>
        !!ISBD!!
 		</div>";
 		
	$this->result = str_replace('!!id!!', $this->notice_id.($this->anti_loop?"_p".$this->anti_loop[count($this->anti_loop)-1]:""), $javascript_template);
	$this->result = str_replace('!!heada!!', $this->lien_suppr_cart.$this->header, $this->result);
	}

// gnration de l'isbd----------------------------------------------------
function do_isbd() {
	global $dbh;
	global $langue_doc;
	global $msg;
	global $tdoc;
	global $fonction_auteur;
	global $charset;
	global $thesaurus_mode_pmb, $thesaurus_categories_categ_in_line, $pmb_keyword_sep;
	
	// constitution de la mention de titre
	if($this->tit_serie) {
		if ($this->print_mode) $this->isbd = $this->tit_serie; 
			else $this->isbd = $this->tit_serie_lien_gestion;
		if($this->notice->tnvol)
			$this->isbd .= ',&nbsp;'.$this->notice->tnvol;
		}
	$this->isbd ? $this->isbd .= '.&nbsp;'.$this->tit1 : $this->isbd = $this->tit1;

	$this->isbd .= ' ['.$tdoc->table[$this->notice->typdoc].']';
	$tit2 = $this->notice->tit2;
	$tit3 = $this->notice->tit3;
	$tit4 = $this->notice->tit4;
	if($tit3) $this->isbd .= "&nbsp;= $tit3";
	if($tit4) $this->isbd .= "&nbsp;: $tit4";
	if($tit2) $this->isbd .= "&nbsp;; $tit2";
	
	$mention_resp = array() ;
	
	// constitution de la mention de responsabilit
	//$this->responsabilites
	$as = array_search ("0", $this->responsabilites["responsabilites"]) ;
	if ($as!== FALSE && $as!== NULL) {
		$auteur_0 = $this->responsabilites["auteurs"][$as] ;
		$auteur = new auteur($auteur_0["id"]);
		if ($this->print_mode) 
			$mention_resp_lib = $auteur->isbd_entry; 
		else 
			$mention_resp_lib = $auteur->isbd_entry_lien_gestion;
		if (!$this->print_mode) $mention_resp_lib .= $auteur->author_web_link ;
		if ($auteur_0["fonction"]) $mention_resp_lib .= ", ".$fonction_auteur[$auteur_0["fonction"]];
		$mention_resp[] = $mention_resp_lib ;
		}
	
	$as = array_keys ($this->responsabilites["responsabilites"], "1" ) ;
	for ($i = 0 ; $i < count($as) ; $i++) {
		$indice = $as[$i] ;
		$auteur_1 = $this->responsabilites["auteurs"][$indice] ;
		$auteur = new auteur($auteur_1["id"]);
		if ($this->print_mode) 
			$mention_resp_lib = $auteur->isbd_entry; 
		else 
			$mention_resp_lib = $auteur->isbd_entry_lien_gestion;
		if (!$this->print_mode) $mention_resp_lib .= $auteur->author_web_link ;
		if ($auteur_1["fonction"]) $mention_resp_lib .= ", ".$fonction_auteur[$auteur_1["fonction"]];
		$mention_resp[] = $mention_resp_lib ;
		}
	
	$as = array_keys ($this->responsabilites["responsabilites"], "2" ) ;
	for ($i = 0 ; $i < count($as) ; $i++) {
		$indice = $as[$i] ;
		$auteur_2 = $this->responsabilites["auteurs"][$indice] ;
		$auteur = new auteur($auteur_2["id"]);
		if ($this->print_mode) 
			$mention_resp_lib = $auteur->isbd_entry; 
		else 
			$mention_resp_lib = $auteur->isbd_entry_lien_gestion;
		if (!$this->print_mode) $mention_resp_lib .= $auteur->author_web_link ;
		if ($auteur_2["fonction"]) $mention_resp_lib .= ", ".$fonction_auteur[$auteur_2["fonction"]];
		$mention_resp[] = $mention_resp_lib ;
		}
		
	$libelle_mention_resp = implode ("; ",$mention_resp) ;
	if($libelle_mention_resp) $this->isbd .= "&nbsp;/ $libelle_mention_resp" ;

	// mention d'dition
	if($this->notice->mention_edition) $this->isbd .= ".&nbsp;-&nbsp;".$this->notice->mention_edition;
	
	// zone de l'adresse
	// on rcupre la collection au passage, si besoin est
	if($this->notice->subcoll_id) {
		$collection = new subcollection($this->notice->subcoll_id);
		$ed_obj = new editeur($collection->editeur) ;
		if ($this->print_mode) {
			$editeurs .= $ed_obj->isbd_entry; 
			$collections = $collection->isbd_entry;
			} else {
				$editeurs .= $ed_obj->isbd_entry_lien_gestion; 
				$collections = $collection->isbd_entry_lien_gestion;
			}
		} elseif ($this->notice->coll_id) {
			$collection = new collection($this->notice->coll_id);
			$ed_obj = new editeur($collection->parent) ;
			if ($this->print_mode) {
				$editeurs .= $ed_obj->isbd_entry; 
				$collections = $collection->isbd_entry;
				} else {
					$editeurs .= $ed_obj->isbd_entry_lien_gestion; 
					$collections = $collection->isbd_entry_lien_gestion;
				}
			} elseif ($this->notice->ed1_id) {
				$editeur = new editeur($this->notice->ed1_id);
				if ($this->print_mode)
					$editeurs .= $editeur->isbd_entry;
				else
					$editeurs .= $editeur->isbd_entry_lien_gestion; 
				}
	
	if($this->notice->ed2_id) {
		$editeur = new editeur($this->notice->ed2_id);
		if ($this->print_mode)
			$ed_isbd=$editeur->isbd_entry;
		else
			$ed_isbd=$editeur->isbd_entry_lien_gestion;
		$editeurs ? $editeurs .= '&nbsp;; '.$ed_isbd : $editeurs = $ed_isbd;
		}

	if($this->notice->year) 
		$editeurs ? $editeurs .= ', '.$this->notice->year : $editeurs = $this->notice->year;
		else 
			$editeurs ? $editeurs .= ', [s.d.]' : $editeurs = "[s.d.]";

	$this->isbd .= ".&nbsp;-&nbsp;$editeurs";
	
	// zone de la collation (ne concerne que a2)
	if($this->notice->npages)
		$collation = $this->notice->npages;
	if($this->notice->ill)
		$collation .= ': '.$this->notice->ill;
	if($this->notice->size)
		$collation .= '; '.$this->notice->size;
	if($this->notice->accomp)
		$collation .= '+ '.$this->notice->accomp;
		
	if($collation)
		$this->isbd .= ".&nbsp;-&nbsp;$collation";
	
	
	if($collections) {
		if($this->notice->nocoll)
			$collections .= '; '.$this->notice->nocoll;
		$this->isbd .= ".&nbsp;-&nbsp;($collections)".' ';
		}

	$this->isbd .= '.';
		
	// note gnrale
	if($this->notice->n_gen)
 		$zoneNote = nl2br(htmlentities($this->notice->n_gen,ENT_QUOTES, $charset)).' ';
		
	// ISBN ou NO. commercial
	if($this->notice->code) {
		if(isISBN($this->notice->code)) {
			if ($zoneNote) { $zoneNote .= '.&nbsp;-&nbsp;ISBN '; } else { $zoneNote = 'ISBN ';}
			} else {
				if($zoneNote) $zoneNote .= '.&nbsp;-&nbsp;';
				}
		$zoneNote .= $this->notice->code;
		}
	if($this->notice->prix) {
		if($this->notice->code) {$zoneNote .= '&nbsp;: '.$this->notice->prix;}
			else { 
				if ($zoneNote) 	{ $zoneNote .= '&nbsp; '.$this->notice->prix;}
					else	{ $zoneNote = $this->notice->prix;}
				}
		}

	if($zoneNote)
		$this->isbd .= "<br><br>$zoneNote.";
	
	//In
	//Recherche des notices parentes
	if (!$this->no_link) {
		$requete="select linked_notice, relation_type, rank, l.niveau_biblio as lnb, l.niveau_hierar as lnh from notices_relations, notices as l where num_notice=".$this->notice_id." and linked_notice=l.notice_id order by relation_type,rank";
		$result_linked=mysql_query($requete) or die(mysql_error());
		//Si il y en a, on prpare l'affichage
		if (mysql_num_rows($result_linked)) {
			global $relation_listup ;
			if (!$relation_listup) $relation_listup=new marc_list("relationtypeup");
			if (!$this->print_mode) $link_parent='./catalog.php?categ=isbd&id=!!id!!'; else $link_parent="";
		}
		$r_type=array();
		$ul_opened=false;
		$r_type_local="";
		//Pour toutes les notices lies
		while ($r_rel=mysql_fetch_object($result_linked)) {
			if ($r_rel->lnb=='s' && $r_rel->lnh=='1') {
				// c'est une notice chapeau
				global $link_serial, $link_analysis, $link_bulletin, $link_explnum_serial ;
				$serial = new serial_display($r_rel->linked_notice, 0, $link_serial, $link_analysis, $link_bulletin, "", $link_explnum_serial, 0, 0, 1, 1 );
				$aff = $serial->header;				
			} else {
				// dans les autres cas
				$parent_notice=new mono_display($r_rel->linked_notice,0,$link_parent);
				$aff = $parent_notice->header ;
				$this->nb_expl+=$parent_notice->nb_expl;
			}
			$parent_notice=new mono_display($r_rel->linked_notice,0,$link_parent);
			//Prsentation diffrente si il y en a un ou plusieurs
			if (mysql_num_rows($result_linked)==1) {
				$this->isbd.="<br/><b>".$relation_listup->table[$r_rel->relation_type]."</b> ".$aff."<br/>";
			} else {
				if ($r_rel->relation_type!=$r_type_local) {
					$r_type_local=$r_rel->relation_type;
					if ($ul_opened) {
						$this->isbd.="</ul>"; 
						$this->isbd.="\n<b>".$relation_listup->table[$r_rel->relation_type]."</b>";
						$this->isbd.="\n<ul class='notice_rel'>\n";
						$ul_opened=true;
					} else { 
						$this->isbd.="\n<br/>"; 
						$this->isbd.="\n<b>".$relation_listup->table[$r_rel->relation_type]."</b>";
						$this->isbd.="\n<ul class='notice_rel'>\n";
						$ul_opened=true; 
					}
				}
				$this->isbd.="\n<li>".$aff."</li>\n";
			}
		}
		if ($ul_opened) $this->isbd.="\n</ul>\n";
	}
	
	// niveau 1
	if($this->level == 1) {
		$this->isbd .= "<!-- !!bouton_modif!! -->";
		if ($this->expl) {
			$this->isbd .= "<br><b>${msg[285]}</b>";
			$this->isbd .= $this->show_expl_per_notice($this->notice->notice_id, $this->link_expl);
			if ($this->show_explnum) {
				$explnum_assoc = show_explnum_per_notice($this->notice->notice_id, 0,$this->link_explnum);
				if ($explnum_assoc) $this->isbd .= "<b>$msg[explnum_docs_associes]</b>".$explnum_assoc;
				}
			}
		if($this->show_resa) {
			$aff_resa=resa_list ($this->notice_id, 0, 0) ;
			if ($aff_resa) $this->isbd .= "<b>$msg[resas]</b>".$aff_resa;
			}
		$this->do_image($this->isbd) ;
		return;
		}			

	// rsum
	if($this->notice->n_resume)
 		// $this->isbd .= "<br><b>${msg[267]}</b>&nbsp;: ".nl2br(htmlentities($this->notice->n_resume,ENT_QUOTES, $charset));
 		$this->isbd .= "<br><b>${msg[267]}</b>&nbsp;: ".nl2br($this->notice->n_resume);

	// note de contenu
	if($this->notice->n_contenu) 
 		// $this->isbd .= "<br><b>${msg[266]}</b>&nbsp;: ".nl2br(htmlentities($this->notice->n_contenu,ENT_QUOTES, $charset));
		$this->isbd .= "<br><b>${msg[266]}</b>&nbsp;: ".nl2br($this->notice->n_contenu);

	// catgories
	$max_categ = sizeof($this->categories) ;
	$categ_repetables = array() ;
	for ($i = 0 ; $i < $max_categ ; $i++) {
		$categ_id = $this->categories[$i]["categ_id"] ;
		$categ = new category($categ_id);
		if ($thesaurus_mode_pmb) {
			$categ_repetables[$categ->thes->getLibelle()][] = $categ->isbd_entry_lien_gestion;
			} else $categ_repetables['MONOTHESAURUS'][] = $categ->isbd_entry_lien_gestion;
		}
	while (list($nom_tesaurus, $val_lib)=each($categ_repetables)) {
		asort($val_lib) ;
		if ($thesaurus_mode_pmb) {
			if (!$thesaurus_categories_categ_in_line) $categ_repetables_aff = "[".$nom_tesaurus."]".implode("<br>[".$nom_tesaurus."]",$val_lib) ;
				else $categ_repetables_aff = "<b>".$nom_tesaurus."</b><br>".implode(" $pmb_keyword_sep ",$val_lib) ;
			} else if (!$thesaurus_categories_categ_in_line) $categ_repetables_aff = implode("<br>",$val_lib) ;
				else $categ_repetables_aff = implode(" $pmb_keyword_sep ",$val_lib) ;
		
		if($categ_repetables_aff) $tmpcateg_aff .= "<br>$categ_repetables_aff";
		}
	if ($tmpcateg_aff) $this->isbd .= "<br>$tmpcateg_aff";
	
	// langues
	if(count($this->langues)) {
		$langues = "<b>${msg[537]}</b>&nbsp;: ".construit_liste_langues($this->langues);
		}
	if(count($this->languesorg)) {
		$langues .= " <b>${msg[711]}</b>&nbsp;: ".construit_liste_langues($this->languesorg);
		}
	if($langues)
		$this->isbd .= "<br>$langues";
			
	// indexation libre
	if($this->notice->index_l)
		$this->isbd .= "<br><b>${msg[324]}</b>&nbsp;: ".$this->notice->index_l;
	
	// indexation interne
	if($this->notice->indexint) {
		$indexint = new indexint($this->notice->indexint);
		if ($this->print_mode) $indexint_isbd=$indexint->display;
			else $indexint_isbd=$indexint->isbd_entry_lien_gestion;
		$this->isbd .= "<br><b>${msg[indexint_catal_title]}</b>&nbsp;: ".$indexint_isbd;
		}
	
	//Champs personaliss
	$perso_aff = "" ;
	if (!$this->p_perso->no_special_fields) {
		$perso_=$this->p_perso->show_fields($this->notice_id);
		for ($i=0; $i<count($perso_["FIELDS"]); $i++) {
			$p=$perso_["FIELDS"][$i];
			// ajout de && ($p['OPAC_SHOW']||$this->show_opac_hidden_fields) afin de masquer les champs masqu de l'POAC en diff de bannette.
			if ($p["AFF"] && ($p['OPAC_SHOW'] || $this->show_opac_hidden_fields)) $perso_aff .="<br/>".$p["TITRE"]." ".$p["AFF"];
		}
	}
	if ($perso_aff) $this->isbd.="<br/>".$perso_aff ;
	
	//Notices lies
	if ((count($this->childs))&&(!$this->print_mode)&&(!$this->no_link)) {
		$link = './catalog.php?categ=isbd&id=!!id!!';
		$link_expl = './catalog.php?categ=edit_expl&id=!!notice_id!!&cb=!!expl_cb!!&expl_id=!!expl_id!!'; 
		$link_explnum = './catalog.php?categ=edit_explnum&id=!!notice_id!!&explnum_id=!!explnum_id!!'; 
		global $relation_typedown;
		if (!$relation_typedown) $relation_typedown=new marc_list("relationtypedown");
		reset($this->childs);
		$aff_childs="<script type='text/javascript' src='./javascript/tablist.js'></script><br/>\n";
		$anti_loop=$this->anti_loop;
		$anti_loop[]=$this->notice_id;
		$n_childs=0;
		while ((list($rel_type,$child_notices)=each($this->childs))&&($n_childs<50)) {
			$aff_childs.="<b>".$relation_typedown->table[$rel_type]."</b>";
			$aff_childs.="<blockquote>";
			for ($i=0; $i<count($child_notices); $i++) {
				$as=array_search($child_notices[$i],$anti_loop);
				if (($as===false)||($as==null)) {
					// il faut aller chercher le niveau biblio et niveau hierar de la notice lie
					$requete_nbnh="select l.niveau_biblio as lnb, l.niveau_hierar as lnh from notices as l where notice_id='".$child_notices[$i]."' ";
					$r_rel=mysql_fetch_object(mysql_query($requete_nbnh));
					if ($r_rel->lnb=='a' && $r_rel->lnh=='2') {
						// c'est un dpouillement de bulletin
						$serial = new serial_display($child_notices[$i], 6, $link_serial, $link_analysis, $link_bulletin, "", $link_explnum_serial, 0, 0, 1, 1 );
						$aff = $serial->result;
						} else { 
							$display = new mono_display($child_notices[$i], 6, $link, 1, $link_expl, '', $link_explnum,1, 0, 1, 1,$anti_loop,$this->drag);
							$display->result=str_replace("<!-- !!bouton_modif!! -->","",$display->result);
							$aff = $display->result;
							$this->nb_expl+=$display->nb_expl;
							}
					$aff_childs.=$aff;
				}
				$n_childs++;
			}
			$aff_childs.="</blockquote>";
		}
		$this->isbd.=$aff_childs;
	}
	
	$this->isbd .= "<!-- !!bouton_modif!! -->";
	$this->do_image($this->isbd) ;
	if($this->expl) {
		$expl_aff = $this->show_expl_per_notice($this->notice->notice_id, $this->link_expl);
		if ($expl_aff) {
			$this->isbd .= "<br><br><b>${msg[285]}</b>";
			$this->isbd .= $expl_aff;
			} 
		}
	if ($this->show_explnum) {
		$explnum_assoc = show_explnum_per_notice($this->notice->notice_id, 0, $this->link_explnum);
		if ($explnum_assoc) $this->isbd .= "<b>$msg[explnum_docs_associes]</b>".$explnum_assoc;
		}
	if($this->show_resa) {
		$rqt_nt="select count(*) from exemplaires, notices, docs_statut where exemplaires.expl_statut=docs_statut.idstatut and notices.notice_id=exemplaires.expl_notice and pret_flag=1 and notices.notice_id=".$this->notice_id;
		$result = mysql_query($rqt_nt, $dbh) or die ($rqt_nt. " ".mysql_error()) ;
		if ($result) {
			$aff_resa=resa_list($this->notice_id, 0, 0) ;
			$ouvrir_reserv = "onclick=\"parent.location.href='./circ.php?categ=resa_from_catal&id_notice=".$this->notice->notice_id."'; return(false) \"";
			if ($aff_resa) $this->isbd .= "<b>$msg[resas]</b><br><input type='button' class='bouton' value='".$msg['351']."' $ouvrir_reserv><br><br>".$aff_resa."<br>";
			else {
				$affich=mysql_fetch_array($result);
				if ($affich[0]!=0) $this->isbd .= "<b>$msg[resas]</b><br><input type='button' class='bouton' value='".$msg['351']."' $ouvrir_reserv><br><br>";
			}
		}	
	}
	return;
}	

// gnration du header----------------------------------------------------
function do_header() {
	
	global $dbh;
	global $charset;
	global $pmb_notice_reduit_format;
	global $base_path;
	global $msg;
	
	$aut1_libelle = array() ;

	if ($this->notice->statut) {
		$rqt_st = "SELECT class_html , gestion_libelle FROM notice_statut WHERE id_notice_statut='".$this->notice->statut."' ";
		$res_st = mysql_query($rqt_st, $dbh) or die ($rqt_st. " ".mysql_error()) ;
		$class_html = " class='".mysql_result($res_st, 0, 0)."' ";
		if ($this->notice->statut>1) $txt = mysql_result($res_st, 0, 1) ;
			else $txt = "" ;
		} else {
			$class_html = " class='statutnot1' " ;
			$txt = "" ;
			}
	if ($this->notice->commentaire_gestion) { 
		if ($txt) $txt .= ":\r\n".$this->notice->commentaire_gestion ;
			else $txt = $this->notice->commentaire_gestion ;
		}
	if ($txt) {
		$statut = "<small><span $class_html style='margin-right: 3px;'><a href=# onmouseover=\"z=document.getElementById('zoom_statut".$this->notice_id."'); z.style.display=''; \" onmouseout=\"z=document.getElementById('zoom_statut".$this->notice_id."'); z.style.display='none'; \"><img src='./images/spacer.gif' width='10' height='10' /></a></span></small>";
		$statut .= "<div id='zoom_statut".$this->notice_id."' style='border: solid 2px #555555; background-color: #FFFFFF; position: absolute; display:none; z-index: 2000;'><b>".nl2br(htmlentities($txt,ENT_QUOTES, $charset))."</b></div>" ;
		} else $statut = "<small><span $class_html style='margin-right: 3px;'><img src='./images/spacer.gif' width='10' height='10' /></span></small>";
	$this->aff_statut = $statut ; 
	
	// rcupration du titre de srie
	if($this->notice->tparent_id) {
		$parent = new serie($this->notice->tparent_id);
		$this->tit_serie = $parent->name;
		$this->tit_serie_lien_gestion = $parent->isbd_entry_lien_gestion;
		$this->header = $this->tit_serie;
		if($this->notice->tnvol)
			$this->header .= ',&nbsp;'.$this->notice->tnvol;
		}
	
	$this->tit1 = $this->notice->tit1;		
	$this->header ? $this->header .= '.&nbsp;'.$this->tit1 : $this->header = $this->tit1;

	//$this->responsabilites
	$as = array_search ("0", $this->responsabilites["responsabilites"]) ;
	if ($as!== FALSE && $as!== NULL) {
		$auteur_0 = $this->responsabilites["auteurs"][$as] ;
		$auteur = new auteur($auteur_0["id"]);
		if ($auteur->isbd_entry) $this->header .= ' / '. $auteur->isbd_entry;
	} else {
		$as = array_keys ($this->responsabilites["responsabilites"], "1" ) ;
		for ($i = 0 ; $i < count($as) ; $i++) {
			$indice = $as[$i] ;
			$auteur_1 = $this->responsabilites["auteurs"][$indice] ;
			$auteur = new auteur($auteur_1["id"]);
			$aut1_libelle[]= $auteur->isbd_entry;
		}
		$auteurs_liste = implode ("; ",$aut1_libelle) ;
		if ($auteurs_liste) $this->header .= ' / '. $auteurs_liste ;
	}
	
	switch ($pmb_notice_reduit_format) {
		case "1":
			if ($this->notice->year != '') $this->header.=' ('.htmlentities($this->notice->year, ENT_QUOTES, $charset).')';
			break;
		default : 
			break;
	}
	if ($this->drag)
		$drag="<span id=\"notice_drag_".$this->notice_id.($this->anti_loop?"_p".$this->anti_loop[count($this->anti_loop)-1]:"")."\"  dragicon=\"$base_path/images/icone_drag_notice.png\" dragtext=\"".$this->header."\" draggable=\"yes\" dragtype=\"notice\" callback_before=\"show_carts\" callback_after=\"hide_carts\" style=\"padding-left:7px\"><img src=\"".$base_path."/images/notice_drag.png\"/></span>";
	if($this->action) {
		$this->header = "<a href=\"".$this->action."\">".$this->header.'</a>';
	}
	if ($this->notice->niveau_biblio=='b') {
		$rqt="select tit1 from bulletins,notices where bulletins.num_notice='".$this->notice_id."' and notices.notice_id=bulletins.bulletin_notice";
		$execute_query=mysql_query($rqt);
		$row=mysql_fetch_object($execute_query);
		$this->header.=" <i>".str_replace("%s",$row->tit1,$msg["bul_titre_perio"])."</i>";
		mysql_free_result($execute_query);
	}
	if ($this->drag) 
		$this->header.=$drag;

	if($this->notice->lien) {
		// ajout du lien pour les ressourcenotice_parent_useds lectroniques
		$this->header .= "<a href=\"".$this->notice->lien."\" target=\"__LINK__\">";
		global $use_opac_url_base, $opac_url_base ;
		if (!$use_opac_url_base) $this->header .= "<img src=\"./images/globe.gif\" border=\"0\" align=\"middle\" hspace=\"3\"";
			else $this->header .= "<img src=\"".$opac_url_base."images/globe.gif\" border=\"0\" align=\"middle\" hspace=\"3\"";
		$this->header .= " alt=\"";
		$this->header .= $this->notice->eformat;
		$this->header .= "\" title=\"";
		$this->header .= $this->notice->eformat;
		$this->header .= "\">";
		$this->header .='</a>';
	}
	
	
	if ($this->show_statut) $this->header = $this->aff_statut.$this->header ;
	
}
  
// rcupration des valeurs en table---------------------------------------
function mono_display_fetch_data() {
	global $dbh;
	
	$requete = "SELECT * FROM notices WHERE notice_id='".$this->notice_id."' ";
	$myQuery = mysql_query($requete, $dbh);
	if(mysql_num_rows($myQuery)) {
		$this->notice = mysql_fetch_object($myQuery);
		}
	$this->langues	= get_notice_langues($this->notice_id, 0) ;	// langues de la publication
	$this->languesorg	= get_notice_langues($this->notice_id, 1) ; // langues originales

	$this->isbn = $this->notice->code ; 
	return mysql_num_rows($myQuery);
}

// fonction retournant les infos d'exemplaires pour une notice donne
function show_expl_per_notice($no_notice, $link_expl='') {
	global $msg;
	global $dbh;
	global $explr_invisible, $explr_visible_unmod, $explr_visible_mod, $pmb_droits_explr_localises ;
	// params :
	// $no_notice= id de la notice
	// $link_expl= lien associ  l'exemplaire avec !!expl_id!! et !!expl_cb!!  mettre  jour

	if(!$no_notice) return;

	$explr_tab_invis=explode(",",$explr_invisible);
	$explr_tab_unmod=explode(",",$explr_visible_unmod);
	$explr_tab_modif=explode(",",$explr_visible_mod);

	// rcupration du nombre total d'exemplaires
	$requete = "SELECT COUNT(1) FROM exemplaires WHERE expl_notice='$no_notice' ";
	$res = mysql_query($requete, $dbh);
	$nb_ex = mysql_result($res, 0, 0);
		
	if($nb_ex) {
		// on rcupre les donnes des exemplaires
		// visibilit des exemplaires:
		if ($pmb_droits_explr_localises && $explr_invisible) $where_expl_localises = "and expl_location not in ($explr_invisible)";
			else $where_expl_localises = "";
		$requete = "SELECT exemplaires.*, pret.*, docs_location.*, docs_section.*, docs_statut.*, tdoc_libelle, ";
		$requete .= " date_format(pret_date, '".$msg["format_date"]."') as aff_pret_date, ";
		$requete .= " date_format(pret_retour, '".$msg["format_date"]."') as aff_pret_retour, ";
		$requete .= " IF(pret_retour>sysdate(),0,1) as retard " ;
		$requete .= " FROM exemplaires LEFT JOIN pret ON exemplaires.expl_id=pret.pret_idexpl ";
		$requete .= " left join docs_location on exemplaires.expl_location=docs_location.idlocation ";
		$requete .= " left join docs_section on exemplaires.expl_section=docs_section.idsection ";
		$requete .= " left join docs_statut on exemplaires.expl_statut=docs_statut.idstatut ";
		$requete .= " left join docs_type on exemplaires.expl_typdoc=docs_type.idtyp_doc  ";
		$requete .= " WHERE expl_notice=$no_notice $where_expl_localises ";
		$requete .= " order by location_libelle, section_libelle, expl_cote, expl_cb ";

		$result = mysql_query($requete, $dbh) or die ("<br>".mysql_error()."<br>".$requete);
		$nbr_expl = mysql_num_rows($result);
		if ($nbr_expl) {
			while($expl = mysql_fetch_object($result)) {
				//visibilit des exemplaires
				if ($pmb_droits_explr_localises) {
					$as_invis = array_search($expl->idlocation,$explr_tab_invis);
					$as_unmod = array_search($expl->idlocation,$explr_tab_unmod);
					$as_modif = array_search($expl->idlocation,$explr_tab_modif);
				} else {
					$as_invis = false;
					$as_unmod = false;
					$as_modif = true;
				}					

				if ($link_expl) {
					$tlink = str_replace('!!expl_id!!', $expl->expl_id, $link_expl);
					$tlink = str_replace('!!expl_cb!!', $expl->expl_cb, $tlink);
					$tlink = str_replace('!!notice_id!!', $expl->expl_notice, $tlink);					
				}
				$expl_liste .= "<tr><td>";
				if (($tlink) && ($as_modif!== FALSE && $as_modif!== NULL) ){
					$expl_liste .= "<a href='$tlink'>";
					$expl_liste .= $expl->expl_cb.'</a>';
				} else $expl_liste .= $expl->expl_cb;
				
				$expl_liste .= "</td><td><strong>";
				$expl_liste .= $expl->expl_cote;
				$expl_liste .= "</strong></td><td>";
				$expl_liste .= $expl->location_libelle;
				$expl_liste .= "</td><td>";
				$expl_liste .= $expl->section_libelle;
				if ($expl->pret_flag) {
					if($expl->pret_retour) {
						// exemplaire sorti
						$rqt_empr = "SELECT empr_nom, empr_prenom, id_empr, empr_cb FROM empr WHERE id_empr='$expl->pret_idempr' ";
						$res_empr = mysql_query ($rqt_empr, $dbh) ;
						$res_empr_obj = mysql_fetch_object ($res_empr) ;
						$situation = "<strong>${msg[358]} ".$expl->aff_pret_retour."</strong>";
						global $empr_show_caddie, $selector_prop_ajout_caddie_empr;
						if ($empr_show_caddie) {
							$img_ajout_empr_caddie="<img src='./images/basket_empr.gif' align='middle' alt='basket' title=\"${msg[400]}\" onClick=\"window.open('./cart.php?object_type=EMPR&item=".$expl->pret_idempr."', 'cart', '$selector_prop_ajout_caddie_empr')\">&nbsp;";
						} else $img_ajout_empr_caddie="";
						$situation .= "<br>$img_ajout_empr_caddie<a href='./circ.php?categ=pret&form_cb=".rawurlencode($res_empr_obj->empr_cb)."'>$res_empr_obj->empr_prenom $res_empr_obj->empr_nom</a>";
					} else {
							// tester si rserv
							$result_resa = mysql_query("select 1 from resa where resa_cb='".$expl->expl_cb."' ", $dbh) or die ("<br>".mysql_error()."<br>".$requete);
							$reserve = mysql_num_rows($result_resa);
	
							if ($reserve) $situation = "<strong>".$msg['expl_reserve']."</strong>"; // exemplaire rserv
							else $situation = "<strong>${msg[359]}</strong>"; // exemplaire disponible
					}
				} else $situation = "";
					
				$expl_liste .= "</td><td>$expl->statut_libelle<br>$situation</td>";
				$expl_liste .= "<td>$expl->tdoc_libelle</td>";
					
				$cart_click = "onClick=\"window.open('./cart.php?object_type=EXPL&item=".$expl->expl_id."', 'cart', 'toolbar=no, dependent=yes, width=500, height=400, resizable=yes, scrollbars=yes')\"";
				$cart_link = "<img src='./images/basket_small_20x20.gif' align='center' alt='basket' title=\"${msg[400]}\" $cart_click>";
				$fiche_click = "onClick=\"window.open('./pdf.php?pdfdoc=fiche_catalographique&expl_id=".$expl->expl_id."', 'Fiche', 'toolbar=no, dependent=yes, width=500, height=400, resizable=yes, scrollbars=yes')\"";
				$fiche_link = "<img src='./images/print.gif' align='center' alt='".$msg['print_fiche_catalographique']."' title='".$msg['print_fiche_catalographique']."' $fiche_click>";
				if ($this->print_mode) $expl_liste .= "<td>&nbsp;</td></tr>"; else $expl_liste .= "<td>$fiche_link $cart_link</td></tr>";
			} // fin while
		} // fin il y a des expl visibles
		if ($expl_liste) $entry = "<table border='0' class='expl-list'><tr><th>$msg[293]</th><th>$msg[296]</th><th>$msg[298]</th><th>$msg[295]</th><th>$msg[297]</th><th>$msg[294]</th><th>&nbsp;</th></tr>$expl_liste</table>";
			else $entry = "";
		$this->nb_expl=$nbr_expl;
		return $entry;
	} else {
		return "";
	}
}
	
	
function do_image(&$entree) {
	global $pmb_book_pics_show ;
	global $pmb_book_pics_url ;
	// pour url OPAC en diff DSI
	global $prefix_url_image ;
	
	global $depliable ;
	
	if ($depliable!==0) $depliable=1 ;
	
	if ($this->notice->code<>"") {
		if ($pmb_book_pics_show=='1' && $pmb_book_pics_url) {
			$code_chiffre = pmb_preg_replace('/-|\.| /', '', $this->notice->code);
			$url_image = $pmb_book_pics_url ;
			$url_image = $prefix_url_image."getimage.php?url_image=".urlencode($url_image) ;
			if ($depliable) $image = "<img id='PMBimagecover".$this->notice_id."' src='".$prefix_url_image."images/vide.png' align='right' hspace='4' vspace='2' isbn='".$code_chiffre."' url_image='".$url_image."'>";
				else {
					$url_image_ok = str_replace("%21%21isbn%21%21", $code_chiffre, $url_image) ;
					$image = "<img src='".$url_image_ok."' align='right' hspace='4' vspace='2'>";
					}
			} else $image="" ;
		if ($image) {
			$entree = "<table width='100%'><tr><td valign=top>$entree</td><td valign=top align=right>$image</td></tr></table>" ;
			} else {
				$entree = "<table width='100%'><tr><td valign=top>$entree</td></tr></table>" ;
				}
			
		} else {
			$entree = "<table width='100%'><tr><td valign=top>$entree</td></tr></table>" ;
			}
	}

}