<?php
// +-------------------------------------------------+
//  2002-2005 PMB Services / www.sigb.net pmb@sigb.net et contributeurs (voir www.sigb.net)
// +-------------------------------------------------+
// $Id: rubriques.class.php,v 1.14 2007/07/20 16:16:14 dbellamy Exp $


if (stristr($_SERVER['REQUEST_URI'], ".class.php")) die("no access");

require_once("$class_path/actes.class.php");

class rubriques{
	
	
	var $id_rubrique = 0;						//Identifiant de rubrique	
	var $num_budget = 0;						//Identifiant du budget auquel appartient la rubrique
	var $num_parent = 0;						//Identifiant de la rubrique parent (0 si rubrique de tte)
	var $libelle = '';							//Libell de rubrique
	var $commentaires = '';						//Commentaires sur la rubrique
	var $montant = '000000.00';					//Montant affect  la rubrique
	var $num_cp_compta = '';					//Numro de compte comptable pour affectation
	var $autorisations = '';					//Autorisations d'accs  la rubrique

	 
	//Constructeur.	 
	function rubriques($id_rubrique= 0) {
		
		if ($id_rubrique) {
			$this->id_rubrique = $id_rubrique;
			$this->load();	
		}
	}

	
	// charge une rubrique  partir de la base.
	function load(){
	
		global $dbh;
		
		$q = "select * from rubriques where id_rubrique = '".$this->id_rubrique."' ";
		$r = mysql_query($q, $dbh) ;
		$obj = mysql_fetch_object($r);
		$this->num_budget = $obj->num_budget;
		$this->num_parent = $obj->num_parent;
		$this->libelle = $obj->libelle;
		$this->commentaires = $obj->commentaires;
		$this->montant = $obj->montant;
		$this->num_cp_compta = $obj->num_cp_compta;
		$this->autorisations = $obj->autorisations;

	}

	
	// enregistre une rubrique en base.
	function save(){
		
		global $dbh;
		
		if ($this->libelle == '' || !$this->num_budget) die("Erreur de cration rubriques");
	
		if ($this->id_rubrique) {
			
			$q = "update rubriques set num_budget = '".$this->num_budget."', num_parent = '".$this->num_parent."', libelle = '".$this->libelle."', ";
			$q.= "commentaires = '".$this->commentaires."', montant = '".$this->montant."', num_cp_compta = '".$this->num_cp_compta."', autorisations = '".$this->autorisations."' ";
			$q.= "where id_rubrique = '".$this->id_rubrique."' ";
			$r = mysql_query($q, $dbh);
			
		} else {
			
			$q = "insert into rubriques set num_budget = '".$this->num_budget."', num_parent = '".$this->num_parent."', libelle = '".$this->libelle."', ";
			$q.= "commentaires = '".$this->commentaires."', montant = '".$this->montant."', num_cp_compta = '".$this->num_cp_compta."', autorisations = '".$this->autorisations."' ";
			$r = mysql_query($q, $dbh);
			$this->id_rubrique = mysql_insert_id($dbh);
			
		}

	}


	//supprime un rubrique de la base
	function delete($id_rubrique= 0) {
		
		global $dbh;

		if(!$id_rubrique) $id_rubrique = $this->id_rubrique; 	

		$q = "delete from rubriques where id_rubrique = '".$id_rubrique."' ";
		$r = mysql_query($q, $dbh);
				
	}

	
	//calcule le montant engag pour une rubrique budgtaire
	function calcEngagement($id_rubrique= 0) {
		
		global $dbh;

		if(!$id_rubrique) $id_rubrique = $this->id_rubrique; 	

		//	Montant Total engag pour une rubrique =
		//	Somme des Montants engags non facturs pour une rubrique par ligne de commande		(nb_command-nb_factur)*prix_commande*(1-remise_commande)
		//+ Somme des Montants engags pour une rubrique par ligne de facture					(nb_factur)*prix_facture*(1-remise_facture)

		$q1 = "select ";
		$q1.= "lignes_actes.id_ligne, lignes_actes.nb as nb, lignes_actes.prix as prix, lignes_actes.remise as rem ";
		$q1.= "from actes, lignes_actes ";
		$q1.= "where ";
		$q1.= "lignes_actes.num_rubrique = '".$id_rubrique."' ";
		$q1.= "and actes.type_acte = '".TYP_ACT_CDE."' ";
		$q1.= "and actes.statut > '".STA_ACT_AVA."' and ( (actes.statut & ".STA_ACT_FAC.") != ".STA_ACT_FAC.") ";
		$q1.= "and actes.id_acte = lignes_actes.num_acte ";
		$r1 = mysql_query($q1, $dbh);

		$tab_cde = array();
		while($row1 = mysql_fetch_object($r1)) {
			
			$tab_cde[$row1->id_ligne]['nb']=$row1->nb;
			$tab_cde[$row1->id_ligne]['prix']=$row1->prix;				
			$tab_cde[$row1->id_ligne]['rem']=$row1->rem;
		
		}			
		
		$q2 = "select ";
		$q2.= "lignes_actes.lig_ref, sum(nb) as nb ";
		$q2.= "from actes, lignes_actes ";
		$q2.= "where ";
		$q2.= "actes.type_acte = '".TYP_ACT_FAC."' ";
		$q2.= "and actes.id_acte = lignes_actes.num_acte ";
		$q2.= "group by lignes_actes.lig_ref ";
		$r2 = mysql_query($q2, $dbh);	

		while($row2 = mysql_fetch_object($r2)) {
			if(array_key_exists($row2->lig_ref,$tab_cde)) {
				$tab_cde[$row2->lig_ref]['nb'] = $tab_cde[$row2->lig_ref]['nb'] - $row2->nb; 
			}
		}

		$q3 = "select ";
		$q3.= "lignes_actes.id_ligne, lignes_actes.nb as nb, lignes_actes.prix as prix, lignes_actes.remise as rem ";
		$q3.= "from actes, lignes_actes ";
		$q3.= "where ";
		$q3.= "lignes_actes.num_rubrique = '".$id_rubrique."' ";
		$q3.= "and actes.type_acte = '".TYP_ACT_FAC."' ";
		$q3.= "and actes.id_acte = lignes_actes.num_acte ";
		$r3 = mysql_query($q3, $dbh);

		$tab_fac = array();
		while($row3 = mysql_fetch_object($r3)) {
			
			$tab_fac[$row3->id_ligne]['nb']=$row3->nb;
			$tab_fac[$row3->id_ligne]['prix']=$row3->prix;				
			$tab_fac[$row3->id_ligne]['rem']=$row3->rem;
		
		}			

		$tot_rub = 0;
		$tab = array_merge($tab_cde, $tab_fac);
		
		foreach($tab as $key=>$value) {
			$tot_lig = $tab[$key]['nb']*$tab[$key]['prix'];
			if($tab[$key]['rem'] != 0) $tot_lig = $tot_lig * (1- ($tab[$key]['rem']/100));
			$tot_rub = $tot_rub + $tot_lig;
		}
		return $tot_rub;
	}


	//compte le nb d'enfants d'une rubrique
	function countChilds($id_rubrique=0) {
		
		global $dbh;
		
		if(!$id_rubrique) $id_rubrique = $this->id_rubrique;
		
		$q = "select count(1) from rubriques where num_parent ='".$id_rubrique."' ";
		$r = mysql_query($q, $dbh);
		return mysql_result($r, 0, 0);
	}		

	
	//Liste les ancetres d'une rubrique et les retourne sous forme d'un tableau [index][$id=>$libelle] 
	function listAncetres($id_rub=0, $inclus=FALSE) {
		
		global $dbh;
		
		if(!$id_rub) {
			$id_rub = $this->id_rubrique;
		}
		
		$q = "select id_rubrique, libelle, num_parent from rubriques where id_rubrique = '".$id_rub."' limit 1";
		$r = mysql_query($q, $dbh);
		$row = mysql_fetch_object($r);
		$rub_list = array();

		$i=0;

		if ($inclus) {
			$rub_list[$i][0] = $row->id_rubrique;
			$rub_list[$i][1] = $row->libelle;
			$rub_list[$i][2] = $row->num_parent;
			$i++;
		}

		while ($row->num_parent){
			$q = "select id_rubrique, libelle, num_parent from rubriques where id_rubrique = '".$row->num_parent."' limit 1";
			$r = mysql_query($q, $dbh);
			$row = mysql_fetch_object($r);
			$rub_list[$i][0] = $row->id_rubrique;
			$rub_list[$i][1] = $row->libelle;
			$rub_list[$i][2] = $row->num_parent;
			$i++;
		}

		$rub_list = array_reverse($rub_list);
		return $rub_list;		
	}	


	//Compte le nb de lignes d'actes affectes  une rubrique budgetaire			
	function hasLignes($id_rubrique=0){
		
		global $dbh;
		if (!$id_rubrique) $id_rubrique = $this->id_rubrique;
		$q = "select count(1) from lignes_actes where num_rubrique = '".$id_rubrique."' ";
		$r = mysql_query($q, $dbh);
		return mysql_result($r, 0, 0);
		
	}	


	//Recalcul des montants des rubriques parent et raz des numros de compte comptable et autorisations
	function maj($num_parent=0, $calcul=TRUE ) {
		
		global $dbh;
		
		if ($calcul) {

			if($num_parent) {
				$q = "select sum(montant) from rubriques where num_parent = '".$num_parent."' ";
				$r = mysql_query($q, $dbh);
				$total = mysql_result($r,0,0);
			
				$parent = new rubriques($num_parent);	
				$parent->montant = $total;
				$parent->num_cp_compta = '';
				$parent->autorisations = '';
				$parent->save();
			
				rubriques::maj($parent->num_parent);
			}

		} else {

			if($num_parent) {
				$parent = new rubriques($num_parent);	
				$parent->num_cp_compta = '';
				$parent->autorisations = '';
				$parent->save();				
				rubriques::maj($parent->num_parent, FALSE);
			}
			
		}
	}

	
	//
	function getAutorisations($id_rubrique, $id_user) {
		
		global $dbh;
		
		$q = "select count(1) from rubriques where id_rubrique = '".$id_rubrique."' and autorisations like('% ".$id_user." %') ";
		$r = mysql_query($q, $dbh);
		return mysql_result($r, 0, 0);
		
	}
	
	//optimization de la table rubriques
	function optimize() {
		
		global $dbh;
		
		$opt = mysql_query('OPTIMIZE TABLE rubriques', $dbh);
		return $opt;
				
	}
	
				
}
?>