<?php
// +-------------------------------------------------+
//  2002-2004 PMB Services / www.sigb.net pmb@sigb.net et contributeurs (voir www.sigb.net)
// +-------------------------------------------------+
// $Id: bull_info.inc.php,v 1.27 2007/09/07 08:52:59 gueluneau Exp $

if (stristr($_SERVER['REQUEST_URI'], ".inc.php")) die("no access");

// affichage des infos bulletin

require_once($include_path."/resa_func.inc.php");
require_once($class_path."/emprunteur.class.php");

// get_expl : retourne un tableau avec les exemplaires du bulletinage
function get_expl($expl) {
	global $bul_id;
	global $msg, $dbh;
	global $cart_link_non;
	global $explr_invisible, $explr_visible_unmod, $explr_visible_mod, $pmb_droits_explr_localises ;
	
	// attention, $bul est un array
	if(!sizeof($expl) || !is_array($expl)) {
		return $msg["bull_no_expl"];
		}
	
	$explr_tab_invis=explode(",",$explr_invisible);
	$explr_tab_unmod=explode(",",$explr_visible_unmod);
	$explr_tab_modif=explode(",",$explr_visible_mod);
		
	// un tableau et qui passe pas en CSS !!! A modifier. FL
	$th = "<th>";
	$th_line = "<tr><th>".$msg[293]."</th><th>".$msg[4016]."</th><th>".$msg[4017]."</th><th>".$msg[4018]."</th><th>".$msg[4019]."</th><th>".$msg[4015]."</th><th></th>";
	$expl_line = "<tr><td>!!1!!</td><td>!!2!!</td><td>!!3!!</td><td>!!4!!</td><td>!!5!!</td><td>!!6!!</td><td>!!7!!</td></tr>";
	$result = "<table border=\"0\" cellspacing=\"1\">";
	$result .= $th_line;
	
	$selector_prop = "toolbar=no, dependent=yes, width=500, height=400, resizable=yes, scrollbars=yes";
	$cart_click_expl = "onClick=\"window.open('./cart.php?object_type=EXPL&item=!!item!!', 'cart', '$selector_prop')\"";
	
	// global $cart_click_expl;
	// ot du global et forc, risque de faire afficher l'icne panier  des endroits peu propices... A surveiller
	$cart_link = "<img src='./images/basket_small_20x20.gif' align='center' alt='middle' title=\"${msg[400]}\" $cart_click_expl>";
	while(list($cle, $valeur) = each($expl)) {

		$requete_prets  = "SELECT pret.*, ";
		$requete_prets .= " date_format(pret_date, '".$msg["format_date"]."') as aff_pret_date, ";
		$requete_prets .= " date_format(pret_retour, '".$msg["format_date"]."') as aff_pret_retour, ";
		$requete_prets .= " IF(pret_retour>sysdate(),0,1) as retard " ;
		$requete_prets .= " FROM pret where pret_idexpl = '$valeur->expl_id' ";
		$result_prets = mysql_query($requete_prets, $dbh) or die ("<br>".mysql_error()."<br>".$requete_prets);
		$expl_pret->pret_flag = mysql_num_rows($result_prets);
		$situation = "";
		if ($expl_pret->pret_flag) {
			$expl_pret = mysql_fetch_object($result_prets) ;
			// exemplaire sorti
			$rqt_empr = "SELECT empr_nom, empr_prenom, id_empr, empr_cb FROM empr WHERE id_empr='$expl_pret->pret_idempr' ";
			$res_empr = mysql_query ($rqt_empr, $dbh) ;
			$res_empr_obj = mysql_fetch_object ($res_empr) ;
			$situation = "<strong>${msg[358]} ".$expl_pret->aff_pret_retour."</strong>";
			global $empr_show_caddie, $selector_prop_ajout_caddie_empr;
			if ($empr_show_caddie) {
				$img_ajout_empr_caddie="<img src='./images/basket_empr.gif' align='middle' alt='basket' title=\"${msg[400]}\" onClick=\"window.open('./cart.php?object_type=EMPR&item=".$expl->pret_idempr."', 'cart', '$selector_prop_ajout_caddie_empr')\">&nbsp;";
				} else $img_ajout_empr_caddie="";
			$situation .= "<br>$img_ajout_empr_caddie<a href='./circ.php?categ=pret&form_cb=".rawurlencode($res_empr_obj->empr_cb)."'>$res_empr_obj->empr_prenom $res_empr_obj->empr_nom</a>";
			} else {
				// tester si rserv
				$result_resa = mysql_query("select 1 from resa where resa_cb='".$valeur->expl_cb."' ", $dbh) or die ();
				$reserve = mysql_num_rows($result_resa);
				if ($reserve) $situation = "<strong>".$msg['expl_reserve']."</strong>"; // exemplaire rserv
					else $situation = "<strong>${msg[359]}</strong>"; // exemplaire disponible
				}
	
		$ajout_expl_panier = str_replace('!!item!!', $valeur->expl_id, $cart_link) ;
		//visibilit des exemplaires
		if ($pmb_droits_explr_localises) {
			$as_invis = array_search($valeur->expl_location,$explr_tab_invis);
			$as_unmod = array_search($valeur->expl_location,$explr_tab_unmod);
			$as_modif = array_search($valeur->expl_location,$explr_tab_modif);
		} else {
			$as_invis = false;
			$as_unmod = false;
			$as_modif = true;
		}
		
		if ($cart_link_non) $link = $valeur->expl_cb;
			else {
				if ($as_modif!== FALSE && $as_modif!== NULL) $link = "<a href=\"./catalog.php?categ=serials&sub=bulletinage&action=expl_form&bul_id=".$valeur->expl_bulletin."&expl_id=".$valeur->expl_id."\">".$valeur->expl_cb."</a>";
					else $link = $valeur->expl_cb;
			}
		$line = str_replace('!!1!!', $link, $expl_line);
		$line = str_replace('!!2!!', $valeur->expl_cote, $line);
		$line = str_replace('!!3!!', $valeur->location_libelle, $line);
		$line = str_replace('!!4!!', $valeur->section_libelle, $line);
		$line = str_replace('!!5!!', $valeur->statut_libelle."<br>".$situation, $line);
		$line = str_replace('!!6!!', $valeur->tdoc_libelle, $line);
		$line = str_replace('!!7!!', $ajout_expl_panier, $line);
		$result .= $line; 
		}
	$result .= "</table>";
	return $result;
	}


// get_analysis : retourne les dpouillements pour un bulletinage donn
function get_analysis($bul_id) {
	global $dbh;

	if(!$bul_id) return '';

	$requete = "SELECT * FROM analysis WHERE analysis_bulletin=$bul_id ORDER BY analysis_notice"; 	
	$myQuery = mysql_query($requete, $dbh);

	// attention, c'est complexe l. on dfinit ce qui va se passer pour les liens affichs dans les notices
	// 1. si le lien est vers une notice chapeau de priodique
	$link_serial = "./catalog.php?categ=serials&sub=view&serial_id=!!id!!";
	// 2. si le lien est vers un dpouillement
	$link_analysis = "./catalog.php?categ=serials&sub=analysis&action=analysis_form&bul_id=$bul_id&analysis_id=!!id!!";
	// 3. si le lien est vers un bulletin
	$link_bulletin = "./catalog.php?categ=serials&sub=bulletinage&action=view&bul_id=!!id!!";
	// note : si une de ces trois variables est vide, aucun lien n'est cre en ce qui la concerne dans les notices
	// exemple : dans cette page, on affiche les infos sur ce bulletinage, il ne sert donc  rien d'afficher un lien
	// vers celui-ci. donc :
	$link_bulletin = '';
	 
	
	while($analysis=mysql_fetch_object($myQuery)) {
		$link_explnum = "./catalog.php?categ=serials&sub=analysis&action=explnum_form&analysis_id=$analysis->analysis_notice&bul_id=$bul_id&explnum_id=!!explnum_id!!";
		$display = new serial_display($analysis->analysis_notice, 6, $link_serial, $link_analysis, $link_bulletin,"",$link_explnum, 1,0,1, 1);
		$analysis_list .= $display->result;
		}
	return $analysis_list;
	} 

// affichage d'informations pour une entre de bulletinage
function show_bulletinage_info($bul_id, $lien_cart_ajout=1, $lien_cart_suppr=0 ) {
	global $dbh;
	global $msg;
	global $liste_script;
	global $liste_debut;
	global $liste_fin;
	global $bul_action_bar;
	global $bul_cb_form;
	global $selector_prop;
	global $url_base_suppr_cart ;
	
	$cart_click_bull = "onClick=\"window.open('./cart.php?object_type=BULL&item=!!item!!', 'cart', '$selector_prop')\"";
	
	$affichage_final = "";
	if($bul_id) {
		if (SESSrights & CATALOGAGE_AUTH) {
			$myBul = new bulletinage($bul_id, 0, "./catalog.php?categ=serials&sub=bulletinage&action=explnum_form&bul_id=$bul_id&explnum_id=!!explnum_id!!");
			// lien vers la notice chapeau
			$link_parent = "<a href=\"./catalog.php?categ=serials\">".$msg[4010]."</a>";
			$link_parent .= "<img src=\"./images/d.gif\" align=\"middle\" hspace=\"5\">";
			$link_parent .= "<a href=\"./catalog.php?categ=serials&sub=view&serial_id=";
			$link_parent .= $myBul->bulletin_notice."\">".$myBul->tit1.'</a>';
			$link_parent .= "<img src=\"./images/d.gif\" align=\"middle\" hspace=\"5\">";
			
			if($myBul->bulletin_numero) $link_bulletin = $myBul->bulletin_numero." ";
			// affichage de la mention de date utile : mention_date si existe, sinon date_date
			if ($myBul->mention_date)
				$date_affichee = " (".$myBul->mention_date.")";
				else if ($myBul->date_date)
					$date_affichee = " [".formatdate($myBul->date_date)."]";
					else $date_affichee = "" ;
			$link_bulletin .= $date_affichee;

			$link_parent .= "<a href='./catalog.php?categ=serials&sub=bulletinage&action=view&bul_id=$bul_id'>$link_bulletin</a>" ;
			$affichage_final .= "<div class='row'><div class='perio-barre'>".$link_parent."</div></div>";
			} else {
				$myBul = new bulletinage($bul_id, 0, "");
				}
				
		
		if ($lien_cart_ajout) {
			$cart_link = "<img src='./images/basket_small_20x20.gif' align='middle' alt='basket' title=\"${msg[400]}\" $cart_click_bull>";
			$cart_link = str_replace('!!item!!', $bul_id, $cart_link);
			} else $cart_link="" ;
			
		if ($lien_cart_suppr) $cart_link .= "<a href='$url_base_suppr_cart&action=del_item&object_type=BULL&item=$bul_id'><img src='./images/basket_empty_20x20.gif' align='middle' alt='basket' title=\"".$msg[caddie_icone_suppr_elt]."\" /></a>";
		
		$bul_action_bar = str_replace('!!bul_id!!', $bul_id, $bul_action_bar);
		$bul_action_bar = str_replace('!!nb_expl!!', sizeof($myBul->expl), $bul_action_bar);
		
		$bul_isbd = $myBul->display;
		
		$javascript_template ="
		<div id=\"el!!id!!Parent\" class=\"notice-parent\">
    		<img src=\"./images/plus.gif\" name=\"imEx\" id=\"el!!id!!Img\" title=\"".$msg['admin_param_detail']."\" border=\"0\" onClick=\"expandBase('el!!id!!', true); return false;\" hspace=\"3\">
    		<span class=\"notice-heada\">!!heada!!</span>
    		<br>
		</div>
		<div id=\"el!!id!!Child\" class=\"notice-child\" style=\"margin-bottom:6px;display:none;\">
           		!!ISBD!!
 		</div>";
		$aff_expandable = str_replace('!!id!!', $bul_id, $javascript_template);
		$aff_expandable = str_replace('!!heada!!', $cart_link." ".$bul_isbd, $aff_expandable);

		// affichage des exemplaires associs
		$list_expl  = "<div class='exemplaires-perio'>";
		$list_expl .= "<h3>".$msg[4012]."</h3>";
		$list_expl .= "<div class='row'>".get_expl($myBul->expl)."</div></div>";
		$affichage_final .= $list_expl;
		
		$aff_expl_num=$myBul->explnum ;
		if ($aff_expl_num) {
			$list_expl = "<div class='exemplaires-perio'><h3>".$msg[explnum_docs_associes]."</h3>";
			$list_expl .= "<div class='row'>".$aff_expl_num."</div></div>";
			$affichage_final .=  $list_expl;
			} 
		
		// zone d'affichage des dpouillements
		$liste = get_analysis($bul_id);
		if($liste) {
			$liste_dep = $liste;
			$liste_dep .= $liste_fin;
			// inclusion du javascript inline
			$liste_dep .= $liste_script;
			} else {
				$liste_dep .= "<div class='row'>Pas de dpouillement</div>";
				}
		$affichage_final .= "
			<div class='depouillements-perio'>
				<h3>".$msg[4013]."</h3>
				<div class='row'>
					$liste_dep
					</div>
				</div>";
		$aff_resa=resa_list (0, $bul_id, 0) ;
		if ($aff_resa) $affichage_final .= "<h3>$msg[resas]</h3>".$aff_resa;
		}
	$aff_expandable = str_replace('!!ISBD!!', $affichage_final, $aff_expandable);
	return $aff_expandable ;
	}

