<?php
// +-------------------------------------------------+
//  2002-2004 PMB Services / www.sigb.net pmb@sigb.net et contributeurs (voir www.sigb.net)
// +-------------------------------------------------+
// $Id: resa_func.inc.php,v 1.56 2007/10/03 13:53:56 jlesaint Exp $

if (stristr($_SERVER['REQUEST_URI'], ".inc.php")) die("no access");

require_once("$class_path/quotas.class.php");
// defines pour flag affichage info de gestion
define ('NO_INFO_GESTION', 0); // 0 >> aucune info de gestion : liste simple, attention utilise un peu partout !
define ('GESTION_INFO_GESTION', 1); // pour traitement des rsa
define ('LECTEUR_INFO_GESTION', 2); // pour affichage en fiche lecteur

function resa_list ($idnotice=0, $idbulletin=0, $idempr=0, $order="", $where = "", $info_gestion=NO_INFO_GESTION, $url_gestion="") {

global $dbh ;
global $msg;
global $montrerquoi ;
global $current_module ;
global $pdflettreresa_priorite_email_manuel;
global $deflt2docs_location, $pmb_lecteurs_localises, $empr_location_id ;

if (!$montrerquoi) $montrerquoi='all' ;

if (!$order) $order="tit, resa_idnotice, resa_idbulletin, resa_date" ;

$sql="SELECT resa_idnotice, resa_idbulletin, resa_date, resa_date_debut, resa_date_fin, resa_cb, resa_confirmee, resa_idempr, empr_nom, empr_prenom, empr_cb, ";
$sql.=" trim(concat(ifnull(notices_m.tit1,''),ifnull(notices_s.tit1,''),' ',ifnull(bulletin_numero,''), if (mention_date, concat(' (',mention_date,')') ,''))) as tit, id_resa, ";
$sql.=" IF(resa_date_fin>=sysdate() or resa_date_fin='0000-00-00',0,1) as perimee, date_format(resa_date_debut, '".$msg["format_date"]."') as aff_resa_date_debut, if(resa_date_fin='0000-00-00', '', date_format(resa_date_fin, '".$msg["format_date"]."')) as aff_resa_date_fin, date_format(resa_date, '".$msg["format_date"]."') as aff_resa_date " ;
$sql.=" FROM (((resa LEFT JOIN notices AS notices_m ON resa_idnotice = notices_m.notice_id ) ";
$sql.=" LEFT JOIN bulletins ON resa_idbulletin = bulletins.bulletin_id) ";
$sql.=" LEFT JOIN notices AS notices_s ON bulletin_notice = notices_s.notice_id), ";
$sql.=" empr ";
if ($idempr) $sql.=" where id_empr='$idempr' AND resa_idempr = id_empr ";
	elseif ($idnotice || $idbulletin) $sql.=" where resa_idnotice = '$idnotice' AND resa_idbulletin='$idbulletin' and resa_idempr = id_empr ";
		else $sql.=" where resa_idempr = id_empr ";
if ($where) $sql.=" AND ".$where ;
$sql.=" group by resa_idnotice, resa_idbulletin, resa_idempr ";
$sql.=" order by ".$order ;

$req = mysql_query($sql) or die("Erreur SQL !<br>".$sql."<br>".mysql_error()); 

switch ($info_gestion) {
	case GESTION_INFO_GESTION:
		$aff_final .= "<form class='form-$current_module' name='check_resa' action='$url_gestion' method='post'><div class='left'>" ;
		$aff_final .= "<span class='usercheckbox'><input type='radio' name='montrerquoi' value='all' id='all' onclick='this.form.submit();' ";
		if ($montrerquoi=='all') $aff_final .= "checked" ;
		$aff_final .= "><label for='all'>".$msg['resa_show_all']."</label></span>&nbsp;<span class='usercheckbox'><input type='radio' name='montrerquoi' value='validees' id='validees' onclick='this.form.submit();' ";
		if ($montrerquoi=='validees') $aff_final .= "checked" ;
		$aff_final .= "><label for='validees'>".$msg['resa_show_validees']."</label></span>&nbsp;<span class='usercheckbox'><input type='radio' name='montrerquoi' value='invalidees' id='invalidees' onclick='this.form.submit();' ";
		if ($montrerquoi=='invalidees') $aff_final .= "checked" ;
		$aff_final .= "><label for='invalidees'>".$msg['resa_show_invalidees']."</label></span>&nbsp;<span class='usercheckbox'><input type='radio' name='montrerquoi' value='valid_noconf' id='valid_noconf' onclick='this.form.submit();' ";
		if ($montrerquoi=='valid_noconf') $aff_final .= "checked" ;
		if (SESSrights & EDIT_AUTH) $lien_edit_resa_traiter = "<a href='./edit.php?categ=notices&sub=resa_a_traiter'>".$msg[1100]."</a>" ;
		$aff_final .= "><label for='valid_noconf'>".$msg['resa_show_non_confirmees']."</label></span></div><div class='right'>".$lien_edit_resa_traiter."</div><div class='row'>&nbsp;</div>" ;
		
		jscript_checkbox() ;
		break;
	case LECTEUR_INFO_GESTION:
		break;
	default:
	case NO_INFO_GESTION:
		break;
	}

if (!mysql_num_rows($req)) {
	switch ($info_gestion) {
		case GESTION_INFO_GESTION:
			$aff_final .= "</form>" ;
			break;
		case LECTEUR_INFO_GESTION:
			break;
		default:
		case NO_INFO_GESTION:
			break;
		}
	return $aff_final ;
	}
	
$aff_final .= "<table width='100%'>";
$aff_final .= "<tr>" ;
if (!$idnotice && !$idbulletin) $aff_final .= "<th>$msg[233]</th>" ;
if (!$idempr) $aff_final .= "<th>$msg[empr_nom_prenom]</th>";

$aff_final .= "<th>$msg[366]</th>
 	<th>$msg[374]</th>
 	<th>$msg[resa_condition]</th>
 	<th>$msg[resa_date_fin]</th>";
switch ($info_gestion) {
	case GESTION_INFO_GESTION:
		$aff_final .= "<th>$msg[resa_validee]</th><th>$msg[resa_confirmee]</th><th>$msg[resa_selectionner]</th>" ;
		break;
	case LECTEUR_INFO_GESTION:
		$aff_final .= "<th>$msg[resa_confirmee]</th><th>$msg[resa_suppr_th]</th>" ;
		break;
	default:
	case NO_INFO_GESTION:
		break;
	}

$aff_final .= "</tr>";
$odd_even=0;
while ($data = mysql_fetch_array($req)) {
	$resa_idnotice = $data['resa_idnotice'];
	$resa_idbulletin = $data['resa_idbulletin'];
	$resa_idempr = $data['resa_idempr'] ;
	$precedenteresa_idbulletin=0;
	$precedenteresa_idnotice=0;
	$rank=1;
	if (($resa_idnotice != $precedenteresa_idnotice) || ($resa_idbulletin != $precedenteresa_idbulletin)) {
		$rank=1;
		$precedenteresa_idnotice=$resa_idnotice;
		$precedenteresa_idbulletin=$resa_idbulletin;
		
		// dtermination de la date  afficher dans la case retour pour le rang 1
		// disponible, rserv ou date de retour du premier exemplaire
		
		// on compte le nombre total d'exemplaires prtables pour la notice
		$query = "select count(1) from exemplaires, docs_statut";
		if ($resa_idnotice)  $query .= " where expl_notice=".$resa_idnotice;
			elseif ($resa_idbulletin) $query .= " where expl_bulletin=".$resa_idbulletin;
		$query .= " and expl_statut=idstatut and pret_flag=1";
		$tresult = @mysql_query($query, $dbh);
		$total_ex = mysql_result($tresult, 0, 0);

		// on compte le nombre d'exemplaires sortis
		$query = "select count(1) as qte from exemplaires e, pret p";
		if ($resa_idnotice) $query .= " where e.expl_notice=".$resa_idnotice;
			elseif ($resa_idbulletin) $query .= " where e.expl_bulletin=".$resa_idbulletin;
		$query .= " and p.pret_idexpl=e.expl_id";
		$tresult = @mysql_query($query, $dbh);
		$total_sortis = mysql_result($tresult, 0, 0);

		// on en dduit le nombre d'exemplaires disponibles
		$total_dispo = $total_ex - $total_sortis;

		if($rank <= $total_dispo) {
			// un exemplaire est disponible pour le rservataire (affichage : disponible)
			$situation = "<strong>$msg[359]</strong>";
			} else {
				if($total_dispo) {
					// un ou des exemplaires sont disponibles, mais pas pour ce rservataire (affichage : reserv)
					$situation = 'reserv';
					} else {
						// rien n'est disponible, on trouve la date du premier retour
						$query = "select date_format(pret_retour, '".$msg["format_date"]."') as aff_pret_retour from pret p, exemplaires e ";
						if ($resa_idnotice) $query .= " where e.expl_notice=".$resa_idnotice;
							elseif ($resa_idbulletin) $query .= " where e.expl_bulletin=".$resa_idbulletin;
						$query .= " and e.expl_id=p.pret_idexpl";
						$query .= " order by p.pret_retour limit 1";
						$tresult = mysql_query($query, $dbh);
						if (mysql_num_rows($tresult)) $situation = mysql_result($tresult, 0, 0);
							else $situation = $msg['resa_no_expl'];
						}
				}
		} else {
			$rank++;
			$situation='';
			}
	
	if ( ($montrerquoi=='validees' && $data['resa_cb']) || 
			($montrerquoi=='invalidees' && !$data['resa_cb']) || 
			($montrerquoi=='all') 
			|| ($montrerquoi=='valid_noconf' && $data['resa_cb'] && !$data['resa_confirmee']) ) {
		$rank = recupere_rang($resa_idempr, $resa_idnotice, $resa_idbulletin) ;
		// on affiche les rsultats 
		if ($odd_even==0) {
			$aff_final .= "\n<tr class='odd' onmouseover=\"this.className='surbrillance'\" onmouseout=\"this.className='odd'\">";
			$odd_even=1;
			} else if ($odd_even==1) {
				$aff_final .= "\n<tr class='even' onmouseover=\"this.className='surbrillance'\" onmouseout=\"this.className='even'\">";
				$odd_even=0;
				}
		if (SESSrights & CATALOGAGE_AUTH) {
			if ($resa_idnotice) $link = "<a href='./catalog.php?categ=isbd&id=".$resa_idnotice."'>".$data['tit']."</a>";
				elseif ($resa_idbulletin) $link = "<a href='./catalog.php?categ=serials&sub=bulletinage&action=view&bul_id=".$resa_idbulletin."'>".$data['tit']."</a>";
			} else $link = $data['tit'];
		if (!$idnotice && !$idbulletin) $aff_final .= "<td><b>$link</b></td>";    
		if (!$idempr) {
			if (SESSrights & CIRCULATION_AUTH) $aff_final .= "<td><a href=\"./circ.php?categ=pret&form_cb=".rawurlencode($data['empr_cb'])."\">".$data['empr_nom'].", ".$data['empr_prenom']."</a></td>"; 
				else $aff_final .= "<td>".$data['empr_nom'].", ".$data['empr_prenom']."</td>"; 
			}
		$aff_final .= "<td>".$rank."</td>"; 
		$aff_final .= "<td>".$data['aff_resa_date']."</td>"; 
		$aff_final .= "<td>".$situation."</td>"; 
		$aff_final .= "<td>".$data['aff_resa_date_fin']."</td>"; 
		// gestion du formulaire de validation/suppression
		switch ($info_gestion) {
			case GESTION_INFO_GESTION:
				$aff_final .= "\n<td style='text-align:center;'>";
				if ($data['resa_cb']) $aff_final .= "<font color='red'><b>X</b></font>" ; else $aff_final .= "&nbsp;" ;
				$aff_final .= "</td>\n" ;
				$aff_final .= "\n<td style='text-align:center;'>";
				if ($data['resa_confirmee']) $aff_final .= "<font color='red'><b>X</b></font>" ; else $aff_final .= "&nbsp;" ;
				$aff_final .= "</td>\n<td style='text-align:center;'><input type='checkbox' name='suppr_id_resa[]' value='".$data['id_resa']."' id='suppr_resa' /></td>" ;
				break;
			case LECTEUR_INFO_GESTION:
				$aff_final .= "\n<td style='text-align:center;'>";
				if ($data['resa_confirmee']) $aff_final .= "<font color='red'><b>X</b></font>" ; else $aff_final .= "&nbsp;" ;
				$aff_final .= "</td>" ;
				$aff_final .= "\n<td style='text-align:center;'>";
				$aff_final .= "<input type='button' class='bouton' name='suppr_resa' value='".$msg['raz']."' id='suppr_resa' ";
				$aff_final .= "onClick=\"document.location='./circ.php?categ=pret&sub=suppr_resa_from_fiche&action=suppr_resa&suppr_id_resa[]=".$data['id_resa']."&id_empr=$idempr'\" />" ;
				$aff_final .= "</td>" ;
				break;
			default:
			case NO_INFO_GESTION:
				break;
			}
		$aff_final .= "</tr>\n";
		}
	} 

$aff_final .= "</table>";

switch ($info_gestion) {
	case GESTION_INFO_GESTION:
		$aff_final .= "<table style='background:none;border-right:0px;border-left:0px;border-bottom:0px;border-top:0px;'>
				<tr><td style='background:none;border-right:0px;border-left:0px;border-bottom:0px;border-top:0px;text-align:left;'>";
		if ($pdflettreresa_priorite_email_manuel!=3) $aff_final .= "<input type='hidden' name='impression_confirmation' value='0' /><input type='button' class='bouton' value='".$msg[resa_impression_confirmation]."' onclick=\"this.form.action.value='suppr_resa'; this.form.impression_confirmation.value=1; this.form.submit();\"/></td>";
		$aff_final .= "<input type='hidden' name='action' value='' />";
		$aff_final .= "<td style='background:none;border-right:0px;border-left:0px;border-bottom:0px;border-top:0px;text-align:left;'><input type='button' class='bouton' value='".$msg[resa_valider_suppression]."'  onclick=\"this.form.action.value='suppr_resa'; this.form.submit();\" />";
				
		$aff_final .= "</td><td style='background:none;border-right:0px;border-left:0px;border-bottom:0px;border-top:0px;text-align:right;'>";
		$aff_final .= "<input type='button' class='bouton' onClick=\"setCheckboxes('check_resa', 'suppr_id_resa', true); return false;\" value='".$msg['resa_tout_cocher']."' />";
		$aff_final .= "</td></tr></table></form>" ;
		break;
	case LECTEUR_INFO_GESTION:
		break;
	default:
	case NO_INFO_GESTION:
		break;
	}

mysql_free_result ($req); 

return $aff_final ;
}

// cette fonction va retourner un tableau des rsa pas traites
function resa_list_resa_a_traiter () {
	
/* Traitement :
	chercher toutes les rservations non traites (resa_cb ="")
	construire le tableau avec le titre de l'ouvrage, le nom du rservataire et son rang
*/
global $dbh ;
global $msg;

$tableau_final=array();

$order="tit, resa_idnotice, resa_idbulletin, resa_date" ;

$sql="SELECT resa_idnotice, resa_idbulletin, resa_date, resa_date_fin, resa_cb, resa_idempr, empr_nom, empr_prenom, empr_cb, ";
$sql.=" trim(concat(ifnull(notices_m.tit1,''),ifnull(notices_s.tit1,''),' ',ifnull(bulletin_numero,''), if (mention_date, concat(' (',mention_date,')') ,''))) as tit, id_resa, ";
$sql.=" IF(resa_date_fin>=sysdate() or resa_date_fin='0000-00-00',0,1) as perimee, date_format(resa_date_debut, '".$msg["format_date"]."') as aff_resa_date_debut, if(resa_date_fin='0000-00-00', '', date_format(resa_date_fin, '".$msg["format_date"]."')) as aff_resa_date_fin, date_format(resa_date, '".$msg["format_date"]."') as aff_resa_date " ;
$sql.=" FROM (((resa LEFT JOIN notices AS notices_m ON resa_idnotice = notices_m.notice_id ) ";
$sql.=" LEFT JOIN bulletins ON resa_idbulletin = bulletins.bulletin_id) ";
$sql.=" LEFT JOIN notices AS notices_s ON bulletin_notice = notices_s.notice_id), empr ";
$sql.=" where resa_idempr=id_empr and (resa_cb='' or resa_cb is null) ";
$sql.=" group by resa_idnotice, resa_idbulletin, resa_idempr ";
$sql.=" order by ".$order ;

$req = mysql_query($sql) or die("Erreur SQL !<br>".$sql."<br>".mysql_error()); 

if (!mysql_num_rows($req)) return $tableau_final;

while ($data = mysql_fetch_array($req)) {
	$rank = recupere_rang($data['resa_idempr'], $data['resa_idnotice'], $data['resa_idbulletin']) ;
	$tableau_final[] = array(
				'resa_tit' => $data['tit'],
				'resa_idnotice' => $data['resa_idnotice'],
				'resa_idbulletin' => $data['resa_idbulletin'],
				'resa_idempr' => $data['resa_idempr'],
				'resa_empr' => $data['empr_nom']." ".$data['empr_prenom'],
				'rank' => $rank ) ;
	} // fin while

mysql_free_result ($req); 

return $tableau_final ;
}


function resa_ranger_list () {
	
global $dbh ;
global $msg;
global $begin_result_liste;
global $end_result_liste;

$sql="SELECT resa_cb, expl_id from resa_ranger left join exemplaires on resa_cb=expl_cb ";
$res = mysql_query($sql, $dbh) ;
while ($ranger = mysql_fetch_object($res)) {
	if ($ranger->expl_id) {
		if($stuff = get_expl_info($ranger->expl_id)) {
			$stuff = check_pret($stuff);
			$aff_final .=  print_info($stuff,0,0,0);
			} else {
				$aff_final .=  "<strong>".$ranger->resa_cb."&nbsp;: ${msg[395]}</strong>";
				}
		} else {
			$aff_final .=  "<strong>".$ranger->resa_cb."&nbsp;: ${msg[395]}</strong>";
			}
	}
if ($aff_final) return $begin_result_liste.$aff_final.$end_result_liste;
	else return $msg['resa_liste_docranger_nodoc'] ;
}

// permet de savoir si un CB expl est dj affect  une rsa
function verif_cb_utilise ($cb) {
	global $dbh ;
	$rqt = "select id_resa from resa where resa_cb='".$cb."' ";
	$res = mysql_query ($rqt, $dbh) ;
	$nb=mysql_num_rows($res) ;
	if (!$nb) return 0 ;
	$obj=mysql_fetch_object($res) ;
	return $obj->id_resa ;
	}
	
function affecte_cb ($cb) {
	global $dbh ;
	global $pmb_utiliser_calendrier, $deflt2docs_location;
	
	// chercher s'il s'agit d'une notice ou d'un bulletin
	$rqt = "select expl_notice, expl_bulletin from exemplaires where expl_cb='".$cb."' ";
	$res = mysql_query ($rqt, $dbh) ;
	$nb=mysql_num_rows($res) ;
	if (!$nb) return 0 ;
	
	$obj=mysql_fetch_object($res) ;
	
	// chercher le premier (par ordre de rang, donc de date de dbut de rsa, non valid
	$rqt = "select id_resa, resa_idempr from resa where resa_idnotice='".$obj->expl_notice."' and resa_idbulletin='".$obj->expl_bulletin."' and resa_cb='' and resa_date_fin='0000-00-00' order by resa_date ";
	$res = mysql_query ($rqt, $dbh) ;
	
	if (!mysql_num_rows($res)) return 0 ;
	
	$obj_resa=mysql_fetch_object($res) ;
	
	$nb_days = get_time($obj_resa->resa_idempr,$obj->expl_notice,$obj->expl_bulletin) ;
	
	$rqt_date = "select date_add(sysdate(), INTERVAL '$nb_days' DAY) as date_fin ";
	$resultatdate = mysql_query($rqt_date);
	$res = mysql_fetch_object($resultatdate) ;
	$date_fin = $res->date_fin ;
	
	if ($pmb_utiliser_calendrier) {
		$rqt_date = "select date_ouverture from ouvertures where ouvert=1 and num_location=$deflt2docs_location and to_days(date_ouverture)>=to_days('$date_fin') order by date_ouverture ";
		$resultatdate=mysql_query($rqt_date);
		$res=@mysql_fetch_object($resultatdate) ;
		if ($res->date_ouverture) $date_fin=$res->date_ouverture ;
		}
	
	// mettre resa_cb  jour pour cette resa
	$rqt = "update resa set resa_cb='".$cb."' " ;
	$rqt .= ", resa_date_debut=sysdate() " ;
	$rqt .= ", resa_date_fin='$date_fin' " ;
	$rqt .= " where id_resa='".$obj_resa->id_resa."' ";
	$res = mysql_query ($rqt, $dbh) or die(mysql_error()." <br>$rqt");
	return $obj_resa->id_resa ;
	}


function desaffecte_cb ($cb) {
	global $dbh ;
	$rqt = "update resa set resa_cb='', resa_date_debut='0000-00-00', resa_date_fin='0000-00-00' where resa_cb='".$cb."' ";
	$res = mysql_query ($rqt, $dbh) ;
	return mysql_affected_rows($dbh) ;
	}

function recupere_cb ($id) {
	global $dbh ;
	$rqt = "select resa_cb from resa where id_resa='".$id."' ";
	$res = mysql_query ($rqt, $dbh) ;
	$nb=mysql_num_rows($res) ;
	if (!$nb) return "" ;
	$obj=mysql_fetch_object($res) ;
	return $obj->resa_cb ;
	}

//   calcul du rang d'un emprunteur sur une rservation
function recupere_rang($id_empr, $id_notice, $id_bulletin) {
	global $dbh;
	$rank = 1;
	if (!$id_notice) $id_notice=0;
	if (!$id_bulletin) $id_bulletin=0 ;
	$query = "select resa_idempr from resa where resa_idnotice='".$id_notice."' and resa_idbulletin='".$id_bulletin."' order by resa_date";
	$result = mysql_query($query, $dbh);
	while($resa=mysql_fetch_object($result)) {
		if($resa->resa_idempr == $id_empr) break;
		$rank++;
		}
	return $rank;
	}

//Rcupration de la dure de rservation pour une notice ou un bulletin et un emprunteur
function get_time($id_empr,$id_notice,$id_bulletin) {
	global $pmb_quotas_avances;
	
	//Si les quotas avancs sont actifs
	if ($pmb_quotas_avances) {
		$struct=array();
		if ($id_notice) {
			$struct["NOTI"]=$id_notice;
			$quota_type="BOOK_TIME_QUOTA";
		} else {
			$struct["BULL"]=$id_bulletin;
			$quota_type="BOOK_TIME_SERIAL_QUOTA";
		}
		$struct["READER"]=$id_empr;
		$qt=new quota($quota_type);
		$t=$qt->get_quota_value($struct);
		if ($t==-1) $t=0;
	} else {
		//Sinon je regarde la dure de rservation la plus dfavorable par type de document
		if ($id_notice)
			$requete="select min(duree_resa) from docs_type, exemplaires where expl_notice=$id_notice and expl_typdoc=idtyp_doc";
		else
			$requete="select min(duree_resa) from docs_type, exemplaires where expl_bulletin=$id_bulletin and expl_typdoc=idtyp_doc";
		$resultat=mysql_query($requete);
		if (mysql_num_rows($resultat)) $t=mysql_result($resultat,0,0); else $t=0;
	}
	return $t;
}

function check_quota_resa($id_empr,$id_notice,$id_bulletin) {
	global $dbh;
	global $msg;
	global $pmb_quotas_avances;
	global $_quotas_elements_;
	global $pmb_resa_quota_pret_depasse;
	
	//Initialisation rsultat
	$error=array();
	$error["ERROR"]=false;
	
	//Si les quotas avancs sont autoriss
	if ($pmb_quotas_avances) {
		$struct=array();
		//Quota de notice ou bulletin ?
		if ($id_notice) {
			$quota_type="BOOK_NMBR_QUOTA";
			$struct["NOTI"]=$id_notice;
			$elt_name="NOTICETYPE";
		} else {
			$quota_type="BOOK_NMBR_SERIAL_QUOTA";
			$struct["BULL"]=$id_bulletin;
			$elt_name="BULLETINTYPE";
		}
		//Initialisation du quota
		$qt=new quota($quota_type);
		$struct["READER"]=$id_empr;
		
		//Si rsa bloque en cas de dpassement de quota de prt
		if (!$pmb_resa_quota_pret_depasse) {
			//Le quota de prt est-il atteint pour cette notice ou bulletin
			//Rcupration de l'lment indirect  tester
			$elt=$qt->get_element_by_name($elt_name);
			//Rcupration de l'exemplaire le plus dfavorable associ  la rservation
			$object_id=$qt->get_object_for_indirect_element($_quotas_elements_[$elt],$struct);
			//Initialisation du quota de prt
			$qt_pret=new quota("LEND_NMBR_QUOTA");
		
			$struct_pret["READER"]=$id_empr;
			$struct_pret["EXPL"]=$object_id;
			$r=$qt_pret->check_quota($struct_pret);
		} else $r=false;
		
		//Si quota de prt non viol alors on regarde les quotas de rservation
		if (!$r) {
			//Vrification
			$r=$qt->check_quota($struct);
			//Si quota viol
			if ($r) {
				$error["ERROR"]=true;
				//Erreur
				$error["MESSAGE"]=$qt->error_message;
				//Peut-on forcer ou pas la rsa
				$error["FORCE"] = $qt->force;
				return $error;
			}
		} else {
			$error["ERROR"]=true;
			//Erreur
			$error["MESSAGE"]=$qt_pret->error_message."<br>".$msg["resa_quota_pret_error"];
			//Peut-on forcer ou pas la rsa
			$error["FORCE"] = 0;
			return $error;
		}
		return $error;
	} else return $error;
}

// retourne un tableau constitu des exemplaires disponibles pour une rsa donne
function expl_dispo ($no_notice=0, $no_bulletin=0) {
	global $dbh;
	// on rcupre les donnes des exemplaires
	$requete = "SELECT expl_id, expl_cb, expl_cote, expl_notice, expl_bulletin, pret_retour, location_libelle, section_libelle, statut_libelle ";
	$requete .= " FROM docs_location, docs_section, docs_statut, ";
	$requete .= " exemplaires LEFT JOIN pret ON exemplaires.expl_id=pret.pret_idexpl";
	$requete .= " WHERE expl_notice='$no_notice' and expl_bulletin='$no_bulletin' ";
	$requete .= " AND docs_statut.pret_flag=1";
	$requete .= " AND exemplaires.expl_location=docs_location.idlocation";
	$requete .= " AND exemplaires.expl_section=docs_section.idsection ";
	$requete .= " AND exemplaires.expl_statut=docs_statut.idstatut ";
	$requete .= " order by location_libelle, section_libelle, expl_cote ";
	
	$result = mysql_query($requete, $dbh);	

	while($expl = mysql_fetch_object($result)) {
		if(!$expl->pret_retour && !verif_cb_utilise($expl->expl_cb))  
			$tableau[] = array (
				'expl_id' => $expl->expl_id,
				'expl_cb' => $expl->expl_cb,
				'expl_notice' => $expl->expl_notice,					
				'expl_bulletin' => $expl->expl_bulletin,					
				'expl_cote' => $expl->expl_cote,
				'location' => $expl->location_libelle,
				'section' => $expl->section_libelle,
				'statut' => $expl->statut_libelle ) ;
		}
	return $tableau ;
	}
