<?php
// +-------------------------------------------------+
//  2002-2004 PMB Services / www.sigb.net pmb@sigb.net et contributeurs (voir www.sigb.net)
//  2006 mental works / www.mental-works.com contact@mental-works.com
// 	compltement repris et corrig par PMB Services 
// +-------------------------------------------------+
// $Id: addtags.php,v 1.13 2007/10/27 08:13:19 touraine37 Exp $

$base_path=".";
require_once($base_path."/includes/init.inc.php");
require_once($base_path."/includes/error_report.inc.php") ;
require_once($base_path."/includes/global_vars.inc.php");
// rcupration paramtres MySQL et connection  la base
require_once($base_path.'/includes/opac_db_param.inc.php');
require_once($base_path.'/includes/opac_mysql_connect.inc.php');
$dbh = connection_mysql();

require_once($base_path."/includes/misc.inc.php");
require_once($base_path.'/includes/opac_config.inc.php');

//Sessions !! Attention, ce doit tre imprativement le premer include ( cause des cookies)
require_once($base_path."/includes/session.inc.php");
require_once($base_path.'/includes/start.inc.php');

if (!$opac_allow_add_tag) die();

require_once($base_path."/includes/notice_authors.inc.php");
require_once($base_path."/includes/notice_categories.inc.php");

require_once($base_path."/includes/check_session_time.inc.php");

// rcupration localisation
require_once($base_path.'/includes/localisation.inc.php');

// version actuelle de l'opac
require_once($base_path.'/includes/opac_version.inc.php');

// fonctions de gestion de formulaire
require_once($base_path.'/includes/javascript/form.inc.php');

require_once($base_path.'/includes/templates/common.tpl.php');
require_once($base_path.'/includes/divers.inc.php');

// classe de gestion des catgories
require_once($base_path.'/classes/categorie.class.php');
require_once($base_path.'/classes/notice.class.php');
require_once($base_path.'/classes/notice_display.class.php');

// classe indexation interne
require_once($base_path.'/classes/indexint.class.php');

// classe d'affichage des tags
require_once($base_path.'/classes/tags.class.php');

// classe de gestion des rservations
require_once($base_path.'/classes/resa.class.php');

// pour l'affichage correct des notices
require_once($base_path."/includes/templates/notice.tpl.php");
require_once($base_path."/includes/navbar.inc.php");
require_once($base_path."/includes/explnum.inc.php");
require_once($base_path."/includes/notice_affichage.inc.php");
require_once($base_path."/includes/bulletin_affichage.inc.php");

require_once($base_path."/includes/connexion_empr.inc.php");

// autenticazione LDAP - by MaxMan
require_once($base_path."/includes/ldap_auth.inc.php");

// RSS
require_once($base_path."/includes/includes_rss.inc.php");

if ($opac_allow_add_tag==0) die("");
// par dfaut, on suppose que le droit donn par le statut est Ok
$allow_avis = 1 ;
$allow_tag = 1 ;

if ($opac_allow_add_tag==1) {
	//ajout possible sans authentification
	$log_ok = 1;
	} else {
		//Vrification de la session
		$log_ok=0;
		if (!$_SESSION["user_code"]) {
			if ($time_expired==0) {
				//Si pas de session en cours, vrification du login
				$verif_query = "SELECT id_empr, empr_cb, empr_nom, empr_prenom, empr_password, empr_lang, empr_date_expiration<sysdate() as isexp , empr_login, empr_ldap FROM empr WHERE empr_login='".$_POST['login']."'";
				$verif_result = mysql_query($verif_query) or die(mysql_error());
				// rcupration des valeurs MySQL du lecteur et injection dans les variables
				while ($verif_line = mysql_fetch_array($verif_result)) {
					$verif_empr_cb = $verif_line['empr_cb'];
					$verif_empr_login = $verif_line['empr_login'];
					$verif_empr_ldap = $verif_line['empr_ldap'];
					$verif_empr_password = $verif_line['empr_password'];
					$verif_lang = ($verif_line['empr_lang']?$verif_line['empr_lang']:"fr_FR");
					$verif_id_empr = $verif_line['id_empr'];
					$verif_isexp = $verif_line['isexp'];
					}
				if (($verif_empr_ldap)) $auth_ok=auth_ldap($_POST['login'],$password); // auth by server ldap
					else $auth_ok=(($verif_empr_password==$password)&&($verif_empr_login!="")&&(!$verif_isexp)); //auth standard
				if ($auth_ok) {
					//Si mot de passe correct, enregistrement dans la session de l'utilisateur
					$log_ok=1;
					//Rcupration de l'environnement prcdent
					$requete="select session from opac_sessions where empr_id=".$verif_id_empr;
					$res_session=mysql_query($requete);
					if (@mysql_num_rows($res_session)) {
						$temp_session=unserialize(mysql_result($res_session,0,0));
						$_SESSION=$temp_session;
						} else $_SESSION=array();
	
					$_SESSION["user_code"]=$verif_empr_login;
					$_SESSION["id_empr_session"]=$verif_id_empr;
					$_SESSION["connect_time"]=time();
					$_SESSION["lang"]=$verif_lang;
				
					// change language and charset after login
					$lang=$_SESSION["lang"]; 
					set_language($lang);	
					$query0 = "select * from empr, empr_statut where empr_login='".$_SESSION['user_code']."' and idstatut=empr_statut ";
					$req0 = mysql_query($query0,$dbh);
					$data = mysql_fetch_array($req0);
					$id_empr = $verif_id_empr;
					$empr_cb = $data['empr_cb'];
					$empr_nom = $data['empr_nom'];
					$empr_prenom= $data['empr_prenom'];
					$empr_adr1= $data['empr_adr1'];
					$empr_adr2= $data['empr_adr2'];
					$empr_cp= $data['empr_cp'];
					$empr_ville= $data['empr_ville'];
					$empr_mail= $data['empr_mail'];
					$empr_tel1= $data['empr_tel1'];
					$empr_tel2= $data['empr_tel2'];
					$empr_prof= $data['empr_prof'];
					$empr_year= $data['empr_year'];
					$empr_categ= $data['empr_categ'];
					$empr_codestat= $data['empr_codestat'];
					$empr_sexe= $data['empr_sexe'];
					$empr_login= $data['empr_login'];
					$empr_ldap= $data['empr_ldap'];
			
					// droits de l'utilisateur
					$allow_loan= $data['allow_loan'];
					$allow_loan_hist= $data['allow_loan_hist'];
					$allow_book= $data['allow_book'];
					$allow_opac= $data['allow_opac'];
					$allow_dsi= $data['allow_dsi'];
					$allow_dsi_priv= $data['allow_dsi_priv'];
					$allow_sugg= $data['allow_sugg'];
					$allow_prol= $data['allow_prol'];
					$allow_avis= $data['allow_avis'];
					$allow_tag= $data['allow_tag'];
					$allow_pwd= $data['allow_pwd'];

					} else {
						//Sinon, on dtruit la session cre
						@session_destroy();
						if ($verif_isexp) echo "<script>alert(\"".$msg["empr_expire"]."\");</script>";
						// si pas de session
						$erreur_session = $empr_erreur_header;
						$erreur_session .= $msg["empr_type_card_number"]."<br/>";
						$erreur_session .= $empr_erreur_footer;
						$log_ok=0 ;
						$time_expired = 0 ;
						}
				} else  // la session a expir, on va le lui dire
					echo "<script>alert(\"".sprintf($msg["session_expired"],round($opac_duration_session_auth/60))."\");</script>";
			} else {
				//Si session en cours, pas de problme...
				$log_ok=1;
				$login=$_SESSION["user_code"];
				// droits de l'utilisateur
				$query0 = "select allow_loan, allow_loan_hist, allow_book, allow_opac, allow_dsi, allow_dsi_priv, allow_sugg, allow_prol, allow_avis, allow_tag, allow_pwd from empr, empr_statut where empr_login='".$_SESSION['user_code']."' and idstatut=empr_statut ";
				$req0 = mysql_query($query0,$dbh);
				$data = mysql_fetch_array($req0);
				$allow_loan= $data['allow_loan'];
				$allow_loan_hist= $data['allow_loan_hist'];
				$allow_book= $data['allow_book'];
				$allow_opac= $data['allow_opac'];
				$allow_dsi= $data['allow_dsi'];
				$allow_dsi_priv= $data['allow_dsi_priv'];
				$allow_sugg= $data['allow_sugg'];
				$allow_prol= $data['allow_prol'];
				$allow_avis= $data['allow_avis'];
				$allow_tag= $data['allow_tag'];
				$allow_pwd= $data['allow_pwd'];
				}
		}

print $popup_header;
if ($opac_allow_add_tag==2 && !$allow_tag) die($popup_footer);

print "<div id='titre-popup'>".$msg[notice_title_tag]."</div>";

// Le lecteur a ajout un mot-cl
if (($ChpTag) && ($log_ok)) {
	$sql="select * from notices where index_l like '%$ChpTag%' and notice_id=$noticeid";
	$r = mysql_query($sql, $dbh);
	if (mysql_numrows($r)>=1) echo "<br /><br />".$msg[addtag_exist];
		else {
			$sql="insert into tags (libelle, num_notice,user_code,dateajout) values ('$ChpTag',$noticeid,'". $_SESSION["user_code"] ."',CURRENT_TIMESTAMP())";
			if (mysql_query($sql, $dbh)) {
				echo "<div align='center'><br /><br />".$msg[addtag_enregistre]."<br /><br /><a href='#' onclick='window.close()'>".$msg[addtag_fermer]."</a></div>";
				} else {
					echo "<div align='center'><br /><br />".$msg[addtag_pb_enr]."<br /><br /><a href='#' onclick='window.close()'>".$msg[addtag_fermer]."</a></div>";
					}
			}
	} else {
		$requete = "select index_l from notices where index_l is not null and index_l!=''";
	
		$r = mysql_query($requete, $dbh);
		if (mysql_numrows($r)){
			while ($loc = mysql_fetch_object($r)) {
				$liste = split($pmb_keyword_sep,$loc->index_l);
				for ($i=0;$i<count($liste);$i++){
					$index=trim($liste[$i]);
					if ($index) $arrTag[strtolower($index)]++;
					}
				}
			}
		ksort($arrTag);
		$lettre="";
		foreach ($arrTag as $key => $value) {
			if ($key{0}!=$lettre){
				$lettre=$key{0};
				$select.="<optgroup  class='erreur' label='$lettre'>";
				}
			$select.="<option style='color:#000000' value='$key'>".$key ."</option>";
			}
		echo "<form id='f' name='f' method='post' action='".$opac_url_base."addtags.php'>
				<input type='hidden' name='noticeid' value='$noticeid' />
				$msg[addtag_choisissez]<br />
				<select name='select' style='width:200px' onchange='document.f.ChpTag.value=this.value;'>
				$select
				</select><br /><br />
				$msg[addtag_nouveau]<br />
				<input type='text' name='ChpTag' style='width:200px'/>
			    <input type='submit' class='bouton' name='submit' value='".$msg[addtag_bt_ajouter]."' />
				</form>";
		}

if (!$log_ok && $opac_allow_add_tag==2) {
	$lvl='tags';
	print do_formulaire_connexion();
	//print $erreur_session ;
	}

print $popup_footer;

/* Fermeture de la connexion */
mysql_close();
		