<?php
// +-------------------------------------------------+
//  2002-2004 PMB Services / www.sigb.net pmb@sigb.net et contributeurs (voir www.sigb.net)
// +-------------------------------------------------+
// $Id: askmdp.php,v 1.10 2007/10/27 08:13:19 touraine37 Exp $

$base_path=".";
require_once($base_path."/includes/init.inc.php");
require_once($base_path."/includes/error_report.inc.php") ;
require_once($base_path."/includes/global_vars.inc.php");
require_once($base_path.'/includes/opac_config.inc.php');

// rcupration paramtres MySQL et connection  la base
require_once($base_path.'/includes/opac_db_param.inc.php');
require_once($base_path.'/includes/opac_mysql_connect.inc.php');
$dbh = connection_mysql();

require_once($base_path."/includes/misc.inc.php");

//Sessions !! Attention, ce doit tre imprativement le premer include ( cause des cookies)
require_once($base_path."/includes/session.inc.php");
require_once($base_path.'/includes/start.inc.php');

require_once($base_path."/includes/notice_authors.inc.php");
require_once($base_path."/includes/notice_categories.inc.php");

require_once($base_path."/includes/check_session_time.inc.php");

// rcupration localisation
require_once($base_path.'/includes/localisation.inc.php');

// version actuelle de l'opac
require_once($base_path.'/includes/opac_version.inc.php');

// fonctions de gestion de formulaire
require_once($base_path.'/includes/javascript/form.inc.php');

require_once($base_path.'/includes/templates/common.tpl.php');
require_once($base_path.'/includes/divers.inc.php');

// classe de gestion des catgories
require_once($base_path.'/classes/categorie.class.php');
require_once($base_path.'/classes/notice.class.php');
require_once($base_path.'/classes/notice_display.class.php');

// classe indexation interne
require_once($base_path.'/classes/indexint.class.php');

// classe d'affichage des tags
require_once($base_path.'/classes/tags.class.php');

// classe de gestion des rservations
require_once($base_path.'/classes/resa.class.php');

// pour l'affichage correct des notices
require_once($base_path."/includes/templates/notice.tpl.php");
require_once($base_path."/includes/navbar.inc.php");
require_once($base_path."/includes/explnum.inc.php");
require_once($base_path."/includes/notice_affichage.inc.php");
require_once($base_path."/includes/bulletin_affichage.inc.php");

// pour l'envoi de mails
require_once($base_path."/includes/mail.inc.php");

// autenticazione LDAP - by MaxMan
require_once($base_path."/includes/ldap_auth.inc.php");

// RSS
require_once($base_path."/includes/includes_rss.inc.php");

//Vrification de la session
$log_ok=0;
if (!$_SESSION["user_code"]) {
	if ($time_expired==0) {
		//Si pas de session en cours, vrification du login
		$verif_query = "SELECT id_empr, empr_cb, empr_nom, empr_prenom, empr_password, empr_lang, empr_date_expiration<sysdate() as isexp , empr_login, empr_ldap FROM empr WHERE empr_login='".$_POST['login']."'";
		$verif_result = mysql_query($verif_query) or die(mysql_error());
		// rcupration des valeurs MySQL du lecteur et injection dans les variables
		while ($verif_line = mysql_fetch_array($verif_result)) {
				$verif_empr_cb = $verif_line['empr_cb'];
				$verif_empr_login = $verif_line['empr_login'];
				$verif_empr_ldap = $verif_line['empr_ldap'];
				$verif_empr_password = $verif_line['empr_password'];
				if ($verif_line['empr_lang']) $verif_lang = $verif_line['empr_lang'];
					else $verif_lang=$opac_default_lang ;
				$verif_id_empr = $verif_line['id_empr'];
				$verif_isexp = $verif_line['isexp'];
				}
		if (($verif_empr_ldap)) {// auth by server ldap
			$auth_ok=auth_ldap($_POST['login'],$password);
			} else { //auth standard
				$auth_ok=(($verif_empr_password==$password)&&($verif_empr_login!="")&&(!$verif_isexp));
				}

		if ($auth_ok) {

				// if (($verif_empr_password==$password)&&($verif_empr_login!="")&&(!$verif_isexp)){

				//Si mot de passe correct, enregistrement dans la session de l'utilisateur
				$log_ok=1;
				//Rcupration de l'environnement prcdent
				$requete="select session from opac_sessions where empr_id=".$verif_id_empr;
				$res_session=mysql_query($requete);

				if (@mysql_num_rows($res_session)) {
					$temp_session=unserialize(mysql_result($res_session,0,0));
					$_SESSION=$temp_session;
					} else $_SESSION=array();

				$_SESSION["user_code"]=$verif_empr_login;
				$_SESSION["id_empr_session"]=$verif_id_empr;
				$_SESSION["connect_time"]=time();
				$_SESSION["lang"]=$verif_lang;
				
				// change language after login
				$lang=$_SESSION["lang"]; 
				set_language($lang);
				
				$query0 = "select * from empr, empr_statut where empr_login='".$_SESSION['user_code']."' and idstatut=empr_statut ";
				$req0 = mysql_query($query0,$dbh);
				$data = mysql_fetch_array($req0);
				$id_empr = $verif_id_empr;
				$empr_cb = $data['empr_cb'];
				$empr_nom = $data['empr_nom'];
				$empr_prenom= $data['empr_prenom'];
				$empr_adr1= $data['empr_adr1'];
				$empr_adr2= $data['empr_adr2'];
				$empr_cp= $data['empr_cp'];
				$empr_ville= $data['empr_ville'];
				$empr_mail= $data['empr_mail'];
				$empr_tel1= $data['empr_tel1'];
				$empr_tel2= $data['empr_tel2'];
				$empr_prof= $data['empr_prof'];
				$empr_year= $data['empr_year'];
				$empr_categ= $data['empr_categ'];
				$empr_codestat= $data['empr_codestat'];
				$empr_sexe= $data['empr_sexe'];
				$empr_login= $data['empr_login'];
				$empr_ldap= $data['empr_ldap'];
		
				// droits de l'utilisateur
				$allow_loan= $data['allow_loan'];
				$allow_loan_hist= $data['allow_loan_hist'];
				$allow_book= $data['allow_book'];
				$allow_opac= $data['allow_opac'];
				$allow_dsi= $data['allow_dsi'];
				$allow_dsi_priv= $data['allow_dsi_priv'];
				$allow_sugg= $data['allow_sugg'];
				$allow_prol= $data['allow_prol'];
				$allow_avis= $data['allow_avis'];
				$allow_tag= $data['allow_tag'];
				$allow_pwd= $data['allow_pwd'];

			} else {
				//Sinon, on dtruit la session cre
				@session_destroy();
				if ($verif_isexp) echo "<script>alert(\"".$msg["empr_expire"]."\");</script>";
				// si pas de session
				$erreur_session = $empr_erreur_header;
				$erreur_session .= $msg["empr_type_card_number"]."<br/>";
				$erreur_session .= $empr_erreur_footer;
				}
		} else { // la session a expir, on va le lui dire
			echo "<script>alert(\"".sprintf($msg["session_expired"],round($opac_duration_session_auth/60))."\");</script>";
		}
	} else {
		//Si session en cours, pas de problme...
		$log_ok=1;
		$login=$_SESSION["user_code"];
		// droits de l'utilisateur
		$query0 = "select allow_loan, allow_loan_hist, allow_book, allow_opac, allow_dsi, allow_dsi_priv, allow_sugg, allow_prol, allow_avis, allow_tag, allow_pwd from empr, empr_statut where empr_login='".$_SESSION['user_code']."' and idstatut=empr_statut ";
		$req0 = mysql_query($query0,$dbh);
		$data = mysql_fetch_array($req0);
		$allow_loan= $data['allow_loan'];
		$allow_loan_hist= $data['allow_loan_hist'];
		$allow_book= $data['allow_book'];
		$allow_opac= $data['allow_opac'];
		$allow_dsi= $data['allow_dsi'];
		$allow_dsi_priv= $data['allow_dsi_priv'];
		$allow_sugg= $data['allow_sugg'];
		$allow_prol= $data['allow_prol'];
		$allow_avis= $data['allow_avis'];
		$allow_tag= $data['allow_tag'];
		$allow_pwd= $data['allow_pwd'];
		}

// si $opac_show_homeontop est  1 alors on affiche le lien retour  l'accueil sous le nom de la bibliothque dans la fiche empr
if ($opac_show_homeontop==1) $std_header= str_replace("!!home_on_top!!",$home_on_top,$std_header);
	else $std_header= str_replace("!!home_on_top!!","",$std_header);

// RSS
$std_header= str_replace("!!liens_rss!!",genere_link_rss(),$std_header);

print $std_header;

require_once ($base_path.'/includes/navigator.inc.php');
	
			$query = "SELECT valeur_param FROM parametres WHERE type_param='opac' AND sstype_param = 'biblio_name'";
			$result = mysql_query($query) or die ("*** Erreur dans la requ&ecirc;te <br>*** $query<br>\n");
			$row = mysql_fetch_array ($result);
			$demandeemail= "<hr><p class='texte'>".$msg[mdp_txt_intro_demande]."</p>
				<form action=\"askmdp.php\" method=\"post\" ><br/>
				<input type=\"text\" name=\"email\" size=\"20\" border=\"0\" value=\"email@\" onFocus=\"this.value='';\">&nbsp;&nbsp;
				<input type=\"hidden\" name=\"demande\" value=\"ok\" >
				<input type='submit' name='ok' value='".$msg[mdp_bt_send]."' class='bouton'>
				</form>"; 
			
			print "<blockquote>";
			if ($demande!="ok" || $email=='') {
		
				// Mettre ici le formulaire de saisie de l'email
				print $demandeemail ;
				} else {
					$query = "SELECT empr_login, empr_password, empr_location,empr_mail,concat(empr_prenom,' ',empr_nom) as nom_prenom FROM empr WHERE empr_mail like '%".$email."%'";
					$result = mysql_query($query) or die ("*** Erreur dans la requ&ecirc;te <br>*** $query<br>\n");
					if (mysql_num_rows($result)!=0) {
						while ($row = mysql_fetch_object ($result)) {
							if (!$opac_biblio_name) {
								$query_loc = "SELECT name, email FROM docs_location WHERE idlocation='$row->empr_location'";
								$result_loc = mysql_query($query_loc) or die ("*** Erreur dans la requ&ecirc;te <br>*** $query_loc<br>\n");
								$info_loc = mysql_fetch_object ($result_loc) ;
								$biblio_name_temp=$info_loc->name ;
								$biblio_email_temp=$info_loc->email ;
								} else {
									$biblio_name_temp=$opac_biblio_name;
									$biblio_email_temp=$opac_biblio_email;
									}
							$headers  = "MIME-Version: 1.0\n";
							$headers .= "Content-type: text/html; charset=iso-8859-1\n";
						
							// Pour faire suite  votre demande, nous vous prions de trouver ci-dessous vos informations de connexion pour <b>!!biblioname!!</b> :<br> -Identifiant: !!login!! <br> -Mot de passe: !!password!! <br><br>Si vous rencontrez des difficults, adressez un mail  !!biblioemail!!.
							$messagemail = $msg[mdp_mail_body] ;
							$messagemail = str_replace("!!login!!",$row->empr_login,$messagemail);
							$messagemail = str_replace("!!password!!",$row->empr_password,$messagemail);
							$messagemail = str_replace("!!biblioname!!","<a href=\"$opac_url_base\">".$biblio_name_temp."</a>",$messagemail);
							$messagemail = str_replace("!!biblioemail!!","<a href=mailto:$opac_biblio_email>$biblio_email_temp</a>",$messagemail);
						
							$objetemail = str_replace("!!biblioname!!",$biblio_name_temp,$msg[mdp_mail_obj]);
							print "<hr>";
						
							$res_envoi=@mailpmb(trim($row->nom_prenom), $row->empr_mail,$objetemail,$messagemail,$biblio_name_temp, $biblio_email_temp, $headers);
							if (!$res_envoi) {
								print "<p class='texte'>Could not send information to $email.</p><br>" ;
								echo "<br>";
								print_r($error_send_mail);
								echo "<br>";
								}
							print "<p class='texte'>".$msg[mdp_sent_ok]." $email.</p>" ;
						}
					} else {
						print "<hr><p class='texte'>".str_replace("!!biblioemail!!","<a href=mailto:$opac_biblio_email>$opac_biblio_email</a>",$msg[mdp_no_email])."</p>" ;
						print $demandeemail ;
						}
				}

			print "</blockquote>";

//insertions des liens du bas dans le $footer si $opac_show_liensbas
if ($opac_show_liensbas==1) $footer = str_replace("!!div_liens_bas!!",$liens_bas,$footer);
	else $footer = str_replace("!!div_liens_bas!!","",$footer);

//affichage du bandeau de gauche si $opac_show_bandeaugauche = 1
if ($opac_show_bandeaugauche==0)
	$footer= str_replace("!!contenu_bandeau!!","",$footer);
	else {
		$home_on_left=str_replace("!!welcome_page!!",$msg["welcome_page"],$home_on_left);
		$adresse=str_replace("!!common_tpl_address!!",$msg["common_tpl_address"],$adresse);
		$adresse=str_replace("!!common_tpl_contact!!",$msg["common_tpl_contact"],$adresse);
		$loginform=str_replace("!!common_tpl_login_invite!!",$msg["common_tpl_login_invite"],$loginform);
		
		// loading the languages avaiable in OPAC - martizva >> Eric
		require_once($base_path.'/includes/languages.inc.php');
		$home_on_left = str_replace("!!common_tpl_lang_select!!", show_select_languages("empr.php"), $home_on_left);
		
		if (!$_SESSION["user_code"]) {
				$loginform__ ="<form action=\"empr.php\" method=\"post\" name=\"myform\"><label>$msg[common_tpl_cardnumber_default]</label><br/>";
				$loginform__.="<input type=\"text\" name=\"login\" size=\"14\" border=\"0\" value=\"".$msg[common_tpl_cardnumber]."\" onFocus=\"this.value='';\"><br/>
				<input type=\"password\" name=\"password\" size=\"8\" border=\"0\" value=\"\" onFocus=\"this.value='';\">&nbsp;&nbsp;<input type='submit' name='ok' value='".$msg[11]."' class='bouton'></form>";
				} else {
					$loginform__.="<b>".$empr_prenom." ".$empr_nom."</b><br/>\n";
					$loginform__.="<a href=\"empr.php\">".$msg["empr_my_account"]."</a><br/>
						<a href=\"index.php?logout=1\">".$msg["empr_logout"]."</a>";
					}
		$loginform = str_replace("!!login_form!!",$loginform__,$loginform);
		$footer= str_replace("!!contenu_bandeau!!",$home_on_left.$loginform.$meteo.$adresse,$footer);
		}

print $footer;

/* Fermeture de la connexion */
mysql_close();
