<?php
// +-------------------------------------------------+
//  2002-2004 PMB Services / www.sigb.net pmb@sigb.net et contributeurs (voir www.sigb.net)
// +-------------------------------------------------+
// $Id: category.class.php,v 1.13 2007/03/14 15:43:44 dbellamy Exp $

if (stristr($_SERVER['REQUEST_URI'], ".class.php")) die("no access");

// dfinition de la classe de gestion des 'auteurs'
if ( ! defined( 'CATEGORY_CLASS' ) ) {
  define( 'CATEGORY_CLASS', 1 );
require_once("$class_path/thesaurus.class.php");

class category {
	
// ---------------------------------------------------------------
//		proprits de la classe
// ---------------------------------------------------------------
var $id=0;
var $libelle='';
var $commentaire='';
var $catalog_form=''; // forme pour affichage complet
var $parent_id=0;
var $parent_libelle = '';
var $voir_id=0;
var $has_child=FALSE;
var $has_parent=FALSE;
var $path_table;	// tableau contenant le path clat (ids et libells)
var $associated_terms; // tableau des termes associs
var $thes;		//le thesaurus d'appartenance
var $libelle_aff_complet = "";

// ---------------------------------------------------------------
//		category($id) : constructeur
// ---------------------------------------------------------------
function category($id=0) {
	if($id) {
		// on cherche  atteindre une notice existante
		$this->id = $id;
		$this->thes = thesaurus::getByEltId($id);
		$this->getData();
		} else {
			// la notice n'existe pas
			$this->id = 0;
			$this->getData();
			}
	}

// ---------------------------------------------------------------
//		getData() : rcupration des proprits
// ---------------------------------------------------------------
function getData() {
	global $dbh;
	global $lang;
	
	$anti_recurse=array();
	
	if(!$this->id) return;

	// rcupration des informations de la catgorie
	$requete = "select count(1) from categories where num_noeud = '".$this->id."' and langue = '".$lang."' ";
	$result = mysql_query($requete, $dbh);
	if ((mysql_result($result, 0, 0)) == 0) $lg = $this->thes->langue_defaut ; else $lg = $lang;  
		
	$requete = "SELECT noeuds.id_noeud as categ_id, categories.libelle_categorie as categ_libelle, ";
	$requete.= "noeuds.num_parent as categ_parent, noeuds.num_renvoi_voir as categ_see, ";
	$requete.= "categories.note_application as categ_comment ";
	$requete.= "FROM noeuds, categories ";
	$requete.= "WHERE noeuds.id_noeud ='".$this->id."' ";
	$requete.= "AND noeuds.id_noeud = categories.num_noeud ";
	$requete.= "AND categories.langue = '".$lg."' ";	
	$result = @mysql_query($requete, $dbh);
	if(!mysql_num_rows($result)) return;
	
	$data = mysql_fetch_object($result);
	$this->id = $data->categ_id;		
	$this->libelle = $data->categ_libelle;
	$this->commentaire = $data->categ_comment;
	$this->parent_id = $data->categ_parent;
	$this->voir_id = $data->categ_see;
	//$anti_recurse[$this->voir_id]=1;
	if($this->parent_id ) $this->has_parent = TRUE;

	$requete = "SELECT id_noeud as categ_id ";
	$requete.= "FROM noeuds ";
	$requete.= "WHERE num_parent='".$this->id."' ";
	$result = @mysql_query($requete, $dbh);
	if(mysql_num_rows($result)) $this->has_child = TRUE;


	// constitution du chemin
	$anti_recurse[$this->id]=1;
	if($this->has_parent) {
		// si notre catgorie a un parent, on initie la boucle en le rcuprant
		$requete = "select count(1) from categories where num_noeud = '".$this->parent_id."' and langue = '".$lang."' ";
		$result = mysql_query($requete, $dbh);
		if (mysql_result($result, 0,0) == 0) $lg = $this->thes->langue_defaut ; else $lg = $lang;  

		$requete = "SELECT noeuds.id_noeud as categ_id, noeuds.num_parent as categ_parent, ";
		$requete.= "noeuds.num_renvoi_voir as categ_see, categories.libelle_categorie as categ_libelle, ";
		$requete.= "categories.note_application as categ_comment ";
		$requete.= "FROM noeuds, categories ";
		$requete.= "WHERE noeuds.id_noeud='".$this->parent_id."' ";
		$requete.= "AND noeuds.id_noeud=categories.num_noeud "; 
		$requete.= "AND categories.langue = '".$lg."' ";		
		$result=@mysql_query($requete);
		if (mysql_num_rows($result)) {
			$parent = mysql_fetch_object($result);
			$anti_recurse[$parent->categ_id]=1;
			$this->path_table[] = array(
						'id' => $parent->categ_id,
						'libelle' => $parent->categ_libelle,
						'commentaire' => $parent->categ_comment);
			// on remonte les ascendants
			while (($parent->categ_parent)&&(!$anti_recurse[$parent->categ_parent])) {

				$requete = "select count(1) from categories where num_noeud = '".$parent->categ_parent."' and langue = '".$lang."' ";
				$result = mysql_query($requete, $dbh);
				if (mysql_result($result, 0,0) == 0) $lg = $this->thes->langue_defaut ; else $lg = $lang;  
				
				$requete = "SELECT noeuds.id_noeud as categ_id, noeuds.num_parent as categ_parent, ";
				$requete.= "noeuds.num_renvoi_voir as categ_see, categories.libelle_categorie as categ_libelle, ";
				$requete.= "categories.note_application as categ_comment ";
				$requete.= "FROM noeuds, categories ";
				$requete.= "WHERE noeuds.id_noeud='".$parent->categ_parent."' "; 
				$requete.= "AND noeuds.id_noeud=categories.num_noeud ";
				$requete.= "AND categories.langue = '".$lg."' ";  
				$result=@mysql_query($requete);
				if (mysql_num_rows($result)) {
					$parent = mysql_fetch_object($result);
					$anti_recurse[$parent->categ_id]=1;
					$this->path_table[] = array(
								'id' => $parent->categ_id,
								'libelle' => $parent->categ_libelle,
								'commentaire' => $parent->categ_comment);
				}
				else {
					break;
				}
			}
		} else {
			$this->path_table=array();
		}
	} else {
		$this->path_table = array();
	}
	
	// ceci remet le tableau dans l'ordre gnral->particulier
	global $opac_categories_show_only_last ; // le paramtre pour afficher le chemin complet ou pas
	$this->path_table = array_reverse($this->path_table);

	if ($opac_categories_show_only_last) {
		$this->catalog_form = $this->libelle;
		
		// si notre catgorie a un parent, on initie la boucle en le rcuprant
		
		$requete = "select count(1) from categories where num_noeud = '".$this->parent_id."' and langue = '".$lang."' ";
		$result = mysql_query($requete, $dbh);
		if (mysql_result($result, 0,0) == 0) $lg = $this->thes->langue_defaut ; else $lg = $lang;  
				
		$requete_temp = "SELECT noeuds.id_noeud as categ_id, categories.libelle_categorie as categ_libelle ";
		$requete_temp.= "FROM noeuds, categories ";
		$requete_temp.= "WHERE noeuds.id_noeud='".$this->parent_id."' ";
		$requete_temp.= "AND noeuds.id_noeud= categories.num_noeud ";
		$requete_temp.= "AND categories.langue = '".$lg."' ";  
		
		$result_temp=@mysql_query($requete_temp);
		if (mysql_num_rows($result_temp)) {
			$parent = mysql_fetch_object($result_temp);
			$this->parent_libelle = $parent->categ_libelle ;
			} else $this->parent_libelle ; 

		} else 
			if(sizeof($this->path_table)) {
				while(list($i, $l) = each($this->path_table)) {
					$temp_table[] = $l['libelle'];
				}
				$this->parent_libelle = join(':', $temp_table);
				$this->catalog_form = $this->parent_libelle.':'.$this->libelle;
			} else {
				$this->catalog_form = $this->libelle;
			}

	// pour libell complet mais sans le nom du thsaurus 
	$this->libelle_aff_complet = $this->catalog_form ;

	global $opac_thesaurus;
	if ($opac_thesaurus) $this->catalog_form="[".$this->thes->libelle_thesaurus."] ".$this->catalog_form;
	//Recherche des termes associs
	$requete = "select count(1) from categories where num_noeud = '".$this->id."' and langue = '".$lang."' ";
	$result = mysql_query($requete, $dbh);
	if (mysql_result($result, 0,0) == 0) $lg = $this->thes->langue_defaut ; else $lg = $lang;  

	$requete = "SELECT distinct voir_aussi.num_noeud_dest as categ_assoc_categassoc, ";
	$requete.= "categories.libelle_categorie as categ_libelle, categories.note_application as categ_comment ";
	$requete.= "FROM voir_aussi, categories ";
	$requete.= "WHERE voir_aussi.num_noeud_orig='".$this->id."' ";
	$requete.= "AND categories.num_noeud=voir_aussi.num_noeud_dest "; 
	$requete.= "AND categories.langue = '".$lg."' ";
	$result=@mysql_query($requete,$dbh);
	while ($ta=mysql_fetch_object($result)) {
		$this->associated_terms[] = array(
						'id' => $ta->categ_assoc_categassoc,
						'libelle' => $ta->categ_libelle,
						'commentaire' => $ta->categ_comment);
	}
}

function has_notices() {
	global $dbh;
	$query = "select count(1) from notices_categories,notices,notice_statut where (notices_categories.num_noeud='".$this->id."' and notices_categories.notcateg_notice=notice_id) and (notices.statut=notice_statut.id_notice_statut and ((notice_statut.notice_visible_opac=1 and notice_statut.notice_visible_opac_abon=0)".($_SESSION["user_code"]?" or (notice_statut.notice_visible_opac_abon=1 and notice_statut.notice_visible_opac=1)":"").")) ";	
	$result = mysql_query($query, $dbh);
	return (mysql_result($result, 0, 0));
	}

} # fin de dfinition de la classe category

} # fin de dclaration
