<?php
// +-------------------------------------------------+
//  2002-2004 PMB Services / www.sigb.net pmb@sigb.net et contributeurs (voir www.sigb.net)
// +-------------------------------------------------+
// $Id: sort.class.php,v 1.13 2007/09/05 09:46:06 jlesaint Exp $



require_once($include_path."/parser.inc.php");
require_once($include_path."/templates/common.tpl.php");

class sort {
	var $sort_name;
	var $params;
	var $error=false;
	var $error_message=""; 
    var $tris_par;
    var $table_tri_tempo; //table temporaire  utiliser
    var $table_primary_tri_tempo; //Cl primaire de la table temporaire  crer
    var $limit; //limitation des enregistrements  utiliser dans la requte de tri pour le pager
    var $champs_select; //champs ventuels  retourner dans la requte
    var $table_select; //table ventuelle  retourner dans la requte
    var $table_primary_key_select; //cl de la table ventuelle  retourner dans la requte
    var $url; //url de la page en cours pour effetcuer le tri  des endroits diffrents 
    
    function sort($sort_name) {
    	if ($sort_name) {
    		$this->sort_name=$sort_name;
    		$this->parse();
    	}
    }
    
    function show_tris_form() {
    	global $show_tris_form;	
    	global $msg;
    	
    	$tris="";
    	if ($_SESSION["nb_sort"]==0) {
    		$tris .= $msg['aucun_tri'];
    		$_SESSION['last_sort']="";
    	} else {
    		$tris .= "<table>"; 
    		$parity=1;
    		//affichage des enregistrements de tris possibles
    		for ($j=$_SESSION["nb_sort"]-1;$j>=0;$j--)
    		{
    			if ($parity % 2) $pair_impair = "even";
				else $pair_impair = "odd";
				$tr_javascript=" onmouseover=\"this.className='surbrillance'\" onmouseout=\"this.className='$pair_impair'\"";
				$tris.= "<tr class='$pair_impair' $tr_javascript style='cursor: pointer'>";
    			$tris .="<td><input type=checkbox name='cases_suppr[]' value='$j'></td>";
    			$tris .= "<td alt='".$msg['appliq_tri']."' title='".$msg['appliq_tri']."'><a href='./index.php?".$this->url."&get_last_query=".$_SESSION["last_query"]."&sort=$j'>".$_SESSION['sort_text'.$j]."</a></td>"; 
    			$tris .="</tr>";	    		
    			$parity += 1;
    		}
    		$tris .= "</table>";
    	}
    	$show_tris_form=str_replace("!!liste_tris!!",$tris,$show_tris_form);
    	$show_tris_form=str_replace("!!page_en_cours!!",urlencode($this->url),$show_tris_form);
    	$tris_form=str_replace("!!page_en_cours1!!",$this->url,$show_tris_form);
    	return $tris_form;
    }
        
    function show_sel_form() {
    	global $show_sel_form;
		global $charset;
		global $msg;
		global $opac_nb_max_criteres_tri;
		
		$fields=$this->params["FIELD"];
    	
    	for ($i=0;$i<count($fields);$i++) {
    		$liste_criteres.="<option value='".$fields[$i]["ID"]."'>".htmlentities($msg[$fields[$i]["NAME"]],ENT_QUOTES,$charset)."</option>\n";
    	}
    	$liste_criteres_tri="";
    	for ($i=1;$i<$opac_nb_max_criteres_tri;$i++) {
    		$liste_criteres_tri.="<tr><td><h4><span>".$msg['puis_par_tri']."</span></td><td><select name='liste_critere".$i."'><option value='' selected>&nbsp;</option>!!liste_criteres!!</select></h4></td>
				<td><select name='croit_decroit".$i."'><option value='c'>".$msg['tri_croissant']."</option><option value='d'>".$msg['tri_decroissant']."</option></select></td>
				<td><select name='num_text".$i."'><option value='text'>".$msg['tri_alpha']."</option><option value='num'>".$msg['tri_num']."</option></select></td>
				</tr>\n";
    	}
    	$show_sel_form=str_replace("!!liste_criteres_tri!!",$liste_criteres_tri,$show_sel_form);
    	$show_sel_form=str_replace("!!liste_criteres!!",$liste_criteres,$show_sel_form);
    	$show_sel_form=str_replace("!!page_en_cours!!",urlencode($this->url),$show_sel_form);
    	
    	$sel_form=str_replace("!!page_en_cours1!!",$this->url,$show_sel_form);
    	return $sel_form;
    }
    
    function sauvegarder() {
    	global $criteres;
    	global $msg;
		global $charset;
		
		
		//initialisation des variables
		$criteres="";
		$trier_par_texte="";
		$fields=$this->params["FIELD"];
		
		//recomposition du tri pour enregistrement (ex: c_num_2 (valeur d'un lment de la liste des champs slectionns)
		// le premier caractre reprsente la croissance (c) ou la dcroissance (d),
		// la chane entre les deux _ reprsente le type du champ (text, num),
		// la dernire partie de la valeur est l'id du critre de tri))
		foreach($this->tris_par as $selectValue)
		{
			$criteres .=$selectValue.",";
			//dcoupage du champ (ex : c_num_2 (croissance ou dcroissance (c ou d),
			//type de champ (num,text,...) et id du champ)
			$temp=explode("_",$selectValue);
    		
    		for ($i=0;$i<count($fields);$i++) {
				if ($fields[$i]["ID"]==$temp[2]) {
    				$trier_par_texte .= $msg[$fields[$i]["NAME"]];
					if ($temp[0]=="c") {
						$trier_par_texte .= " croissant(e),";
					} else {
						$trier_par_texte .= " dcroissant(e),";
					}
				}
    		}
		}
		$criteres=substr($criteres,0,strlen($criteres)-1);
		$trier_par_texte=substr($trier_par_texte,0,strlen($trier_par_texte)-1);
		
		//si nombre de tris enregistrs dans la session n'est pas null, parcours des variables de session pour l'existence tri et sauvegarde
		if ($_SESSION["nb_sort"]==0) {
			$_SESSION["sort".$_SESSION["nb_sort"]]=htmlentities($criteres,ENT_QUOTES,$charset);
			$_SESSION["sort_text".$_SESSION["nb_sort"]]=htmlentities($trier_par_texte,ENT_QUOTES,$charset);
			$_SESSION["nb_sort"]++;
		} else {
			$bool=false;
			for ($i=0;$i<$_SESSION["nb_sort"];$i++) {
				if (($_SESSION["sort".$i]==htmlentities($criteres,ENT_QUOTES,$charset))&&($_SESSION["sort_text".$i]==htmlentities($trier_par_texte,ENT_QUOTES,$charset))) {	
					$bool=true;
				}
			}
			if ($bool==true) {
				return "<script>alert ('".$msg['tri_existant']."');</script>";
			} else {
				$_SESSION["sort".$_SESSION["nb_sort"]]=htmlentities($criteres,ENT_QUOTES,$charset);
				$_SESSION["sort_text".$_SESSION["nb_sort"]]=htmlentities($trier_par_texte,ENT_QUOTES,$charset);
				$_SESSION["nb_sort"]++;
			}		
		}
	}
    
    function appliquer_tri() {
    	global $msg;
    	$fields=$this->params["FIELD"];
    	
    	//rcupration du tri  
    	$trier_par=$_SESSION["sort".$_SESSION["last_sort"]];
    	
    	//dcoupage du tri
    	$trier_par=explode(",",$trier_par);
    	
    	//initialisation des variables
    	$where=$this->params["REFERENCE"][0][value].".".$this->params["REFERENCEKEY"][0][value]."=".$this->table_tri_tempo.".".$this->table_primary_tri_tempo." and ";
    	$tables = $this->table_tri_tempo.",";
    	$groupby="";
    	if ($this->table_select!="") {
    		$tables .= $this->table_select.",";
    		$where .= $this->table_select.".".$this->table_primary_key_select."=".$this->params["REFERENCE"][0][value].".".$this->params["REFERENCEKEY"][0][value]." and ";
    		$groupby="group by ".$this->params["REFERENCE"][0][value].".".$this->params["REFERENCEKEY"][0][value];	
    	}
    	$tables .= $this->params["REFERENCE"][0][value];
    	$orderby="";
    	$union="(";
    		
    	//parcours des champs sur lesquels trier		
    	for($j=0;$j<count($trier_par);$j++)
		{
			//dcoupage du champ (ex : c_num_2 (croissance ou dcroissance (c ou d),
			//type de champ (num,text,...) et id du champ)
			$temp=explode("_",$trier_par[$j]);
			
			for ($i=0;$i<count($fields);$i++) {
				if ($fields[$i]["ID"]==$temp[2]) {
					//dtermination d'un champs spcial
    				if ($fields[$i]["SPECIAL"]=="yes") {
    					$bool=false;
    					$requete_fields=mysql_query("SELECT * FROM ".$this->table_tri_tempo);
    					$x=0;
    					while ($x<mysql_num_fields($requete_fields)) {
    						$ligne=mysql_fetch_field($requete_fields,$x);
    						if ($ligne->name==$fields[$i]["SPECIALTYPE"]) {
    							$this->champs_select=$fields[$i]["TABLEFIELD"][0][value];
    							$bool=true;	
    						}
    						$x++;	
    					}    						
    					mysql_free_result($requete_fields);			
    				}
					
					//dtermination d'une relation ventuelle ou une union
    				if ($fields[$i]["EXTERNAL"]!="yes") {
						$requete="select ".$this->params["REFERENCE"][0][value].".".$this->params["REFERENCEKEY"][0][value];
						if ($fields[$i]["TABLEFIELD"]) {
							if ($this->champs_select) $this->champs_select .= ",".$fields[$i]["TABLEFIELD"][0][value];
								else $this->champs_select .= $fields[$i]["TABLEFIELD"][0][value];
						}
						if ($this->champs_select!="") {
							$requete .=",".$this->champs_select;
						}
						if ($fields[$i]["ORDERBY"]) {
							if ($fields[$i]["ORDERBY"][0]["NULLVALUE"]) {
								$orderby .= "IFNULL(";	
							}
								$orderby .= $fields[$i]["ORDERBY"][0][value];
							if ($fields[$i]["ORDERBY"][0]["NULLVALUE"]) {
								$orderby .= ",'".$fields[$i]["ORDERBY"][0]["NULLVALUE"]."')";	
							}
							$orderby .=",";	
						}
						if ($fields[$i]["TABLEFIELD"][0]["NULLVALUE"]) {
							$orderby .= "IFNULL(";	
						}
						if ($fields[$i]["SPECIAL"]=="yes") {
							if ($bool==true) {
								$orderby .= $fields[$i]["TABLEFIELD"][0][value];
							}
						} else {
							$orderby .= $fields[$i]["TABLEFIELD"][0][value];	
						}
						if ($fields[$i]["TABLEFIELD"][0]["NULLVALUE"]) {
							$orderby .= ",'".$fields[$i]["TABLEFIELD"][0]["NULLVALUE"]."')";	
						}
						if ($fields[$i]["SPECIAL"]=="yes") {
							if ($bool==true) {
								if ($fields[$i]["TYPE"]=="num") {
									$orderby .= "*1";	
								}						
								if ($temp[0]=="c") {
									$orderby .= " ASC";
								} else {
									$orderby .= " DESC";
								}
								$orderby .=",";
							}
						} else {
							if ($fields[$i]["TYPE"]=="num") {
								$orderby .= "*1";	
							}						
							if ($temp[0]=="c") {
								$orderby .= " ASC";
							} else {
								$orderby .= " DESC";
							}
							$orderby .=",";	
						}
					} elseif ($fields[$i]["TABLE"]) {
					$requete="select ".$this->params["REFERENCE"][0][value].".".$this->params["REFERENCEKEY"][0][value];
					if ($this->champs_select!="") {
						$requete .=",".$this->champs_select;
					}
					if ($fields[$i]["ORDERBY"]) {
						if ($fields[$i]["ORDERBY"][0]["NULLVALUE"]) {
							$orderby .= "IFNULL(";	
						}
						$orderby .= $fields[$i]["ORDERBY"][0][value];	
						if ($fields[$i]["ORDERBY"][0]["NULLVALUE"]) {
							$orderby .= ",'".$fields[$i]["ORDERBY"][0]["NULLVALUE"]."')";	
						}
						$orderby .=",";
					}
					if ($fields[$i]["TABLEFIELD"][0]["NULLVALUE"]) {
						$orderby .= "IFNULL(";	
					}
					if ($fields[$i]["SPECIAL"]=="yes") {
						if ($bool==true) {
    						$orderby .= $fields[$i]["TABLEFIELD"][0][value];	
						}
					} else {
						$orderby .= $fields[$i]["TABLE"][0][value].".".$fields[$i]["TABLEFIELD"][0][value];	
					}
					if ($fields[$i]["TABLEFIELD"][0]["NULLVALUE"]) {
						$orderby .= ",'".$fields[$i]["TABLEFIELD"][0]["NULLVALUE"]."')";	
					}
					if ($fields[$i]["SPECIAL"]=="yes") {
						if ($bool==true) {
							if ($fields[$i]["TYPE"]=="num") {
								$orderby .= "*1";	
							}						
							if ($temp[0]=="c") {
								$orderby .= " ASC";
							} else {
								$orderby .= " DESC";
							}
							$orderby .=",";
						}
					} else {
						if ($fields[$i]["TYPE"]=="num") {
							$orderby .= "*1";	
						}						
						if ($temp[0]=="c") {
							$orderby .= " ASC";
						} else {
							$orderby .= " DESC";
						}
						$orderby .=",";	
					}
					for ($x=0;$x<=count($fields[$i]["LINK"]);$x++) {
						switch ($fields[$i]["LINK"][$x]["TYPE"]) {
							case "1n":
								$tables .= " left join ".$fields[$i]["TABLE"][0][value]." on (".$fields[$i]["TABLE"][0][value].".".$fields[$i]["TABLEKEY"][0][value]."=".$this->params["REFERENCE"][0][value].".".$fields[$i]["LINK"][0]["REFERENCEFIELD"][0][value].") ";
							break;
							case "nn":
								$tables .= " left join ".$fields[$i]["LINK"][$x]["TABLE"][0][value]." on (".$this->params["REFERENCE"][0][value].".".$this->params["REFERENCEKEY"][0][value]."=".$fields[$i]["LINK"][$x]["TABLE"][0][value].".".$fields[$i]["LINK"][$x]["REFERENCEFIELD"][0][value].") ";
								$tables .= " left join ".$fields[$i]["TABLE"][0][value]." on (".$fields[$i]["LINK"][$x]["TABLE"][0][value].".".$fields[$i]["LINK"][$x]["EXTERNALFIELD"][0][value]."=".$fields[$i]["TABLE"][0][value].".".$fields[$i]["TABLEKEY"][0][value].") ";
								$groupby ="group by ".$this->params["REFERENCE"][0][value].".".$this->params["REFERENCEKEY"][0][value];	
							break;
						}
					}
    			} elseif ($fields[$i]["UNION"]) {
    				//cration du deuxime table temporaire  cause de l'union 
    				$creer_table_tempo="CREATE TEMPORARY TABLE tri_tempo1 ENGINE=MyISAM (select * from ".$this->table_tri_tempo.")";
					@mysql_query ($creer_table_tempo);
					if ($this->table_primary_tri_tempo) {
						$modif_primaire="ALTER TABLE tri_tempo1 PRIMARY KEY ".$this->table_primary_tri_tempo;
					} else {
						$modif_primaire="ALTER TABLE tri_tempo1 PRIMARY KEY ".$this->params["REFERENCEKEY"][0][value];
					}
					@mysql_query ($modif_primaire);  
					$where1=$where;  			
	   				for ($j=0;$j<count($fields[$i]["UNION"]);$j++) {
    					$requete="select ".$this->params["REFERENCE"][0][value].".".$this->params["REFERENCEKEY"][0][value].",";
    					if ($this->champs_select!="") {
							$requete .= $this->champs_select.",";
						}
    					if ($fields[$i]["UNION"][$j]["TABLEFIELD"][0][value]) {
    						$requete .= $fields[$i]["UNION"][$j]["TABLEFIELD"][0][value];
						} else $requete=substr($requete,0,strlen($requete)-1);	   				
    					$requete .= " from ";
    					if ($this->table_select!="") {
    						$requete .= $this->table_select.",";
    					}
    					if ($j==0) {
    						$requete .= $this->table_tri_tempo.",";
    					} else {
    						$requete .="tri_tempo1,";	
    					}
    					$requete .= $this->params["REFERENCE"][0][value];
    					for ($x=0;$x<=count($fields[$i]["UNION"][$j]["LINK"]);$x++) {
    						switch ($fields[$i]["UNION"][$j]["LINK"][$x]["TYPE"]) {
    							case "n1":
    								if ($fields[$i]["UNION"][$j]["LINK"][$x]["TABLEKEY"][0][value]) {
    									$requete .= " left join ".$fields[$i]["UNION"][$j]["LINK"][$x]["TABLE"][0][value];
										$requete .= " on ".$fields[$i]["UNION"][$j]["TABLE"][0][value].".".$fields[$i]["UNION"][$j]["LINK"][$x]["EXTERNALFIELD"][0][value];
    									$requete .= "=".$fields[$i]["UNION"][$j]["LINK"][$x]["TABLE"][0][value].".".$fields[$i]["UNION"][$j]["LINK"][$x]["TABLEKEY"][0][value];
    								} else {
    									$requete .= " left join ".$fields[$i]["UNION"][$j]["TABLE"][0][value];
										$requete .= " on ".$this->params["REFERENCE"][0][value].".".$this->params["REFERENCEKEY"][0][value];
    									$requete .= "=".$fields[$i]["UNION"][$j]["TABLE"][0][value].".".$fields[$i]["UNION"][$j]["LINK"][$x]["EXTERNALFIELD"][0][value];
    								}
    							break;
    							case "nn":
    								$requete .= " left join ".$fields[$i]["UNION"][$j]["LINK"][0]["TABLE"][0][value];
									$requete .= " on ".$this->params["REFERENCE"][0][value].".".$this->params["REFERENCEKEY"][0][value];
    								$requete .= "=".$fields[$i]["UNION"][$j]["LINK"][$x]["TABLE"][0][value].".".$fields[$i]["UNION"][$j]["LINK"][$x]["REFERENCEFIELD"][0][value];
    								if ($fields[$i]["UNION"][$j]["LINK"][$x]["TABLEKEY"][0][value]) {
    									$requete .= " left join ".$fields[$i]["UNION"][$j]["TABLE"][0][value];
										$requete .= " on ".$fields[$i]["UNION"][$j]["LINK"][$x]["TABLE"][0][value].".".$fields[$i]["UNION"][$j]["LINK"][$x]["TABLEKEY"][0][value];
    									$requete .= "=".$fields[$i]["UNION"][$j]["TABLE"][0][value].".".$fields[$i]["UNION"][$j]["LINK"][$x]["EXTERNALFIELD"][0][value];
    								} else {
    									$requete .= " left join ".$fields[$i]["UNION"][$j]["TABLE"][0][value];
										$requete .= " on ".$fields[$i]["UNION"][$j]["LINK"][$x]["TABLE"][0][value].".".$fields[$i]["UNION"][$j]["LINK"][$x]["EXTERNALFIELD"][0][value];
    									$requete .= "=".$fields[$i]["UNION"][$j]["TABLE"][0][value].".".$fields[$i]["UNION"][$j]["TABLEKEY"][0][value];	
    								}
    							break;
    						}
    					}
    					if ($j==1) {
    						if ($this->table_primary_tri_tempo) {
    							$where1= $this->params["REFERENCE"][0][value].".".$this->params["REFERENCEKEY"][0][value]."=tri_tempo1.".$this->table_primary_tri_tempo." and ";
    						} else {
    							$where1= $this->params["REFERENCE"][0][value].".".$this->params["REFERENCEKEY"][0][value]."=tri_tempo1.".$this->params["REFERENCEKEY"][0][value]." and ";
    						}
    					}
    					if ($this->table_select) {
    						$where1 .= $this->table_select.".".$this->table_primary_key_select."=".$this->params["REFERENCE"][0][value].".".$this->params["REFERENCEKEY"][0][value]." and ";
    					}
    					$where1 .= $fields[$i]["UNION"][$j]["FILTER"];
    					$requete .=" where ".$where1;
    					$requete .=" group by ".$this->params["REFERENCE"][0][value].".".$this->params["REFERENCEKEY"][0][value];
    					$union .= $requete.") union (";
    				}
    				if ($fields[$i]["UNION"][0]["TABLEFIELD"][0][value]) {
    					if ($fields[$i]["UNION"][0]["TABLEFIELD"][0]["NULLVALUE"]) $orderby .= "IFNULL(";	
    				} elseif ($fields[$i]["UNION"][0]["ORDERBY"][0][value])  {
    					if ($fields[$i]["UNION"][0]["ORDERBY"][0]["NULLVALUE"]) $orderby .= "IFNULL(";
    				}
					if ($fields[$i]["SPECIAL"]=="yes") {
						if ($bool==true) {
    						$orderby .= $fields[$i]["UNION"][0]["TABLEFIELD"][0][value];	
						}
					} else {
						if ($fields[$i]["UNION"][0]["TABLE"]) {
							if ($fields[$i]["UNION"][0]["TABLEFIELD"][0][value]) $orderby .= $fields[$i]["UNION"][0]["TABLEFIELD"][0][value];	
								else $orderby .= $fields[$i]["UNION"][0]["ORDERBY"][0][value];
						} else {
							$orderby .= $this->params["REFERENCE"][0][value].".".$fields[$i]["UNION"][0]["TABLEFIELD"][0][value];	
						}	
					}
    				if ($fields[$i]["UNION"][0]["TABLEFIELD"][0][value]) {
    					if ($fields[$i]["UNION"][0]["TABLEFIELD"][0]["NULLVALUE"]) $orderby .= ",'".$fields[$i]["UNION"][0]["TABLEFIELD"][0]["NULLVALUE"]."')";	
    				} elseif ($fields[$i]["UNION"][0]["ORDERBY"][0][value])  {
    					if ($fields[$i]["UNION"][0]["ORDERBY"][0]["NULLVALUE"]) $orderby .= ",'".$fields[$i]["UNION"][0]["ORDERBY"][0]["NULLVALUE"]."')";
    				}
					if ($fields[$i]["SPECIAL"]=="yes") {
						if ($bool==true) {
							if ($fields[$i]["TYPE"]=="num") {
								$orderby .= "*1";	
							}						
							if ($temp[0]=="c") {
								$orderby .= " ASC";
							} else {
								$orderby .= " DESC";
							}
							$orderby .=",";
						}
					} else {
						if ($fields[$i]["TYPE"]=="num") {
							$orderby .= "*1";	
						}						
						if ($temp[0]=="c") {
							$orderby .= " ASC";
						} else {
							$orderby .= " DESC";
						}
						$orderby .=",";	
					}
    			}
    		}
			}
		}
		
		for ($i=0;$i<count($fields);$i++) {
			if ($fields[$i]["ID"]==$temp[2]) {
    			if ($fields[$i]["EXTERNAL"]!="yes") {
    				$where=substr($where,0,strlen($where)-4);
					$orderby=substr($orderby,0,strlen($orderby)-1);
					if ($orderby) {
						$requete .= " FROM ".$tables." where ".$where."".$groupby." order by ".$orderby." ".$this->limit;		
					} else {
						$requete .= " FROM ".$tables." where ".$where."".$groupby." ".$this->limit;
					}
    			} elseif ($fields[$i]["TABLE"]) {
    				$tables=substr($tables,0,strlen($tables)-1);
    				$where=substr($where,0,strlen($where)-4);
					$orderby=substr($orderby,0,strlen($orderby)-1);
    				if ($orderby) {
						$requete .= " FROM ".$tables." where ".$where."".$groupby." order by ".$orderby." ".$this->limit;
					} else {
    					$requete .= " FROM ".$tables." where ".$where."".$groupby." ".$this->limit;
					}
    			} elseif ($fields[$i]["UNION"]) {
    				$union=substr($union,0,strlen($union)-8);
    				$orderby=substr($orderby,0,strlen($orderby)-1);
    				if ($orderby) {
    					$requete = $union." order by ".$orderby." ".$this->limit;	
    				} else {
    					$requete = $union." ".$this->limit;	
    				}	
    			}
    		}
		}
		if ($this->table_tri_tempo) {
    		$requete=str_replace("!!table!!",$this->table_tri_tempo,$requete);
    	}
    	return $requete;			
	}
    
    function parse() {
    	global $include_path;
    	$params_name=$this->sort_name."_params";
    	global $$params_name;
    	$params=$$params_name;
    	if ($params) {
    		$this->params=$params;
    	} else {
    		if (file_exists($include_path."/sort/".$this->sort_name."/sort_subst.xml")) {
    			$fp=fopen($include_path."/sort/".$this->sort_name."/sort_subst.xml","r");	
    		} else {
    			$fp=fopen($include_path."/sort/".$this->sort_name."/sort.xml","r");
    		}
    		if ($fp) {
    			$xml=fread($fp,filesize($include_path."/sort/".$this->sort_name."/sort.xml"));
    			fclose($fp);
    			$params=_parser_text_no_function_($xml,"SORT");
    			$this->params=$params;
    		} else {
    			$this->error=true;
    			$this->error_message="Can't open definition file";
    		}
    	}
    }
}
?>