<?php
// +-------------------------------------------------+
//  2002-2004 PMB Services / www.sigb.net pmb@sigb.net et contributeurs (voir www.sigb.net)
// +-------------------------------------------------+
// $Id: empr.php,v 1.87 2007/10/27 08:13:19 touraine37 Exp $

$base_path=".";
require_once($base_path."/includes/init.inc.php");
require_once($base_path."/includes/error_report.inc.php") ;
require_once($base_path."/includes/global_vars.inc.php");
require_once($base_path.'/includes/opac_config.inc.php');

// rcupration paramtres MySQL et connection  la base
require_once($base_path.'/includes/opac_db_param.inc.php');
require_once($base_path.'/includes/opac_mysql_connect.inc.php');
$dbh = connection_mysql();

require_once($base_path."/includes/misc.inc.php");

//Sessions !! Attention, ce doit tre imprativement le premer include ( cause des cookies)
require_once($base_path."/includes/session.inc.php");
require_once($base_path.'/includes/start.inc.php');

require_once($base_path."/includes/notice_authors.inc.php");
require_once($base_path."/includes/notice_categories.inc.php");

require_once($base_path."/includes/check_session_time.inc.php");

// rcupration localisation
require_once($base_path.'/includes/localisation.inc.php');

// version actuelle de l'opac
require_once($base_path.'/includes/opac_version.inc.php');

// fonctions de gestion de formulaire
require_once($base_path.'/includes/javascript/form.inc.php');

require_once($base_path.'/includes/templates/common.tpl.php');
require_once($base_path.'/includes/divers.inc.php');

// classe de gestion des catgories
require_once($base_path.'/classes/categorie.class.php');
require_once($base_path.'/classes/notice.class.php');
require_once($base_path.'/classes/notice_display.class.php');

// classe indexation interne
require_once($base_path.'/classes/indexint.class.php');

// classe d'affichage des tags
require_once($base_path.'/classes/tags.class.php');

// classe de gestion des rservations
require_once($base_path.'/classes/resa.class.php');

// pour l'affichage correct des notices
require_once($base_path."/includes/templates/notice.tpl.php");
require_once($base_path."/includes/navbar.inc.php");
require_once($base_path."/includes/explnum.inc.php");
require_once($base_path."/includes/notice_affichage.inc.php");
require_once($base_path."/includes/bulletin_affichage.inc.php");

// autenticazione LDAP - by MaxMan
require_once($base_path."/includes/ldap_auth.inc.php");

// RSS
require_once($base_path."/includes/includes_rss.inc.php");

// si paramtrage authentification particulire
if (file_exists($base_path.'/includes/ext_auth.inc.php')) { $file_orig="empr.php"; require_once($base_path.'/includes/ext_auth.inc.php'); }

//Vrification de la session
$log_ok=0;
if (!$_SESSION["user_code"]) {
	if ($time_expired==0) {
		//Si pas de session en cours, vrification du login
		$verif_query = "SELECT id_empr, empr_cb, empr_nom, empr_prenom, empr_password, empr_lang, empr_date_expiration<sysdate() as isexp , empr_login, empr_ldap, allow_opac FROM empr, empr_statut WHERE empr_login='".$_POST['login']."' and idstatut=empr_statut";
		$verif_result = mysql_query($verif_query) or die(mysql_error());
		// rcupration des valeurs MySQL du lecteur et injection dans les variables
		while ($verif_line = mysql_fetch_array($verif_result)) {
			$verif_empr_cb = $verif_line['empr_cb'];
			$verif_empr_login = $verif_line['empr_login'];
			$verif_empr_ldap = $verif_line['empr_ldap'];
			$verif_empr_password = $verif_line['empr_password'];
			if ($verif_line['empr_lang']) $verif_lang = $verif_line['empr_lang'];
				else $verif_lang=$opac_default_lang ;
			$verif_id_empr = $verif_line['id_empr'];
			$verif_isexp = $verif_line['isexp'];
			// Traiter ici l'interdiction de connexion  l'OPAC
			$allow_opac=$verif_line['allow_opac'];
			}

		if ($allow_opac) {
			if (($verif_empr_ldap)) { // auth by server ldap
				$auth_ok=auth_ldap($_POST['login'],$password);
				} else { //auth standard
					$auth_ok=(($verif_empr_password==$password)&&($verif_empr_login!="")&&(!$verif_isexp));
					}
			} else $auth_ok=false ;

		if ($auth_ok) {
			//Si mot de passe correct, enregistrement dans la session de l'utilisateur
			$log_ok=1;
			//Rcupration de l'environnement prcdent
			$requete="select session from opac_sessions where empr_id=".$verif_id_empr;
			$res_session=mysql_query($requete);
			if (@mysql_num_rows($res_session)) {
				$temp_session=unserialize(mysql_result($res_session,0,0));
				$_SESSION=$temp_session;
				} else $_SESSION=array();

			$_SESSION["user_code"]=$verif_empr_login;
			$_SESSION["id_empr_session"]=$verif_id_empr;
			$_SESSION["connect_time"]=time();
			$_SESSION["lang"]=$verif_lang;
				
			// change language after login
			$lang=$_SESSION["lang"]; 
			set_language($lang);
				
			$query0 = "select * from empr, empr_statut where empr_login='".$_SESSION['user_code']."' and idstatut=empr_statut ";
			$req0 = mysql_query($query0,$dbh);
			$data = mysql_fetch_array($req0);
			$id_empr = $verif_id_empr;
			$empr_cb = $data['empr_cb'];
			$empr_nom = $data['empr_nom'];
			$empr_prenom= $data['empr_prenom'];
			$empr_adr1= $data['empr_adr1'];
			$empr_adr2= $data['empr_adr2'];
			$empr_cp= $data['empr_cp'];
			$empr_ville= $data['empr_ville'];
			$empr_mail= $data['empr_mail'];
			$empr_tel1= $data['empr_tel1'];
			$empr_tel2= $data['empr_tel2'];
			$empr_prof= $data['empr_prof'];
			$empr_year= $data['empr_year'];
			$empr_categ= $data['empr_categ'];
			$empr_codestat= $data['empr_codestat'];
			$empr_sexe= $data['empr_sexe'];
			$empr_login= $data['empr_login'];
			$empr_ldap= $data['empr_ldap'];
			
			// droits de l'utilisateur
			$allow_loan= $data['allow_loan'];
			$allow_loan_hist= $data['allow_loan_hist'];
			$allow_book= $data['allow_book'];
			$allow_opac= $data['allow_opac'];
			$allow_dsi= $data['allow_dsi'];
			$allow_dsi_priv= $data['allow_dsi_priv'];
			$allow_sugg= $data['allow_sugg'];
			$allow_prol= $data['allow_prol'];
			$allow_avis= $data['allow_avis'];
			$allow_tag= $data['allow_tag'];
			$allow_pwd= $data['allow_pwd'];

			// connexion en cours et paramtre de rebond ailleurs que sur le compte emprunteur
			if (($opac_show_login_form_next) && ($_POST['login']) && ($_POST['password'])) die ("<SCRIPT>document.location='$opac_show_login_form_next';</SCRIPT>");
			} else {
				//Sinon, on dtruit la session cre
				@session_destroy();
				if ($verif_isexp) echo "<script>alert(\"".$msg["empr_expire"]."\");</script>";
				if ((!$allow_opac) && $verif_empr_login) echo "<script>alert(\"".$msg["empr_no_allow_opac"]."\");</script>";
				if ($verif_isexp || ((!$allow_opac) && $verif_empr_login)) die ("<SCRIPT>document.location='$opac_url_base';</SCRIPT>");
				// si pas de session
				$erreur_session = $empr_erreur_header;
				$erreur_session .= $msg["empr_type_card_number"]."<br/>";
				$erreur_session .= $empr_erreur_footer;
				}
		} else { // la session a expir, on va le lui dire
			echo "<script>alert(\"".sprintf($msg["session_expired"],round($opac_duration_session_auth/60))."\");</script>";
			}
	} else {
		//Si session en cours, pas de problme...
		$log_ok=1;
		$login=$_SESSION["user_code"];
		// droits de l'utilisateur
		$query0 = "select allow_loan, allow_loan_hist, allow_book, allow_opac, allow_dsi, allow_dsi_priv, allow_sugg, allow_prol, allow_avis, allow_tag, allow_pwd from empr, empr_statut where empr_login='".$_SESSION['user_code']."' and idstatut=empr_statut ";
		$req0 = mysql_query($query0,$dbh);
		$data = mysql_fetch_array($req0);
		$allow_loan= $data['allow_loan'];
		$allow_loan_hist= $data['allow_loan_hist'];
		$allow_book= $data['allow_book'];
		$allow_opac= $data['allow_opac'];
		$allow_dsi= $data['allow_dsi'];
		$allow_dsi_priv= $data['allow_dsi_priv'];
		$allow_sugg= $data['allow_sugg'];
		$allow_prol= $data['allow_prol'];
		$allow_avis= $data['allow_avis'];
		$allow_tag= $data['allow_tag'];
		$allow_pwd= $data['allow_pwd'];
		}

// si $opac_show_homeontop est  1 alors on affiche le lien retour  l'accueil sous le nom de la bibliothque dans la fiche empr
if ($opac_show_homeontop==1) $std_header= str_replace("!!home_on_top!!",$home_on_top,$std_header);
	else $std_header= str_replace("!!home_on_top!!","",$std_header);

// RSS
$std_header= str_replace("!!liens_rss!!",genere_link_rss(),$std_header);
// l'image $logo_rss_si_rss est calcule par genere_link_rss() en global
$liens_bas = str_replace("<!-- rss -->",$logo_rss_si_rss,$liens_bas);

print $std_header;

require_once ($base_path.'/includes/navigator.inc.php');

if (!$lvl) $lvl="late" ;
if ($log_ok) {
	require_once("empr/empr.inc.php");
	
	/* Affichage du bandeau action en bas de la page. A externaliser dans le template */
	print "<br/>
		<form action=\"empr.php\" method=\"post\" name=\"FormName\">\n<div class='boutoncirculation'>";
	if ($allow_loan) print "<INPUT type=\"button\" class=\"bouton\" name=\"lvlx\" value=\"".$msg[empr_bt_show_late]."\" onClick=\"this.form.lvl.value='late'; this.form.submit();\">&nbsp;
		<INPUT type='button' class='bouton' name='lvlx' value=\"".$msg[empr_bt_show_all]."\" onClick=\"this.form.lvl.value='all'; this.form.submit();\">&nbsp;";
	if ($allow_loan_hist) print "<INPUT type='button' class='bouton' name='lvlx' value=\"".$msg[empr_bt_show_old]."\" onClick=\"this.form.lvl.value='old'; this.form.submit();\">&nbsp;";

	if ($opac_resa_planning && $allow_book) print "<input type=\"button\" class=\"bouton\" name='ok' value=\"".$msg[empr_bt_show_resa]."\" onClick=\"this.form.lvl.value='resa_planning'; this.form.submit();\">\n";
		else if ($allow_book) print "<input type=\"button\" class=\"bouton\" name='ok' value=\"".$msg[empr_bt_show_resa]."\" onClick=\"this.form.lvl.value='resa'; this.form.submit();\">\n";

	print "</div>
		<input type=\"hidden\" name=\"lvl\" value=\"$lvl\"/>
		";

	if (!$empr_ldap && $allow_pwd) print "<br/><br/><input type='button' class='bouton' name='ok' value='$msg[empr_modify_password]' onClick=\"this.form.lvl.value='change_password'; this.form.submit();\">&nbsp;";
	if (($opac_dsi_active) && ($allow_dsi || $allow_dsi_priv)) print "<br/><br/><input type='button' class='bouton' name='dsi_afficher' value=\"$msg[dsi_bannette_acceder]\" onClick=\"this.form.lvl.value='bannette'; this.form.submit();\">&nbsp;";
	if (($opac_show_categ_bannette || $opac_allow_bannette_priv) && ($allow_dsi || $allow_dsi_priv)) print "<input type='button' class='bouton' name='dsi_gerer' value=\"$msg[dsi_bannette_gerer]\" onClick=\"this.form.lvl.value='bannette_gerer'; this.form.submit();\">&nbsp;";
	if ($opac_allow_bannette_priv && $allow_dsi_priv) print "<input type='button' class='bouton' name='dsi_priv' value=\"$msg[dsi_bt_bannette_priv]\" onClick=\"document.location='./index.php?bt_cree_bannette_priv=1&search_type_asked=extended_search'\">&nbsp;";
	if ($opac_show_suggest) {
		print "<br /><br />";
		if ($allow_sugg) print "<input type='button' class='bouton' id=make_sugg' name='make_sugg' value='$msg[empr_bt_make_sugg]' onClick=\"this.form.lvl.value='make_sugg'; this.form.submit();\">&nbsp;";
		print "<input type='button' class='bouton' id=view_sugg' name='view_sugg' value='$msg[empr_bt_view_sugg]' onClick=\"this.form.lvl.value='view_sugg'; this.form.submit();\">";
		}
	print "</form><br/>";
	
	switch($lvl) {
		case 'change_password':
				$change_password_checked =" checked";
				require_once($base_path.'/empr/change_password.inc.php');
				break;
		case 'valid_change_password':
				$change_password_checked =" checked";
				require_once($base_path.'/empr/valid_change_password.inc.php');
				break;
		case 'message':
				$message_checked =" checked";
				require_once($base_path.'/empr/message.inc.php');
				break;
		case 'all':
				$all_checked =" checked";
				print "<h3><span>$msg[empr_loans]</span></h3>";
				$critere_requete=" AND empr.empr_login='$login' order by pret_retour ";
				require_once($base_path.'/empr/all.inc.php');
				break;
		case 'old':
				print "<h3><span>$msg[empr_loans_old]</span></h3>";
				require_once($base_path.'/empr/old.inc.php');
				break;
		case 'resa':
				if ($allow_book) include($base_path.'/includes/resa.inc.php');
					else print $msg[empr_no_allow_book];
				break;
		case 'resa_planning':
				include($base_path.'/includes/resa_planning.inc.php');
				break;
		case 'bannette':
				if ($allow_dsi_priv || $allow_dsi) require_once($base_path.'/includes/bannette.inc.php');
					else print $msg[empr_no_allow_dsi];
				break;
		case 'bannette_gerer':
				if ($allow_dsi_priv || $allow_dsi) require_once($base_path.'/includes/bannette_gerer.inc.php');
					else print $msg[empr_no_allow_dsi];
				break;
		case 'bannette_creer':
				if ($allow_dsi_priv) require_once($base_path.'/includes/bannette_creer.inc.php');
					else print $msg[empr_no_allow_dsi_priv];
				break;
		case 'make_sugg':
				if ($allow_sugg) require_once($base_path.'/empr/make_sugg.inc.php');
					else print $msg[empr_no_allow_sugg];
				break;
		case 'valid_sugg':
				if ($allow_sugg) require_once($base_path.'/empr/valid_sugg.inc.php');
					else print $msg[empr_no_allow_sugg];
				break;
		case 'view_sugg':
				require_once($base_path.'/empr/view_sugg.inc.php');
				break;
				
		default:
		case 'late':
				print pmb_bidi($empr_identite);
				print "<h3><span>$msg[empr_late]</span></h3>";
				$critere_requete=" AND pret_retour < '".date('Y-m-d')."' AND empr.empr_login='$login' order by pret_retour ";
				require_once($base_path.'/empr/all.inc.php');
				break;
		}

	} else {
		// Si les mot de passe et code-barre ne concordent pas
		if (!$time_expired) print "<br/>".$msg["empr_bad_login"]."<br/><br/><br/>";
			else print "<br/>".sprintf($msg["session_expired"],round($opac_duration_session_auth/60))."<br/><br/><br/>";
		}
if ($erreur_session) print $erreur_session ;

//insertions des liens du bas dans le $footer si $opac_show_liensbas
if ($opac_show_liensbas==1) $footer = str_replace("!!div_liens_bas!!",$liens_bas,$footer);
	else $footer = str_replace("!!div_liens_bas!!","",$footer);

//affichage du bandeau de gauche si $opac_show_bandeaugauche = 1
if ($opac_show_bandeaugauche==0)
	$footer= str_replace("!!contenu_bandeau!!","",$footer);
	else {
		$home_on_left=str_replace("!!welcome_page!!",$msg["welcome_page"],$home_on_left);
		$adresse=str_replace("!!common_tpl_address!!",$msg["common_tpl_address"],$adresse);
		$adresse=str_replace("!!common_tpl_contact!!",$msg["common_tpl_contact"],$adresse);
		$loginform=str_replace("!!common_tpl_login_invite!!",$msg["common_tpl_login_invite"],$loginform);
		
		// loading the languages avaiable in OPAC - martizva >> Eric
		require_once($base_path.'/includes/languages.inc.php');
		$home_on_left = str_replace("!!common_tpl_lang_select!!", show_select_languages("empr.php"), $home_on_left);
		
		if (!$_SESSION["user_code"]) {
				$loginform__ ="<form action=\"empr.php\" method=\"post\" name=\"myform\"><label>$msg[common_tpl_cardnumber_default]</label><br/>";
				$loginform__.="<input type=\"text\" name=\"login\" size=\"14\" border=\"0\" value=\"".$msg[common_tpl_cardnumber]."\" onFocus=\"this.value='';\"><br/>
				<input type=\"password\" name=\"password\" size=\"8\" border=\"0\" value=\"\" />&nbsp;&nbsp;<input type='submit' name='ok' value='".$msg[11]."' class='bouton'></form>"."<a href=./askmdp.php>".$msg[mdp_forgotten]."</a>";
				} else {
					$loginform__.="<b>".$empr_prenom." ".$empr_nom."</b><br/>\n";
					$loginform__.="<a href=\"empr.php\">".$msg["empr_my_account"]."</a><br/>
						<a href=\"index.php?logout=1\">".$msg["empr_logout"]."</a>";
					}
		$loginform = str_replace("!!login_form!!",$loginform__,$loginform);
		$footer= str_replace("!!contenu_bandeau!!",$home_on_left.$loginform.$meteo.$adresse,$footer);
		}

print $footer;

/* Fermeture de la connexion */
mysql_close();
