<?php
// +-------------------------------------------------+
//  2002-2004 PMB Services / www.sigb.net pmb@sigb.net et contributeurs (voir www.sigb.net)
// +-------------------------------------------------+
// $Id: etagere_func.inc.php,v 1.27 2007/03/12 21:05:31 dbellamy Exp $

if (stristr($_SERVER['REQUEST_URI'], ".inc.php")) die("no access");

require_once($base_path.'/includes/templates/notice_display.tpl.php');
require_once($base_path.'/includes/explnum.inc.php');

// tableau des tagres avec leurs petits caddies associs
// 	$accueil=1 filtre les tagres de l'accueil uniquement
//	$idetagere permet de rcuprer soit toutes les ragres soit une seule
function tableau_etagere($idetagere, $accueil=0) {
	global $dbh;
	
	global $opac_etagere_order ;
	if (!$opac_etagere_order) $opac_etagere_order =" name ";
	
	$tableau_etagere = array() ;
	
	// on constitue un tableau avec les tagres et les addies associs
	if ($accueil) $clause_accueil="visible_accueil=1 and";
	if ($idetagere) $clause_etagere="idetagere in ($idetagere) and";
	$query = "select idetagere, name, comment from etagere where $clause_accueil $clause_etagere ( (validite_date_deb<=sysdate() and validite_date_fin>=sysdate()) or validite=1 ) order by $opac_etagere_order ";
	$result = mysql_query($query, $dbh);
	if (mysql_num_rows($result)) {
		while ($etagere=mysql_fetch_object($result)) {
			$tableau_etagere[] = array (
					'idetagere' => $etagere->idetagere,
					'nometagere' => $etagere->name,
					'commentetagere' => $etagere->comment,
					'idcaddies' => caddies_etagere($etagere->idetagere)
					);
			}
		}
	return $tableau_etagere;
	}

// tableau des caddies d'une tagre
function caddies_etagere($idetagere) {
	global $dbh ;
	$caddie_tableau=array() ;
	// on constitue un tableau avec les caddies de l'tagre
	$query_caddie = "select caddie_id from etagere_caddie where etagere_id='".$idetagere."' ";
	$result_caddie = mysql_query($query_caddie, $dbh);
	if (mysql_num_rows($result_caddie)) {
		while ($caddie=mysql_fetch_object($result_caddie)) {
			$caddie_tableau[]= $caddie->caddie_id ; 
			}
		} // fin if caddies
	return 	$caddie_tableau ;
	}
	
// tableau des notices d'un caddie
function notices_caddie($idcaddie, &$notices) {
	global $dbh ;
	global $opac_etagere_notices_order ;
	if (!$opac_etagere_notices_order) $opac_etagere_notices_order =" index_serie, tit1 ";
		else $opac_etagere_notices_order = " $opac_etagere_notices_order ";

	$notice_tableau=array() ;
	// on constitue un tableau avec les notices du caddie
	$query_notice = "select distinct notice_id, niveau_biblio from caddie_content, notices, notice_statut  where caddie_id='".$idcaddie."' and object_id=notice_id ";
	$query_notice .= " and statut=id_notice_statut and ((notice_visible_opac=1 and notice_visible_opac_abon=0)".($_SESSION["user_code"]?" or (notice_visible_opac_abon=1 and notice_visible_opac=1)":"").")";
	$query_notice .= " order by $opac_etagere_notices_order ";
	$result_notice = mysql_query($query_notice, $dbh);
	if (mysql_num_rows($result_notice)) {
		while ($notice=mysql_fetch_object($result_notice)) {
			$notices[$notice->notice_id]= $notice->niveau_biblio ; 
			}
		} // fin if notices
	}

// paramtres :
//	$accueil : filtres les tagres de l'accueil uniquement si 1
//	$etageres : les numros des tagres spars par les ',' toutes si vides
//	$aff_notices_nb : nombres de notices affiches : toutes = 0 
//	$mode_aff_notice : mode d'affichage des notices, REDUIT (titre+auteur principal) ou ISBD ou PMB ou les deux : dans ce cas : (titre + auteur) en entte du truc,  faire dans notice_display.class.php
//	$depliable : affichage des notices une par ligne avec le bouton de dpliable
//	$link_to_etagere : lien pour afficher le contenu de l'tagre
//	$htmldiv_id="etagere-container", $htmldiv_class="etagere-container", $htmldiv_zindex="" : les id, class et zindex du <DIV > englobant le rsultat de la fonction
//	$liens_opac : tableau contenant les url destinatrices des liens si voulu 
function affiche_etagere($accueil=0, $etageres="", $aff_commentaire=0, $aff_notices_nb=0, $mode_aff_notice=AFF_ETA_NOTICES_BOTH, $depliable=AFF_ETA_NOTICES_DEPLIABLES_OUI, $link_to_etagere="", $liens_opac=array(), $htmldiv_id="etagere-container", $htmldiv_class="etagere-container", $htmldiv_zindex="" ) {
	global $dbh;
	global $charset;
	global $opac_etagere_nbnotices_accueil;
	
	// rcupration des tagres
	if (!$etageres) $tableau_etageres = tableau_etagere(0, $accueil) ;
		else $tableau_etageres = tableau_etagere($etageres, $accueil) ;
	

	if (!sizeof($tableau_etageres)) return "" ;
	
	// prparation du div comme il faut
	$retour_aff = "<div id='$htmldiv_id' class='$htmldiv_class'";
	if ($htmldiv_zindex) $retour_aff .=" zindex='$htmldiv_zindex' ";
	$retour_aff .=" >";
	for ($i=0; $i<sizeof($tableau_etageres); $i++ ) {
		$idetagere=$tableau_etageres[$i]['idetagere'] ;
		$nometagere=$tableau_etageres[$i]['nometagere'] ;
		$commentetagere=$tableau_etageres[$i]['commentetagere'] ;
		$retour_aff.="\n<div id='etagere' class='etagere' ><div id='etagere-titre'><h1>";
		if ($link_to_etagere) $retour_aff.="<a href=\"".str_replace("!!id!!",$idetagere,$link_to_etagere)."\">";
		$retour_aff.= htmlentities($nometagere,ENT_QUOTES, $charset);
		if ($link_to_etagere) $retour_aff.="</a>";
		$retour_aff.= "</h1></div>";
		if ($aff_commentaire) {
			$retour_aff .="\n<div id='etagere-comment'><h2>".htmlentities($commentetagere,ENT_QUOTES, $charset)."</h2></div>";
		}
		$idcaddies=$tableau_etageres[$i]['idcaddies'] ;
		$notices = array() ;
		for ($j=0; $j<sizeof($idcaddies); $j++ ) {
			notices_caddie($idcaddies[$j], $notices) ;
			}
		if ($aff_notices_nb>0) $limite_notices = min($aff_notices_nb, count($notices)) ;
			elseif ($aff_notices_nb<0) $limite_notices = min($aff_notices_nb, count($notices)) ;
				else  $limite_notices = count($notices) ;
		reset ($notices) ;
		$limit=0;
		if ($limite_notices) $retour_aff.= "<div id='etagere-notice-list'>";
		while ((list($idnotice, $niveau_biblio)= each($notices)) && ($limit<$limite_notices)) {
			$limit++;
			$notice = new notice_affichage($idnotice, $liens_opac) ;
			$notice->do_header();
			switch ($mode_aff_notice) {
				case AFF_ETA_NOTICES_REDUIT :	
					$retour_aff .= inslink($notice->notice_header, str_replace("!!id!!", $idnotice, $liens_opac['lien_rech_notice']))." " ;
					break;
				case AFF_ETA_NOTICES_ISBD :	
					$notice->do_isbd();
					$notice->genere_simple($depliable, 'ISBD') ;
					$retour_aff .= $notice->result ;
					break;
				case AFF_ETA_NOTICES_PUBLIC :
					$notice->do_public();
					$notice->genere_simple($depliable, 'PUBLIC') ;
					$retour_aff .= $notice->result ;
					break;
				case AFF_ETA_NOTICES_BOTH :
					$notice->do_isbd();
					$notice->do_public();
					$notice->genere_double($depliable, 'PUBLIC') ;
					$retour_aff .= $notice->result ;
					break ;
				
				}
			}
		if ($limite_notices&&($limite_notices<count($notices))) $retour_aff.= "<br/>";
		if ($opac_etagere_nbnotices_accueil>=0) {
			if ($link_to_etagere) $retour_aff.="<a href=\"".str_replace("!!id!!",$idetagere,$link_to_etagere)."\">";
			$retour_aff.="<span class='etagere-suite'>...</span>";
			if ($link_to_etagere) $retour_aff.="</a>";
		}
		if ($limite_notices) $retour_aff.= "</div>";
		$retour_aff .= "</div>" ;		
		}
	
	// fermeture du DIV
	$retour_aff .= "</div><!-- fin id='$htmldiv_id' class='$htmldiv_class' -->";
	return $retour_aff ; 
	
	}