<?php
// +-------------------------------------------------+
//  2002-2004 PMB Services / www.sigb.net pmb@sigb.net et contributeurs (voir www.sigb.net)
// +-------------------------------------------------+
// $Id: pdf.php,v 1.30 2007/10/02 12:55:49 touraine37


// dfinition du minimum ncssaire 
$base_path=".";                            
$base_auth = "CATALOGAGE_AUTH|CIRCULATION_AUTH|EDIT_AUTH|ACQUISITION_AUTH";  
$base_title = "PDF";
$base_noheader=1;
$base_nosession = 0 ; // pas d'envoi de cookie avant l'entte PDF
require_once ("$base_path/includes/init.inc.php");  

// modules propres  pdf.php ou  ses sous-modules
require_once("$include_path/fpdf.inc.php");
require_once("$include_path/misc.inc.php");
require_once("$class_path/author.class.php");
require_once("$include_path/notice_authors.inc.php");
require_once("$include_path/notice_categories.inc.php");
require_once("$base_path/circ/pret_func.inc.php");

// pour les champs perso
require_once("$include_path/fields_empr.inc.php");
require_once("$include_path/datatype.inc.php");
require_once("$include_path/parser.inc.php");

// inclusion de la classe de gestion des impressions PDF
// Definition de la police si pas dfinie dans les paramtres
if (!$pmb_pdf_font) $pmb_pdf_font = 'pmb'; 
if (!$pmb_pdf_fontfixed) $pmb_pdf_fontfixed = 'pmbmono'; 
define('FPDF_FONTPATH',"$class_path/font/");
require_once("$class_path/fpdf.class.php");
require_once("$class_path/ufpdf.class.php");

switch ($pdfdoc) {
	case 'ticket_pret':
		if(SESSrights & CIRCULATION_AUTH) include("./circ/ticket-pret.inc.php");
			else echo "<script> self.close(); </script>" ;
		break;
	case 'liste_pret':
		if(SESSrights & CIRCULATION_AUTH) include("./edit/liste_pret.inc.php");
			else echo "<script> self.close(); </script>" ;
		break;
	case 'lettre_retard':
		if ($niveau) $relance=$niveau; else $relance=1;
		if(SESSrights & EDIT_AUTH) include("./edit/lettre-retard.inc.php");
			else echo "<script> self.close(); </script>" ;
		break;
	case 'lettre_resa':
		if(SESSrights & CIRCULATION_AUTH) include("./edit/lettre-resa.inc.php");
			else echo "<script> self.close(); </script>" ;
		break;
	case 'lettre_resa_planning':
		if(SESSrights & CIRCULATION_AUTH) include("./edit/lettre-resa_planning.inc.php");
			else echo "<script> self.close(); </script>" ;
		break;
	case 'lettre_retard_groupe':
		$relance=1;
		if(SESSrights & EDIT_AUTH) include("./edit/lettre-retard.inc.php");
			else echo "<script> self.close(); </script>" ;
		break;
	case 'liste_pret_groupe':
		if(SESSrights & EDIT_AUTH) include("./edit/liste_prets.inc.php");
			else echo "<script> self.close(); </script>" ;
		break;
	case 'lettre_relance_adhesion':
		if(SESSrights & EDIT_AUTH) include("./edit/lettre-relance-adhesion.inc.php");
			else echo "<script> self.close(); </script>" ;
		break;
	case 'fiche_catalographique':
		if(SESSrights & CATALOGAGE_AUTH) include("./edit/fiche_catalographique.inc.php");
			else echo "<script> self.close(); </script>" ;
		break;
	case 'carte-lecteur':
		if(SESSrights & CIRCULATION_AUTH) {
			require("$class_path/fpdf_carte_lecteur.class.php");
			include("./circ/carte-lecteur.inc.php");
			} else echo "<script> self.close(); </script>" ;
		break;	
	// ----------------- Lliurex --------------------
	case 'listadoCarnets':
		if(SESSrights & CIRCULATION_AUTH) {
			require("$class_path/fpdf_carte_lecteur.class.php");
			include("./circ/listado-carnets.inc.php");
			} else echo "<script> self.close(); </script>" ;
		break;	
	// ----------------- Lliurex --------------------
	case 'cmde':
		if(SESSrights & ACQUISITION_AUTH) {
			include("./acquisition/achats/commandes/lettre-commande.inc.php");
			} else echo "<script> self.close(); </script>" ;	
		break;		
	case 'devi':
		if(SESSrights & ACQUISITION_AUTH) {
			include("./acquisition/achats/devis/lettre-devis.inc.php");
			} else echo "<script> self.close(); </script>" ;	
		break;		
	case 'livr':
		if(SESSrights & ACQUISITION_AUTH) {
			include("./acquisition/achats/livraisons/lettre-livraison.inc.php");
			}	
		break;		
	case 'fact':
		if(SESSrights & ACQUISITION_AUTH) {
			include("./acquisition/achats/factures/lettre-facture.inc.php");
			}	
		break;		
	case 'listsug':
		if(SESSrights & ACQUISITION_AUTH) {
			include("./acquisition/suggestions/liste-suggestions.inc.php");
			}	
		break;		
	case 'liste_bulletinage':
		if(SESSrights & CIRCULATION_AUTH) include("./edit/liste_bulletinage.inc.php");
			else echo "<script> self.close(); </script>" ;
		break;
	case 'lettre_retard_fournisseur':
		if ($niveau) $relance=$niveau; else $relance=1;
		if(SESSrights & EDIT_AUTH) include("./edit/lettre_retard_fournisseur.php");
			else echo "<script> self.close(); </script>" ;
		break;		
	default:
		echo "<script> self.close(); </script>" ;
		break;
}

mysql_close($dbh);
