<?php
// +-------------------------------------------------+
//  2002-2004 PMB Services / www.sigb.net pmb@sigb.net et contributeurs (voir www.sigb.net)
// +-------------------------------------------------+
// $Id: print_thesaurus.php,v 1.1 2007/05/07 17:45:56 touraine37 Exp $

$base_path = ".";
$base_auth = "AUTORITES_AUTH";
$base_title = "Impression thsaurus";
$base_nobody=1;
$base_noheader=1;

require($base_path."/includes/init.inc.php");
@set_time_limit(0);

function aff_enfants($queryparents) {
	$resultparents = mysql_query($queryparents) or die("Query failed");
	$arrayparents = array();
	while ($rowparents = mysql_fetch_assoc($resultparents)) {
		$arrayparents[] = $rowparents;
		}
	return $arrayparents;
	}

function creer_arbres() {

	global $arbres;
	global $resultat_query_parents;
	global $aff_langue;
	global $aff_note_application;
	global $aff_voir;

	for($i = 0 ; $i < count($resultat_query_parents) ; $i++) {
		
		$current_row = $resultat_query_parents[$i];
		$node = $current_row["id_noeud"];
		$parent_node = $current_row["num_parent"];
		
		// set label of the current row in the global structure, creating it if not already done.
		if(!isset($arbres[$node])) {
			$arbres[$node] = array();
			$arbres[$node]["enfants"] = array();
			}
			
		$arbres[$node]["id_noeud"] = $current_row["id_noeud"];
		$arbres[$node]["libelle_categorie"] = $current_row["libelle_categorie"];
			
		if ($aff_note_application == 1) {
			$arbres[$node]["note_application"] = $current_row["note_application"];
			}
		if (($aff_voir == 1)  && ($current_row["num_renvoi_voir"]>0)) {
			$arbres[$node]["num_renvoi_voir"] = $current_row["num_renvoi_voir"];
			$query_renvoi_voir="SELECT n.id_noeud, n.num_parent, c.libelle_categorie, c.note_application FROM noeuds n, categories c WHERE n.id_noeud = c.num_noeud AND n.id_noeud=".$current_row["num_renvoi_voir"]." AND c.langue = '".$aff_langue."'";
			$result_renvoi_voir = mysql_query($query_renvoi_voir) or die("Query 'renvoi voir' failed");
			$array_renvoi_voir = mysql_fetch_array($result_renvoi_voir);
			$arbres[$node]["libelle_renvoi_voir"] = $array_renvoi_voir["libelle_categorie"];
			}			 

		//add the current row in the child list of its parent, creating the parent if not already done
		if(!isset($arbres[$parent_node])) {
			$arbres[$parent_node] = array();
			$arbres[$parent_node]["enfants"] = array();
			}
			
		$arbres[$parent_node]["enfants"][] = $node;
		}
	}

function aff_enfants3($parent, $nv) {

	global $arbres;

	$enfants = $arbres[$parent]["enfants"];

	for($i = 0 ; $i < count($enfants) ; $i++) {
		$enfant = $arbres[$enfants[$i]];
		echo "<li><a name='".$enfant["id_noeud"]."'></a>".$enfant["libelle_categorie"];
		if ($enfant["num_renvoi_voir"] > 0) {
			echo " <i>voir</i> <a href='#".$enfant["num_renvoi_voir"]."'>".$enfant["libelle_renvoi_voir"]."</a>";
			}
		if ($enfant["note_application"] != "") {
			echo "<br><i>".$enfant["note_application"]."</i>";
			}
		echo "</li>";
		echo "<ul class=\"nv".$nv."\">";
		aff_enfants3($enfants[$i], $nv+1);
		echo "</ul>";
		}
	}


if ($action!="print") {
	print $std_header;
	print "<h3>Impression du thsaurus</h3>\n";
	print "<form name='print_options' action='print_thesaurus.php?action=print' method='post'>
		<b>Options d'impression du thsaurus</b>
		<blockquote>
			<input type='checkbox' name='aff_note_application_on' CHECKED/>&nbsp;Imprimer la note d'application<br>
			<input type='checkbox' name='aff_voir_on' CHECKED/>&nbsp;Imprimer les renvois 'voir'
		</blockquote>
		<b>".$msg["print_output_title"]."</b>
		<blockquote>
			<input type='radio' name='output' value='printer' checked/>&nbsp;".$msg["print_output_printer"]."<br/>
			<input type='radio' name='output' value='tt'/>&nbsp;".$msg["print_output_writer"]."
		</blockquote>
		<input type='hidden' name='aff_langue' value='fr_FR'>
		<input type='hidden' name='aff_num_thesaurus' value='";
	if ($thesaurus>0) print $thesaurus;
		 else die( "> Error with # of thesaurus");
	print "'><center><input type='submit' value='".$msg["print_print"]."' class='bouton'/>&nbsp;<input type='button'
 		value='".$msg["print_cancel"]."' class='bouton' onClick='self.close();'/></center>";
	print "</body></html>";
	}

$aff_langue = "fr_FR";

if ($action=="print") {
	if ($output=="tt") {
		header("Content-Type: application/word");
		header("Content-Disposition: attachement; filename=thesaurus.doc");
		}
	print "<body><html>";
	
	$rqt_id_noeud_top = "select id_noeud from noeuds where autorite='TOP' and num_thesaurus=".$aff_num_thesaurus ;
	$result_rqt_id_noeud_top = mysql_query($rqt_id_noeud_top) or die("Query 'TOP' failed");
	$obj_id_noeud_top = mysql_fetch_object($result_rqt_id_noeud_top);
	$id_noeud_top = $obj_id_noeud_top->id_noeud;
	
	if ($aff_note_application_on=="on") $aff_note_application=1;
		else $aff_note_application=0;

	if ($aff_voir_on=="on") $aff_voir=1;
		else $aff_voir=0;

	$arbres = array();

	$queryparents_effective = "SELECT n.id_noeud, n.num_parent, c.libelle_categorie, c.note_application, n.num_renvoi_voir FROM noeuds n, categories c WHERE n.id_noeud = c.num_noeud AND n.num_thesaurus = ".$aff_num_thesaurus." and c.langue = '".$aff_langue."' ORDER BY c.libelle_categorie ASC";

	$resultat_query_parents = aff_enfants($queryparents_effective);

	creer_arbres();

	aff_enfants3($id_noeud_top, 0);
	
	if ($output=="printer") print "<script>self.print();</script>";

	// pied de page
	print "</body></html>";

	}

mysql_close($dbh);

?>
