-- +-------------------------------------------------+
--  2002-2004 PMB Services / www.sigb.net pmb@sigb.net et contributeurs (voir www.sigb.net)
-- +-------------------------------------------------+
-- $Id: minimum.sql,v 1.24 2006/09/04 16:57:27 touraine37 Exp $

-- 
-- Contenu de la table `classements`
-- 

INSERT INTO classements (id_classement, type_classement, nom_classement) VALUES (1, '', '_NON CLASSE_');

-- 
-- Contenu de la table `origine_notice`
-- 

INSERT INTO origine_notice (orinot_id, orinot_nom, orinot_pays, orinot_diffusion) VALUES (1, 'Catalogage interne', 'FR', 1);

-- 
-- Contenu de la table `parametres`
-- 

#
# Contenu de la table `parametres`
#

INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pmb', 'bdd_version', 'v4.09', 'Versione del nucleo della base dati, pu essere cambiato solo in diminuzione nel caso di errato aggiornamento per ripetere l''aggiornamento stesso. In caso di bisogno contattate la mailing list pmb.user@sigb.net', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pmb', 'prefill_cote', 'custom_cote_01.inc.php', 'Script personalizzato per la generazione della collocazione di un esemplare (attivato al momento dell''inserimento di un nuovo esemplare)', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'z3950', 'accessible', '1', 'funzione Z3950 attivata\r\n 0 : no, menu inaccessibile, la ricerca z3950 non  possibile\r\n 1 : s, la libreria PHP_YAZ  attivata, la ricerca z3950   possibile', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pmb', 'nb_lastautorities', '10', 'Numero delle ultime autorit mostrate in Gestione Autorit', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pdflettreretard', '1before_list', 'Salvo errori da parte nostra, ci risultano ancora in Suo possesso le opere seguenti la cui durata del prestito  gi scaduta :', 'Testo che precede lalista delle opere in ritardo nella sezione dei solleciti', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pdflettreretard', '1after_list', 'La preghiamo di contattarci con cortese sollecitudine per telefono al n.$biblio_phone o per email all''indirizzo $biblio_email per esaminare la possibilit di prolungare il prestito o per restituire le opere a suo tempo prelevate.', 'Testo che segue la lista delle opere con riconsegna in ritardo', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pdflettreretard', '1fdp', 'Il Responsabile della Biblioteca $biblio_name.', 'Firmatario della lettera, utilizzare $biblio_name per stampare il parametro "biblio name" o mettere qualunque altra cosa.', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pdflettreretard', '1madame_monsieur', 'Sig.ra, Sig.,', 'Intestazione della lettera', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pdflettreretard', '1nb_par_page', '7', 'Numero delle opere in ritardo stampate sulle pagine siccessive', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pdflettreretard', '1nb_1ere_page', '4', 'Numero delle opere in ritardo stampate sulla prima pagina\r\n', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pdflettreretard', '1taille_bloc_expl', '16', 'Dimensione di un blocco (2 linee) per l''opera in ritardo. Spazio di separazione tra un''opera e l''altra', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pdflettreretard', '1debut_expl_1er_page', '160', 'Posizione di partenza dell''elenco delle opere nella prima pagina. E'' espresso in mm a partire dal bordo superiore della pagina. Deve essere regolato in funzione del testo che precede l''elenco delle opere, il quale pu avere diversa lunghezza.', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pdflettreretard', '1debut_expl_page', '15', 'Posizione di partenza dell''elenco delle opere nelle pagine successive, espresso in mm a partire dal bordo superiore.', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pdflettreretard', '1limite_after_list', '270', 'Posizione limite in fondo alla pagina. Se un elemento da stampare oltrepassa questo limite, verr stampato sulla pagina seguente.', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pdflettreretard', '1marge_page_gauche', '10', 'Margine sinistro in mm', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pdflettreretard', '1marge_page_droite', '10', 'Margine destro in mm', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pdflettreretard', '1largeur_page', '210', 'Larghezza della pagina in mm', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pdflettreretard', '1hauteur_page', '297', 'Altezza della pagina in mm', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pdflettreretard', '1format_page', 'P', 'Orientamento del foglio: \r\n P : Portrait (verticale)\r\n L : Landscape (orizzontale)', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pdfcartelecteur', 'pos_h', '20', 'Margine sinistro in mm \r\n', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pdfcartelecteur', 'pos_v', '20', 'Margine superiore in mm', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pdfcartelecteur', 'biblio_name', '$biblio_name', 'Nome della biblioteca stampato sulla tessera dell''utente. Inserire $biblio_name per stampare il parametro "biblio name" oppure inserire qualunque altra cosa.', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pdfcartelecteur', 'largeur_nom', '80', 'Larghezza di stampa in mm del nome dell''utente', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pdfcartelecteur', 'valabledu', 'Validit dal', '''Validit dal'' in "VALIDIT DAL ##/##/#### al ##/##/####"', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pdfcartelecteur', 'valableau', 'al', '''al'' nel "valevole dal ##/##/#### AL ##/##/####"', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pdfcartelecteur', 'carteno', 'Tessera N :', 'Didascalia che precede il numero della tessera', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'sauvegarde', 'cle_crypt1', '9b4a840d790eadc71b9064c9a843719b', '', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'sauvegarde', 'cle_crypt2', '51580d4fd5f1ad2d981c91ddb04095ec', '', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pmb', 'resa_dispo', '1', 'Prenotazione dei documenti disponibili\r\n 0 : No\r\n 1 : Si', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'mailretard', '1objet', 'Pubblicazioni da restituire', 'Oggetto della mail di sollecito per ritardo nella restituzione', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'mailretard', '1before_list', 'Salvo errori da parte nostra di cui vorrete scusarci, ci risulta che le opere di cui all''elenco seguente e il cui periodo di prestito  gi scaduto sono tutt''ora in Suo possesso:', 'Testo visualizzato prima della lista delle opere la cui restituzione  in ritardo nella mail di sollecito', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'mailretard', '1after_list', 'La preghiamo di contattarci urgentemente al n. di tel. 0000000 o per e-mail all''indirizzo mail@mail.mail per esaminare la possibilit di prolungare il prestito o per restituire le opere attualmente in Suo possesso.', 'Testo mail che appare dopo la lista delle opere la cui restituzione ritarda', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'mailretard', '1madame_monsieur', 'Sig.ra, Sig.', 'Intestazione della mail', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'mailretard', '1fdp', 'Il Responsabile della Biblioteca $biblio_name.', 'Firmatario della mail di sollecito alla restituzione', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pmb', 'serial_link_article', '0', 'Pre riempimento del link della spunta con il link della scheda principale nella catalogazione dei periodici\r\n 0 : No\r\n 1 : Si', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pmb', 'num_carte_auto', '1', 'Numero tessera utente automatico\r\n 1 : Si\r\n 0 : No (nel caso si utilizzino tessere prestampate)', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'modules_search_title', '1', 'Cerca nel campo TITOLO', 'c_recherche', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'modules_search_author', '1', 'Cerca nel campo AUTORE', 'c_recherche', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'modules_search_publisher', '1', 'Cerca nel campo EDITORE', 'c_recherche', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'modules_search_collection', '1', 'Cerca nel campo COLLEZIONE', 'c_recherche', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'modules_search_subcollection', '1', 'Cerca nel campo SOTTOCOLLEZIONE', 'c_recherche', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'modules_search_category', '1', 'Cerca nel campo SOGGETTI/CATEGORIE', 'c_recherche', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'modules_search_keywords', '1', 'Cerca tra le PAROLE CHIAVE', 'c_recherche', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'modules_search_abstract', '1', 'Cerca nel campo RIASSUNTO', 'c_recherche', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'modules_search_content', '1', 'Cerca nel campo CONTENUTO', 'c_recherche', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'categories_categ_path_sep', '>', 'Separatore per le Categorie', 'i_categories', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'categories_columns', '3', 'Numero delle colonne del sommario generale delle Categorie', 'i_categories', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'categories_categ_rec_per_page', '6', 'Numero delle schede visualizzabili per pagina durante l''esplorazione delle categorie', 'i_categories', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'categories_categ_sort_records', 'index_serie, tnvol, index_sew', 'Esploratore delle categorie: modo di scelta delle schede', 'i_categories', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'search_results_first_level', '4', 'Numero dei risultati visualizzati sulla prima pagina', 'z_unused', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'search_results_per_page', '10', 'Numero dei risultati visualizzati sulle pagine successive', 'd_aff_recherche', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'authors_aut_rec_per_page', '1', 'Numero degli autori visualizzati per pagina', 'd_aff_recherche', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'categories_sub_display', '3', 'Numero delle sottocategoria sulla prima pagina', 'i_categories', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'categories_sub_mode', 'categ_libelle', 'Modo di visualizzazione delle sotto-categorie: \r\n rand() : casuale\r\n categ_libelle : alfabetico', 'i_categories', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'authors_aut_sort_records', 'index_serie, tnvol, index_sew', 'Vista autori : selezione delle schede', 'd_aff_recherche', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'default_lang', 'it_IT', 'Lingua dell''OPAC : it_IT o fr_FR o en_US o es_ES o ar', 'a_general', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'show_categ_browser', '1', 'Visualizzazione delle categorie nella home page OPAC\r\n 1: Si  \r\n 0: No', 'f_modules', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'show_book_pics', '1', 'Visualizzazione delle miniature dei libri nelle schede delle opere:\r\n 0 : No\r\n 1 : Si', 'e_aff_notice', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'resa', '1', 'Prenotazioni via OPAC possibili:\r\n 1 Si\r\n 0 No', 'a_general', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'resa_dispo', '1', 'Prenotazioni possibili per i documenti disponibili via OPAC\r\n 1: Si\r\n 0: No', 'a_general', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'show_meteo', '0', 'Visualizzazione del METEO (0/1)\r\n', 'f_modules', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'duration_session_auth', '1200', 'Durata in secondi della sessione OPAC dell''utente', 'a_general', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pmb', 'relance_adhesion', '31', 'Numero giorni di preavviso per il sollecito al rinnovo della tessera di adesione', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pmb', 'pret_adhesion_depassee', '1', 'Prestiti a tessera scaduta\r\n 0 impossibile\r\n 1 possibile', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pdflettreadhesion', 'fdp', 'Il Responsabile della Biblioteca', 'Formula di cortesia a fondo pagina', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pdflettreadhesion', 'madame_monsieur', 'Sig.ra, Sig.,', 'Titolo del destinatario', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pdflettreadhesion', 'texte', 'Il Suo abbonamento alla Biblioteca scadr il!!date_fin_adhesion!!. Potr rinnovarlo alla prossima visita.\r\n\r\nCogliamo lccasione per porgere distinti saluti.', 'Frase introduttiva per l''abbonamento in scadenza', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pdflettreadhesion', 'marge_page_gauche', '10', 'Margine sinistro in mm', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pdflettreadhesion', 'marge_page_droite', '10', 'Margine destro in mm', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pdflettreadhesion', 'largeur_page', '210', 'Larghezza della pagina in mm', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pdflettreadhesion', 'hauteur_page', '297', 'Altezza della pagina in mm', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pdflettreadhesion', 'format_page', 'P', 'Orientamento del foglio: \r\n  P : Portrait (verticale)\r\n  L : Landscape (orizzontale)', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'mailrelanceadhesion', 'objet', 'Biblioteca : abbonamento', 'Oggetto della dettera di sollecito all''adesione', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'mailrelanceadhesion', 'texte', 'Il Suo abbonamento alla biblioteca scade il !!date_fin_adhesion!!. La preghiamo di rinnovarlo la prossima volta che verr a trovarci.\r\n\r\nCordiali saluti,\r\n\r\n', 'Testo del sollecito, !!date_fin_adhesion!! - rimpiazzato durante la stampa dalla data di scadenza dell''abbonamento', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'mailrelanceadhesion', 'madame_monsieur', 'Sig.ra, Sig.,', 'Intestazione della lettera per il sollecito all''adesione', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'mailrelanceadhesion', 'fdp', 'Il responsabile della Biblioteca.', 'Formula di cortesia in calce alla pagina', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'show_marguerite_browser', '0', 'Ventaglio delle categorie (0/1)\r\n', 'f_modules', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'show_100cases_browser', '0', 'Vsualizzazione di 100 categorie/soggetti (0/1)', 'f_modules', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pmb', 'indexint_decimal', '1', '0 o 1 : l''indicizzazione interna  di tipo Dewey', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'modules_search_indexint', '1', 'Cerca nelle INDICIZZAZIONI INTERNE', 'c_recherche', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'empr', 'birthdate_optional', '1', 'Anno di nascita facoltativo:\r\n 0 = no: dato obbligatorio\r\n 1 = si', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'categories', 'show_empty_categ', '1', 'Visualizzazione delle categorie senza schede:\r\n0=No, 1=Si', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'categories', 'term_search_n_per_page', '500', 'Numero dei termini per pagina visualizzati a seguito di una ricerca per termini nelle categorie (soggetti)', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'show_loginform', '1', 'Visualizzazione del login utente \r\n 0: No \r\n 1: Si', 'f_modules', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'default_style', '1', 'Stile grafico dell''OPAC, 1 stile di default, senza margini: senza visualizzazione della colonna di sinistra', 'a_general', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'show_exemplaires', '1', 'Visualizzazione degli esemplari nell''OPAC\r\n 1 : Si\r\n 0 : No', 'e_aff_notice', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pmb', 'import_modele', 'func_bdp.inc.php', 'Script contenente le funzioni per personalizzare l''import dei dati', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pmb', 'quotas_avances', '0', 'Quota dei prestiti richiesti in anticipo\r\n 0 : No\r\n 1 : Si', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'logo', 'logo_default.jpg', 'Nome del file dell''immagine del logo', 'z_unused', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'logosmall', 'images/site/logo_default_small.jpg', 'Nome del file con il logo piccolo', 'b_aff_general', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'show_bandeaugauche', '1\r\n', 'Visualizzazione della banda laterale sinistra ? \r\n 0 : No\r\n 1 : Si', 'f_modules', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'show_liensbas', '1', 'Visualizzazione a fondo pagina dei link (pmb, google, bibli) \r\n 0 : No\r\n 1 : Si', 'f_modules', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'show_homeontop', '0\r\n', 'Visualizzazione del link HOME sotto il nome della Biblioteca (necessario se la banda sinistra  nascosta)\r\n 0 : No\r\n 1 : Si', 'f_modules', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pmb', 'resa_quota_pret_depasse', '1', 'Prenotazione possibile anche se la quota prestiti  stata superata\r\n 0 : No\r\n 1 : Si', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pmb', 'import_limit_read_file', '100', 'Dimensione della quantit di record importabili in una singola lettura, generalmente 100 o 200  un valore ragionevole, se si sperimentano problemi di timeout fissare un valore inferiore, ad esempio 50.', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pmb', 'import_limit_record_load', '100', 'Dimensione della quantit di schede importabili in una singola lettura, generalmente 100 o 200  un valore ragionevole, se si sperimentano problemi di timeout fissare un valore inferiore, ad esempio 50.', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'biblio_preamble_p1', 'Benvenuto nella nostra Biblioteca.......buona ricerca!', 'Informazioni sulla Biblioteca - paragrafo 1', 'b_aff_general', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'biblio_preamble_p2', 'La Biblioteca ONLINE  ancora in fase sperimentale, al momento non sono ancora stati immessi gli esemplari presenti nella biblioteca d''Istituto.', 'Informazioni paragrafo 2 - orario per il pubblico', 'b_aff_general', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'biblio_quicksummary_p1', '', 'Paragrafo 1 del riassunto sulla biblioteca,  mascherato per default nel foglio di stile, vedi id quickSummary.p1', 'z_unused', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'biblio_quicksummary_p2', '', 'Paragrafo 2 Pdel riassunto sulla biblioteca,  mascherato per default nel foglio di stile, vedi id quickSummary.p2', 'z_unused', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'show_dernieresnotices', '0', 'Visualizzazione a fondo pagine delle ultime schede create\r\n 0 : No\r\n 1 : Si', 'f_modules', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'show_etageresaccueil', '1', 'Visualizzazione a fondo pagina degli Scaffali\r\n 0 : No\r\n 1 : Si', 'f_modules', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'biblio_important_p1', '', 'Infos importanti 1 sulla Biblioteca, di default  nascosto nel foglio di stile (vedi id iportant.p1)', 'b_aff_general', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'biblio_important_p2', '', 'Infos importanti 2 sulla Biblioteca, di default  nascosto nel foglio di stile (vedi id iportant.p2)', 'b_aff_general', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'biblio_name', 'Biblioteca XXXXXXX', 'Nome della Biblioteca', 'b_aff_general', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'biblio_website', 'www.xxxxxxxxxxx.org', 'Sito web della biblioteca', 'b_aff_general', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'biblio_adr1', 'Via 25 Aprile', 'Indirizzo della Biblioteca come visualizzato nell''OPAC', 'b_aff_general', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'biblio_town', 'XXXXXX (YY)', 'Citt sede della Biblioteca', 'b_aff_general', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'biblio_cp', '00000', 'Codice postale della Biblioteca', 'b_aff_general', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'biblio_country', 'Italia', 'Paese della Biblioteca visualizzato nell''OPAC', 'b_aff_general', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'biblio_phone', '0000000000', 'Numero telefonico della Biblioteca', 'b_aff_general', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'biblio_dep', '', 'Dipartimento della Biblioteca per il meteo', 'b_aff_general', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'biblio_email', 'xxxxxx@yyyyy.it', 'Indirizzo Email della Biblioteca', 'b_aff_general', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'etagere_notices_order', 'index_serie, tnvol, index_sew', 'Ordine di visualizzazionedelle schede negli scaffali OPAC\r\n index_serie, tit1 : scelta per titolo di serie e titolo\r\n rand()  : casuale', 'j_etagere', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'etagere_notices_format', '8', 'Formato di visualizzazione delle schede negli scaffali in home page\r\n 1 : solo ISBD \r\n 2 : solo Publico \r\n 4 : ISBD e Publico\r\n 8 : Ridotto (titolo+autori)', 'j_etagere', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'etagere_notices_depliables', '0', 'Visualizzazione espandibile delle schede negli scaffali in home page\r\n 0 : No\r\n 1 : Si', 'j_etagere', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'etagere_nbnotices_accueil', '5', 'Numero delle schede visualizzate nella home page\r\n 0  : Tutte\r\n -1 : Nessuna \r\n x : x schede visualizzate al massimo', 'j_etagere', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'nb_aut_rec_per_page', '15', 'Numero delle schede visualizzate per una data autorit', 'd_aff_recherche', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'notices_format', '4', 'Formato di presentazione delle bibliografie negli scaffali nella homepage \r\n 1 : ISBD solamente\r\n 2 : Public solamente\r\n 4 : ISBD e Public \r\n 5 : ISBD e Public con ISBD selezionato \r\n 8 : Ridotto (titolo+autori) solamente', 'e_aff_notice', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'notices_depliable', '1', 'Visualizzazione espandibile delle schede risultato di una ricerca\r\n  0: No\r\n  1: Si', 'e_aff_notice', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'term_search_n_per_page', '200', 'Ricerca per termini: numero dei termini visualizzati per pagina', 'c_recherche', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'show_empty_categ', '0', 'Nella ricerca per termine, visualizzazione delle categorie senza opere associate:\r\n 0 : No \r\n 1 : Si', 'i_categories', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'allow_extended_search', '1', 'Autorizzazione alla ricerca OPAC avanzata\r\n 0 : No\r\n 1 : Si', 'c_recherche', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'allow_term_search', '1', 'Autorizzazione alla ricerca per termini\r\n 0 : No\r\n 1 : Si\r\n', 'c_recherche', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'term_search_height', '200', 'Altezza in pixel del frame di ricerca per termini (se lasciato vuoto o posto a zero il valore di default  di 200 pixel)', 'c_recherche', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'categories_nb_col_subcat', '3', 'Numero delle colonne delle sottocategorie durante la consultazione per categoria\r\n 3 default', 'i_categories', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'max_resa', '5', 'Numero massimo delle prenotazioni su un documento\r\n 5 default\r\n 0 nessun limite', 'a_general', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pmb', 'show_help', '1', 'Visualizzazione dell''aiuto in linea in PMB-gestione \r\n 1 Si \r\n 0 No', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'show_help', '1', 'Visualizzazione dell''Aiuto in linea\r\n 1 Si \r\n 0 No', 'f_modules', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'cart_allow', '1', 'Selezioni possibili nell''OPAC di PMB\r\n 1 Si \r\n 0 No', 'f_modules', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'max_cart_items', '200', 'Numero massimo delle schede nella Selezione utente.', 'h_cart', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'show_section_browser', '1', 'Visualizzare il raccoglitore della collocazione e delle sezioni \r\n 0 : No\r\n 1 : Si', 'f_modules', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'nb_localisations_per_line', '6', 'Numero delle ubicazioni visualizzate per linea in home page (se show_section_browser=1)', 'k_section', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'nb_sections_per_line', '6', 'Numero delle sezioni visualizzate per linea in visualizzazione della localizzazione (se show_section_browser=1)', 'k_section', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'cart_only_for_subscriber', '1', 'Selezione delle schede riservata ai soci della Biblioteca\r\n 1: Si\r\n 0: No, autorizzata per tutti i visitatori', 'h_cart', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'notice_reduit_format', '0', 'Formato di presentazione delle notizie in forma ridotta :\r\n 0 normale = titolo+autori principali\r\n P 1,2,3: Perso. : tit+aut+champs persos id 1 2 3\r\n E 1,2,3: Perso. : tit+aut+dit+champs persos id 1 2 3', 'e_aff_notice', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pdflettreresa', 'before_list', 'In seguito alla Sua domanda di prenotazione, La informiamo che la/le opere qui di seguito elencate sono a Sua disposizione presso la biblioteca.', 'Testo che compare prima dell''elenco delle opere prenotate nella ricevuta di confermata prenotazione', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pdflettreresa', 'after_list', 'Trascorso il periodo di validit della prenotazione, queste opere verranno rimesse in circolazione, vi preghiamo di volerle ritirare entro il termine prestabilito.', 'Testo che compare dopo l''elenco delle opere', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pdflettreresa', 'fdp', 'Il responsabile della $biblio_name.', 'Firmatario della lettera, utilizzare $biblio_name per stampare il parametro "biblio name" o mettere qualunque altra cosa.', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pdflettreresa', 'madame_monsieur', 'Sig.ra, Sig.,', 'Intestazione della lettera', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pdflettreresa', 'nb_par_page', '7', 'Numero di opere in ritardo stampate sulle pagine seguenti.', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pdflettreresa', 'nb_1ere_page', '4', 'Numero di opere in ritardo stampate sulla prima pagina', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pdflettreresa', 'taille_bloc_expl', '16', 'Dimensione di un blocco (2 linee) per l''opera in ritardo. Spazio di separazione tra un''opera e l''altra', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pdflettreresa', 'debut_expl_1er_page', '160', 'Posizione di partenza dell''elenco delle opere nella prima pagina. E'' espresso in mm a partire dal bordo superiore della pagina. Deve essere regolato in funzione del testo che precede l''elenco delle opere, il quale pu avere diversa lunghezza.', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pdflettreresa', 'debut_expl_page', '15', 'Posizione di partenza dell''elenco delle opere nelle pagine successive, espresso in mm a partire dal bordo superiore.', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pdflettreresa', 'limite_after_list', '270', 'Posizione limite in fondo alla pagina. Se un elemento da stampare oltrepassa questo limite, verr stampato sulla pagina seguente.', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pdflettreresa', 'marge_page_gauche', '10', 'Margine sinistro in mm', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pdflettreresa', 'marge_page_droite', '10', 'Margine di destra in mm', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pdflettreresa', 'largeur_page', '210', 'Larghezza della pagina in mm', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pdflettreresa', 'hauteur_page', '297', 'Altezza della pagina in mm', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pdflettreresa', 'format_page', 'P', 'Orientamento del foglio: \r\n  P : Portrait (verticale)\r\n  L : Landscape (orizzontale)', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'categories_max_display', '200', 'Numero massimo di categorie principali mostrate nella home page', 'i_categories', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'search_other_function', '', 'Funzione aggiuntiva per le ricerche nella home page', 'c_recherche', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'lien_bas_supplementaire', '', 'Link supplementare in fondo alla home page, da inserire per intero: a href= lien /a', 'b_aff_general', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'z3950', 'import_modele', 'func_other.inc.php', 'Quale script delle funzioni d''importazione utilizzare per personalizzare l''importazione delle schede bibliografiche mediante  lo z39.50 ?', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'ldap', 'server', '127.0.0.1', 'Server LDAP, inserire l''IP oppure l''host', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'ldap', 'basedn', 'dc=isi,dc=org', 'Suffisso del nome del dominio LDAP', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'ldap', 'port', '389', 'Porta del server LDAP', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'ldap', 'filter', '(&(objectclass=person)(gidnumber=GID))', 'Filtro', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'ldap', 'fields', 'uid,gecos,departmentnumber', 'Campi del server LDAP', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'ldap', 'lang', 'it_IT', 'Lingua del server LDAP', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'ldap', 'groups', 'Domain Users, alunni', 'Gruppi del server LDAP', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'ldap', 'accessible', '0', 'Supporto LDAP attivato?\r\n0 no\r\n1 s', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'ldap', 'proto', '3', 'Versione del protocollo LDAP : 3 o 2', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'ldap', 'binddn', 'uid=UID,ou=People', 'Descrizione del link : costruzione della catena bindn per poter autenticare gli utenti con il server LDAP nell''OPAC', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'categories_show_only_last', '0', 'Nella scheda bibliografica: \r\n 0 mostrare tutto\r\n 1 : mostrare solamente l''ultimo elemento dell''albero delle categorie', 'i_categories', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'categories', 'show_only_last', '0', 'Nella scheda di una bibliografia : \r\n 0 mostra tutto \r\n 1 : mostra solo l''ultimo elemento dell''albero delle categorie', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'empr', 'corresp_import', 'a:24:{s:7:"empr_cb";s:1:"1";s:8:"empr_nom";s:1:"1";s:11:"empr_prenom";s:1:"0";s:9:"empr_adr1";s:1:"0";s:5:"plus1";s:1:"0";s:9:"empr_adr2";s:1:"2";s:7:"empr_cp";s:1:"3";s:10:"empr_ville";s:1:"4";s:9:"empr_pays";s:1:"5";s:9:"empr_mail";s:1:"0";s:9:"empr_tel1";s:1:"0";s:9:"empr_tel2";s:1:"0";s:9:"empr_prof";s:1:"0";s:9:"empr_year";s:1:"0";s:9:"empr_sexe";s:1:"0";s:10:"empr_login";s:1:"5";s:13:"empr_password";s:1:"0";s:8:"empr_msg";s:1:"0";s:9:"empr_lang";s:1:"0";s:8:"type_abt";s:1:"0";s:14:"last_loan_date";s:0:"";s:9:"from_ldap";s:1:"1";s:10:"selectStat";s:1:"6";s:11:"Enregistrer";s:6:"Avanti";}', 'Tabella delle corrispondenze colonne/campi al momento dell''importazione dei lettori da un file ASCII', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pmb', 'type_audit', '0', 'Gestione/visualizzazione delle date di creazione/modifica\r\n 0: Nessuna data\r\n 1: Creazione e ultima modifica\r\n 2: Creazione e tutte le date di modifica', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pmb', 'utiliser_calendrier', '0', 'Utilizzare il calendario dei giorni d''apertura? \r\n 0 : No\r\n 1 : S', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pmb', 'gestion_financiere', '0', 'Utilizzare il modulo per la gestione finanziaria ? \r\n 0 : No\r\n 1 : S', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pmb', 'gestion_abonnement', '0', 'Utilizzare la gestione degli abbonamenti dei lettori? \r\n 0 : No\r\n 1 : S, gestione semplificata\r\n 2 : S, gestione avanzata', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pmb', 'gestion_tarif_prets', '0', 'Utilizzare la gestione delle tariffe per i prestiti?\r\n 0 : No\r\n 1 : S, gestione semplificata\r\n 2 : S, gestione avanzata', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pmb', 'gestion_amende', '0', 'Utilizzare la gestione delle ammende?\r\n 0 : No\r\n 1 : S', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'finance', 'amende_jour', '0.15', 'Amende par jour de retard pour tout type de document. Attention, le sparateur dcimal est le point, pas la virgule', '', 1);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'finance', 'delai_avant_amende', '15', 'Dlai avant dclenchement de l''amende, en jour', '', 1);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'finance', 'delai_recouvrement', '15', 'Dlai avant mise en recouvrement officiel de l''amende, en jour', '', 1);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'finance', 'amende_maximum', '0', 'Amende maximum, quel que soit le retard l''amende est plafonne  ce montant. 0 pour dsactiver ce plafonnement.', '', 1);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pdflettreresa', 'priorite_email', '1', 'Metodi di comunicazione nelle lettere di conferma delle prenotazioni:\r\n 0 : Solamente lettera \r\n 1 : Mail, a default lettera\r\n 2 : Mail e lettera', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pdflettreresa', 'priorite_email_manuel', '1', 'Priorit des lettres de confirmation de rservation par mail lors de l''impression  partir du bouton :\n 0 : Lettre seule \n 1 : Mail,  dfaut lettre\n 2 : Mail ET lettre\n 3 : Aucune alerte', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'finance', 'blocage_abt', '1', 'Blocage du prt si le compte abonnement est dbiteur\n 0 : pas de blocage \n 1 : blocage avec forage possible  : blocage incontournable.', '', 1);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'finance', 'blocage_pret', '1', 'Blocage du prt si le compte prt est dbiteur\n 0 : pas de blocage \n 1 : blocage avec forage possible  : blocage incontournable.', '', 1);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'finance', 'blocage_amende', '1', 'Blocage du prt si le compte amende est dbiteur\n 0 : pas de blocage \n 1 : blocage avec forage possible  : blocage incontournable.', '', 1);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pmb', 'gestion_devise', '', 'Divisa per la gestione finanziaria, quella che sar mostrata nel codice HTML', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'book_pics_url', '', 'URL delle immagini delle schede bibliografiche, all''interno del path, !!isbn!! viene sostituito dal codice ISBN o EAN della scheda, ripulito dai segni di punteggiatura come trattini e punti. \r\n esempio : http://www.monsite/opac/images/vignettes/!!isbn!!.j', 'e_aff_notice', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'lien_moteur_recherche', '<a href=http://www.google.it target=_blank>Fare una ricerca con Google</a>', 'Link aggiuntivo in fondo alla home page, da inserire in modo completo : a href= lien /a', 'b_aff_general', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pmb', 'pret_express_statut', '2', 'Status della scheda bibliografica da utilizzare al momento della creazione di esemplari per il prestito espresso', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'notice_affichage_class', 'notice_affichage_custom_it', 'Nome della classe da utilizzare per personalizzare la presentazione delle bibliografie.\r\n\r\nnotice_affichage_custom_it mette la funzione davanti all''autore:\r\n\r\nes: note di Mario Rossi vs Mario Rossi annotatore', 'e_aff_notice', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pmb', 'confirm_retour', '1', 'Al rientro di un documento, il rientro deve essere confermato? \r\n 0 : No, si possono leggere i codici a barre uno dopo l''altro \r\n 1 : S,  necessario confermare i dati dopo l''immissione di ogni codice a barre', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'show_meteo_url', '<img src="http://perso0.free.fr/cgi-bin/meteo.pl?dep=" alt="" border="0" hspace=0>', 'URL de la mto affiche', 'f_modules', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pmb', 'limitation_dewey', '0', 'Nombre maximum de caractres dans la Dewey (676) en import : \n 0 aucune limitation \n 3 : limitation de 000  999 \n 5 (exemple) limitation 000.0 \n -1 : aucune importation', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'finance', 'delai_1_2', '15', 'Dlai entre 1ere et 2eme relance', '', 1);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'finance', 'delai_2_3', '15', 'Dlai entre 2eme et 3eme relance', '', 1);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'dsi', 'active', '0', 'D.S.I. attivato ? \r\n 0: No \r\n 1: S', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'dsi', 'auto', '0', 'D.S.I. automatica attivata ? \r\n 0: No\r\n 1: S', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'dsi', 'insc_categ', '0', 'Inscription automatique dans les bannettes de la catgorie du lecteur en cration ? \n 0: Non \n 1: Oui', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'allow_bannette_priv', '0', 'Possibilit pour les lecteurs de crer ou modifier leurs bannettes prives \n 0: Non \n 1: Oui', 'l_dsi', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'allow_resiliation', '0', 'Possibilit pour les lecteurs de rsilier leur abonnement aux bannettes pro \n 0: Non \n 1: Oui', 'l_dsi', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'show_categ_bannette', '0', 'Affichage des bannettes de la catgorie du lecteur et possibilit de s''y abonner \r\n 0: Non \r\n 1: Oui', 'l_dsi', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'url_base', './opac_css/', 'URL de base de l''opac : typiquement mettre l''url publique web http://monsite/opac/ ne pas oublier le / final', 'a_general', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'finance', 'relance_1', '0.53', 'Frais de la premire lettre de relance', '', 1);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'finance', 'relance_2', '0.53', 'Frais de la deuxime lettre de relance', '', 1);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'finance', 'relance_3', '2.50', 'Frais de la troisime lettre de relance', '', 1);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'finance', 'statut_perdu', '', 'Statut (d''exemplaire) perdu pour des ouvrages non rendus', '', 1);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pdflettreretard', '2after_list', 'Nous vous remercions de prendre rapidement contact par tlphone au 02 47 24 89 29 ou par mail  pmb@sigb.net pour tudier la possibilit de prolonger ces prts ou de ramener les ouvrages concerns.', 'Texte apparaissant aprs la liste des ouvrages en retard dans le courrier', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pdflettreretard', '2before_list', 'Sauf erreur de notre part, vous avez toujours en votre possession le ou les ouvrage(s) suivant(s) dont la dure de prt est aujourd''hui dpasse :', 'Texte apparaissant avant la liste des ouvrages en retard dans le courrier de relance de retard', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pdflettreretard', '2debut_expl_1er_page', '160', 'Dbut de la liste des exemplaires sur la premire page, en mm depuis le bord suprieur de la page. Doit tre rgl en fonction du texte qui prcde la liste des ouvrages, lequel peut tre plus ou moins long.', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pdflettreretard', '2debut_expl_page', '15', 'Dbut de la liste des exemplaires sur les pages suivantes, en mm depuis le bord suprieur de la page.', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pdflettreretard', '2fdp', 'Le responsable de la Bibliothque test de PMB.', 'Signataire de la lettre, utiliser Bibliothque test de PMB pour reprendre le paramtre "biblio name" ou bien mettre autre chose.', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pdflettreretard', '2format_page', 'P', 'Format de la page : \r\n P : Portrait\r\n L : Landscape = paysage', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pdflettreretard', '2hauteur_page', '297', 'Hauteur de la page en mm', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pdflettreretard', '2largeur_page', '210', 'Largeur de la page en mm', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pdflettreretard', '2limite_after_list', '270', 'Position limite en bas de page. Si un lment imprim tente de dpasser cette limite, il sera imprim sur la page suivante.', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pdflettreretard', '2madame_monsieur', 'Madame, Monsieur,', 'Entte de la lettre', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pdflettreretard', '2marge_page_droite', '10', 'Marge de droite en mm', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pdflettreretard', '2marge_page_gauche', '10', 'Marge de gauche en mm', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pdflettreretard', '2nb_1ere_page', '4', 'Nombre d''ouvrages en retard imprim sur la premire page', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pdflettreretard', '2nb_par_page', '7', 'Nombre d''ouvrages en retard imprim sur les pages suivantes.', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pdflettreretard', '2taille_bloc_expl', '16', 'Taille d''un bloc (2 lignes) d''ouvrage en retard. Le dbut de chaque ouvrage en retard sera espac de cette valeur sur la page', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pdflettreretard', '3after_list', 'Nous vous remercions de prendre rapidement contact par tlphone au 02 47 24 89 29 ou par mail  pmb@sigb.net pour tudier la possibilit de prolonger ces prts ou de ramener les ouvrages concerns.', 'Texte apparaissant aprs la liste des ouvrages en retard dans le courrier', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pdflettreretard', '3before_list', 'Sauf erreur de notre part, vous avez toujours en votre possession le ou les ouvrage(s) suivant(s) dont la dure de prt est aujourd''hui dpasse :', 'Texte apparaissant avant la liste des ouvrages en retard dans le courrier de relance de retard', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pdflettreretard', '3debut_expl_1er_page', '160', 'Dbut de la liste des exemplaires sur la premire page, en mm depuis le bord suprieur de la page. Doit tre rgl en fonction du texte qui prcde la liste des ouvrages, lequel peut tre plus ou moins long.', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pdflettreretard', '3debut_expl_page', '15', 'Dbut de la liste des exemplaires sur les pages suivantes, en mm depuis le bord suprieur de la page.', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pdflettreretard', '3fdp', 'Le responsable de la Bibliothque test de PMB.', 'Signataire de la lettre, utiliser Bibliothque test de PMB pour reprendre le paramtre "biblio name" ou bien mettre autre chose.', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pdflettreretard', '3format_page', 'P', 'Format de la page : \r\n P : Portrait\r\n L : Landscape = paysage', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pdflettreretard', '3hauteur_page', '297', 'Hauteur de la page en mm', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pdflettreretard', '3largeur_page', '210', 'Largeur de la page en mm', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pdflettreretard', '3limite_after_list', '270', 'Position limite en bas de page. Si un lment imprim tente de dpasser cette limite, il sera imprim sur la page suivante.', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pdflettreretard', '3madame_monsieur', 'Madame, Monsieur,', 'Entte de la lettre', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pdflettreretard', '3marge_page_droite', '10', 'Marge de droite en mm', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pdflettreretard', '3marge_page_gauche', '10', 'Marge de gauche en mm', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pdflettreretard', '3nb_1ere_page', '4', 'Nombre d''ouvrages en retard imprim sur la premire page', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pdflettreretard', '3nb_par_page', '7', 'Nombre d''ouvrages en retard imprim sur les pages suivantes.', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pdflettreretard', '3taille_bloc_expl', '16', 'Taille d''un bloc (2 lignes) d''ouvrage en retard. Le dbut de chaque ouvrage en retard sera espac de cette valeur sur la page', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pdflettreretard', '3before_recouvrement', 'Sans nouvelles de votre part dans les sept jours, nous nous verrons contraints de dlguer au trsor public le recouvrement des ouvrages suivants :', 'Texte avant la liste des ouvrages en recouvrement', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'bannette_notices_order', ' index_serie, tnvol, index_sew ', 'Ordre d''affichage des notices dans les bannettes dans l''opac \n  index_serie, tnvol, index_sew : tri par titre de srie et titre \n rand()  : alatoire', 'l_dsi', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'bannette_notices_format', '8', 'Format d''affichage des notices dans les bannettes \n 1 : ISBD seul \n 2 : Public seul \n 4 : ISBD et Public \n 8 : Rduit (titre+auteurs) seul', 'l_dsi', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'bannette_notices_depliables', '1', 'Affichage dpliable des notices dans les bannettes \n 0 : Non \n 1 : Oui', 'l_dsi', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'bannette_nb_liste', '0', 'Nbre de notices par bannettes en affichage de la liste des bannettes \n 0 Toutes \n N : maxi N\n -1 : aucune', 'l_dsi', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'dsi_active', '0', 'DSI, bannettes accessibles par l''OPAC ? \n 0 : Non \n 1 : Oui', 'l_dsi', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'mailretard', '2after_list', 'Nous vous remercions de prendre rapidement contact par tlphone au 00 00 00 00 00 ou de nous rpondre par mail  mail@mail.mail pour tudier la possibilit de prolonger ces prts ou de ramener les ouvrages concerns.', 'Texte apparaissant aprs la liste des ouvrages en retard dans le mail', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'mailretard', '2before_list', 'Sauf erreur de notre part, vous avez toujours en votre possession le ou les ouvrage(s) suivant(s) dont la dure de prt est aujourd''hui dpasse :', 'Texte apparaissant avant la liste des ouvrages en retard dans le mail de relance de retard', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'mailretard', '2fdp', 'Le responsable de la Bibliothque Bibliothque test de PMB.', 'Signataire du mail de relance de retard', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'mailretard', '2madame_monsieur', 'Madame, Monsieur', 'Entte du mail', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'mailretard', '2objet', 'Documents en retard', 'Objet du mail de relance de retard', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'mailretard', '3after_list', 'Nous vous remercions de prendre rapidement contact par tlphone au 00 00 00 00 00 ou de nous rpondre par mail  mail@mail.mail pour tudier la possibilit de prolonger ces prts ou de ramener les ouvrages concerns.', 'Texte apparaissant aprs la liste des ouvrages en retard dans le mail', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'mailretard', '3before_list', 'Sauf erreur de notre part, vous avez toujours en votre possession le ou les ouvrage(s) suivant(s) dont la dure de prt est aujourd''hui dpasse :', 'Texte apparaissant avant la liste des ouvrages en retard dans le mail de relance de retard', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'mailretard', '3fdp', 'Le responsable de la Bibliothque Bibliothque test de PMB.', 'Signataire du mail de relance de retard', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'mailretard', '3madame_monsieur', 'Madame, Monsieur', 'Entte du mail', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'mailretard', '3objet', 'Documents en retard', 'Objet du mail de relance de retard', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'mailretard', '3before_recouvrement', 'Sans nouvelles de votre part dans les sept jours, nous nous verrons contraints de dlguer au trsor public le recouvrement des ouvrages suivants :', 'Texte avant la liste des ouvrages en recouvrement', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'mailretard', 'priorite_email', '1', 'Priorit des lettres de retard lors des relances :\n 0 : Lettre seule \n 1 : Mail,  dfaut lettre\n 2 : Mail ET lettre', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pmb', 'import_modele_lecteur', '', 'Modle d''import des lecteurs', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pmb', 'blocage_retard', '1', 'Bloquer le prt d''une dure quivalente au retard ? 0=non, 1=oui', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pmb', 'blocage_delai', '7', 'Dlai  partir duquel le retard est pris en compte', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pmb', 'blocage_max', '60', 'Nombre maximum de jours bloqus (0 = pas de limite)', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pmb', 'blocage_coef', '1', 'Coefficient de proportionnalit des jours de retard pour le blocage', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pmb', 'blocage_retard_force', '1', '1 = Le prt peut-tre forc lors d''un blocage du compte, 2 = Pas de forage possible', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'etagere_order', ' name ', 'Tri des tagres dans l''cran d''accueil, \n name = par nom\n name DESC = par nom dcroissant', 'j_etagere', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pmb', 'book_pics_show', '0', 'Affichage des couvertures de livres en gestion\n 1: oui  \n 0: non', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pmb', 'book_pics_url', '', 'URL des vignettes des notices, dans le chemin fourni, !!isbn!! sera remplac par le code ISBN ou EAN de la notice purg de tous les tirets ou points. \r\n exemple : http://www.monsite/opac/images/vignettes/!!isbn!!.jpg', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pmb', 'opac_url', './opac_css/', 'URL de l''OPAC vu depuis la partie gestion, par dfaut ./opac_css/', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'resa_popup', '1', 'Demande de connexion sous forme de popup ? :\n 0 : Non\n 1 : Oui', 'a_general', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pmb', 'vignette_x', '100', 'Largeur de la vignette cre pour un exemplaire numrique image', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pmb', 'vignette_y', '100', 'Hauteur de la vignette cre pour un exemplaire numrique image', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pmb', 'lecteurs_localises', '0', 'Lecteurs localiss ? \n 0: Non \n 1: Oui', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pmb', 'vignette_imagemagick', '', 'Chemin de l''excutable ImageMagick (/usr/bin/imagemagick par exemple)', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'show_rss_browser', '0', 'Affichage des flux RSS du catalogue en page d''accueil OPAC 1: oui  ou 0: non', 'f_modules', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pmb', 'mail_methode', 'php', 'Mthode d''envoi des mails : \n php : fonction mail() de php\n smtp,hote:port,auth,user,pass : en smtp, mettre O ou 1 pour l''authentification...', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'mail_methode', 'php', 'Mthode d''envoi des mails dans l''opac : \n php : fonction mail() de php\n smtp,hote:port,auth,user,pass : en smtp, mettre O ou 1 pour l''authentification...', 'a_general', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'search_show_typdoc', '1', 'Affichage de la restriction par type de document pour les recherches en page d''accueil', 'c_recherche', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pmb', 'verif_on_line', '0', 'Dans le menu Administration > Outils > Maj Base : vrification d''une version plus rcente de PMB en ligne ? \r\n0 : non : si vous n''tes pas connect  internet \r\n 1 : Oui : si vous avez une connexion  internet', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'show_languages', '1 fr_FR,it_IT,en_UK,nl_NL,oc_FR', 'Afficher la liste droulante de slection de la langue ? \r\n 0 : Non \r\n 1 : Oui \r\nFaire suivre d''un espace et des codes des langues possibles spares par des virgules : fr_FR,it_IT,en_UK,nl_NL,oc_FR', 'a_general', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pmb', 'pdf_font', 'Helvetica', 'Police de caractres  chasse variable pour les ditions en pdf - Police Arial', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pmb', 'pdf_fontfixed', 'Courier', 'Police de caractres  chasse fixe pour les ditions en pdf - Police Courier', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'z3950', 'debug', '0', 'Debugage (export fichier) des notices lues en Z3950 \r\n 0: Non \r\n 1: 0ui', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pmb', 'nb_lastnotices', '10', 'Nombre de dernires notices affiches en Catalogue - Dernires notices', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'show_dernieresnotices_nb', '10', 'Nombre de dernires notices affiches en Catalogue - Dernires notices', 'f_modules', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pmb', 'recouvrement_auto', '0', 'Par dfaut passage en recouvrement propos en gestion des relances si niveau=3 et devrait tre en 4: \r\n 1: Oui, recouvrement propos par dfaut \r\n 0: Ne rien faire par dfaut', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'pmb', 'keyword_sep', ' ', 'Sparateur des mots cls dans la partie indexation libre, espace ou ; ou , ou ...', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'thesaurus', 'mode_pmb', '0', 'Niveau d''utilisation des thsaurus.\n 0 : Un seul thsaurus par dfaut.\n 1 : Choix du thsaurus possible.', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'thesaurus', 'defaut', '1', 'Identifiant du thsaurus par dfaut.', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'thesaurus', 'liste_trad', 'fr_FR', 'Liste des langues affiches dans les thsaurus.\n(ex : fr_FR,en_UK,...,ar)', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'thesaurus', '0', 'Niveau d''utilisation des thsaurus.\n 0 : Un seul thsaurus par dfaut.\n 1 : Choix du thsaurus possible.', 'm_thesaurus', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'acquisition', 'active', '0', 'Module acquisitions activ.\n 0 : Non.\n 1 : Oui.', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'acquisition', 'gestion_tva', '0', 'Gestion de la TVA.\n 0 : Non.\n 1 : Oui.', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'acquisition', 'poids_sugg', 'U=1.00,E=0.70,V=0.00', 'Pondration des suggestions par dfaut en pourcentage.\n U=Utilisateurs, E=Emprunteurs, V=Visiteurs.\n ex : U=1.00,E=0.70,V=0.00 \n', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'acquisition', 'format', '8,CA,DD,BL,FA', 'Taille du Numro et Prfixes des actes d''achats.\nex : 8,CA,DD,BL,FA \n8 = Prfixe + 8 Chiffres\nCA=Commande Achat, DD=Demande de Devis,BL=Bon de Livraison, FA=Facture Achat \n', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'categories', 'categ_in_line', '0', 'Affichage des catgories en ligne.\n 0 : Non.\n 1 : Oui.', '', 0);
INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion) VALUES (0, 'opac', 'categories_categ_in_line', '0', 'Affichage des catgories en ligne.\r\n 0 : Non.\r\n 1 : Oui.', 'i_categories', 0);

#
# Contenuto della tabella `users`
#
INSERT INTO users (userid, create_dt, last_updated_dt, username, pwd, nom, prenom, rights, user_lang, nb_per_page_search, nb_per_page_select, nb_per_page_gestion, param_popup_ticket, param_sounds, param_licence, deflt_notice_statut, deflt_docs_type, deflt_lenders, deflt_styles, deflt_docs_statut, deflt_docs_codestat, value_deflt_lang, value_deflt_fonction, deflt_docs_location, deflt_docs_section, value_deflt_module, user_email, user_alert_resamail, deflt2docs_location, deflt_thesaurus, value_prefix_cote, xmlta_doctype) VALUES (1, '2002-07-28', '2005-08-10', 'admin', password('admin'), 'Super User', '', 255, 'it_IT', 20, 10, 20, 0, 1, 0, 1, 1, 2, 'couleurs_onglets', 1, 12, 'fre', '070', 1, 10, 'admin', 'pmb@sigb.net', 1, 1, 1, '', 'a');

#
# Contenuto della tabella `notice_statut`
# 

INSERT INTO notice_statut (id_notice_statut, gestion_libelle, opac_libelle, notice_visible_opac, notice_visible_gestion, expl_visible_opac, class_html, notice_visible_opac_abon) VALUES (1, 'Privo di uno status particolare', '', 1, 1, 1, 'statutnot1', 0);
INSERT INTO notice_statut (id_notice_statut, gestion_libelle, opac_libelle, notice_visible_opac, notice_visible_gestion, expl_visible_opac, class_html, notice_visible_opac_abon) VALUES (2, 'Prestito espresso', '', 0, 1, 1, 'statutnot2', 1);

-- Le strict minimum pour dmarrer sans thsaurus et en pouvant en crer un. Ces lignes sont supprimes si on installe un thsaurus  l'installation.
-- 
-- Contenu de la table `thesaurus`
-- 
INSERT INTO thesaurus (id_thesaurus, libelle_thesaurus, langue_defaut, active, opac_active, num_noeud_racine) VALUES (1, 'Thesaurus n1', 'fr_FR', '1', '1', 1);
-- 
-- Contenu de la table `noeuds`
-- 
INSERT INTO noeuds (id_noeud, autorite, num_parent, num_renvoi_voir, visible, num_thesaurus) VALUES (1, 'TOP', 0, 0, '0', 1);
INSERT INTO noeuds (id_noeud, autorite, num_parent, num_renvoi_voir, visible, num_thesaurus) VALUES (2, 'NONCLASSES', 1, 0, '0', 1);
INSERT INTO noeuds (id_noeud, autorite, num_parent, num_renvoi_voir, visible, num_thesaurus) VALUES (3, 'ORPHELINS', 1, 0, '0', 1);
INSERT INTO categories (num_noeud, langue, libelle_categorie, note_application, comment_public, comment_voir, index_categorie) VALUES (2, 'fr_FR', '~termes non classs', '', '', '', ' termes non classes ');
INSERT INTO categories (num_noeud, langue, libelle_categorie, note_application, comment_public, comment_voir, index_categorie) VALUES (3, 'fr_FR', '~termes orphelins', '', '', '', ' termes orphelins ');
